/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/strings","vs/base/common/arrays","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/base/common/uuid","vs/base/common/process","os","vs/platform/environment/common/environment","fs","vs/platform/configuration/common/configuration","vs/base/common/map","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/codicons","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/performance","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/marshalling","vs/editor/common/core/range","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/base/common/semver/semver","vs/workbench/api/node/uriTransformer","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","url","vs/platform/terminal/node/shellEnv","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/processes","vs/base/common/normalization","vs/base/common/severity","vs/base/common/console","vs/base/common/glob","vs/base/common/htmlContent","vs/base/common/labels","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/credentials/common/credentials","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/localizations/node/localizations","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/languagePacks","path","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","graceful-fs","yauzl","yazl","http","vs/server/node/server.main"],ye=function(J){for(var e=[],_=0,t=J.length;_<t;_++)e[_]=we[J[_]];return e};define(we[116],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class _{static get(){const p=new Map,C=new Map,k=new Map,D=new Map;function v(S,c){S.has(c.detail)||S.set(c.detail,-c.timestamp)}function I(S,c){let h=S.get(c.detail);!h||h>=0||S.set(c.detail,h+c.timestamp)}const A=J.getStats().slice(0).sort((S,c)=>S.timestamp-c.timestamp);for(const S of A)switch(S.type){case 10:v(p,S);break;case 11:case 12:I(p,S);break;case 21:v(C,S);break;case 22:I(C,S);break;case 33:v(k,S);break;case 34:I(k,S);break;case 31:v(D,S);break;case 32:I(D,S);break}let R=0;k.forEach(S=>R+=S);function g(S){let c=[];return S.forEach((h,m)=>c.push([m,h])),c}return{amdLoad:g(p),amdInvoke:g(C),nodeRequire:g(k),nodeEval:g(D),nodeRequireTotal:R}}static toMarkdownTable(p,C){let k="",D=[];return p.forEach((v,I)=>{D[I]=v.length}),C.forEach(v=>{v.forEach((I,A)=>{typeof I=="undefined"&&(I=v[A]="-");const R=I.toString().length;D[A]=Math.max(R,D[A])})}),p.forEach((v,I)=>{k+=`| ${v+" ".repeat(D[I]-v.toString().length)} `}),k+=`|
`,p.forEach((v,I)=>{k+=`| ${"-".repeat(D[I])} `}),k+=`|
`,C.forEach(v=>{v.forEach((I,A)=>{typeof I!="undefined"&&(k+=`| ${I+" ".repeat(D[A]-I.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=_}),define(we[117],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(t,p){if(!t)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=_}),define(we[37],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function _(k){return k?k.replace(/\$\((.*?)\)/g,(D,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=_;class t{constructor(D,v,I){this.id=D,this.definition=v,this.description=I,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function p(k,D){const v=["codicon","codicon-"+k];return D&&v.push("codicon-modifier-"+D),v}e.getClassNamesArray=p;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function v(R){if(R instanceof t)return["codicon","codicon-"+R.id];const g=D.exec(R.id);if(!g)return v(t.error);let[,S,c]=g;const h=["codicon","codicon-"+S];return c&&h.push("codicon-modifier-"+c.substr(1)),h}k.asClassNameArray=v;function I(R){return v(R).join(" ")}k.asClassName=I;function A(R){return"."+v(R).join(".")}k.asCSSSelector=A})(C=e.CSSIcon||(e.CSSIcon={}))}),define(we[71],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function _(k){return(D,v,I)=>{let A=null,R=null;if(typeof I.value=="function"?(A="value",R=I.value):typeof I.get=="function"&&(A="get",R=I.get),!R)throw new Error("not supported");I[A]=k(R,v)}}e.createDecorator=_;function t(k,D,v){let I=null,A=null;if(typeof v.value=="function"?(I="value",A=v.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(I="get",A=v.get),!A)throw new Error("not supported");const R=`$memoize$${D}`;v[I]=function(...g){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,g)}),this[R]}}e.memoize=t;function p(k,D,v){return _((I,A)=>{const R=`$debounce$${A}`,g=`$debounce$result$${A}`;return function(...S){this[g]||(this[g]=v?v():void 0),clearTimeout(this[R]),D&&(this[g]=D(this[g],...S),S=[this[g]]),this[R]=setTimeout(()=>{I.apply(this,S),this[g]=v?v():void 0},k)}})}e.debounce=p;function C(k,D,v){return _((I,A)=>{const R=`$throttle$timer$${A}`,g=`$throttle$result$${A}`,S=`$throttle$lastRun$${A}`,c=`$throttle$pending$${A}`;return function(...h){if(this[g]||(this[g]=v?v():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),D&&(this[g]=D(this[g],...h)),this[c])return;const m=this[S]+k;m<=Date.now()?(this[S]=Date.now(),I.apply(this,[this[g]]),this[g]=v?v():void 0):(this[c]=!0,this[R]=setTimeout(()=>{this[c]=!1,this[S]=Date.now(),I.apply(this,[this[g]]),this[g]=v?v():void 0},m-Date.now()))}})}e.throttle=C}),define(we[11],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(o=>{o(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=_,e.errorHandler=new _;function t(E){e.errorHandler.setUnexpectedErrorHandler(E)}e.setUnexpectedErrorHandler=t;function p(E){v(E)||e.errorHandler.onUnexpectedError(E)}e.onUnexpectedError=p;function C(E){v(E)||e.errorHandler.onUnexpectedExternalError(E)}e.onUnexpectedExternalError=C;function k(E){if(E instanceof Error){let{name:u,message:o}=E;const l=E.stacktrace||E.stack;return{$isError:!0,name:u,message:o,stack:l}}return E}e.transformErrorForSerialization=k;const D="Canceled";function v(E){return E instanceof I?!0:E instanceof Error&&E.name===D&&E.message===D}e.isCancellationError=v;class I extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=I;function A(){const E=new Error(D);return E.name=E.message,E}e.canceled=A;function R(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}e.illegalArgument=R;function g(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}e.illegalState=g;function S(E){return E?new Error(`readonly property '${E} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function c(E){const u=new Error(`${E} has been disposed`);return u.name="DISPOSED",u}e.disposed=c;function h(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}e.getErrorMessage=h;class m extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}e.NotImplementedError=m;class y extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}e.NotSupportedError=y;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;class f extends Error{constructor(){super(...arguments);this.logTelemetry=!1}}e.ErrorNoTelemetry=f}),define(we[17],ye([0,1,11]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(Y,z=0){return Y[Y.length-(1+z)]}e.tail=t;function p(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.tail2=p;function C(Y,z,H=(q,ee)=>q===ee){if(Y===z)return!0;if(!Y||!z||Y.length!==z.length)return!1;for(let q=0,ee=Y.length;q<ee;q++)if(!H(Y[q],z[q]))return!1;return!0}e.equals=C;function k(Y,z,H){let q=0,ee=Y.length-1;for(;q<=ee;){const he=(q+ee)/2|0,Ie=H(Y[he],z);if(Ie<0)q=he+1;else if(Ie>0)ee=he-1;else return he}return-(q+1)}e.binarySearch=k;function D(Y,z){let H=0,q=Y.length;if(q===0)return 0;for(;H<q;){const ee=Math.floor((H+q)/2);z(Y[ee])?q=ee:H=ee+1}return H}e.findFirstInSorted=D;function v(Y,z,H){if(Y=Y|0,Y>=z.length)throw new TypeError("invalid index");let q=z[Math.floor(z.length*Math.random())],ee=[],he=[],Ie=[];for(let se of z){const fe=H(se,q);fe<0?ee.push(se):fe>0?he.push(se):Ie.push(se)}return Y<ee.length?v(Y,ee,H):Y<ee.length+Ie.length?Ie[0]:v(Y-(ee.length+Ie.length),he,H)}e.quickSelect=v;function I(Y,z){const H=[];let q;for(const ee of Y.slice(0).sort(z))!q||z(q[0],ee)!==0?(q=[ee],H.push(q)):q.push(ee);return H}e.groupBy=I;function A(Y,z,H){const q=[];function ee(se,fe,ve){if(fe===0&&ve.length===0)return;const X=q[q.length-1];X&&X.start+X.deleteCount===se?(X.deleteCount+=fe,X.toInsert.push(...ve)):q.push({start:se,deleteCount:fe,toInsert:ve})}let he=0,Ie=0;for(;;){if(he===Y.length){ee(he,0,z.slice(Ie));break}if(Ie===z.length){ee(he,Y.length-he,[]);break}const se=Y[he],fe=z[Ie],ve=H(se,fe);ve===0?(he+=1,Ie+=1):ve<0?(ee(he,1,[]),he+=1):ve>0&&(ee(he,0,[fe]),Ie+=1)}return q}e.sortedDiff=A;function R(Y,z,H){const q=A(Y,z,H),ee=[],he=[];for(const Ie of q)ee.push(...Y.slice(Ie.start,Ie.start+Ie.deleteCount)),he.push(...Ie.toInsert);return{removed:ee,added:he}}e.delta=R;function g(Y,z,H){if(H===0)return[];const q=Y.slice(0,H).sort(z);return c(Y,z,q,H,Y.length),q}e.top=g;function S(Y,z,H,q,ee){return H===0?Promise.resolve([]):new Promise((he,Ie)=>{(async()=>{const se=Y.length,fe=Y.slice(0,H).sort(z);for(let ve=H,X=Math.min(H+q,se);ve<se;ve=X,X=Math.min(X+q,se)){if(ve>H&&await new Promise(B=>setTimeout(B)),ee&&ee.isCancellationRequested)throw(0,_.canceled)();c(Y,z,fe,ve,X)}return fe})().then(he,Ie)})}e.topAsync=S;function c(Y,z,H,q,ee){for(const he=H.length;q<ee;q++){const Ie=Y[q];if(z(Ie,H[he-1])<0){H.pop();const se=D(H,fe=>z(Ie,fe)<0);H.splice(se,0,Ie)}}}function h(Y){return Y.filter(z=>!!z)}e.coalesce=h;function m(Y){let z=0;for(let H=0;H<Y.length;H++)Y[H]&&(Y[z]=Y[H],z+=1);Y.length=z}e.coalesceInPlace=m;function y(Y,z,H){Y.splice(H,0,Y.splice(z,1)[0])}e.move=y;function b(Y){return!Array.isArray(Y)||Y.length===0}e.isFalsyOrEmpty=b;function f(Y){return Array.isArray(Y)&&Y.length>0}e.isNonEmptyArray=f;function E(Y,z=H=>H){const H=new Set;return Y.filter(q=>{const ee=z(q);return H.has(ee)?!1:(H.add(ee),!0)})}e.distinct=E;function u(Y){const z=new Set;return H=>{const q=Y(H);return z.has(q)?!1:(z.add(q),!0)}}e.uniqueFilter=u;function o(Y,z){const H=l(Y,z);if(H!==-1)return Y[H]}e.findLast=o;function l(Y,z){for(let H=Y.length-1;H>=0;H--){const q=Y[H];if(z(q))return H}return-1}e.lastIndex=l;function s(Y,z){return Y.length>0?Y[0]:z}e.firstOrDefault=s;function n(Y,z,H=(q,ee)=>q===ee){let q=0;for(let ee=0,he=Math.min(Y.length,z.length);ee<he&&H(Y[ee],z[ee]);ee++)q++;return q}e.commonPrefixLength=n;function r(Y){return[].concat(...Y)}e.flatten=r;function i(Y,z){let H=typeof z=="number"?Y:0;typeof z=="number"?H=Y:(H=0,z=Y);const q=[];if(H<=z)for(let ee=H;ee<z;ee++)q.push(ee);else for(let ee=H;ee>z;ee--)q.push(ee);return q}e.range=i;function a(Y,z,H){return Y.reduce((q,ee)=>(q[z(ee)]=H?H(ee):ee,q),Object.create(null))}e.index=a;function d(Y,z){return Y.push(z),()=>w(Y,z)}e.insert=d;function w(Y,z){const H=Y.indexOf(z);if(H>-1)return Y.splice(H,1),z}e.remove=w;function P(Y,z,H){const q=Y.slice(0,z),ee=Y.slice(z);return q.concat(H,ee)}e.arrayInsert=P;function O(Y,z){let H;if(typeof z=="number"){let q=z;H=()=>{const ee=Math.sin(q++)*179426549;return ee-Math.floor(ee)}}else H=Math.random;for(let q=Y.length-1;q>0;q-=1){const ee=Math.floor(H()*(q+1)),he=Y[q];Y[q]=Y[ee],Y[ee]=he}}e.shuffle=O;function $(Y,z){const H=Y.indexOf(z);H>-1&&(Y.splice(H,1),Y.unshift(z))}e.pushToStart=$;function L(Y,z){const H=Y.indexOf(z);H>-1&&(Y.splice(H,1),Y.push(z))}e.pushToEnd=L;function T(Y,z){return Array.isArray(Y)?Y.map(z):z(Y)}e.mapArrayOrNot=T;function U(Y){return Array.isArray(Y)?Y:[Y]}e.asArray=U;function N(Y){return Y[Math.floor(Math.random()*Y.length)]}e.getRandomElement=N;function W(Y,z){for(const H of Y){const q=z(H);if(q!==void 0)return q}}e.mapFind=W;function ie(Y,z,H){const q=re(Y,z),ee=Y.length,he=H.length;Y.length=ee+he;for(let Ie=ee-1;Ie>=q;Ie--)Y[Ie+he]=Y[Ie];for(let Ie=0;Ie<he;Ie++)Y[Ie+q]=H[Ie]}e.insertInto=ie;function j(Y,z,H,q){const ee=re(Y,z),he=Y.splice(ee,H);return ie(Y,ee,q),he}e.splice=j;function re(Y,z){return z<0?Math.max(z+Y.length,0):Math.min(z,Y.length)}function x(Y,z){return(H,q)=>z(Y(H),Y(q))}e.compareBy=x;const K=(Y,z)=>Y-z;e.numberComparator=K;function te(Y,z){if(Y.length===0)return;let H=Y[0];for(let q=1;q<Y.length;q++){const ee=Y[q];z(ee,H)>0&&(H=ee)}return H}e.findMaxBy=te;function ce(Y,z){if(Y.length===0)return;let H=Y[0];for(let q=1;q<Y.length;q++){const ee=Y[q];z(ee,H)>=0&&(H=ee)}return H}e.findLastMaxBy=ce;function oe(Y,z){return te(Y,(H,q)=>-z(H,q))}e.findMinBy=oe;class me{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let H=this.firstIdx;for(;H<this.items.length&&z(this.items[H]);)H++;const q=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,q}takeFromEndWhile(z){let H=this.lastIdx;for(;H>=0&&z(this.items[H]);)H--;const q=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,q}peek(){return this.items[this.firstIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}takeCount(z){const H=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,H}}e.ArrayQueue=me}),define(we[72],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(t){const p=this;let C=!1,k;return function(){return C||(C=!0,k=t.apply(p,arguments)),k}}e.once=_}),define(we[49],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(t){function p(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=p;const C=Object.freeze([]);function k(){return C}t.empty=k;function*D(u){yield u}t.single=D;function v(u){return u||C}t.from=v;function I(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=I;function A(u){return u[Symbol.iterator]().next().value}t.first=A;function R(u,o){for(const l of u)if(o(l))return!0;return!1}t.some=R;function g(u,o){for(const l of u)if(o(l))return l}t.find=g;function*S(u,o){for(const l of u)o(l)&&(yield l)}t.filter=S;function*c(u,o){let l=0;for(const s of u)yield o(s,l++)}t.map=c;function*h(...u){for(const o of u)for(const l of o)yield l}t.concat=h;function*m(u){for(const o of u)for(const l of o)yield l}t.concatNested=m;function y(u,o,l){let s=l;for(const n of u)s=o(s,n);return s}t.reduce=y;function*b(u,o,l=u.length){for(o<0&&(o+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);o<l;o++)yield u[o]}t.slice=b;function f(u,o=Number.POSITIVE_INFINITY){const l=[];if(o===0)return[l,u];const s=u[Symbol.iterator]();for(let n=0;n<o;n++){const r=s.next();if(r.done)return[l,t.empty()];l.push(r.value)}return[l,{[Symbol.iterator](){return s}}]}t.consume=f;function E(u,o,l=(s,n)=>s===n){const s=u[Symbol.iterator](),n=o[Symbol.iterator]();for(;;){const r=s.next(),i=n.next();if(r.done!==i.done)return!1;if(r.done)return!0;if(!l(r.value,i.value))return!1}}t.equals=E})(_=e.Iterable||(e.Iterable={}))}),define(we[59],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var p;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(p=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(o,l=!1){let s=0,n=o.length,r="",i=0,a=16,d=0;function w(N){let W=0,ie=0;for(;W<N;){const j=o.charCodeAt(s);if(j>=48&&j<=57)ie=ie*16+j-48;else if(j>=65&&j<=70)ie=ie*16+j-65+10;else if(j>=97&&j<=102)ie=ie*16+j-97+10;else break;s++,W++}return W<N&&(ie=-1),ie}function P(N){s=N,r="",i=0,a=16,d=0}function O(){const N=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&I(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&I(o.charCodeAt(s)))for(s++;s<o.length&&I(o.charCodeAt(s));)s++;else return d=3,o.substring(N,s);let W=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&I(o.charCodeAt(s))){for(s++;s<o.length&&I(o.charCodeAt(s));)s++;W=s}else d=3;return o.substring(N,W)}function $(){let N="",W=s;for(;;){if(s>=n){N+=o.substring(W,s),d=2;break}const ie=o.charCodeAt(s);if(ie===34){N+=o.substring(W,s),s++;break}if(ie===92){if(N+=o.substring(W,s),s++,s>=n){d=2;break}switch(o.charCodeAt(s++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const re=w(4);re>=0?N+=String.fromCharCode(re):d=4;break}default:d=5}W=s;continue}if(ie>=0&&ie<=31)if(v(ie)){N+=o.substring(W,s),d=2;break}else d=6;s++}return N}function L(){if(r="",d=0,i=s,s>=n)return i=n,a=17;let N=o.charCodeAt(s);if(D(N)){do s++,r+=String.fromCharCode(N),N=o.charCodeAt(s);while(D(N));return a=15}if(v(N))return s++,r+=String.fromCharCode(N),N===13&&o.charCodeAt(s)===10&&(s++,r+=`
`),a=14;switch(N){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,r=$(),a=10;case 47:{const W=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<n&&!v(o.charCodeAt(s));)s++;return r=o.substring(W,s),a=12}if(o.charCodeAt(s+1)===42){s+=2;const ie=n-1;let j=!1;for(;s<ie;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,j=!0;break}s++}return j||(s++,d=1),r=o.substring(W,s),a=13}return r+=String.fromCharCode(N),s++,a=16}case 45:if(r+=String.fromCharCode(N),s++,s===n||!I(o.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),a=11;default:for(;s<n&&T(N);)s++,N=o.charCodeAt(s);if(i!==s){switch(r=o.substring(i,s),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(N),s++,a=16}}function T(N){if(D(N)||v(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let N;do N=L();while(N>=12&&N<=15);return N}return{setPosition:P,getPosition:()=>s,scan:l?U:L,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>i,getTokenLength:()=>s-i,getTokenError:()=>d}}e.createScanner=k;function D(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function v(o){return o===10||o===13||o===8232||o===8233}function I(o){return o>=48&&o<=57}var A;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(A||(A={}));function R(o,l){const s=[],n=new Object;let r;const i={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function d(w,P,O,$){i.value=w,i.offset=P,i.length=O,i.type=$,i.colonOffset=void 0,r=i}try{f(o,{onObjectBegin:(w,P)=>{if(l<=w)throw n;r=void 0,a=l>w,s.push("")},onObjectProperty:(w,P,O)=>{if(l<P||(d(w,P,O,"property"),s[s.length-1]=w,l<=P+O))throw n},onObjectEnd:(w,P)=>{if(l<=w)throw n;r=void 0,s.pop()},onArrayBegin:(w,P)=>{if(l<=w)throw n;r=void 0,s.push(0)},onArrayEnd:(w,P)=>{if(l<=w)throw n;r=void 0,s.pop()},onLiteralValue:(w,P,O)=>{if(l<P||(d(w,P,O,u(w)),l<=P+O))throw n},onSeparator:(w,P,O)=>{if(l<=P)throw n;if(w===":"&&r&&r.type==="property")r.colonOffset=P,a=!1,r=void 0;else if(w===","){const $=s[s.length-1];typeof $=="number"?s[s.length-1]=$+1:(a=!0,s[s.length-1]=""),r=void 0}}})}catch(w){if(w!==n)throw w}return{path:s,previousNode:r,isAtPropertyKey:a,matches:w=>{let P=0;for(let O=0;P<w.length&&O<s.length;O++)if(w[P]===s[O]||w[P]==="*")P++;else if(w[P]!=="**")return!1;return P===w.length}}}e.getLocation=R;function g(o,l=[],s=C.DEFAULT){let n=null,r=[];const i=[];function a(w){Array.isArray(r)?r.push(w):n!==null&&(r[n]=w)}return f(o,{onObjectBegin:()=>{const w={};a(w),i.push(r),r=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{r=i.pop()},onArrayBegin:()=>{const w=[];a(w),i.push(r),r=w,n=null},onArrayEnd:()=>{r=i.pop()},onLiteralValue:a,onError:(w,P,O)=>{l.push({error:w,offset:P,length:O})}},s),r[0]}e.parse=g;function S(o,l=[],s=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function i(w){return n.children.push(w),w}f(o,{onObjectBegin:w=>{n=i({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,P,O)=>{n=i({type:"property",offset:P,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:P,length:O,parent:n})},onObjectEnd:(w,P)=>{n.length=w+P-n.offset,n=n.parent,r(w+P)},onArrayBegin:(w,P)=>{n=i({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,P)=>{n.length=w+P-n.offset,n=n.parent,r(w+P)},onLiteralValue:(w,P,O)=>{i({type:u(w),offset:P,length:O,parent:n,value:w}),r(P+O)},onSeparator:(w,P,O)=>{n.type==="property"&&(w===":"?n.colonOffset=P:w===","&&r(P))},onError:(w,P,O)=>{l.push({error:w,offset:P,length:O})}},s);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=S;function c(o,l){if(!o)return;let s=o;for(let n of l)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const i of s.children)if(Array.isArray(i.children)&&i.children[0].value===n){s=i.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=c;function h(o){if(!o.parent||!o.parent.children)return[];const l=h(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;l.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&l.push(s)}return l}e.getNodePath=h;function m(o){switch(o.type){case"array":return o.children.map(m);case"object":{const l=Object.create(null);for(let s of o.children){const n=s.children[1];n&&(l[s.children[0].value]=m(n))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=m;function y(o,l,s=!1){return l>=o.offset&&l<o.offset+o.length||s&&l===o.offset+o.length}e.contains=y;function b(o,l,s=!1){if(y(o,l,s)){const n=o.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=l;r++){const i=b(n[r],l,s);if(i)return i}return o}}e.findNodeAtOffset=b;function f(o,l,s=C.DEFAULT){const n=k(o,!1);function r(me){return me?()=>me(n.getTokenOffset(),n.getTokenLength()):()=>!0}function i(me){return me?Y=>me(Y,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=r(l.onObjectBegin),d=i(l.onObjectProperty),w=r(l.onObjectEnd),P=r(l.onArrayBegin),O=r(l.onArrayEnd),$=i(l.onLiteralValue),L=i(l.onSeparator),T=r(l.onComment),U=i(l.onError),N=s&&s.disallowComments,W=s&&s.allowTrailingComma;function ie(){for(;;){const me=n.scan();switch(n.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:N||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(me){case 12:case 13:N?j(10):T();break;case 16:j(1);break;case 15:case 14:break;default:return me}}}function j(me,Y=[],z=[]){if(U(me),Y.length+z.length>0){let H=n.getToken();for(;H!==17;){if(Y.indexOf(H)!==-1){ie();break}else if(z.indexOf(H)!==-1)break;H=ie()}}}function re(me){const Y=n.getTokenValue();return me?$(Y):d(Y),ie(),!0}function x(){switch(n.getToken()){case 11:{let me=0;try{me=JSON.parse(n.getTokenValue()),typeof me!="number"&&(j(2),me=0)}catch{j(2)}$(me);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return ie(),!0}function K(){return n.getToken()!==10?(j(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(L(":"),ie(),oe()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function te(){a(),ie();let me=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(me||j(4,[],[]),L(","),ie(),n.getToken()===2&&W)break}else me&&j(6,[],[]);K()||j(4,[],[2,5]),me=!0}return w(),n.getToken()!==2?j(7,[2],[]):ie(),!0}function ce(){P(),ie();let me=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(me||j(4,[],[]),L(","),ie(),n.getToken()===4&&W)break}else me&&j(6,[],[]);oe()||j(4,[],[4,5]),me=!0}return O(),n.getToken()!==4?j(8,[4],[]):ie(),!0}function oe(){switch(n.getToken()){case 3:return ce();case 1:return te();case 10:return re(!0);default:return x()}}return ie(),n.getToken()===17?s.allowEmptyContent?!0:(j(4,[],[]),!1):oe()?(n.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=f;function E(o,l){let s=k(o),n=[],r,i=0,a;do switch(a=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:i!==a&&n.push(o.substring(i,a)),l!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,l)),i=s.getPosition();break}while(r!==17);return n.join("")}e.stripComments=E;function u(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(we[118],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(p){this.executor=p,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(p){this._error=p}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(p){return new _(()=>p(this.getValue()))}}e.Lazy=_}),define(we[2],ye([0,1,72,49]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const p=!1;let C=null;function k(r){C=r}if(e.setDisposableTracker=k,p){const r="__is_disposable_tracked__";k(new class{trackDisposable(i){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(a)},3e3)}setParent(i,a){if(i&&i!==b.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==b.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function D(r){return C?.trackDisposable(r),r}function v(r){C?.markAsDisposed(r)}function I(r,i){C?.setParent(r,i)}function A(r,i){if(!!C)for(const a of r)C.setParent(a,i)}function R(r){return C?.markAsSingleton(r),r}e.markAsSingleton=R;class g extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=g;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function c(r){if(t.Iterable.is(r)){let i=[];for(const a of r)if(a)try{a.dispose()}catch(d){i.push(d)}if(i.length===1)throw i[0];if(i.length>1)throw new g(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=c;function h(...r){const i=m(()=>c(r));return A(r,i),i}e.combinedDisposable=h;function m(r){const i=D({dispose:(0,_.once)(()=>{v(i),r()})});return i}e.toDisposable=m;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return I(i,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new y,D(this),I(this._store,this)}dispose(){v(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&I(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&I(i,null),i}}e.MutableDisposable=f;class E{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=E;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(i){let a=i;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,v(this))},this}}e.SafeDisposable=u;class o{constructor(){this.references=new Map}acquire(i,...a){let d=this.references.get(i);d||(d={counter:0,object:this.createReferencedObject(i,...a)},this.references.set(i,d));const{object:w}=d,P=(0,_.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(i,d.object),this.references.delete(i))});return d.counter++,{object:w,dispose:P}}}e.ReferenceCollection=o;class l{constructor(i){this.referenceCollection=i}async acquire(i,...a){const d=this.referenceCollection.acquire(i,...a);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(w){throw d.dispose(),w}}}e.AsyncReferenceCollection=l;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s;function n(r){const i=new y;try{r(i)}finally{i.dispose()}}e.disposeOnReturn=n}),define(we[119],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(C){this.element=C,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class t{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){let C=this._first;for(;C!==_.Undefined;){const k=C.next;C.prev=_.Undefined,C.next=_.Undefined,C=k}this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const D=new _(C);if(this._first===_.Undefined)this._first=D,this._last=D;else if(k){const I=this._last;this._last=D,D.prev=I,I.next=D}else{const I=this._first;this._first=D,D.next=I,I.prev=D}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(D))}}shift(){if(this._first!==_.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==_.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==_.Undefined&&C.next!==_.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===_.Undefined&&C.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):C.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):C.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==_.Undefined;)yield C.element,C=C.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[120],ye([1]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(se,fe){for(var ve=0;ve<fe.length;ve++){var X=fe[ve];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(se,X.key,X)}}function _(se,fe,ve){return fe&&e(se.prototype,fe),ve&&e(se,ve),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,fe){if(!!se){if(typeof se=="string")return p(se,fe);var ve=Object.prototype.toString.call(se).slice(8,-1);if(ve==="Object"&&se.constructor&&(ve=se.constructor.name),ve==="Map"||ve==="Set")return Array.from(se);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return p(se,fe)}}function p(se,fe){(fe==null||fe>se.length)&&(fe=se.length);for(var ve=0,X=new Array(fe);ve<fe;ve++)X[ve]=se[ve];return X}function C(se,fe){var ve=typeof Symbol!="undefined"&&se[Symbol.iterator]||se["@@iterator"];if(ve)return(ve=ve.call(se)).next.bind(ve);if(Array.isArray(se)||(ve=t(se))||fe&&se&&typeof se.length=="number"){ve&&(se=ve);var X=0;return function(){return X>=se.length?{done:!0}:{done:!1,value:se[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=k();function D(se){J.defaults=se}var v=/[&<>"']/,I=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(fe){return g[fe]};function c(se,fe){if(fe){if(v.test(se))return se.replace(I,S)}else if(A.test(se))return se.replace(R,S);return se}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(se){return se.replace(h,function(fe,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var y=/(^|[^\[])\^/g;function b(se,fe){se=se.source||se,fe=fe||"";var ve={replace:function(B,V){return V=V.source||V,V=V.replace(y,"$1"),se=se.replace(B,V),ve},getRegex:function(){return new RegExp(se,fe)}};return ve}var f=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(se,fe,ve){if(se){var X;try{X=decodeURIComponent(m(ve)).replace(f,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}fe&&!E.test(ve)&&(ve=r(fe,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var o={},l=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(se,fe){o[" "+se]||(l.test(se)?o[" "+se]=se+"/":o[" "+se]=w(se,"/",!0)),se=o[" "+se];var ve=se.indexOf(":")===-1;return fe.substring(0,2)==="//"?ve?fe:se.replace(s,"$1")+fe:fe.charAt(0)==="/"?ve?fe:se.replace(n,"$1")+fe:se+fe}var i={exec:function(){}};function a(se){for(var fe=1,ve,X;fe<arguments.length;fe++){ve=arguments[fe];for(X in ve)Object.prototype.hasOwnProperty.call(ve,X)&&(se[X]=ve[X])}return se}function d(se,fe){var ve=se.replace(/\|/g,function(V,Q,ue){for(var pe=!1,Pe=Q;--Pe>=0&&ue[Pe]==="\\";)pe=!pe;return pe?"|":" |"}),X=ve.split(/ \|/),B=0;if(X[0].trim()||X.shift(),X[X.length-1].trim()||X.pop(),X.length>fe)X.splice(fe);else for(;X.length<fe;)X.push("");for(;B<X.length;B++)X[B]=X[B].trim().replace(/\\\|/g,"|");return X}function w(se,fe,ve){var X=se.length;if(X===0)return"";for(var B=0;B<X;){var V=se.charAt(X-B-1);if(V===fe&&!ve)B++;else if(V!==fe&&ve)B++;else break}return se.substr(0,X-B)}function P(se,fe){if(se.indexOf(fe[1])===-1)return-1;for(var ve=se.length,X=0,B=0;B<ve;B++)if(se[B]==="\\")B++;else if(se[B]===fe[0])X++;else if(se[B]===fe[1]&&(X--,X<0))return B;return-1}function O(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(se,fe){if(fe<1)return"";for(var ve="";fe>1;)fe&1&&(ve+=se),fe>>=1,se+=se;return ve+se}function L(se,fe,ve,X){var B=fe.href,V=fe.title?c(fe.title):null,Q=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){X.state.inLink=!0;var ue={type:"link",raw:ve,href:B,title:V,text:Q,tokens:X.inlineTokens(Q,[])};return X.state.inLink=!1,ue}else return{type:"image",raw:ve,href:B,title:V,text:c(Q)}}function T(se,fe){var ve=se.match(/^(\s+)(?:```)/);if(ve===null)return fe;var X=ve[1];return fe.split(`
`).map(function(B){var V=B.match(/^\s+/);if(V===null)return B;var Q=V[0];return Q.length>=X.length?B.slice(X.length):B}).join(`
`)}var U=function(){function se(ve){this.options=ve||J.defaults}var fe=se.prototype;return fe.space=function(X){var B=this.rules.block.newline.exec(X);if(B&&B[0].length>0)return{type:"space",raw:B[0]}},fe.code=function(X){var B=this.rules.block.code.exec(X);if(B){var V=B[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:B[0],codeBlockStyle:"indented",text:this.options.pedantic?V:w(V,`
`)}}},fe.fences=function(X){var B=this.rules.block.fences.exec(X);if(B){var V=B[0],Q=T(V,B[3]||"");return{type:"code",raw:V,lang:B[2]?B[2].trim():B[2],text:Q}}},fe.heading=function(X){var B=this.rules.block.heading.exec(X);if(B){var V=B[2].trim();if(/#$/.test(V)){var Q=w(V,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(V=Q.trim())}var ue={type:"heading",raw:B[0],depth:B[1].length,text:V,tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},fe.hr=function(X){var B=this.rules.block.hr.exec(X);if(B)return{type:"hr",raw:B[0]}},fe.blockquote=function(X){var B=this.rules.block.blockquote.exec(X);if(B){var V=B[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:B[0],tokens:this.lexer.blockTokens(V,[]),text:V}}},fe.list=function(X){var B=this.rules.block.list.exec(X);if(B){var V,Q,ue,pe,Pe,Re,Fe,Ue,ae,ge,de,Te,Me=B[1].trim(),He=Me.length>1,Be={type:"list",raw:"",ordered:He,start:He?+Me.slice(0,-1):"",loose:!1,items:[]};Me=He?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=He?Me:"[*+-]");for(var je=new RegExp("^( {0,3}"+Me+")((?: [^\\n]*)?(?:\\n|$))");X&&(Te=!1,!(!(B=je.exec(X))||this.rules.block.hr.test(X)));){if(V=B[0],X=X.substring(V.length),Ue=B[2].split(`
`,1)[0],ae=X.split(`
`,1)[0],this.options.pedantic?(pe=2,de=Ue.trimLeft()):(pe=B[2].search(/[^ ]/),pe=pe>4?1:pe,de=Ue.slice(pe),pe+=B[1].length),Re=!1,!Ue&&/^ *$/.test(ae)&&(V+=ae+`
`,X=X.substring(ae.length+1),Te=!0),!Te)for(var qe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])");X&&(ge=X.split(`
`,1)[0],Ue=ge,this.options.pedantic&&(Ue=Ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!qe.test(Ue));){if(Ue.search(/[^ ]/)>=pe||!Ue.trim())de+=`
`+Ue.slice(pe);else if(!Re)de+=`
`+Ue;else break;!Re&&!Ue.trim()&&(Re=!0),V+=ge+`
`,X=X.substring(ge.length+1)}Be.loose||(Fe?Be.loose=!0:/\n *\n *$/.test(V)&&(Fe=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(de),Q&&(ue=Q[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:V,task:!!Q,checked:ue,loose:!1,text:de}),Be.raw+=V}Be.items[Be.items.length-1].raw=V.trimRight(),Be.items[Be.items.length-1].text=de.trimRight(),Be.raw=Be.raw.trimRight();var ne=Be.items.length;for(Pe=0;Pe<ne;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var be=Be.items[Pe].tokens.filter(function(Le){return Le.type==="space"}),ke=be.every(function(Le){for(var Ne=Le.raw.split(""),Qe=0,$e=C(Ne),Ve;!(Ve=$e()).done;){var Ye=Ve.value;if(Ye===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Be.loose&&be.length&&ke&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},fe.html=function(X){var B=this.rules.block.html.exec(X);if(B){var V={type:"html",raw:B[0],pre:!this.options.sanitizer&&(B[1]==="pre"||B[1]==="script"||B[1]==="style"),text:B[0]};return this.options.sanitize&&(V.type="paragraph",V.text=this.options.sanitizer?this.options.sanitizer(B[0]):c(B[0]),V.tokens=[],this.lexer.inline(V.text,V.tokens)),V}},fe.def=function(X){var B=this.rules.block.def.exec(X);if(B){B[3]&&(B[3]=B[3].substring(1,B[3].length-1));var V=B[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:V,raw:B[0],href:B[2],title:B[3]}}},fe.table=function(X){var B=this.rules.block.table.exec(X);if(B){var V={type:"table",header:d(B[1]).map(function(Fe){return{text:Fe}}),align:B[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:B[3]?B[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(V.header.length===V.align.length){V.raw=B[0];var Q=V.align.length,ue,pe,Pe,Re;for(ue=0;ue<Q;ue++)/^ *-+: *$/.test(V.align[ue])?V.align[ue]="right":/^ *:-+: *$/.test(V.align[ue])?V.align[ue]="center":/^ *:-+ *$/.test(V.align[ue])?V.align[ue]="left":V.align[ue]=null;for(Q=V.rows.length,ue=0;ue<Q;ue++)V.rows[ue]=d(V.rows[ue],V.header.length).map(function(Fe){return{text:Fe}});for(Q=V.header.length,pe=0;pe<Q;pe++)V.header[pe].tokens=[],this.lexer.inlineTokens(V.header[pe].text,V.header[pe].tokens);for(Q=V.rows.length,pe=0;pe<Q;pe++)for(Re=V.rows[pe],Pe=0;Pe<Re.length;Pe++)Re[Pe].tokens=[],this.lexer.inlineTokens(Re[Pe].text,Re[Pe].tokens);return V}}},fe.lheading=function(X){var B=this.rules.block.lheading.exec(X);if(B){var V={type:"heading",raw:B[0],depth:B[2].charAt(0)==="="?1:2,text:B[1],tokens:[]};return this.lexer.inline(V.text,V.tokens),V}},fe.paragraph=function(X){var B=this.rules.block.paragraph.exec(X);if(B){var V={type:"paragraph",raw:B[0],text:B[1].charAt(B[1].length-1)===`
`?B[1].slice(0,-1):B[1],tokens:[]};return this.lexer.inline(V.text,V.tokens),V}},fe.text=function(X){var B=this.rules.block.text.exec(X);if(B){var V={type:"text",raw:B[0],text:B[0],tokens:[]};return this.lexer.inline(V.text,V.tokens),V}},fe.escape=function(X){var B=this.rules.inline.escape.exec(X);if(B)return{type:"escape",raw:B[0],text:c(B[1])}},fe.tag=function(X){var B=this.rules.inline.tag.exec(X);if(B)return!this.lexer.state.inLink&&/^<a /i.test(B[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(B[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(B[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(B[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:B[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):c(B[0]):B[0]}},fe.link=function(X){var B=this.rules.inline.link.exec(X);if(B){var V=B[2].trim();if(!this.options.pedantic&&/^</.test(V)){if(!/>$/.test(V))return;var Q=w(V.slice(0,-1),"\\");if((V.length-Q.length)%2==0)return}else{var ue=P(B[2],"()");if(ue>-1){var pe=B[0].indexOf("!")===0?5:4,Pe=pe+B[1].length+ue;B[2]=B[2].substring(0,ue),B[0]=B[0].substring(0,Pe).trim(),B[3]=""}}var Re=B[2],Fe="";if(this.options.pedantic){var Ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);Ue&&(Re=Ue[1],Fe=Ue[3])}else Fe=B[3]?B[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(V)?Re=Re.slice(1):Re=Re.slice(1,-1)),L(B,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},B[0],this.lexer)}},fe.reflink=function(X,B){var V;if((V=this.rules.inline.reflink.exec(X))||(V=this.rules.inline.nolink.exec(X))){var Q=(V[2]||V[1]).replace(/\s+/g," ");if(Q=B[Q.toLowerCase()],!Q||!Q.href){var ue=V[0].charAt(0);return{type:"text",raw:ue,text:ue}}return L(V,Q,V[0],this.lexer)}},fe.emStrong=function(X,B,V){V===void 0&&(V="");var Q=this.rules.inline.emStrong.lDelim.exec(X);if(!!Q&&!(Q[3]&&V.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=Q[1]||Q[2]||"";if(!ue||ue&&(V===""||this.rules.inline.punctuation.exec(V))){var pe=Q[0].length-1,Pe,Re,Fe=pe,Ue=0,ae=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,B=B.slice(-1*X.length+pe);(Q=ae.exec(B))!=null;)if(Pe=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Pe){if(Re=Pe.length,Q[3]||Q[4]){Fe+=Re;continue}else if((Q[5]||Q[6])&&pe%3&&!((pe+Re)%3)){Ue+=Re;continue}if(Fe-=Re,!(Fe>0)){if(Re=Math.min(Re,Re+Fe+Ue),Math.min(pe,Re)%2){var ge=X.slice(1,pe+Q.index+Re);return{type:"em",raw:X.slice(0,pe+Q.index+Re+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var de=X.slice(2,pe+Q.index+Re-1);return{type:"strong",raw:X.slice(0,pe+Q.index+Re+1),text:de,tokens:this.lexer.inlineTokens(de,[])}}}}}},fe.codespan=function(X){var B=this.rules.inline.code.exec(X);if(B){var V=B[2].replace(/\n/g," "),Q=/[^ ]/.test(V),ue=/^ /.test(V)&&/ $/.test(V);return Q&&ue&&(V=V.substring(1,V.length-1)),V=c(V,!0),{type:"codespan",raw:B[0],text:V}}},fe.br=function(X){var B=this.rules.inline.br.exec(X);if(B)return{type:"br",raw:B[0]}},fe.del=function(X){var B=this.rules.inline.del.exec(X);if(B)return{type:"del",raw:B[0],text:B[2],tokens:this.lexer.inlineTokens(B[2],[])}},fe.autolink=function(X,B){var V=this.rules.inline.autolink.exec(X);if(V){var Q,ue;return V[2]==="@"?(Q=c(this.options.mangle?B(V[1]):V[1]),ue="mailto:"+Q):(Q=c(V[1]),ue=Q),{type:"link",raw:V[0],text:Q,href:ue,tokens:[{type:"text",raw:Q,text:Q}]}}},fe.url=function(X,B){var V;if(V=this.rules.inline.url.exec(X)){var Q,ue;if(V[2]==="@")Q=c(this.options.mangle?B(V[0]):V[0]),ue="mailto:"+Q;else{var pe;do pe=V[0],V[0]=this.rules.inline._backpedal.exec(V[0])[0];while(pe!==V[0]);Q=c(V[0]),V[1]==="www."?ue="http://"+Q:ue=Q}return{type:"link",raw:V[0],text:Q,href:ue,tokens:[{type:"text",raw:Q,text:Q}]}}},fe.inlineText=function(X,B){var V=this.rules.inline.text.exec(X);if(V){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(V[0]):c(V[0]):V[0]:Q=c(this.options.smartypants?B(V[0]):V[0]),{type:"text",raw:V[0],text:Q}}},se}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:i,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=b(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=b(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=b(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=b(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=b(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=b(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=a({},N),N.gfm=a({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=b(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=b(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=a({},N.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:i,paragraph:b(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:i,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:i,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=b(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=b(N._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=b(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=b(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=b(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=b(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=b(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=b(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=b(W.reflink).replace("label",W._label).replace("ref",N._label).getRegex(),W.nolink=b(W.nolink).replace("ref",N._label).getRegex(),W.reflinkSearch=b(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=a({},W),W.pedantic=a({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=a({},W.normal,{escape:b(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=b(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=a({},W.gfm,{br:b(W.br).replace("{2,}","*").getRegex(),text:b(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ie(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(se){var fe="",ve,X,B=se.length;for(ve=0;ve<B;ve++)X=se.charCodeAt(ve),Math.random()>.5&&(X="x"+X.toString(16)),fe+="&#"+X+";";return fe}var re=function(){function se(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||J.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:N.normal,inline:W.normal};this.options.pedantic?(X.block=N.pedantic,X.inline=W.pedantic):this.options.gfm&&(X.block=N.gfm,this.options.breaks?X.inline=W.breaks:X.inline=W.gfm),this.tokenizer.rules=X}se.lex=function(X,B){var V=new se(B);return V.lex(X)},se.lexInline=function(X,B){var V=new se(B);return V.inlineTokens(X)};var fe=se.prototype;return fe.lex=function(X){X=X.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(X,this.tokens);for(var B;B=this.inlineQueue.shift();)this.inlineTokens(B.src,B.tokens);return this.tokens},fe.blockTokens=function(X,B){var V=this;B===void 0&&(B=[]),this.options.pedantic&&(X=X.replace(/^ +$/gm,""));for(var Q,ue,pe,Pe;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(Q=Fe.call({lexer:V},X,B))?(X=X.substring(Q.raw.length),B.push(Q),!0):!1}))){if(Q=this.tokenizer.space(X)){X=X.substring(Q.raw.length),Q.raw.length===1&&B.length>0?B[B.length-1].raw+=`
`:B.push(Q);continue}if(Q=this.tokenizer.code(X)){X=X.substring(Q.raw.length),ue=B[B.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+Q.raw,ue.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):B.push(Q);continue}if(Q=this.tokenizer.fences(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.heading(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.hr(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.blockquote(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.list(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.html(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.def(X)){X=X.substring(Q.raw.length),ue=B[B.length-1],ue&&(ue.type==="paragraph"||ue.type==="text")?(ue.raw+=`
`+Q.raw,ue.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=ue.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.lheading(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(pe=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,Ue=X.slice(1),ae=void 0;V.options.extensions.startBlock.forEach(function(ge){ae=ge.call({lexer:this},Ue),typeof ae=="number"&&ae>=0&&(Fe=Math.min(Fe,ae))}),Fe<1/0&&Fe>=0&&(pe=X.substring(0,Fe+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(pe))){ue=B[B.length-1],Pe&&ue.type==="paragraph"?(ue.raw+=`
`+Q.raw,ue.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):B.push(Q),Pe=pe.length!==X.length,X=X.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(X)){X=X.substring(Q.raw.length),ue=B[B.length-1],ue&&ue.type==="text"?(ue.raw+=`
`+Q.raw,ue.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ue.text):B.push(Q);continue}if(X){var Re="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,B},fe.inline=function(X,B){this.inlineQueue.push({src:X,tokens:B})},fe.inlineTokens=function(X,B){var V=this;B===void 0&&(B=[]);var Q,ue,pe,Pe=X,Re,Fe,Ue;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)ae.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Re.index)+"["+$("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"["+$("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Fe||(Ue=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(Q=de.call({lexer:V},X,B))?(X=X.substring(Q.raw.length),B.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.tag(X)){X=X.substring(Q.raw.length),ue=B[B.length-1],ue&&Q.type==="text"&&ue.type==="text"?(ue.raw+=Q.raw,ue.text+=Q.text):B.push(Q);continue}if(Q=this.tokenizer.link(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(Q.raw.length),ue=B[B.length-1],ue&&Q.type==="text"&&ue.type==="text"?(ue.raw+=Q.raw,ue.text+=Q.text):B.push(Q);continue}if(Q=this.tokenizer.emStrong(X,Pe,Ue)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.codespan(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.br(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.del(X)){X=X.substring(Q.raw.length),B.push(Q);continue}if(Q=this.tokenizer.autolink(X,j)){X=X.substring(Q.raw.length),B.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(X,j))){X=X.substring(Q.raw.length),B.push(Q);continue}if(pe=X,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Te=X.slice(1),Me=void 0;V.options.extensions.startInline.forEach(function(He){Me=He.call({lexer:this},Te),typeof Me=="number"&&Me>=0&&(de=Math.min(de,Me))}),de<1/0&&de>=0&&(pe=X.substring(0,de+1))}(),Q=this.tokenizer.inlineText(pe,ie)){X=X.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&(Ue=Q.raw.slice(-1)),Fe=!0,ue=B[B.length-1],ue&&ue.type==="text"?(ue.raw+=Q.raw,ue.text+=Q.text):B.push(Q);continue}if(X){var ge="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return B},_(se,null,[{key:"rules",get:function(){return{block:N,inline:W}}}]),se}(),x=function(){function se(ve){this.options=ve||J.defaults}var fe=se.prototype;return fe.code=function(X,B,V){var Q=(B||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(X,Q);ue!=null&&ue!==X&&(V=!0,X=ue)}return X=X.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+c(Q,!0)+'">'+(V?X:c(X,!0))+`</code></pre>
`:"<pre><code>"+(V?X:c(X,!0))+`</code></pre>
`},fe.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},fe.html=function(X){return X},fe.heading=function(X,B,V,Q){return this.options.headerIds?"<h"+B+' id="'+this.options.headerPrefix+Q.slug(V)+'">'+X+"</h"+B+`>
`:"<h"+B+">"+X+"</h"+B+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(X,B,V){var Q=B?"ol":"ul",ue=B&&V!==1?' start="'+V+'"':"";return"<"+Q+ue+`>
`+X+"</"+Q+`>
`},fe.listitem=function(X){return"<li>"+X+`</li>
`},fe.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(X){return"<p>"+X+`</p>
`},fe.table=function(X,B){return B&&(B="<tbody>"+B+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+B+`</table>
`},fe.tablerow=function(X){return`<tr>
`+X+`</tr>
`},fe.tablecell=function(X,B){var V=B.header?"th":"td",Q=B.align?"<"+V+' align="'+B.align+'">':"<"+V+">";return Q+X+"</"+V+`>
`},fe.strong=function(X){return"<strong>"+X+"</strong>"},fe.em=function(X){return"<em>"+X+"</em>"},fe.codespan=function(X){return"<code>"+X+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(X){return"<del>"+X+"</del>"},fe.link=function(X,B,V){if(X=u(this.options.sanitize,this.options.baseUrl,X),X===null)return V;var Q='<a href="'+c(X)+'"';return B&&(Q+=' title="'+B+'"'),Q+=">"+V+"</a>",Q},fe.image=function(X,B,V){if(X=u(this.options.sanitize,this.options.baseUrl,X),X===null)return V;var Q='<img src="'+X+'" alt="'+V+'"';return B&&(Q+=' title="'+B+'"'),Q+=this.options.xhtml?"/>":">",Q},fe.text=function(X){return X},se}(),K=function(){function se(){}var fe=se.prototype;return fe.strong=function(X){return X},fe.em=function(X){return X},fe.codespan=function(X){return X},fe.del=function(X){return X},fe.html=function(X){return X},fe.text=function(X){return X},fe.link=function(X,B,V){return""+V},fe.image=function(X,B,V){return""+V},fe.br=function(){return""},se}(),te=function(){function se(){this.seen={}}var fe=se.prototype;return fe.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(X,B){var V=X,Q=0;if(this.seen.hasOwnProperty(V)){Q=this.seen[X];do Q++,V=X+"-"+Q;while(this.seen.hasOwnProperty(V))}return B||(this.seen[X]=Q,this.seen[V]=0),V},fe.slug=function(X,B){B===void 0&&(B={});var V=this.serialize(X);return this.getNextSafeSlug(V,B.dryrun)},se}(),ce=function(){function se(ve){this.options=ve||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new te}se.parse=function(X,B){var V=new se(B);return V.parse(X)},se.parseInline=function(X,B){var V=new se(B);return V.parseInline(X)};var fe=se.prototype;return fe.parse=function(X,B){B===void 0&&(B=!0);var V="",Q,ue,pe,Pe,Re,Fe,Ue,ae,ge,de,Te,Me,He,Be,je,qe,ne,be,ke,Le=X.length;for(Q=0;Q<Le;Q++){if(de=X[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(ke=this.options.extensions.renderers[de.type].call({parser:this},de),ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){V+=ke||"";continue}switch(de.type){case"space":continue;case"hr":{V+=this.renderer.hr();continue}case"heading":{V+=this.renderer.heading(this.parseInline(de.tokens),de.depth,m(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{V+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(ae="",Ue="",Pe=de.header.length,ue=0;ue<Pe;ue++)Ue+=this.renderer.tablecell(this.parseInline(de.header[ue].tokens),{header:!0,align:de.align[ue]});for(ae+=this.renderer.tablerow(Ue),ge="",Pe=de.rows.length,ue=0;ue<Pe;ue++){for(Fe=de.rows[ue],Ue="",Re=Fe.length,pe=0;pe<Re;pe++)Ue+=this.renderer.tablecell(this.parseInline(Fe[pe].tokens),{header:!1,align:de.align[pe]});ge+=this.renderer.tablerow(Ue)}V+=this.renderer.table(ae,ge);continue}case"blockquote":{ge=this.parse(de.tokens),V+=this.renderer.blockquote(ge);continue}case"list":{for(Te=de.ordered,Me=de.start,He=de.loose,Pe=de.items.length,ge="",ue=0;ue<Pe;ue++)je=de.items[ue],qe=je.checked,ne=je.task,Be="",je.task&&(be=this.renderer.checkbox(qe),He?je.tokens.length>0&&je.tokens[0].type==="paragraph"?(je.tokens[0].text=be+" "+je.tokens[0].text,je.tokens[0].tokens&&je.tokens[0].tokens.length>0&&je.tokens[0].tokens[0].type==="text"&&(je.tokens[0].tokens[0].text=be+" "+je.tokens[0].tokens[0].text)):je.tokens.unshift({type:"text",text:be}):Be+=be),Be+=this.parse(je.tokens,He),ge+=this.renderer.listitem(Be,ne,qe);V+=this.renderer.list(ge,Te,Me);continue}case"html":{V+=this.renderer.html(de.text);continue}case"paragraph":{V+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ge=de.tokens?this.parseInline(de.tokens):de.text;Q+1<Le&&X[Q+1].type==="text";)de=X[++Q],ge+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);V+=B?this.renderer.paragraph(ge):ge;continue}default:{var Ne='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return V},fe.parseInline=function(X,B){B=B||this.renderer;var V="",Q,ue,pe,Pe=X.length;for(Q=0;Q<Pe;Q++){if(ue=X[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(pe=this.options.extensions.renderers[ue.type].call({parser:this},ue),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ue.type))){V+=pe||"";continue}switch(ue.type){case"escape":{V+=B.text(ue.text);break}case"html":{V+=B.html(ue.text);break}case"link":{V+=B.link(ue.href,ue.title,this.parseInline(ue.tokens,B));break}case"image":{V+=B.image(ue.href,ue.title,ue.text);break}case"strong":{V+=B.strong(this.parseInline(ue.tokens,B));break}case"em":{V+=B.em(this.parseInline(ue.tokens,B));break}case"codespan":{V+=B.codespan(ue.text);break}case"br":{V+=B.br();break}case"del":{V+=B.del(this.parseInline(ue.tokens,B));break}case"text":{V+=B.text(ue.text);break}default:{var Re='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return V},se}();function oe(se,fe,ve){if(typeof se=="undefined"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof fe=="function"&&(ve=fe,fe=null),fe=a({},oe.defaults,fe||{}),O(fe),ve){var X=fe.highlight,B;try{B=re.lex(se,fe)}catch(pe){return ve(pe)}var V=function(Pe){var Re;if(!Pe)try{fe.walkTokens&&oe.walkTokens(B,fe.walkTokens),Re=ce.parse(B,fe)}catch(Fe){Pe=Fe}return fe.highlight=X,Pe?ve(Pe):ve(null,Re)};if(!X||X.length<3||(delete fe.highlight,!B.length))return V();var Q=0;oe.walkTokens(B,function(pe){pe.type==="code"&&(Q++,setTimeout(function(){X(pe.text,pe.lang,function(Pe,Re){if(Pe)return V(Pe);Re!=null&&Re!==pe.text&&(pe.text=Re,pe.escaped=!0),Q--,Q===0&&V()})},0))}),Q===0&&V();return}try{var ue=re.lex(se,fe);return fe.walkTokens&&oe.walkTokens(ue,fe.walkTokens),ce.parse(ue,fe)}catch(pe){if(pe.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+c(pe.message+"",!0)+"</pre>";throw pe}}oe.options=oe.setOptions=function(se){return a(oe.defaults,se),D(oe.defaults),oe},oe.getDefaults=k,oe.defaults=J.defaults,oe.use=function(){for(var se=arguments.length,fe=new Array(se),ve=0;ve<se;ve++)fe[ve]=arguments[ve];var X=a.apply(void 0,[{}].concat(fe)),B=oe.defaults.extensions||{renderers:{},childTokens:{}},V;fe.forEach(function(Q){if(Q.extensions&&(V=!0,Q.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Pe=B.renderers?B.renderers[pe.name]:null;Pe?B.renderers[pe.name]=function(){for(var Re=arguments.length,Fe=new Array(Re),Ue=0;Ue<Re;Ue++)Fe[Ue]=arguments[Ue];var ae=pe.renderer.apply(this,Fe);return ae===!1&&(ae=Pe.apply(this,Fe)),ae}:B.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");B[pe.level]?B[pe.level].unshift(pe.tokenizer):B[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?B.startBlock?B.startBlock.push(pe.start):B.startBlock=[pe.start]:pe.level==="inline"&&(B.startInline?B.startInline.push(pe.start):B.startInline=[pe.start]))}pe.childTokens&&(B.childTokens[pe.name]=pe.childTokens)})),Q.renderer&&function(){var pe=oe.defaults.renderer||new x,Pe=function(Ue){var ae=pe[Ue];pe[Ue]=function(){for(var ge=arguments.length,de=new Array(ge),Te=0;Te<ge;Te++)de[Te]=arguments[Te];var Me=Q.renderer[Ue].apply(pe,de);return Me===!1&&(Me=ae.apply(pe,de)),Me}};for(var Re in Q.renderer)Pe(Re);X.renderer=pe}(),Q.tokenizer&&function(){var pe=oe.defaults.tokenizer||new U,Pe=function(Ue){var ae=pe[Ue];pe[Ue]=function(){for(var ge=arguments.length,de=new Array(ge),Te=0;Te<ge;Te++)de[Te]=arguments[Te];var Me=Q.tokenizer[Ue].apply(pe,de);return Me===!1&&(Me=ae.apply(pe,de)),Me}};for(var Re in Q.tokenizer)Pe(Re);X.tokenizer=pe}(),Q.walkTokens){var ue=oe.defaults.walkTokens;X.walkTokens=function(pe){Q.walkTokens.call(this,pe),ue&&ue.call(this,pe)}}V&&(X.extensions=B),oe.setOptions(X)})},oe.walkTokens=function(se,fe){for(var ve=function(){var Q=B.value;switch(fe.call(oe,Q),Q.type){case"table":{for(var ue=C(Q.header),pe;!(pe=ue()).done;){var Pe=pe.value;oe.walkTokens(Pe.tokens,fe)}for(var Re=C(Q.rows),Fe;!(Fe=Re()).done;)for(var Ue=Fe.value,ae=C(Ue),ge;!(ge=ae()).done;){var de=ge.value;oe.walkTokens(de.tokens,fe)}break}case"list":{oe.walkTokens(Q.items,fe);break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[Q.type]?oe.defaults.extensions.childTokens[Q.type].forEach(function(Te){oe.walkTokens(Q[Te],fe)}):Q.tokens&&oe.walkTokens(Q.tokens,fe)}},X=C(se),B;!(B=X()).done;)ve()},oe.parseInline=function(se,fe){if(typeof se=="undefined"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");fe=a({},oe.defaults,fe||{}),O(fe);try{var ve=re.lexInline(se,fe);return fe.walkTokens&&oe.walkTokens(ve,fe.walkTokens),ce.parseInline(ve,fe)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+c(X.message+"",!0)+"</pre>";throw X}},oe.Parser=ce,oe.parser=ce.parse,oe.Renderer=x,oe.TextRenderer=K,oe.Lexer=re,oe.lexer=re.lex,oe.Tokenizer=U,oe.Slugger=te,oe.parse=oe;var me=oe.options,Y=oe.setOptions,z=oe.use,H=oe.walkTokens,q=oe.parseInline,ee=oe,he=ce.parse,Ie=re.lex;J.Lexer=re,J.Parser=ce,J.Renderer=x,J.Slugger=te,J.TextRenderer=K,J.Tokenizer=U,J.getDefaults=k,J.lexer=Ie,J.marked=oe,J.options=me,J.parse=ee,J.parseInline=q,J.parser=he,J.setOptions=Y,J.use=z,J.walkTokens=H,Object.defineProperty(J,"__esModule",{value:!0})}),function(){function J(p){const C=[];typeof p=="number"&&C.push("code/timeOrigin",p);function k(v){C.push(v,Date.now())}function D(){const v=[];for(let I=0;I<C.length;I+=2)v.push({name:C[I],startTime:C[I+1]});return v}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(p){performance.mark(p)},getMarks(){let p=performance.timeOrigin;typeof p!="number"&&(p=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(p)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(p+k.startTime)});return C}};if(typeof process=="object"){const p=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(p)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function _(p){return p.MonacoPerformanceMarks||(p.MonacoPerformanceMarks=e()),p.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=_(t))}(),define(we[3],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const _="en";let t=!1,p=!1,C=!1,k=!1,D=!1,v=!1,I=!1,A=!1,R=!1,g,S=_,c,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const y=typeof m?.versions?.electron=="string",b=y&&m?.type==="renderer";if(e.isElectronSandboxed=b&&m?.sandboxed,typeof navigator=="object"&&!b)h=navigator.userAgent,t=h.indexOf("Windows")>=0,p=h.indexOf("Macintosh")>=0,A=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,v=!0,g=navigator.language,S=g;else if(typeof m=="object"){t=m.platform==="win32",p=m.platform==="darwin",C=m.platform==="linux",k=C&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,I=y,R=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=_,S=_;const i=m.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),d=a.availableLanguages["*"];g=a.locale,S=d||_,c=a._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var f;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function E(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let u=0;p?u=1:t?u=3:C&&(u=2),e.isWindows=t,e.isMacintosh=p,e.isLinux=C,e.isLinuxSnap=k,e.isNative=D,e.isElectron=I,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isCI=R,e.platform=u,e.userAgent=h,e.language=S;var o;(function(i){function a(){return e.language}i.value=a;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=d;function w(){return e.language==="en"}i.isDefault=w})(o=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=c,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let i=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let w=0,P=i.length;w<P;w++){const O=i[w];if(O.id===d.data.vscodeScheduleAsyncWork){i.splice(w,1),O.callback();return}}});let a=0;return d=>{const w=++a;i.push({id:w,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return i=>setTimeout(i)})();var l;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=p||A?2:t?1:3;let s=!0,n=!1;function r(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,s=new Uint16Array(i.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(we[24],ye([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof _.globals.vscode!="undefined"&&typeof _.globals.vscode.process!="undefined"){const p=_.globals.vscode.process;t={get platform(){return p.platform},get arch(){return p.arch},get env(){return p.env},cwd(){return p.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(we[5],ye([0,1,24]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,p=97,C=90,k=122,D=46,v=47,I=92,A=58,R=63;class g extends Error{constructor(E,u,o){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const s=E.indexOf(".")!==-1?"property":"argument";let n=`The "${E}" ${s} ${l} of type ${u}`;n+=`. Received type ${typeof o}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function S(f,E){if(typeof f!="string")throw new g(E,"string",f)}function c(f){return f===v||f===I}function h(f){return f===v}function m(f){return f>=t&&f<=C||f>=p&&f<=k}function y(f,E,u,o){let l="",s=0,n=-1,r=0,i=0;for(let a=0;a<=f.length;++a){if(a<f.length)i=f.charCodeAt(a);else{if(o(i))break;i=v}if(o(i)){if(!(n===a-1||r===1))if(r===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==D||l.charCodeAt(l.length-2)!==D){if(l.length>2){const d=l.lastIndexOf(u);d===-1?(l="",s=0):(l=l.slice(0,d),s=l.length-1-l.lastIndexOf(u)),n=a,r=0;continue}else if(l.length!==0){l="",s=0,n=a,r=0;continue}}E&&(l+=l.length>0?`${u}..`:"..",s=2)}else l.length>0?l+=`${u}${f.slice(n+1,a)}`:l=f.slice(n+1,a),s=a-n-1;n=a,r=0}else i===D&&r!==-1?++r:r=-1}return l}function b(f,E){if(E===null||typeof E!="object")throw new g("pathObject","Object",E);const u=E.dir||E.root,o=E.base||`${E.name||""}${E.ext||""}`;return u?u===E.root?`${u}${o}`:`${u}${f}${o}`:o}e.win32={resolve(...f){let E="",u="",o=!1;for(let l=f.length-1;l>=-1;l--){let s;if(l>=0){if(s=f[l],S(s,"path"),s.length===0)continue}else E.length===0?s=_.cwd():(s=_.env[`=${E}`]||_.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==E.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${E}\\`));const n=s.length;let r=0,i="",a=!1;const d=s.charCodeAt(0);if(n===1)c(d)&&(r=1,a=!0);else if(c(d))if(a=!0,c(s.charCodeAt(1))){let w=2,P=w;for(;w<n&&!c(s.charCodeAt(w));)w++;if(w<n&&w!==P){const O=s.slice(P,w);for(P=w;w<n&&c(s.charCodeAt(w));)w++;if(w<n&&w!==P){for(P=w;w<n&&!c(s.charCodeAt(w));)w++;(w===n||w!==P)&&(i=`\\\\${O}\\${s.slice(P,w)}`,r=w)}}}else r=1;else m(d)&&s.charCodeAt(1)===A&&(i=s.slice(0,2),r=2,n>2&&c(s.charCodeAt(2))&&(a=!0,r=3));if(i.length>0)if(E.length>0){if(i.toLowerCase()!==E.toLowerCase())continue}else E=i;if(o){if(E.length>0)break}else if(u=`${s.slice(r)}\\${u}`,o=a,a&&E.length>0)break}return u=y(u,!o,"\\",c),o?`${E}\\${u}`:`${E}${u}`||"."},normalize(f){S(f,"path");const E=f.length;if(E===0)return".";let u=0,o,l=!1;const s=f.charCodeAt(0);if(E===1)return h(s)?"\\":f;if(c(s))if(l=!0,c(f.charCodeAt(1))){let r=2,i=r;for(;r<E&&!c(f.charCodeAt(r));)r++;if(r<E&&r!==i){const a=f.slice(i,r);for(i=r;r<E&&c(f.charCodeAt(r));)r++;if(r<E&&r!==i){for(i=r;r<E&&!c(f.charCodeAt(r));)r++;if(r===E)return`\\\\${a}\\${f.slice(i)}\\`;r!==i&&(o=`\\\\${a}\\${f.slice(i,r)}`,u=r)}}}else u=1;else m(s)&&f.charCodeAt(1)===A&&(o=f.slice(0,2),u=2,E>2&&c(f.charCodeAt(2))&&(l=!0,u=3));let n=u<E?y(f.slice(u),!l,"\\",c):"";return n.length===0&&!l&&(n="."),n.length>0&&c(f.charCodeAt(E-1))&&(n+="\\"),o===void 0?l?`\\${n}`:n:l?`${o}\\${n}`:`${o}${n}`},isAbsolute(f){S(f,"path");const E=f.length;if(E===0)return!1;const u=f.charCodeAt(0);return c(u)||E>2&&m(u)&&f.charCodeAt(1)===A&&c(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let E,u;for(let s=0;s<f.length;++s){const n=f[s];S(n,"path"),n.length>0&&(E===void 0?E=u=n:E+=`\\${n}`)}if(E===void 0)return".";let o=!0,l=0;if(typeof u=="string"&&c(u.charCodeAt(0))){++l;const s=u.length;s>1&&c(u.charCodeAt(1))&&(++l,s>2&&(c(u.charCodeAt(2))?++l:o=!1))}if(o){for(;l<E.length&&c(E.charCodeAt(l));)l++;l>=2&&(E=`\\${E.slice(l)}`)}return e.win32.normalize(E)},relative(f,E){if(S(f,"from"),S(E,"to"),f===E)return"";const u=e.win32.resolve(f),o=e.win32.resolve(E);if(u===o||(f=u.toLowerCase(),E=o.toLowerCase(),f===E))return"";let l=0;for(;l<f.length&&f.charCodeAt(l)===I;)l++;let s=f.length;for(;s-1>l&&f.charCodeAt(s-1)===I;)s--;const n=s-l;let r=0;for(;r<E.length&&E.charCodeAt(r)===I;)r++;let i=E.length;for(;i-1>r&&E.charCodeAt(i-1)===I;)i--;const a=i-r,d=n<a?n:a;let w=-1,P=0;for(;P<d;P++){const $=f.charCodeAt(l+P);if($!==E.charCodeAt(r+P))break;$===I&&(w=P)}if(P!==d){if(w===-1)return o}else{if(a>d){if(E.charCodeAt(r+P)===I)return o.slice(r+P+1);if(P===2)return o.slice(r+P)}n>d&&(f.charCodeAt(l+P)===I?w=P:P===2&&(w=3)),w===-1&&(w=0)}let O="";for(P=l+w+1;P<=s;++P)(P===s||f.charCodeAt(P)===I)&&(O+=O.length===0?"..":"\\..");return r+=w,O.length>0?`${O}${o.slice(r,i)}`:(o.charCodeAt(r)===I&&++r,o.slice(r,i))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const E=e.win32.resolve(f);if(E.length<=2)return f;if(E.charCodeAt(0)===I){if(E.charCodeAt(1)===I){const u=E.charCodeAt(2);if(u!==R&&u!==D)return`\\\\?\\UNC\\${E.slice(2)}`}}else if(m(E.charCodeAt(0))&&E.charCodeAt(1)===A&&E.charCodeAt(2)===I)return`\\\\?\\${E}`;return f},dirname(f){S(f,"path");const E=f.length;if(E===0)return".";let u=-1,o=0;const l=f.charCodeAt(0);if(E===1)return c(l)?f:".";if(c(l)){if(u=o=1,c(f.charCodeAt(1))){let r=2,i=r;for(;r<E&&!c(f.charCodeAt(r));)r++;if(r<E&&r!==i){for(i=r;r<E&&c(f.charCodeAt(r));)r++;if(r<E&&r!==i){for(i=r;r<E&&!c(f.charCodeAt(r));)r++;if(r===E)return f;r!==i&&(u=o=r+1)}}}}else m(l)&&f.charCodeAt(1)===A&&(u=E>2&&c(f.charCodeAt(2))?3:2,o=u);let s=-1,n=!0;for(let r=E-1;r>=o;--r)if(c(f.charCodeAt(r))){if(!n){s=r;break}}else n=!1;if(s===-1){if(u===-1)return".";s=u}return f.slice(0,s)},basename(f,E){E!==void 0&&S(E,"ext"),S(f,"path");let u=0,o=-1,l=!0,s;if(f.length>=2&&m(f.charCodeAt(0))&&f.charCodeAt(1)===A&&(u=2),E!==void 0&&E.length>0&&E.length<=f.length){if(E===f)return"";let n=E.length-1,r=-1;for(s=f.length-1;s>=u;--s){const i=f.charCodeAt(s);if(c(i)){if(!l){u=s+1;break}}else r===-1&&(l=!1,r=s+1),n>=0&&(i===E.charCodeAt(n)?--n==-1&&(o=s):(n=-1,o=r))}return u===o?o=r:o===-1&&(o=f.length),f.slice(u,o)}for(s=f.length-1;s>=u;--s)if(c(f.charCodeAt(s))){if(!l){u=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":f.slice(u,o)},extname(f){S(f,"path");let E=0,u=-1,o=0,l=-1,s=!0,n=0;f.length>=2&&f.charCodeAt(1)===A&&m(f.charCodeAt(0))&&(E=o=2);for(let r=f.length-1;r>=E;--r){const i=f.charCodeAt(r);if(c(i)){if(!s){o=r+1;break}continue}l===-1&&(s=!1,l=r+1),i===D?u===-1?u=r:n!==1&&(n=1):u!==-1&&(n=-1)}return u===-1||l===-1||n===0||n===1&&u===l-1&&u===o+1?"":f.slice(u,l)},format:b.bind(null,"\\"),parse(f){S(f,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return E;const u=f.length;let o=0,l=f.charCodeAt(0);if(u===1)return c(l)?(E.root=E.dir=f,E):(E.base=E.name=f,E);if(c(l)){if(o=1,c(f.charCodeAt(1))){let w=2,P=w;for(;w<u&&!c(f.charCodeAt(w));)w++;if(w<u&&w!==P){for(P=w;w<u&&c(f.charCodeAt(w));)w++;if(w<u&&w!==P){for(P=w;w<u&&!c(f.charCodeAt(w));)w++;w===u?o=w:w!==P&&(o=w+1)}}}}else if(m(l)&&f.charCodeAt(1)===A){if(u<=2)return E.root=E.dir=f,E;if(o=2,c(f.charCodeAt(2))){if(u===3)return E.root=E.dir=f,E;o=3}}o>0&&(E.root=f.slice(0,o));let s=-1,n=o,r=-1,i=!0,a=f.length-1,d=0;for(;a>=o;--a){if(l=f.charCodeAt(a),c(l)){if(!i){n=a+1;break}continue}r===-1&&(i=!1,r=a+1),l===D?s===-1?s=a:d!==1&&(d=1):s!==-1&&(d=-1)}return r!==-1&&(s===-1||d===0||d===1&&s===r-1&&s===n+1?E.base=E.name=f.slice(n,r):(E.name=f.slice(n,s),E.base=f.slice(n,r),E.ext=f.slice(s,r))),n>0&&n!==o?E.dir=f.slice(0,n-1):E.dir=E.root,E},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let E="",u=!1;for(let o=f.length-1;o>=-1&&!u;o--){const l=o>=0?f[o]:_.cwd();S(l,"path"),l.length!==0&&(E=`${l}/${E}`,u=l.charCodeAt(0)===v)}return E=y(E,!u,"/",h),u?`/${E}`:E.length>0?E:"."},normalize(f){if(S(f,"path"),f.length===0)return".";const E=f.charCodeAt(0)===v,u=f.charCodeAt(f.length-1)===v;return f=y(f,!E,"/",h),f.length===0?E?"/":u?"./":".":(u&&(f+="/"),E?`/${f}`:f)},isAbsolute(f){return S(f,"path"),f.length>0&&f.charCodeAt(0)===v},join(...f){if(f.length===0)return".";let E;for(let u=0;u<f.length;++u){const o=f[u];S(o,"path"),o.length>0&&(E===void 0?E=o:E+=`/${o}`)}return E===void 0?".":e.posix.normalize(E)},relative(f,E){if(S(f,"from"),S(E,"to"),f===E||(f=e.posix.resolve(f),E=e.posix.resolve(E),f===E))return"";const u=1,o=f.length,l=o-u,s=1,n=E.length-s,r=l<n?l:n;let i=-1,a=0;for(;a<r;a++){const w=f.charCodeAt(u+a);if(w!==E.charCodeAt(s+a))break;w===v&&(i=a)}if(a===r)if(n>r){if(E.charCodeAt(s+a)===v)return E.slice(s+a+1);if(a===0)return E.slice(s+a)}else l>r&&(f.charCodeAt(u+a)===v?i=a:a===0&&(i=0));let d="";for(a=u+i+1;a<=o;++a)(a===o||f.charCodeAt(a)===v)&&(d+=d.length===0?"..":"/..");return`${d}${E.slice(s+i)}`},toNamespacedPath(f){return f},dirname(f){if(S(f,"path"),f.length===0)return".";const E=f.charCodeAt(0)===v;let u=-1,o=!0;for(let l=f.length-1;l>=1;--l)if(f.charCodeAt(l)===v){if(!o){u=l;break}}else o=!1;return u===-1?E?"/":".":E&&u===1?"//":f.slice(0,u)},basename(f,E){E!==void 0&&S(E,"ext"),S(f,"path");let u=0,o=-1,l=!0,s;if(E!==void 0&&E.length>0&&E.length<=f.length){if(E===f)return"";let n=E.length-1,r=-1;for(s=f.length-1;s>=0;--s){const i=f.charCodeAt(s);if(i===v){if(!l){u=s+1;break}}else r===-1&&(l=!1,r=s+1),n>=0&&(i===E.charCodeAt(n)?--n==-1&&(o=s):(n=-1,o=r))}return u===o?o=r:o===-1&&(o=f.length),f.slice(u,o)}for(s=f.length-1;s>=0;--s)if(f.charCodeAt(s)===v){if(!l){u=s+1;break}}else o===-1&&(l=!1,o=s+1);return o===-1?"":f.slice(u,o)},extname(f){S(f,"path");let E=-1,u=0,o=-1,l=!0,s=0;for(let n=f.length-1;n>=0;--n){const r=f.charCodeAt(n);if(r===v){if(!l){u=n+1;break}continue}o===-1&&(l=!1,o=n+1),r===D?E===-1?E=n:s!==1&&(s=1):E!==-1&&(s=-1)}return E===-1||o===-1||s===0||s===1&&E===o-1&&E===u+1?"":f.slice(E,o)},format:b.bind(null,"/"),parse(f){S(f,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return E;const u=f.charCodeAt(0)===v;let o;u?(E.root="/",o=1):o=0;let l=-1,s=0,n=-1,r=!0,i=f.length-1,a=0;for(;i>=o;--i){const d=f.charCodeAt(i);if(d===v){if(!r){s=i+1;break}continue}n===-1&&(r=!1,n=i+1),d===D?l===-1?l=i:a!==1&&(a=1):l!==-1&&(a=-1)}if(n!==-1){const d=s===0&&u?1:s;l===-1||a===0||a===1&&l===n-1&&l===s+1?E.base=E.name=f.slice(d,n):(E.name=f.slice(d,l),E.base=f.slice(d,n),E.ext=f.slice(l,n))}return s>0?E.dir=f.slice(0,s-1):u&&(E.dir="/"),E},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[60],ye([0,1,5]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(R){R.text="text/plain",R.binary="application/octet-stream",R.unknown="application/unknown",R.markdown="text/markdown",R.latex="text/latex",R.uriList="text/uri-list"})(t=e.Mimes||(e.Mimes={}));const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(R){const g=(0,_.extname)(R),S=p[g.toLowerCase()];return S!==void 0?S:D(R)}e.getMediaOrTextMime=k;function D(R){const g=(0,_.extname)(R);return C[g.toLowerCase()]}e.getMediaMime=D;function v(R){for(const g in C)if(C[g]===R)return g}e.getExtensionForMimeType=v;const I=/^(.+)\/(.+?)(;.+)?$/;function A(R,g){const S=I.exec(R);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:g?void 0:R}e.normalizeMimeType=A}),define(we[73],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var t;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function p(C,...k){const D=k.reduce((A,R)=>(A[R]=!0,A),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(A=>!D[A]).forEach(A=>{for(let R=0;R<v.length;R++)if(A.search(v[R])!==-1){delete C[A];break}})}e.sanitizeProcessEnvironment=p}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var _=e();for(var t in _)(typeof exports=="object"?exports:J)[t]=_[t]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function _(t){if(e[t])return e[t].exports;var p=e[t]={i:t,l:!1,exports:{}};return J[t].call(p.exports,p,p.exports,_),p.l=!0,p.exports}return _.m=J,_.c=e,_.d=function(t,p,C){_.o(t,p)||Object.defineProperty(t,p,{enumerable:!0,get:C})},_.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},_.t=function(t,p){if(1&p&&(t=_(t)),8&p||4&p&&typeof t=="object"&&t&&t.__esModule)return t;var C=Object.create(null);if(_.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:t}),2&p&&typeof t!="string")for(var k in t)_.d(C,k,function(D){return t[D]}.bind(null,k));return C},_.n=function(t){var p=t&&t.__esModule?function(){return t.default}:function(){return t};return _.d(p,"a",p),p},_.o=function(t,p){return Object.prototype.hasOwnProperty.call(t,p)},_.p="",_(_.s=0)}([function(J,e,_){(function(t){var p;e=J.exports=z,p=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],v=e.src=[],I=0,A=I++;v[A]="0|[1-9]\\d*";var R=I++;v[R]="[0-9]+";var g=I++;v[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=I++;v[S]="("+v[A]+")\\.("+v[A]+")\\.("+v[A]+")";var c=I++;v[c]="("+v[R]+")\\.("+v[R]+")\\.("+v[R]+")";var h=I++;v[h]="(?:"+v[A]+"|"+v[g]+")";var m=I++;v[m]="(?:"+v[R]+"|"+v[g]+")";var y=I++;v[y]="(?:-("+v[h]+"(?:\\."+v[h]+")*))";var b=I++;v[b]="(?:-?("+v[m]+"(?:\\."+v[m]+")*))";var f=I++;v[f]="[0-9A-Za-z-]+";var E=I++;v[E]="(?:\\+("+v[f]+"(?:\\."+v[f]+")*))";var u=I++,o="v?"+v[S]+v[y]+"?"+v[E]+"?";v[u]="^"+o+"$";var l="[v=\\s]*"+v[c]+v[b]+"?"+v[E]+"?",s=I++;v[s]="^"+l+"$";var n=I++;v[n]="((?:<|>)?=?)";var r=I++;v[r]=v[R]+"|x|X|\\*";var i=I++;v[i]=v[A]+"|x|X|\\*";var a=I++;v[a]="[v=\\s]*("+v[i]+")(?:\\.("+v[i]+")(?:\\.("+v[i]+")(?:"+v[y]+")?"+v[E]+"?)?)?";var d=I++;v[d]="[v=\\s]*("+v[r]+")(?:\\.("+v[r]+")(?:\\.("+v[r]+")(?:"+v[b]+")?"+v[E]+"?)?)?";var w=I++;v[w]="^"+v[n]+"\\s*"+v[a]+"$";var P=I++;v[P]="^"+v[n]+"\\s*"+v[d]+"$";var O=I++;v[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=I++;v[$]="(?:~>?)";var L=I++;v[L]="(\\s*)"+v[$]+"\\s+",D[L]=new RegExp(v[L],"g");var T=I++;v[T]="^"+v[$]+v[a]+"$";var U=I++;v[U]="^"+v[$]+v[d]+"$";var N=I++;v[N]="(?:\\^)";var W=I++;v[W]="(\\s*)"+v[N]+"\\s+",D[W]=new RegExp(v[W],"g");var ie=I++;v[ie]="^"+v[N]+v[a]+"$";var j=I++;v[j]="^"+v[N]+v[d]+"$";var re=I++;v[re]="^"+v[n]+"\\s*("+l+")$|^$";var x=I++;v[x]="^"+v[n]+"\\s*("+o+")$|^$";var K=I++;v[K]="(\\s*)"+v[n]+"\\s*("+l+"|"+v[a]+")",D[K]=new RegExp(v[K],"g");var te=I++;v[te]="^\\s*("+v[a]+")\\s+-\\s+("+v[a]+")\\s*$";var ce=I++;v[ce]="^\\s*("+v[d]+")\\s+-\\s+("+v[d]+")\\s*$";var oe=I++;v[oe]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)p(me,v[me]),D[me]||(D[me]=new RegExp(v[me]));function Y(ae,ge){if(ae instanceof z)return ae;if(typeof ae!="string"||ae.length>C||!(ge?D[s]:D[u]).test(ae))return null;try{return new z(ae,ge)}catch{return null}}function z(ae,ge){if(ae instanceof z){if(ae.loose===ge)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof z))return new z(ae,ge);p("SemVer",ae,ge),this.loose=ge;var de=ae.trim().match(ge?D[s]:D[u]);if(!de)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Te){if(/^[0-9]+$/.test(Te)){var Me=+Te;if(Me>=0&&Me<k)return Me}return Te}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=Y,e.valid=function(ae,ge){var de=Y(ae,ge);return de?de.version:null},e.clean=function(ae,ge){var de=Y(ae.trim().replace(/^[=v]+/,""),ge);return de?de.version:null},e.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(ae){return p("SemVer.compare",this.version,this.loose,ae),ae instanceof z||(ae=new z(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},z.prototype.compareMain=function(ae){return ae instanceof z||(ae=new z(ae,this.loose)),q(this.major,ae.major)||q(this.minor,ae.minor)||q(this.patch,ae.patch)},z.prototype.comparePre=function(ae){if(ae instanceof z||(ae=new z(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ge=0;do{var de=this.prerelease[ge],Te=ae.prerelease[ge];if(p("prerelease compare",ge,de,Te),de===void 0&&Te===void 0)return 0;if(Te===void 0)return 1;if(de===void 0)return-1;if(de!==Te)return q(de,Te)}while(++ge)},z.prototype.inc=function(ae,ge){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ge,de,Te){typeof de=="string"&&(Te=de,de=void 0);try{return new z(ae,de).inc(ge,Te).version}catch{return null}},e.diff=function(ae,ge){if(se(ae,ge))return null;var de=Y(ae),Te=Y(ge);if(de.prerelease.length||Te.prerelease.length){for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Te[Me])return"pre"+Me;return"prerelease"}for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Te[Me])return Me},e.compareIdentifiers=q;var H=/^[0-9]+$/;function q(ae,ge){var de=H.test(ae),Te=H.test(ge);return de&&Te&&(ae=+ae,ge=+ge),de&&!Te?-1:Te&&!de?1:ae<ge?-1:ae>ge?1:0}function ee(ae,ge,de){return new z(ae,de).compare(new z(ge,de))}function he(ae,ge,de){return ee(ae,ge,de)>0}function Ie(ae,ge,de){return ee(ae,ge,de)<0}function se(ae,ge,de){return ee(ae,ge,de)===0}function fe(ae,ge,de){return ee(ae,ge,de)!==0}function ve(ae,ge,de){return ee(ae,ge,de)>=0}function X(ae,ge,de){return ee(ae,ge,de)<=0}function B(ae,ge,de,Te){var Me;switch(ge){case"===":typeof ae=="object"&&(ae=ae.version),typeof de=="object"&&(de=de.version),Me=ae===de;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof de=="object"&&(de=de.version),Me=ae!==de;break;case"":case"=":case"==":Me=se(ae,de,Te);break;case"!=":Me=fe(ae,de,Te);break;case">":Me=he(ae,de,Te);break;case">=":Me=ve(ae,de,Te);break;case"<":Me=Ie(ae,de,Te);break;case"<=":Me=X(ae,de,Te);break;default:throw new TypeError("Invalid operator: "+ge)}return Me}function V(ae,ge){if(ae instanceof V){if(ae.loose===ge)return ae;ae=ae.value}if(!(this instanceof V))return new V(ae,ge);p("comparator",ae,ge),this.loose=ge,this.parse(ae),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,p("comp",this)}e.rcompareIdentifiers=function(ae,ge){return q(ge,ae)},e.major=function(ae,ge){return new z(ae,ge).major},e.minor=function(ae,ge){return new z(ae,ge).minor},e.patch=function(ae,ge){return new z(ae,ge).patch},e.compare=ee,e.compareLoose=function(ae,ge){return ee(ae,ge,!0)},e.rcompare=function(ae,ge,de){return ee(ge,ae,de)},e.sort=function(ae,ge){return ae.sort(function(de,Te){return e.compare(de,Te,ge)})},e.rsort=function(ae,ge){return ae.sort(function(de,Te){return e.rcompare(de,Te,ge)})},e.gt=he,e.lt=Ie,e.eq=se,e.neq=fe,e.gte=ve,e.lte=X,e.cmp=B,e.Comparator=V;var Q={};function ue(ae,ge){if(ae instanceof ue)return ae.loose===ge?ae:new ue(ae.raw,ge);if(ae instanceof V)return new ue(ae.value,ge);if(!(this instanceof ue))return new ue(ae,ge);if(this.loose=ge,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Pe(ae,ge,de,Te,Me,He,Be,je,qe,ne,be,ke,Le){return((ge=pe(de)?"":pe(Te)?">="+de+".0.0":pe(Me)?">="+de+"."+Te+".0":">="+ge)+" "+(je=pe(qe)?"":pe(ne)?"<"+(+qe+1)+".0.0":pe(be)?"<"+qe+"."+(+ne+1)+".0":ke?"<="+qe+"."+ne+"."+be+"-"+ke:"<="+je)).trim()}function Re(ae,ge){for(var de=0;de<ae.length;de++)if(!ae[de].test(ge))return!1;if(ge.prerelease.length){for(de=0;de<ae.length;de++)if(p(ae[de].semver),ae[de].semver!==Q&&ae[de].semver.prerelease.length>0){var Te=ae[de].semver;if(Te.major===ge.major&&Te.minor===ge.minor&&Te.patch===ge.patch)return!0}return!1}return!0}function Fe(ae,ge,de){try{ge=new ue(ge,de)}catch{return!1}return ge.test(ae)}function Ue(ae,ge,de,Te){var Me,He,Be,je,qe;switch(ae=new z(ae,Te),ge=new ue(ge,Te),de){case">":Me=he,He=X,Be=Ie,je=">",qe=">=";break;case"<":Me=Ie,He=ve,Be=he,je="<",qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(ae,ge,Te))return!1;for(var ne=0;ne<ge.set.length;++ne){var be=ge.set[ne],ke=null,Le=null;if(be.forEach(function(Ne){Ne.semver===Q&&(Ne=new V(">=0.0.0")),ke=ke||Ne,Le=Le||Ne,Me(Ne.semver,ke.semver,Te)?ke=Ne:Be(Ne.semver,Le.semver,Te)&&(Le=Ne)}),ke.operator===je||ke.operator===qe||(!Le.operator||Le.operator===je)&&He(ae,Le.semver)||Le.operator===qe&&Be(ae,Le.semver))return!1}return!0}V.prototype.parse=function(ae){var ge=this.loose?D[re]:D[x],de=ae.match(ge);if(!de)throw new TypeError("Invalid comparator: "+ae);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new z(de[2],this.loose):this.semver=Q},V.prototype.toString=function(){return this.value},V.prototype.test=function(ae){return p("Comparator.test",ae,this.loose),this.semver===Q||(typeof ae=="string"&&(ae=new z(ae,this.loose)),B(ae,this.operator,this.semver,this.loose))},V.prototype.intersects=function(ae,ge){if(!(ae instanceof V))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new ue(ae.value,ge),Fe(this.value,de,ge);if(ae.operator==="")return de=new ue(this.value,ge),Fe(ae.semver,de,ge);var Te=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),He=this.semver.version===ae.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),je=B(this.semver,"<",ae.semver,ge)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),qe=B(this.semver,">",ae.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Te||Me||He&&Be||je||qe},e.Range=ue,ue.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},ue.prototype.toString=function(){return this.range},ue.prototype.parseRange=function(ae){var ge=this.loose;ae=ae.trim(),p("range",ae,ge);var de=ge?D[ce]:D[te];ae=ae.replace(de,Pe),p("hyphen replace",ae),ae=ae.replace(D[K],"$1$2$3"),p("comparator trim",ae,D[K]),ae=(ae=(ae=ae.replace(D[L],"$1~")).replace(D[W],"$1^")).split(/\s+/).join(" ");var Te=ge?D[re]:D[x],Me=ae.split(" ").map(function(He){return function(Be,je){return p("comp",Be),Be=function(qe,ne){return qe.trim().split(/\s+/).map(function(be){return function(ke,Le){p("caret",ke,Le);var Ne=Le?D[j]:D[ie];return ke.replace(Ne,function(Qe,$e,Ve,Ye,xe){var Ze;return p("caret",ke,Qe,$e,Ve,Ye,xe),pe($e)?Ze="":pe(Ve)?Ze=">="+$e+".0.0 <"+(+$e+1)+".0.0":pe(Ye)?Ze=$e==="0"?">="+$e+"."+Ve+".0 <"+$e+"."+(+Ve+1)+".0":">="+$e+"."+Ve+".0 <"+(+$e+1)+".0.0":xe?(p("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=$e==="0"?Ve==="0"?">="+$e+"."+Ve+"."+Ye+xe+" <"+$e+"."+Ve+"."+(+Ye+1):">="+$e+"."+Ve+"."+Ye+xe+" <"+$e+"."+(+Ve+1)+".0":">="+$e+"."+Ve+"."+Ye+xe+" <"+(+$e+1)+".0.0"):(p("no pr"),Ze=$e==="0"?Ve==="0"?">="+$e+"."+Ve+"."+Ye+" <"+$e+"."+Ve+"."+(+Ye+1):">="+$e+"."+Ve+"."+Ye+" <"+$e+"."+(+Ve+1)+".0":">="+$e+"."+Ve+"."+Ye+" <"+(+$e+1)+".0.0"),p("caret return",Ze),Ze})}(be,ne)}).join(" ")}(Be,je),p("caret",Be),Be=function(qe,ne){return qe.trim().split(/\s+/).map(function(be){return function(ke,Le){var Ne=Le?D[U]:D[T];return ke.replace(Ne,function(Qe,$e,Ve,Ye,xe){var Ze;return p("tilde",ke,Qe,$e,Ve,Ye,xe),pe($e)?Ze="":pe(Ve)?Ze=">="+$e+".0.0 <"+(+$e+1)+".0.0":pe(Ye)?Ze=">="+$e+"."+Ve+".0 <"+$e+"."+(+Ve+1)+".0":xe?(p("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+$e+"."+Ve+"."+Ye+xe+" <"+$e+"."+(+Ve+1)+".0"):Ze=">="+$e+"."+Ve+"."+Ye+" <"+$e+"."+(+Ve+1)+".0",p("tilde return",Ze),Ze})}(be,ne)}).join(" ")}(Be,je),p("tildes",Be),Be=function(qe,ne){return p("replaceXRanges",qe,ne),qe.split(/\s+/).map(function(be){return function(ke,Le){ke=ke.trim();var Ne=Le?D[P]:D[w];return ke.replace(Ne,function(Qe,$e,Ve,Ye,xe,Ze){p("xRange",ke,Qe,$e,Ve,Ye,xe,Ze);var et=pe(Ve),rt=et||pe(Ye),nt=rt||pe(xe);return $e==="="&&nt&&($e=""),et?Qe=$e===">"||$e==="<"?"<0.0.0":"*":$e&&nt?(rt&&(Ye=0),nt&&(xe=0),$e===">"?($e=">=",rt?(Ve=+Ve+1,Ye=0,xe=0):nt&&(Ye=+Ye+1,xe=0)):$e==="<="&&($e="<",rt?Ve=+Ve+1:Ye=+Ye+1),Qe=$e+Ve+"."+Ye+"."+xe):rt?Qe=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":nt&&(Qe=">="+Ve+"."+Ye+".0 <"+Ve+"."+(+Ye+1)+".0"),p("xRange return",Qe),Qe})}(be,ne)}).join(" ")}(Be,je),p("xrange",Be),Be=function(qe,ne){return p("replaceStars",qe,ne),qe.trim().replace(D[oe],"")}(Be,je),p("stars",Be),Be}(He,ge)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(He){return!!He.match(Te)})),Me=Me.map(function(He){return new V(He,ge)})},ue.prototype.intersects=function(ae,ge){if(!(ae instanceof ue))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Te){return ae.set.some(function(Me){return Me.every(function(He){return Te.intersects(He,ge)})})})})},e.toComparators=function(ae,ge){return new ue(ae,ge).set.map(function(de){return de.map(function(Te){return Te.value}).join(" ").trim().split(" ")})},ue.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new z(ae,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Re(this.set[ge],ae))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(ae,ge,de){var Te=null,Me=null;try{var He=new ue(ge,de)}catch{return null}return ae.forEach(function(Be){He.test(Be)&&(Te&&Me.compare(Be)!==-1||(Me=new z(Te=Be,de)))}),Te},e.minSatisfying=function(ae,ge,de){var Te=null,Me=null;try{var He=new ue(ge,de)}catch{return null}return ae.forEach(function(Be){He.test(Be)&&(Te&&Me.compare(Be)!==1||(Me=new z(Te=Be,de)))}),Te},e.validRange=function(ae,ge){try{return new ue(ae,ge).range||"*"}catch{return null}},e.ltr=function(ae,ge,de){return Ue(ae,ge,"<",de)},e.gtr=function(ae,ge,de){return Ue(ae,ge,">",de)},e.outside=Ue,e.prerelease=function(ae,ge){var de=Y(ae,ge);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ae,ge,de){return ae=new ue(ae,de),ge=new ue(ge,de),ae.intersects(ge)},e.coerce=function(ae){if(ae instanceof z)return ae;if(typeof ae!="string")return null;var ge=ae.match(D[O]);return ge==null?null:Y((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,_(1))},function(J,e){var _,t,p=J.exports={};function C(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function D(m){if(_===setTimeout)return setTimeout(m,0);if((_===C||!_)&&setTimeout)return _=setTimeout,setTimeout(m,0);try{return _(m,0)}catch{try{return _.call(null,m,0)}catch{return _.call(this,m,0)}}}(function(){try{_=typeof setTimeout=="function"?setTimeout:C}catch{_=C}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var v,I=[],A=!1,R=-1;function g(){A&&v&&(A=!1,v.length?I=v.concat(I):R=-1,I.length&&S())}function S(){if(!A){var m=D(g);A=!0;for(var y=I.length;y;){for(v=I,I=[];++R<y;)v&&v[R].run();R=-1,y=I.length}v=null,A=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(m)}}function c(m,y){this.fun=m,this.array=y}function h(){}p.nextTick=function(m){var y=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)y[b-1]=arguments[b];I.push(new c(m,y)),I.length!==1||A||D(S)},c.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=h,p.addListener=h,p.once=h,p.off=h,p.removeListener=h,p.removeAllListeners=h,p.emit=h,p.prependListener=h,p.prependOnceListener=h,p.listeners=function(m){return[]},p.binding=function(m){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(m){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}}])}),define(we[121],ye([0,1]),function(J,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(D,v,I){this.level=D,this.key=v,this.value=I,this.forward=[]}}const p=void 0;class C{constructor(D,v=2**16){this.comparator=D,this[_]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(v)|0),this._header=new t(this._maxLevel,p,p)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,p,p)}has(D){return Boolean(C._search(this,D,this.comparator))}get(D){return C._search(this,D,this.comparator)?.value}set(D,v){return C._insert(this,D,v,this.comparator)&&(this._size+=1),this}delete(D){const v=C._delete(this,D,this.comparator);return v&&(this._size-=1),v}forEach(D,v){let I=this._header.forward[0];for(;I;)D.call(v,I.value,I.key,this),I=I.forward[0]}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",v=this._header.forward[0];for(;v;)D+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return D}static _search(D,v,I){let A=D._header;for(let R=D._level-1;R>=0;R--)for(;A.forward[R]&&I(A.forward[R].key,v)<0;)A=A.forward[R];if(A=A.forward[0],A&&I(A.key,v)===0)return A}static _insert(D,v,I,A){let R=[],g=D._header;for(let S=D._level-1;S>=0;S--){for(;g.forward[S]&&A(g.forward[S].key,v)<0;)g=g.forward[S];R[S]=g}if(g=g.forward[0],g&&A(g.key,v)===0)return g.value=I,!1;{let S=C._randomLevel(D);if(S>D._level){for(let c=D._level;c<S;c++)R[c]=D._header;D._level=S}g=new t(S,v,I);for(let c=0;c<S;c++)g.forward[c]=R[c].forward[c],R[c].forward[c]=g;return!0}}static _randomLevel(D,v=.5){let I=1;for(;Math.random()<v&&I<D._maxLevel;)I+=1;return I}static _delete(D,v,I){let A=[],R=D._header;for(let g=D._level-1;g>=0;g--){for(;R.forward[g]&&I(R.forward[g].key,v)<0;)R=R.forward[g];A[g]=R}if(R=R.forward[0],!R||I(R.key,v)!==0)return!1;for(let g=0;g<D._level&&A[g].forward[g]===R;g++)A[g].forward[g]=R.forward[g];for(;D._level>0&&D._header.forward[D._level-1]===p;)D._level-=1;return!0}}e.SkipList=C}),define(we[122],ye([0,1,3]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=_.globals.performance&&typeof _.globals.performance.now=="function";class p{constructor(k){this._highResolution=t&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new p(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=p}),define(we[7],ye([0,1,11,72,2,119,122]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let D=!1,v=!1;var I;(function(s){s.None=()=>p.Disposable.None;function n(ce){if(v){const{onListenerDidAdd:oe}=ce,me=c.create();let Y=0;ce.onListenerDidAdd=()=>{++Y==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),oe?.()}}}function r(ce){return(oe,me=null,Y)=>{let z=!1,H;return H=ce(q=>{if(!z)return H?H.dispose():z=!0,oe.call(me,q)},null,Y),z&&H.dispose(),H}}s.once=r;function i(ce,oe,me){return $((Y,z=null,H)=>ce(q=>Y.call(z,oe(q)),null,H),me)}s.map=i;function a(ce,oe,me){return $((Y,z=null,H)=>ce(q=>{oe(q),Y.call(z,q)},null,H),me)}s.forEach=a;function d(ce,oe,me){return $((Y,z=null,H)=>ce(q=>oe(q)&&Y.call(z,q),null,H),me)}s.filter=d;function w(ce){return ce}s.signal=w;function P(...ce){return(oe,me=null,Y)=>(0,p.combinedDisposable)(...ce.map(z=>z(H=>oe.call(me,H),null,Y)))}s.any=P;function O(ce,oe,me,Y){let z=me;return i(ce,H=>(z=oe(z,H),z),Y)}s.reduce=O;function $(ce,oe){let me;const Y={onFirstListenerAdd(){me=ce(z.fire,z)},onLastListenerRemove(){me.dispose()}};oe||n(Y);const z=new m(Y);return oe&&oe.add(z),z.event}function L(ce,oe,me=100,Y=!1,z,H){let q,ee,he,Ie=0;const se={leakWarningThreshold:z,onFirstListenerAdd(){q=ce(ve=>{Ie++,ee=oe(ee,ve),Y&&!he&&(fe.fire(ee),ee=void 0),clearTimeout(he),he=setTimeout(()=>{const X=ee;ee=void 0,he=void 0,(!Y||Ie>1)&&fe.fire(X),Ie=0},me)})},onLastListenerRemove(){q.dispose()}};H||n(se);const fe=new m(se);return H&&H.add(fe),fe.event}s.debounce=L;function T(ce,oe=(Y,z)=>Y===z,me){let Y=!0,z;return d(ce,H=>{const q=Y||!oe(H,z);return Y=!1,z=H,q},me)}s.latch=T;function U(ce,oe,me){return[s.filter(ce,oe,me),s.filter(ce,Y=>!oe(Y),me)]}s.split=U;function N(ce,oe=!1,me=[]){let Y=me.slice(),z=ce(ee=>{Y?Y.push(ee):q.fire(ee)});const H=()=>{Y&&Y.forEach(ee=>q.fire(ee)),Y=null},q=new m({onFirstListenerAdd(){z||(z=ce(ee=>q.fire(ee)))},onFirstListenerDidAdd(){Y&&(oe?setTimeout(H):H())},onLastListenerRemove(){z&&z.dispose(),z=null}});return q.event}s.buffer=N;class W{constructor(oe){this.event=oe}map(oe){return new W(i(this.event,oe))}forEach(oe){return new W(a(this.event,oe))}filter(oe){return new W(d(this.event,oe))}reduce(oe,me){return new W(O(this.event,oe,me))}latch(){return new W(T(this.event))}debounce(oe,me=100,Y=!1,z){return new W(L(this.event,oe,me,Y,z))}on(oe,me,Y){return this.event(oe,me,Y)}once(oe,me,Y){return r(this.event)(oe,me,Y)}}function ie(ce){return new W(ce)}s.chain=ie;function j(ce,oe,me=Y=>Y){const Y=(...ee)=>q.fire(me(...ee)),z=()=>ce.on(oe,Y),H=()=>ce.removeListener(oe,Y),q=new m({onFirstListenerAdd:z,onLastListenerRemove:H});return q.event}s.fromNodeEventEmitter=j;function re(ce,oe,me=Y=>Y){const Y=(...ee)=>q.fire(me(...ee)),z=()=>ce.addEventListener(oe,Y),H=()=>ce.removeEventListener(oe,Y),q=new m({onFirstListenerAdd:z,onLastListenerRemove:H});return q.event}s.fromDOMEventEmitter=re;function x(ce){return new Promise(oe=>r(ce)(oe))}s.toPromise=x;function K(ce,oe){return oe(void 0),ce(me=>oe(me))}s.runAndSubscribe=K;function te(ce,oe){let me=null;function Y(H){me?.dispose(),me=new p.DisposableStore,oe(H,me)}Y(void 0);const z=ce(H=>Y(H));return(0,p.toDisposable)(()=>{z.dispose(),me?.dispose()})}s.runAndSubscribeWithStore=te})(I=e.Event||(e.Event={}));class A{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${A._idPool++}`}start(n){this._stopWatch=new k.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}A._idPool=0;let R=-1;function g(s){const n=R;return R=s,{dispose(){R=n}}}e.setGlobalLeakWarningThreshold=g;class S{constructor(n,r=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,r){let i=R;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||r<i)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let d,w=0;for(const[P,O]of this._stacks)(!d||w<O)&&(d=P,w=O);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${w}):`),console.warn(d)}return()=>{const d=this._stacks.get(n.value)||0;this._stacks.set(n.value,d-1)}}}class c{constructor(n){this.value=n}static create(){return new c(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(n,r,i){this.callback=n,this.callbackThis=r,this.stack=i,this.subscription=new p.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class m{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=R>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,r,i)=>{this._listeners||(this._listeners=new C.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let d,w;this._leakageMon&&this._listeners.size>=30&&(w=c.create(),d=this._leakageMon.check(w,this._listeners.size+1)),D&&(w=w??c.create());const P=new h(n,r,w),O=this._listeners.push(P);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,r);const $=P.subscription.set(()=>{d&&d(),this._disposed||(O(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof p.DisposableStore?i.add($):Array.isArray(i)&&i.push($),$}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,n]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,i]=this._deliveryQueue.shift();try{r.invoke(i)}catch(a){(0,_.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=m;class y extends m{async fireAsync(n,r,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,n]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[a,d]=this._asyncDeliveryQueue.shift(),w=[],P={...d,token:r,waitUntil:O=>{if(Object.isFrozen(w))throw new Error("waitUntil can NOT be called asynchronous");i&&(O=i(O,a.callback)),w.push(O)}};try{a.invoke(P)}catch(O){(0,_.onUnexpectedError)(O);continue}Object.freeze(w),await Promise.allSettled(w).then(O=>{for(const $ of O)$.status==="rejected"&&(0,_.onUnexpectedError)($.reason)})}}}}e.AsyncEmitter=y;class b extends m{constructor(n){super(n);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=b;class f extends b{constructor(n){super(n);this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=f;class E extends m{constructor(n){super(n);this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const r={event:n,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const i=()=>{this.hasListeners&&this.unhook(r);const a=this.events.indexOf(r);this.events.splice(a,1)};return(0,p.toDisposable)((0,t.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(r=>this.emitter.fire(r))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class o{constructor(){this.buffers=[]}wrapEvent(n){return(r,i,a)=>n(d=>{const w=this.buffers[this.buffers.length-1];w?w.push(()=>r.call(i,d)):r.call(i,d)},void 0,a)}bufferEvents(n){const r=[];this.buffers.push(r);const i=n();return this.buffers.pop(),r.forEach(a=>a()),i}}e.EventBufferer=o;class l{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=p.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(we[20],ye([0,1,7]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(D,v){const I=setTimeout(D.bind(v),0);return{dispose(){clearTimeout(I)}}});var p;(function(D){function v(I){return I===D.None||I===D.Cancelled||I instanceof C?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}D.isCancellationToken=v,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(p=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=p.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=p.None}}e.CancellationTokenSource=k}),define(we[123],ye([0,1,20]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new _.CancellationTokenSource,D=this.task(k.token);return this.result={promise:D,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=t;class p{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const D=JSON.stringify(k);return this.lastArgKey!==D&&(this.lastArgKey=D,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=p}),define(we[42],ye([0,1,11,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function p(f){const E=f;return E?[E.on,E.pause,E.resume,E.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=p;function C(f){const E=f;return E?p(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(f,E){return new D(f,E)}e.newWriteableStream=k;class D{constructor(E,u){this.reducer=E,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E!="undefined"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(u=>u(E))}emitError(E){this.listeners.error.length===0?(0,_.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(u=>u(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,u){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(E,u){if(this.state.destroyed)return;let o;switch(E){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const l=o.indexOf(u);l>=0&&o.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(f,E){const u=[];let o;for(;(o=f.read())!==null;)u.push(o);return E(u)}e.consumeReadable=v;function I(f,E,u){const o=[];let l;for(;(l=f.read())!==null&&o.length<u;)o.push(l);return l===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return f.read()}}}e.peekReadable=I;function A(f,E){return new Promise((u,o)=>{const l=[];R(f,{onData:s=>{E&&l.push(s)},onError:s=>{E?o(s):u(void 0)},onEnd:()=>{u(E?E(l):void 0)}})})}e.consumeStream=A;function R(f,E){let u=!1;return f.on("error",o=>{u||E.onError(o)}),f.on("end",()=>{u||E.onEnd()}),f.on("data",o=>{u||E.onData(o)}),(0,t.toDisposable)(()=>u=!0)}e.listenStream=R;function g(f,E){return new Promise((u,o)=>{const l=new t.DisposableStore,s=[],n=a=>{if(s.push(a),s.length>E)return l.dispose(),f.pause(),u({stream:f,buffer:s,ended:!1})},r=a=>o(a),i=()=>u({stream:f,buffer:s,ended:!0});l.add((0,t.toDisposable)(()=>f.removeListener("error",r))),f.on("error",r),l.add((0,t.toDisposable)(()=>f.removeListener("end",i))),f.on("end",i),l.add((0,t.toDisposable)(()=>f.removeListener("data",n))),f.on("data",n)})}e.peekStream=g;function S(f,E){const u=k(E);return u.end(f),u}e.toStream=S;function c(){const f=k(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=c;function h(f){let E=!1;return{read:()=>E?null:(E=!0,f)}}e.toReadable=h;function m(f,E,u){const o=k(u);return R(f,{onData:l=>o.write(E.data(l)),onError:l=>o.error(E.error?E.error(l):l),onEnd:()=>o.end()}),o}e.transform=m;function y(f,E,u){let o=!1;return{read:()=>{const l=E.read();return o?l:(o=!0,l!==null?u([f,l]):f)}}}e.prefixedReadable=y;function b(f,E,u){let o=!1;const l=k(u);return R(E,{onData:s=>o?l.write(s):(o=!0,l.write(u([f,s]))),onError:s=>l.error(s),onEnd:()=>{o||(o=!0,l.write(f)),l.end()}}),l}e.prefixedStream=b}),define(we[15],ye([0,1,42]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let p,C;class k{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new k(Buffer.allocUnsafe(d)):new k(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new k(d)}static fromString(d,w){return!(w?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(d)):(p||(p=new TextEncoder),new k(p.encode(d)))}static fromByteArray(d){const w=k.alloc(d.length);for(let P=0,O=d.length;P<O;P++)w.buffer[P]=d[P];return w}static concat(d,w){if(typeof w=="undefined"){w=0;for(let $=0,L=d.length;$<L;$++)w+=d[$].byteLength}const P=k.alloc(w);let O=0;for(let $=0,L=d.length;$<L;$++){const T=d[$];P.set(T,O),O+=T.byteLength}return P}clone(){const d=k.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(d,w){return new k(this.buffer.subarray(d,w))}set(d,w){if(d instanceof k)this.buffer.set(d.buffer,w);else if(d instanceof Uint8Array)this.buffer.set(d,w);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),w);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return I(this.buffer,d)}writeUInt32BE(d,w){A(this.buffer,d,w)}readUInt32LE(d){return R(this.buffer,d)}writeUInt32LE(d,w){g(this.buffer,d,w)}readUInt8(d){return S(this.buffer,d)}writeUInt8(d,w){c(this.buffer,d,w)}}e.VSBuffer=k;function D(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0}e.readUInt16LE=D;function v(a,d,w){a[w+0]=d&255,d=d>>>8,a[w+1]=d&255}e.writeUInt16LE=v;function I(a,d){return a[d]*2**24+a[d+1]*2**16+a[d+2]*2**8+a[d+3]}e.readUInt32BE=I;function A(a,d,w){a[w+3]=d,d=d>>>8,a[w+2]=d,d=d>>>8,a[w+1]=d,d=d>>>8,a[w]=d}e.writeUInt32BE=A;function R(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0|a[d+2]<<16>>>0|a[d+3]<<24>>>0}e.readUInt32LE=R;function g(a,d,w){a[w+0]=d&255,d=d>>>8,a[w+1]=d&255,d=d>>>8,a[w+2]=d&255,d=d>>>8,a[w+3]=d&255}e.writeUInt32LE=g;function S(a,d){return a[d]}e.readUInt8=S;function c(a,d,w){a[w]=d}e.writeUInt8=c;function h(a){return _.consumeReadable(a,d=>k.concat(d))}e.readableToBuffer=h;function m(a){return _.toReadable(a)}e.bufferToReadable=m;function y(a){return _.consumeStream(a,d=>k.concat(d))}e.streamToBuffer=y;async function b(a){return a.ended?k.concat(a.buffer):k.concat([...a.buffer,await y(a.stream)])}e.bufferedStreamToBuffer=b;function f(a){return _.toStream(a,d=>k.concat(d))}e.bufferToStream=f;function E(a){return _.transform(a,{data:d=>typeof d=="string"?k.fromString(d):k.wrap(d)},d=>k.concat(d))}e.streamToBufferReadableStream=E;function u(a){return _.newWriteableStream(d=>k.concat(d),a)}e.newWriteableBufferStream=u;function o(a,d){return _.prefixedReadable(a,d,w=>k.concat(w))}e.prefixedBufferReadable=o;function l(a,d){return _.prefixedStream(a,d,w=>k.concat(w))}e.prefixedBufferStream=l;function s(a){let d=0,w=0,P=0;const O=new Uint8Array(Math.floor(a.length/4*3)),$=T=>{switch(w){case 3:O[P++]=d|T,w=0;break;case 2:O[P++]=d|T>>>2,d=T<<6,w=3;break;case 1:O[P++]=d|T>>>4,d=T<<4,w=2;break;default:d=T<<2,w=1}};for(let T=0;T<a.length;T++){const U=a.charCodeAt(T);if(U>=65&&U<=90)$(U-65);else if(U>=97&&U<=122)$(U-97+26);else if(U>=48&&U<=57)$(U-48+52);else if(U===43||U===45)$(62);else if(U===47||U===95)$(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${a[T]}`)}}const L=P;for(;w>0;)$(0);return k.wrap(O).slice(0,L)}e.decodeBase64=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function i({buffer:a},d=!0,w=!1){const P=w?r:n;let O="";const $=a.byteLength%3;let L=0;for(;L<a.byteLength-$;L+=3){const T=a[L+0],U=a[L+1],N=a[L+2];O+=P[T>>>2],O+=P[(T<<4|U>>>4)&63],O+=P[(U<<2|N>>>6)&63],O+=P[N&63]}if($===1){const T=a[L+0];O+=P[T>>>2],O+=P[T<<4&63],d&&(O+="==")}else if($===2){const T=a[L+0],U=a[L+1];O+=P[T>>>2],O+=P[(T<<4|U>>>4)&63],O+=P[U<<2&63],d&&(O+="=")}return O}e.encodeBase64=i}),define(we[16],ye([0,1,123,118]),function(J,e,_,t){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=C;const k=/{(\d+)}/g;function D(ne,...be){return be.length===0?ne:ne.replace(k,function(ke,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=be.length?ke:be[Ne]})}e.format=D;const v=/{([^}]+)}/g;function I(ne,be){return ne.replace(v,(ke,Le)=>be[Le]??ke)}e.format2=I;function A(ne){return ne.replace(/[<>&]/g,function(be){switch(be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return be}})}e.escape=A;function R(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function g(ne,be){let ke=0;const Le=be.charCodeAt(0);for(let Ne=ne.length-1;Ne>=0;Ne--)ne.charCodeAt(Ne)===Le&&ke++;return ke}e.count=g;function S(ne,be,ke="\u2026"){return ne.length<=be?ne:`${ne.substr(0,be)}${ke}`}e.truncate=S;function c(ne,be=" "){const ke=h(ne,be);return m(ke,be)}e.trim=c;function h(ne,be){if(!ne||!be)return ne;const ke=be.length;if(ke===0||ne.length===0)return ne;let Le=0;for(;ne.indexOf(be,Le)===Le;)Le=Le+ke;return ne.substring(Le)}e.ltrim=h;function m(ne,be){if(!ne||!be)return ne;const ke=be.length,Le=ne.length;if(ke===0||Le===0)return ne;let Ne=Le,Qe=-1;for(;Qe=ne.lastIndexOf(be,Ne-1),!(Qe===-1||Qe+ke!==Ne);){if(Qe===0)return"";Ne=Qe}return ne.substring(0,Ne)}e.rtrim=m;function y(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function b(ne){return ne.replace(/\*/g,"")}e.stripWildcards=b;function f(ne,be,ke={}){if(!ne)throw new Error("Cannot create regex from empty string");be||(ne=R(ne)),ke.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Le="";return ke.global&&(Le+="g"),ke.matchCase||(Le+="i"),ke.multiline&&(Le+="m"),ke.unicode&&(Le+="u"),new RegExp(ne,Le)}e.createRegExp=f;function E(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function u(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function o(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=o;function l(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=l;function s(ne){for(let be=0,ke=ne.length;be<ke;be++){const Le=ne.charCodeAt(be);if(Le!==32&&Le!==9)return be}return-1}e.firstNonWhitespaceIndex=s;function n(ne,be=0,ke=ne.length){for(let Le=be;Le<ke;Le++){const Ne=ne.charCodeAt(Le);if(Ne!==32&&Ne!==9)return ne.substring(be,Le)}return ne.substring(be,ke)}e.getLeadingWhitespace=n;function r(ne,be=ne.length-1){for(let ke=be;ke>=0;ke--){const Le=ne.charCodeAt(ke);if(Le!==32&&Le!==9)return ke}return-1}e.lastNonWhitespaceIndex=r;function i(ne,be){return ne<be?-1:ne>be?1:0}e.compare=i;function a(ne,be,ke=0,Le=ne.length,Ne=0,Qe=be.length){for(;ke<Le&&Ne<Qe;ke++,Ne++){let Ye=ne.charCodeAt(ke),xe=be.charCodeAt(Ne);if(Ye<xe)return-1;if(Ye>xe)return 1}const $e=Le-ke,Ve=Qe-Ne;return $e<Ve?-1:$e>Ve?1:0}e.compareSubstring=a;function d(ne,be){return w(ne,be,0,ne.length,0,be.length)}e.compareIgnoreCase=d;function w(ne,be,ke=0,Le=ne.length,Ne=0,Qe=be.length){for(;ke<Le&&Ne<Qe;ke++,Ne++){let Ye=ne.charCodeAt(ke),xe=be.charCodeAt(Ne);if(Ye===xe)continue;if(Ye>=128||xe>=128)return a(ne.toLowerCase(),be.toLowerCase(),ke,Le,Ne,Qe);P(Ye)&&(Ye-=32),P(xe)&&(xe-=32);const Ze=Ye-xe;if(Ze!==0)return Ze}const $e=Le-ke,Ve=Qe-Ne;return $e<Ve?-1:$e>Ve?1:0}e.compareSubstringIgnoreCase=w;function P(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=P;function O(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=O;function $(ne,be){return ne.length===be.length&&w(ne,be)===0}e.equalsIgnoreCase=$;function L(ne,be){const ke=be.length;return be.length>ne.length?!1:w(ne,be,0,ke)===0}e.startsWithIgnoreCase=L;function T(ne,be){let ke,Le=Math.min(ne.length,be.length);for(ke=0;ke<Le;ke++)if(ne.charCodeAt(ke)!==be.charCodeAt(ke))return ke;return Le}e.commonPrefixLength=T;function U(ne,be){let ke,Le=Math.min(ne.length,be.length);const Ne=ne.length-1,Qe=be.length-1;for(ke=0;ke<Le;ke++)if(ne.charCodeAt(Ne-ke)!==be.charCodeAt(Qe-ke))return ke;return Le}e.commonSuffixLength=U;function N(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=N;function W(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=W;function ie(ne,be){return(ne-55296<<10)+(be-56320)+65536}e.computeCodePoint=ie;function j(ne,be,ke){const Le=ne.charCodeAt(ke);if(N(Le)&&ke+1<be){const Ne=ne.charCodeAt(ke+1);if(W(Ne))return ie(Le,Ne)}return Le}e.getNextCodePoint=j;function re(ne,be){const ke=ne.charCodeAt(be-1);if(W(ke)&&be>1){const Le=ne.charCodeAt(be-2);if(N(Le))return ie(Le,ke)}return ke}class x{constructor(be,ke=0){this._str=be,this._len=be.length,this._offset=ke}get offset(){return this._offset}setOffset(be){this._offset=be}prevCodePoint(){const be=re(this._str,this._offset);return this._offset-=be>=65536?2:1,be}nextCodePoint(){const be=j(this._str,this._len,this._offset);return this._offset+=be>=65536?2:1,be}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class K{constructor(be,ke=0){this._iterator=new x(be,ke)}get offset(){return this._iterator.offset}nextGraphemeLength(){const be=ge.getInstance(),ke=this._iterator,Le=ke.offset;let Ne=be.getGraphemeBreakType(ke.nextCodePoint());for(;!ke.eol();){const Qe=ke.offset,$e=be.getGraphemeBreakType(ke.nextCodePoint());if(Ue(Ne,$e)){ke.setOffset(Qe);break}Ne=$e}return ke.offset-Le}prevGraphemeLength(){const be=ge.getInstance(),ke=this._iterator,Le=ke.offset;let Ne=be.getGraphemeBreakType(ke.prevCodePoint());for(;ke.offset>0;){const Qe=ke.offset,$e=be.getGraphemeBreakType(ke.prevCodePoint());if(Ue($e,Ne)){ke.setOffset(Qe);break}Ne=$e}return Le-ke.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function te(ne,be){return new K(ne,be).nextGraphemeLength()}e.nextCharLength=te;function ce(ne,be){return new K(ne,be).prevGraphemeLength()}e.prevCharLength=ce;function oe(ne,be){be>0&&W(ne.charCodeAt(be))&&be--;const ke=be+te(ne,be);return[ke-ce(ne,ke),ke]}e.getCharContainingOffset=oe;const me=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(ne){return me.test(ne)}e.containsRTL=Y;const z=/^[\t\n\r\x20-\x7E]*$/;function H(ne){return z.test(ne)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=q;function ee(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=ee;function he(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=he;function Ie(ne,be){if(ne.length<be)return ne;const ke=/\b/g;let Le=0;for(;ke.test(ne)&&!(ne.length-ke.lastIndex<be);)Le=ke.lastIndex,ke.lastIndex+=1;return ne.substring(Le).replace(/^\s/,"")}e.lcut=Ie;const se=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function X(ne){return ne&&(ne=ne.replace(se,""),ne=ne.replace(fe,""),ne=ne.replace(ve,"")),ne}e.removeAnsiEscapeCodes=X,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function B(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=B;function V(ne){return B(ne)?ne.substr(1):ne}e.stripUTF8BOM=V;function Q(ne,be){if(!ne||!be||ne.length<be.length)return!1;const ke=be.length,Le=ne.toLowerCase();let Ne=0,Qe=-1;for(;Ne<ke;){const $e=Le.indexOf(be[Ne],Qe+1);if($e<0)return!1;Qe=$e,Ne++}return!0}e.fuzzyContains=Q;function ue(ne,be=!1){return ne?(be&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=ue;function pe(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=pe;function Pe(ne,be=1){if(be===0)return"";let ke=-1;do ke=ne.indexOf(`
`,ke+1),be--;while(be>0&&ke>=0);return ke===-1?ne:(ne[ke-1]==="\r"&&ke--,ne.substr(0,ke))}e.getNLines=Pe;function Re(ne){const be=90-65+1;return ne=ne%(2*be),ne<be?String.fromCharCode(97+ne):String.fromCharCode(65+ne-be)}e.singleLetterHash=Re;function Fe(ne){return ge.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=Fe;function Ue(ne,be){return ne===0?be!==5&&be!==7:ne===2&&be===3?!1:ne===4||ne===2||ne===3||be===4||be===2||be===3?!0:!(ne===8&&(be===8||be===9||be===11||be===12)||(ne===11||ne===9)&&(be===9||be===10)||(ne===12||ne===10)&&be===10||be===5||be===13||be===7||ne===1||ne===13&&be===14||ne===6&&be===6)}var ae;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(ae=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ge{constructor(){this._data=de()}static getInstance(){return ge._INSTANCE||(ge._INSTANCE=new ge),ge._INSTANCE}getGraphemeBreakType(be){if(be<32)return be===10?3:be===13?2:4;if(be<127)return 0;const ke=this._data,Le=ke.length/3;let Ne=1;for(;Ne<=Le;)if(be<ke[3*Ne])Ne=2*Ne;else if(be>ke[3*Ne+1])Ne=2*Ne+1;else return ke[3*Ne+2];return 0}}ge._INSTANCE=null;function de(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(ne,be){if(ne===0)return 0;const ke=Me(ne,be);if(ke!==void 0)return ke;const Le=new x(be,ne);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=Te;function Me(ne,be){const ke=new x(be,ne);let Le=ke.prevCodePoint();for(;He(Le)||Le===65039||Le===8419;){if(ke.offset===0)return;Le=ke.prevCodePoint()}if(!he(Le))return;let Ne=ke.offset;return Ne>0&&ke.prevCodePoint()===8205&&(Ne=ke.offset),Ne}function He(ne){return 127995<=ne&&ne<=127999}var Be;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class je{constructor(be){this.confusableDictionary=be}static getInstance(be){return je.cache.get(Array.from(be))}static getLocales(){return je._locales.getValue()}isAmbiguous(be){return this.confusableDictionary.has(be)}getPrimaryConfusable(be){return this.confusableDictionary.get(be)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,p=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new _.LRUCachedComputed(ne=>{function be(xe){const Ze=new Map;for(let et=0;et<xe.length;et+=2)Ze.set(xe[et],xe[et+1]);return Ze}function ke(xe,Ze){const et=new Map(xe);for(const[rt,nt]of Ze)et.set(rt,nt);return et}function Le(xe,Ze){if(!xe)return Ze;const et=new Map;for(const[rt,nt]of xe)Ze.has(rt)&&et.set(rt,nt);return et}const Ne=p.ambiguousCharacterData.getValue();let Qe=ne.filter(xe=>!xe.startsWith("_")&&xe in Ne);Qe.length===0&&(Qe=["_default"]);let $e;for(const xe of Qe){const Ze=be(Ne[xe]);$e=Le($e,Ze)}const Ve=be(Ne._common),Ye=ke(Ve,$e);return new je(Ye)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(ne=>!ne.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(be){return qe.getData().has(be)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(we[124],ye([0,1,16]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(y){return p(y,0)}e.hash=t;function p(y,b){switch(typeof y){case"object":return y===null?C(349,b):Array.isArray(y)?v(y,b):I(y,b);case"string":return D(y,b);case"boolean":return k(y,b);case"number":return C(y,b);case"undefined":return C(937,b);default:return C(617,b)}}e.doHash=p;function C(y,b){return(b<<5)-b+y|0}e.numberHash=C;function k(y,b){return C(y?433:863,b)}function D(y,b){b=C(149417,b);for(let f=0,E=y.length;f<E;f++)b=C(y.charCodeAt(f),b);return b}e.stringHash=D;function v(y,b){return b=C(104579,b),y.reduce((f,E)=>p(E,f),b)}function I(y,b){return b=C(181387,b),Object.keys(y).sort().reduce((f,E)=>(f=D(E,f),p(y[E],f)),b)}class A{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=p(b,this._value),this._value}}e.Hasher=A;var R;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function g(y,b,f=32){const E=f-b,u=~((1<<E)-1);return(y<<b|(u&y)>>>E)>>>0}function S(y,b=0,f=y.byteLength,E=0){for(let u=0;u<f;u++)y[b+u]=E}function c(y,b,f="0"){for(;y.length<b;)y=f+y;return y}function h(y,b=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(f=>f.toString(16).padStart(2,"0")).join(""):c((y>>>0).toString(16),b/4)}e.toHexString=h;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const f=b.length;if(f===0)return;const E=this._buff;let u=this._buffLen,o=this._leftoverHighSurrogate,l,s;for(o!==0?(l=o,s=-1,o=0):(l=b.charCodeAt(0),s=0);;){let n=l;if(_.isHighSurrogate(l))if(s+1<f){const r=b.charCodeAt(s+1);_.isLowSurrogate(r)?(s++,n=_.computeCodePoint(l,r)):n=65533}else{o=l;break}else _.isLowSurrogate(l)&&(n=65533);if(u=this._push(E,u,n),s++,s<f)l=b.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=o}_push(b,f,E){return E<128?b[f++]=E:E<2048?(b[f++]=192|(E&1984)>>>6,b[f++]=128|(E&63)>>>0):E<65536?(b[f++]=224|(E&61440)>>>12,b[f++]=128|(E&4032)>>>6,b[f++]=128|(E&63)>>>0):(b[f++]=240|(E&1835008)>>>18,b[f++]=128|(E&258048)>>>12,b[f++]=128|(E&4032)>>>6,b[f++]=128|(E&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=m._bigBlock32,f=this._buffDV;for(let a=0;a<64;a+=4)b.setUint32(a,f.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)b.setUint32(a,g(b.getUint32(a-12,!1)^b.getUint32(a-32,!1)^b.getUint32(a-56,!1)^b.getUint32(a-64,!1),1),!1);let E=this._h0,u=this._h1,o=this._h2,l=this._h3,s=this._h4,n,r,i;for(let a=0;a<80;a++)a<20?(n=u&o|~u&l,r=1518500249):a<40?(n=u^o^l,r=1859775393):a<60?(n=u&o|u&l|o&l,r=2400959708):(n=u^o^l,r=3395469782),i=g(E,5)+n+s+r+b.getUint32(a*4,!1)&4294967295,s=l,l=o,o=g(u,30),u=E,E=i;this._h0=this._h0+E&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var yt=this&&this.__classPrivateFieldSet||function(J,e,_,t,p){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?p.call(J,_):p?p.value=_:e.set(J,_),_},tt=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(we[29],ye([0,1,17,16]),function(J,e,_,t){"use strict";var p,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(s,n,r){let i=s.get(n);return i===void 0&&(i=r,s.set(n,i)),i}e.getOrSet=D;function v(s){const n=[];return s.forEach((r,i)=>{n.push(`${i} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=v;function I(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=I;class A{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return r-i}value(){return this._value[this._pos]}}e.StringIterator=A;class R{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class g{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let r=n.length-1;r>=0;r--,this._valueLen--){const i=this._value.charCodeAt(r);if(!(i===47||this._splitOnBackslash&&i===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var S;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(S||(S={}));class c{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(m||(m={}));class y{constructor(n){this._iter=n}static forUris(n=()=>!1){return new y(new c(n))}static forPaths(n=!1){return new y(new g(void 0,!n))}static forStrings(){return new y(new A)}static forConfigKeys(){return new y(new R)}clear(){this._root=void 0}fill(n,r){if(r){const i=r.slice(0);(0,_.shuffle)(i);for(let a of i)this.set(a,n)}else{const i=n.slice(0);(0,_.shuffle)(i);for(let a of i)this.set(a[0],a[1])}}set(n,r){const i=this._iter.reset(n);let a;this._root||(this._root=new h,this._root.segment=i.value());const d=[];for(a=this._root;;){const P=i.cmp(a.segment);if(P>0)a.left||(a.left=new h,a.left.segment=i.value()),d.push([-1,a]),a=a.left;else if(P<0)a.right||(a.right=new h,a.right.segment=i.value()),d.push([1,a]),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new h,a.mid.segment=i.value()),d.push([0,a]),a=a.mid;else break}const w=a.value;a.value=r,a.key=n;for(let P=d.length-1;P>=0;P--){const O=d[P][1];O.updateHeight();const $=O.balanceFactor();if($<-1||$>1){const L=d[P][0],T=d[P+1][0];if(L===1&&T===1)d[P][1]=O.rotateLeft();else if(L===-1&&T===-1)d[P][1]=O.rotateRight();else if(L===1&&T===-1)O.right=d[P+1][1]=d[P+1][1].rotateRight(),d[P][1]=O.rotateLeft();else if(L===-1&&T===1)O.left=d[P+1][1]=d[P+1][1].rotateLeft(),d[P][1]=O.rotateRight();else throw new Error;if(P>0)switch(d[P-1][0]){case-1:d[P-1][1].left=d[P][1];break;case 1:d[P-1][1].right=d[P][1];break;case 0:d[P-1][1].mid=d[P][1];break}else this._root=d[0][1]}}return w}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let i=this._root;for(;i;){const a=r.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else break}return i}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const i=this._iter.reset(n),a=[];let d=this._root;for(;d;){const w=i.cmp(d.segment);if(w>0)a.push([-1,d]),d=d.left;else if(w<0)a.push([1,d]),d=d.right;else if(i.hasNext())i.next(),a.push([0,d]),d=d.mid;else break}if(!!d){if(r?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const w=this._min(d.right),{key:P,value:O,segment:$}=w;this._delete(w.key,!1),d.key=P,d.value=O,d.segment=$}else{const w=d.left??d.right;if(a.length>0){const[P,O]=a[a.length-1];switch(P){case-1:O.left=w;break;case 0:O.mid=w;break;case 1:O.right=w;break}}else this._root=w}for(let w=a.length-1;w>=0;w--){const P=a[w][1];P.updateHeight();const O=P.balanceFactor();if(O>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),a[w][1]=P.rotateLeft()):O<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),a[w][1]=P.rotateRight()),w>0)switch(a[w-1][0]){case-1:a[w-1][1].left=a[w][1];break;case 1:a[w-1][1].right=a[w][1];break;case 0:a[w-1][1].mid=a[w][1];break}else this._root=a[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const r=this._iter.reset(n);let i=this._root,a;for(;i;){const d=r.cmp(i.segment);if(d>0)i=i.left;else if(d<0)i=i.right;else if(r.hasNext())r.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(n){const r=this._iter.reset(n);let i=this._root;for(;i;){const a=r.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[r,i]of this)n(i,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=r=>{if(!r)return!0;const i=r.balanceFactor();return i<-1||i>1?!1:n(r.left)&&n(r.right)};return n(this._root)}}e.TernarySearchTree=y;class b{constructor(n,r){this.uri=n,this.value=r}}class f{constructor(n,r){this[p]="ResourceMap",n instanceof f?(this.map=new Map(n.map),this.toKey=r??f.defaultToKey):(this.map=new Map,this.toKey=n??f.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),new b(n,r)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[i,a]of this.map)n(a.value,a.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=f,f.defaultToKey=s=>s.toString();var E;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class u{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const i=this._map.get(n);if(!!i)return r!==0&&this.touch(i,r),i.value}set(n,r,i=0){let a=this._map.get(n);if(a)a.value=r,i!==0&&this.touch(a,i);else{switch(a={key:n,value:r,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const i=this._state;let a=this._head;for(;a;){if(r?n.bind(r)(a.value,a.key,this):n(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.key,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return a}values(){const n=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:i.value,done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return a}entries(){const n=this,r=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const d={value:[i.key,i.value],done:!1};return i=i.next,d}else return{value:void 0,done:!0}}};return a}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,i=this.size;for(;r&&i>n;)this._map.delete(r.key),r=r.next,i--;this._head=r,this._size=i,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,i=n.previous;if(!r||!i)throw new Error("Invalid list");r.previous=i,i.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const i=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const i=n.next,a=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,i)=>{n.push([i,r])}),n}fromJSON(n){this.clear();for(const[r,i]of n)this.set(r,i)}}e.LinkedMap=u;class o extends u{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(n){k.set(this,void 0),yt(this,k,n,"f")}get size(){return tt(this,k,"f").size}forEach(n,r){tt(this,k,"f").forEach(n,r)}get(n){return tt(this,k,"f").get(n)}has(n){return tt(this,k,"f").has(n)}entries(){return tt(this,k,"f").entries()}keys(){return tt(this,k,"f").keys()}values(){return tt(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return tt(this,k,"f").entries()}}e.ReadonlyMapView=l}),define(we[125],ye([0,1,29,16]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function p(...B){return function(V,Q){for(let ue=0,pe=B.length;ue<pe;ue++){const Pe=B[ue](V,Q);if(Pe)return Pe}return null}}e.or=p,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(B,V,Q){if(!Q||Q.length<V.length)return null;let ue;return B?ue=t.startsWithIgnoreCase(Q,V):ue=Q.indexOf(V)===0,ue?V.length>0?[{start:0,end:V.length}]:[]:null}function k(B,V){const Q=V.toLowerCase().indexOf(B.toLowerCase());return Q===-1?null:[{start:Q,end:Q+B.length}]}e.matchesContiguousSubString=k;function D(B,V){return v(B.toLowerCase(),V.toLowerCase(),0,0)}e.matchesSubString=D;function v(B,V,Q,ue){if(Q===B.length)return[];if(ue===V.length)return null;if(B[Q]===V[ue]){let pe=null;return(pe=v(B,V,Q+1,ue+1))?y({start:ue,end:ue+1},pe):null}return v(B,V,Q,ue+1)}function I(B){return 97<=B&&B<=122}function A(B){return 65<=B&&B<=90}e.isUpper=A;function R(B){return 48<=B&&B<=57}function g(B){return B===32||B===9||B===10||B===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>S.add(B.charCodeAt(0)));function c(B){return g(B)||S.has(B)}function h(B,V){return B===V||c(B)&&c(V)}function m(B){return I(B)||A(B)||R(B)}function y(B,V){return V.length===0?V=[B]:B.end===V[0].start?V[0].start=B.start:V.unshift(B),V}function b(B,V){for(let Q=V;Q<B.length;Q++){const ue=B.charCodeAt(Q);if(A(ue)||R(ue)||Q>0&&!m(B.charCodeAt(Q-1)))return Q}return B.length}function f(B,V,Q,ue){if(Q===B.length)return[];if(ue===V.length)return null;if(B[Q]!==V[ue].toLowerCase())return null;{let pe=null,Pe=ue+1;for(pe=f(B,V,Q+1,ue+1);!pe&&(Pe=b(V,Pe))<V.length;)pe=f(B,V,Q+1,Pe),Pe++;return pe===null?null:y({start:ue,end:ue+1},pe)}}function E(B){let V=0,Q=0,ue=0,pe=0,Pe=0;for(let ge=0;ge<B.length;ge++)Pe=B.charCodeAt(ge),A(Pe)&&V++,I(Pe)&&Q++,m(Pe)&&ue++,R(Pe)&&pe++;const Re=V/B.length,Fe=Q/B.length,Ue=ue/B.length,ae=pe/B.length;return{upperPercent:Re,lowerPercent:Fe,alphaPercent:Ue,numericPercent:ae}}function u(B){const{upperPercent:V,lowerPercent:Q}=B;return Q===0&&V>.6}function o(B){const{upperPercent:V,lowerPercent:Q,alphaPercent:ue,numericPercent:pe}=B;return Q>.2&&V<.8&&ue>.6&&pe<.2}function l(B){let V=0,Q=0,ue=0,pe=0;for(let Pe=0;Pe<B.length;Pe++)ue=B.charCodeAt(Pe),A(ue)&&V++,I(ue)&&Q++,g(ue)&&pe++;return(V===0||Q===0)&&pe===0?B.length<=30:V<=5}function s(B,V){if(!V||(V=V.trim(),V.length===0)||!l(B)||V.length>60)return null;const Q=E(V);if(!o(Q)){if(!u(Q))return null;V=V.toLowerCase()}let ue=null,pe=0;for(B=B.toLowerCase();pe<V.length&&(ue=f(B,V,0,pe))===null;)pe=b(V,pe+1);return ue}e.matchesCamelCase=s;function n(B,V,Q=!1){if(!V||V.length===0)return null;let ue=null,pe=0;for(B=B.toLowerCase(),V=V.toLowerCase();pe<V.length&&(ue=r(B,V,0,pe,Q))===null;)pe=i(V,pe+1);return ue}e.matchesWords=n;function r(B,V,Q,ue,pe){if(Q===B.length)return[];if(ue===V.length)return null;if(h(B.charCodeAt(Q),V.charCodeAt(ue))){let Pe=null,Re=ue+1;if(Pe=r(B,V,Q+1,ue+1,pe),!pe)for(;!Pe&&(Re=i(V,Re))<V.length;)Pe=r(B,V,Q+1,Re,pe),Re++;return Pe===null?null:y({start:ue,end:ue+1},Pe)}else return null}function i(B,V){for(let Q=V;Q<B.length;Q++)if(c(B.charCodeAt(Q))||Q>0&&c(B.charCodeAt(Q-1)))return Q;return B.length}const a=p(e.matchesPrefix,s,k),d=p(e.matchesPrefix,s,D),w=new _.LRUCache(1e4);function P(B,V,Q=!1){if(typeof B!="string"||typeof V!="string")return null;let ue=w.get(B);ue||(ue=new RegExp(t.convertSimple2RegExpPattern(B),"i"),w.set(B,ue));const pe=ue.exec(V);return pe?[{start:pe.index,end:pe.index+pe[0].length}]:Q?d(B,V):a(B,V)}e.matchesFuzzy=P;function O(B,V){const Q=ee(B,B.toLowerCase(),0,V,V.toLowerCase(),0,!0);return Q?L(Q):null}e.matchesFuzzy2=O;function $(B,V,Q,ue,pe,Pe){const Re=Math.min(13,B.length);for(;Q<Re;Q++){const Fe=ee(B,V,Q,ue,pe,Pe,!1);if(Fe)return Fe}return[0,Pe]}e.anyScore=$;function L(B){if(typeof B=="undefined")return[];const V=[],Q=B[1];for(let ue=B.length-1;ue>1;ue--){const pe=B[ue]+Q,Pe=V[V.length-1];Pe&&Pe.end===pe?Pe.end=pe+1:V.push({start:pe,end:pe+1})}return V}e.createMatches=L;const T=128;function U(){const B=[],V=[];for(let Q=0;Q<=T;Q++)V[Q]=0;for(let Q=0;Q<=T;Q++)B.push(V.slice(0));return B}function N(B){const V=[];for(let Q=0;Q<=B;Q++)V[Q]=0;return V}const W=N(2*T),ie=N(2*T),j=U(),re=U(),x=U(),K=!1;function te(B,V,Q,ue,pe){function Pe(Fe,Ue,ae=" "){for(;Fe.length<Ue;)Fe=ae+Fe;return Fe}let Re=` |   |${ue.split("").map(Fe=>Pe(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=Q;Fe++)Fe===0?Re+=" |":Re+=`${V[Fe-1]}|`,Re+=B[Fe].slice(0,pe+1).map(Ue=>Pe(Ue.toString(),3)).join("|")+`
`;return Re}function ce(B,V,Q,ue){B=B.substr(V),Q=Q.substr(ue),console.log(te(re,B,B.length,Q,Q.length)),console.log(te(x,B,B.length,Q,Q.length)),console.log(te(j,B,B.length,Q,Q.length))}function oe(B,V){if(V<0||V>=B.length)return!1;const Q=B.codePointAt(V);switch(Q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(Q)}}function me(B,V){if(V<0||V>=B.length)return!1;switch(B.charCodeAt(V)){case 32:case 9:return!0;default:return!1}}function Y(B,V,Q){return V[B]!==Q[B]}function z(B,V,Q,ue,pe,Pe,Re=!1){for(;V<Q&&pe<Pe;)B[V]===ue[pe]&&(Re&&(W[V]=pe),V+=1),pe+=1;return V===Q}e.isPatternInWord=z;var H;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(H||(H={}));var q;(function(B){B.Default=[-100,0];function V(Q){return!Q||Q.length===2&&Q[0]===-100&&Q[1]===0}B.isDefault=V})(q=e.FuzzyScore||(e.FuzzyScore={}));function ee(B,V,Q,ue,pe,Pe,Re){const Fe=B.length>T?T:B.length,Ue=ue.length>T?T:ue.length;if(Q>=Fe||Pe>=Ue||Fe-Q>Ue-Pe||!z(V,Q,Fe,pe,Pe,Ue,!0))return;he(Fe,Ue,Q,Pe,V,pe);let ae=1,ge=1,de=Q,Te=Pe;const Me=[!1];for(ae=1,de=Q;de<Fe;ae++,de++){const ne=W[de],be=ie[de],ke=de+1<Fe?ie[de+1]:Ue;for(ge=ne-Pe+1,Te=ne;Te<ke;ge++,Te++){let Le=Number.MIN_SAFE_INTEGER,Ne=!1;Te<=be&&(Le=Ie(B,V,de,Q,ue,pe,Te,Ue,Pe,j[ae-1][ge-1]===0,Me));let Qe=0;Le!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Qe=Le+re[ae-1][ge-1]);const $e=Te>ne,Ve=$e?re[ae][ge-1]+(j[ae][ge-1]>0?-5:0):0,Ye=Te>ne+1&&j[ae][ge-1]>0,xe=Ye?re[ae][ge-2]+(j[ae][ge-2]>0?-5:0):0;if(Ye&&(!$e||xe>=Ve)&&(!Ne||xe>=Qe))re[ae][ge]=xe,x[ae][ge]=3,j[ae][ge]=0;else if($e&&(!Ne||Ve>=Qe))re[ae][ge]=Ve,x[ae][ge]=2,j[ae][ge]=0;else if(Ne)re[ae][ge]=Qe,x[ae][ge]=1,j[ae][ge]=j[ae-1][ge-1]+1;else throw new Error("not possible")}}if(K&&ce(B,Q,ue,Pe),!Me[0]&&!Re)return;ae--,ge--;const He=[re[ae][ge],Pe];let Be=0,je=0;for(;ae>=1;){let ne=ge;do{const be=x[ae][ne];if(be===3)ne=ne-2;else if(be===2)ne=ne-1;else break}while(ne>=1);Be>1&&V[Q+ae-1]===pe[Pe+ge-1]&&!Y(ne+Pe-1,ue,pe)&&Be+1>j[ae][ne]&&(ne=ge),ne===ge?Be++:Be=1,je||(je=ne),ae--,ge=ne-1,He.push(ge)}Ue===Fe&&(He[0]+=2);const qe=je-Fe;return He[0]-=qe,He}e.fuzzyScore=ee;function he(B,V,Q,ue,pe,Pe){let Re=B-1,Fe=V-1;for(;Re>=Q&&Fe>=ue;)pe[Re]===Pe[Fe]&&(ie[Re]=Fe,Re--),Fe--}function Ie(B,V,Q,ue,pe,Pe,Re,Fe,Ue,ae,ge){if(V[Q]!==Pe[Re])return Number.MIN_SAFE_INTEGER;let de=1,Te=!1;return Re===Q-ue?de=B[Q]===pe[Re]?7:5:Y(Re,pe,Pe)&&(Re===0||!Y(Re-1,pe,Pe))?(de=B[Q]===pe[Re]?7:5,Te=!0):oe(Pe,Re)&&(Re===0||!oe(Pe,Re-1))?de=5:(oe(Pe,Re-1)||me(Pe,Re-1))&&(de=5,Te=!0),de>1&&Q===ue&&(ge[0]=!0),Te||(Te=Y(Re,pe,Pe)||oe(Pe,Re-1)||me(Pe,Re-1)),Q===ue?Re>Ue&&(de-=Te?3:5):ae?de+=Te?2:0:de+=Te?0:1,Re+1===Fe&&(de-=Te?3:5),de}function se(B,V,Q,ue,pe,Pe,Re){return ve(B,V,Q,ue,pe,Pe,!0,Re)}e.fuzzyScoreGracefulAggressive=se;function fe(B,V,Q,ue,pe,Pe,Re){return ve(B,V,Q,ue,pe,Pe,!1,Re)}e.fuzzyScoreGraceful=fe;function ve(B,V,Q,ue,pe,Pe,Re,Fe){let Ue=ee(B,V,Q,ue,pe,Pe,Fe);if(Ue&&!Re)return Ue;if(B.length>=3){const ae=Math.min(7,B.length-1);for(let ge=Q+1;ge<ae;ge++){const de=X(B,ge);if(de){const Te=ee(de,de.toLowerCase(),Q,ue,pe,Pe,Fe);Te&&(Te[0]-=3,(!Ue||Te[0]>Ue[0])&&(Ue=Te))}}}return Ue}function X(B,V){if(V+1>=B.length)return;const Q=B[V],ue=B[V+1];if(Q!==ue)return B.slice(0,V)+ue+Q+B.slice(V+2)}}),define(we[126],ye([0,1,37,125,16]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(_.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${C.source}`,"g");function v(m){return m.replace(D,(y,b)=>b?y:`\\${y}`)}e.escapeIcons=v;const I=new RegExp(`\\\\${C.source}`,"g");function A(m){return m.replace(I,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=A;const R=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function g(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(R,(y,b,f,E)=>f?y:b||E||"")}e.stripIcons=g;function S(m){const y=m.indexOf(e.iconStartMarker);return y===-1?{text:m}:c(m,y)}e.parseLabelWithIcons=S;function c(m,y){const b=[];let f="";function E(a){if(a){f+=a;for(const d of a)b.push(l)}}let u=-1,o="",l=0,s,n,r=y;const i=m.length;for(E(m.substr(0,y));r<i;)s=m[r],n=m[r+1],s===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(u=r,E(o),o=e.iconStartMarker,r++):s===")"&&u!==-1?(l+=r-u+1,u=-1,o=""):u!==-1?k.test(s)?o+=s:(E(o),u=-1,o=""):E(s),r++;return E(o),{text:f,iconOffsets:b}}function h(m,y,b=!1){const{text:f,iconOffsets:E}=y;if(!E||E.length===0)return(0,t.matchesFuzzy)(m,f,b);const u=(0,p.ltrim)(f," "),o=f.length-u.length,l=(0,t.matchesFuzzy)(m,u,b);if(l)for(const s of l){const n=E[s.start+o]+o;s.start+=n,s.end+=n}return l}e.matchesFuzzyIconAware=h}),define(we[74],ye([0,1,29]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new _.LRUCache(1e4);function p(I){return v(I,"NFC",t)}e.normalizeNFC=p;const C=new _.LRUCache(1e4);function k(I){return v(I,"NFD",C)}e.normalizeNFD=k;const D=/[^\u0000-\u0080]/;function v(I,A,R){if(!I)return I;const g=R.get(I);if(g)return g;let S;return D.test(I)?S=I.normalize(A):S=I,R.set(I,S),S}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(A){return k(A).replace(I,"")}}()}),define(we[75],ye([0,1,16]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(p){p[p.Ignore=0]="Ignore",p[p.Info=1]="Info",p[p.Warning=2]="Warning",p[p.Error=3]="Error"})(t||(t={})),function(p){const C="error",k="warning",D="warn",v="info",I="ignore";function A(g){return g?_.equalsIgnoreCase(C,g)?p.Error:_.equalsIgnoreCase(k,g)||_.equalsIgnoreCase(D,g)?p.Warning:_.equalsIgnoreCase(v,g)?p.Info:p.Ignore:p.Ignore}p.fromValue=A;function R(g){switch(g){case p.Error:return C;case p.Warning:return k;case p.Info:return v;default:return I}}p.toString=R}(t||(t={})),e.default=t}),define(we[12],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(i){return Array.isArray(i)}e.isArray=_;function t(i){return typeof i=="string"}e.isString=t;function p(i){return Array.isArray(i)&&i.every(a=>t(a))}e.isStringArray=p;function C(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=C;function k(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=k;function D(i){return!!i&&typeof i[Symbol.iterator]=="function"}e.isIterable=D;function v(i){return i===!0||i===!1}e.isBoolean=v;function I(i){return typeof i=="undefined"}e.isUndefined=I;function A(i){return!R(i)}e.isDefined=A;function R(i){return I(i)||i===null}e.isUndefinedOrNull=R;function g(i,a){if(!i)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=g;function S(i){if(R(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=S;function c(...i){const a=[];for(let d=0;d<i.length;d++){const w=i[d];if(R(w))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);a.push(w)}return a}e.assertAllDefined=c;const h=Object.prototype.hasOwnProperty;function m(i){if(!C(i))return!1;for(let a in i)if(h.call(i,a))return!1;return!0}e.isEmptyObject=m;function y(i){return typeof i=="function"}e.isFunction=y;function b(...i){return i.length>0&&i.every(y)}e.areFunctions=b;function f(i,a){const d=Math.min(i.length,a.length);for(let w=0;w<d;w++)E(i[w],a[w])}e.validateConstraints=f;function E(i,a){if(t(a)){if(typeof i!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(y(a)){try{if(i instanceof a)return}catch{}if(!R(i)&&i.constructor===a||a.length===1&&a.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function u(i){let a=[],d=Object.getPrototypeOf(i);for(;Object.prototype!==d;)a=a.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return a}e.getAllPropertyNames=u;function o(i){const a=[];for(const d of u(i))typeof i[d]=="function"&&a.push(d);return a}e.getAllMethodNames=o;function l(i,a){const d=P=>function(){const O=Array.prototype.slice.call(arguments,0);return a(P,O)};let w={};for(const P of i)w[P]=d(P);return w}e.createProxyObject=l;function s(i){return i===null?void 0:i}e.withNullAsUndefined=s;function n(i){return typeof i=="undefined"?null:i}e.withUndefinedAsNull=n;function r(i,a="Unreachable"){throw new Error(a)}e.assertNever=r}),define(we[34],ye([0,1,5,3,16,12]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function D(r){return r.replace(/[\\/]/g,_.posix.sep)}e.toSlashes=D;function v(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=v;function I(r,i=_.posix.sep){if(!r)return"";const a=r.length,d=r.charCodeAt(0);if(k(d)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let P=3;const O=P;for(;P<a&&!k(r.charCodeAt(P));P++);if(O!==P&&!k(r.charCodeAt(P+1))){for(P+=1;P<a;P++)if(k(r.charCodeAt(P)))return r.slice(0,P+1).replace(/[\\/]/g,i)}}return i}else if(y(d)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(k(r.charCodeAt(w)))return r.slice(0,w+1)}return""}e.getRoot=I;function A(r){if(!t.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let a=2;const d=a;for(;a<r.length&&(i=r.charCodeAt(a),i!==92);a++);return!(d===a||(i=r.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=A;const R=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(r,i=t.isWindows){const a=i?R:g;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||i&&S.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=c;function h(r,i,a){const d=r===i;return!a||d?d:!r||!i?!1:(0,p.equalsIgnoreCase)(r,i)}e.isEqual=h;function m(r,i,a,d=_.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(a){if(!(0,p.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let P=i.length;return i.charAt(i.length-1)===d&&P--,r.charAt(P)===d}return i.charAt(i.length-1)!==d&&(i+=d),r.indexOf(i)===0}e.isEqualOrParent=m;function y(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=y;function b(r,i){return t.isWindows&&r.endsWith(":")&&(r+=_.sep),(0,_.isAbsolute)(r)||(r=(0,_.join)(i,r)),r=(0,_.normalize)(r),t.isWindows?(r=(0,p.rtrim)(r,_.sep),r.endsWith(":")&&(r+=_.sep)):(r=(0,p.rtrim)(r,_.sep),r||(r=_.sep)),r}e.sanitizeFilePath=b;function f(r){const i=(0,_.normalize)(r);return t.isWindows?r.length>3?!1:E(i)&&(r.length===2||i.charCodeAt(2)===92):i===_.posix.sep}e.isRootOrDriveLetter=f;function E(r,i){return(i!==void 0?i:t.isWindows)?y(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function u(r){return E(r)?r[0]:void 0}e.getDriveLetter=u;function o(r,i,a){return i.length>r.length?-1:r===i?0:(a&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=o;function l(r){const i=r.split(":");let a,d,w;for(const P of i){const O=Number(P);(0,C.isNumber)(O)?d===void 0?d=O:w===void 0&&(w=O):a=a?[a,P].join(":"):P}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,i,a=8){let d="";for(let P=0;P<a;P++)d+=s.charAt(Math.floor(Math.random()*s.length));let w;return i?w=`${i}-${d}`:w=d,r?(0,_.join)(r,w):w}e.randomPath=n}),define(we[21],ye([0,1,12]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.keys(h).forEach(y=>{h[y]&&typeof h[y]=="object"?m[y]=t(h[y]):m[y]=h[y]}),m}e.deepClone=t;function p(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const y=m.shift();Object.freeze(y);for(const b in y)if(C.call(y,b)){const f=y[b];typeof f=="object"&&!Object.isFrozen(f)&&m.push(f)}}return h}e.deepFreeze=p;const C=Object.prototype.hasOwnProperty;function k(h,m){return D(h,m,new Set)}e.cloneAndChange=k;function D(h,m,y){if((0,_.isUndefinedOrNull)(h))return h;const b=m(h);if(typeof b!="undefined")return b;if((0,_.isArray)(h)){const f=[];for(const E of h)f.push(D(E,m,y));return f}if((0,_.isObject)(h)){if(y.has(h))throw new Error("Cannot clone recursive data-structure");y.add(h);const f={};for(let E in h)C.call(h,E)&&(f[E]=D(h[E],m,y));return y.delete(h),f}return h}function v(h,m,y=!0){return(0,_.isObject)(h)?((0,_.isObject)(m)&&Object.keys(m).forEach(b=>{b in h?y&&((0,_.isObject)(h[b])&&(0,_.isObject)(m[b])?v(h[b],m[b],y):h[b]=m[b]):h[b]=m[b]}),h):m}e.mixin=v;function I(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let y,b;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(y=0;y<h.length;y++)if(!I(h[y],m[y]))return!1}else{const f=[];for(b in h)f.push(b);f.sort();const E=[];for(b in m)E.push(b);if(E.sort(),!I(f,E))return!1;for(y=0;y<f.length;y++)if(!I(h[f[y]],m[f[y]]))return!1}return!0}e.equals=I;function A(h){const m=new Set;return JSON.stringify(h,(y,b)=>{if((0,_.isObject)(b)||Array.isArray(b)){if(m.has(b))return"[Circular]";m.add(b)}return b})}e.safeStringify=A;function R(h,m,y){const b=m(h);return typeof b=="undefined"?y:b}e.getOrDefault=R;function g(h,m){const y=Object.create(null);return!h||!m||Object.keys(m).forEach(f=>{const E=h[f],u=m[f];I(E,u)||(y[f]=u)}),y}e.distinct=g;function S(h,m){const y=m.toLowerCase(),b=Object.keys(h).find(f=>f.toLowerCase()===y);return b?h[b]:h[m]}e.getCaseInsensitive=S;function c(h,m){const y=Object.create(null);for(const[b,f]of Object.entries(h))m(b,f)&&(y[b]=f);return y}e.filter=c}),define(we[4],ye([0,1,5,3]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const p=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function D(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!p.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(s,n){return!s&&!n?"file":s}function I(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==R&&(n=R+n):n=R;break}return n}const A="",R="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(n,r,i,a,d,w=!1){typeof n=="object"?(this.scheme=n.scheme||A,this.authority=n.authority||A,this.path=n.path||A,this.query=n.query||A,this.fragment=n.fragment||A):(this.scheme=v(n,w),this.authority=r||A,this.path=I(this.scheme,i||A),this.query=a||A,this.fragment=d||A,D(this,w))}static isUri(n){return n instanceof S?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:i,path:a,query:d,fragment:w}=n;return r===void 0?r=this.scheme:r===null&&(r=A),i===void 0?i=this.authority:i===null&&(i=A),a===void 0?a=this.path:a===null&&(a=A),d===void 0?d=this.query:d===null&&(d=A),w===void 0?w=this.fragment:w===null&&(w=A),r===this.scheme&&i===this.authority&&a===this.path&&d===this.query&&w===this.fragment?this:new h(r,i,a,d,w)}static parse(n,r=!1){const i=g.exec(n);return i?new h(i[2]||A,l(i[4]||A),l(i[5]||A),l(i[7]||A),l(i[9]||A),r):new h(A,A,A,A,A)}static file(n){let r=A;if(t.isWindows&&(n=n.replace(/\\/g,R)),n[0]===R&&n[1]===R){const i=n.indexOf(R,2);i===-1?(r=n.substring(2),n=R):(r=n.substring(2,i),n=n.substring(i)||R)}return new h("file",r,n,A,A)}static from(n){const r=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return D(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let i;return t.isWindows&&n.scheme==="file"?i=S.file(_.win32.join(f(n,!0),...r)).path:i=_.posix.join(n.path,...r),n.with({path:i})}toString(n=!1){return E(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof S)return n;{const r=new h(n);return r._formatted=n.external,r._fsPath=n._sep===c?n.fsPath:null,r}}else return n}}e.URI=S;const c=t.isWindows?1:void 0;class h extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(s,n){let r,i=-1;for(let a=0;a<s.length;a++){const d=s.charCodeAt(a);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||n&&d===47)i!==-1&&(r+=encodeURIComponent(s.substring(i,a)),i=-1),r!==void 0&&(r+=s.charAt(a));else{r===void 0&&(r=s.substr(0,a));const w=m[d];w!==void 0?(i!==-1&&(r+=encodeURIComponent(s.substring(i,a)),i=-1),r+=w):i===-1&&(i=a)}}return i!==-1&&(r+=encodeURIComponent(s.substring(i))),r!==void 0?r:s}function b(s){let n;for(let r=0;r<s.length;r++){const i=s.charCodeAt(r);i===35||i===63?(n===void 0&&(n=s.substr(0,r)),n+=m[i]):n!==void 0&&(n+=s[r])}return n!==void 0?n:s}function f(s,n){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=f;function E(s,n){const r=n?b:y;let i="",{scheme:a,authority:d,path:w,query:P,fragment:O}=s;if(a&&(i+=a,i+=":"),(d||a==="file")&&(i+=R,i+=R),d){let $=d.indexOf("@");if($!==-1){const L=d.substr(0,$);d=d.substr($+1),$=L.indexOf(":"),$===-1?i+=r(L,!1):(i+=r(L.substr(0,$),!1),i+=":",i+=r(L.substr($+1),!1)),i+="@"}d=d.toLowerCase(),$=d.indexOf(":"),$===-1?i+=r(d,!1):(i+=r(d.substr(0,$),!1),i+=d.substr($))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const $=w.charCodeAt(1);$>=65&&$<=90&&(w=`/${String.fromCharCode($+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const $=w.charCodeAt(0);$>=65&&$<=90&&(w=`${String.fromCharCode($+32)}:${w.substr(2)}`)}i+=r(w,!0)}return P&&(i+="?",i+=r(P,!1)),O&&(i+="#",i+=n?O:y(O,!1)),i}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(o)?s.replace(o,n=>u(n)):s}}),define(we[76],ye([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(I){const A=I;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.isRemoteConsoleLog=t;function p(I){const A=[];let R;try{const g=JSON.parse(I.arguments),S=g[g.length-1];S&&S.__$stack&&(g.pop(),R=S.__$stack),A.push(...g)}catch{A.push("Unable to log remote console arguments",I.arguments)}return{args:A,stack:R}}e.parse=p;function C(I){if(typeof I!="string")return C(p(I).stack);const A=I;if(A){const R=k(A),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(g&&g.length===4)return{uri:_.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=C;function k(I){if(!I)return I;const A=I.indexOf(`
`);return A===-1?I:I.substring(0,A)}function D(I,A){const{args:R,stack:g}=p(I),S=typeof R[0]=="string"&&R.length===1;let c=k(g);c&&(c=`(${c.trim()})`);let h=[];if(typeof R[0]=="string"?c&&S?h=[`%c[${A}] %c${R[0]} %c${c}`,v("blue"),v(""),v("grey")]:h=[`%c[${A}] %c${R[0]}`,v("blue"),v(""),...R.slice(1)]:h=[`%c[${A}]%`,v("blue"),...R],c&&!S&&h.push(c),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,h)}e.log=D;function v(I){return`color: ${I}`}}),define(we[50],ye([0,1,15,16,4]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(I){return JSON.stringify(I,D)}e.stringify=C;function k(I){let A=JSON.parse(I);return A=v(A),A}e.parse=k;function D(I,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function v(I,A=0){if(!I||A>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return p.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof _.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let R=0;R<I.length;++R)I[R]=v(I[R],A+1);else for(const R in I)Object.hasOwnProperty.call(I,R)&&(I[R]=v(I[R],A+1))}return I}e.revive=v}),define(we[8],ye([0,1,3,4]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var p;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(p=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,I,A){this._hosts[v]=I,this._ports[v]=A}setConnectionToken(v,I){this._connectionTokens[v]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)return this._delegate(v);const I=v.authority;let A=this._hosts[I];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const R=this._ports[I],g=this._connectionTokens[I];let S=`path=${encodeURIComponent(v.path)}`;return typeof g=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),t.URI.from({scheme:_.isWeb?this._preferredWebSchema:p.vscodeRemoteResource,authority:`${A}:${R}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new C;class k{asBrowserUri(v,I){const A=this.toUri(v,I);return A.scheme===p.vscodeRemote?e.RemoteAuthorities.rewrite(A):A.scheme===p.file&&(_.isNative||_.isWebWorker&&_.globals.origin===`${p.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?A.with({scheme:p.vscodeFileResource,authority:A.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(v,I){const A=this.toUri(v,I);return A.scheme===p.vscodeFileResource?A.with({scheme:p.file,authority:A.authority!==k.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(v,I){return t.URI.isUri(v)?v:t.URI.parse(I.toUrl(v))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(we[22],ye([0,1,34,8,5,3,16,4]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(S){return(0,D.uriToFsPath)(S,!0)}e.originalFSPath=v;class I{constructor(c){this._ignorePathCasing=c}compare(c,h,m=!1){return c===h?0:(0,k.compare)(this.getComparisonKey(c,m),this.getComparisonKey(h,m))}isEqual(c,h,m=!1){return c===h?!0:!c||!h?!1:this.getComparisonKey(c,m)===this.getComparisonKey(h,m)}getComparisonKey(c,h=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,h,m=!1){if(c.scheme===h.scheme){if(c.scheme===t.Schemas.file)return _.isEqualOrParent(v(c),v(h),this._ignorePathCasing(c))&&c.query===h.query&&(m||c.fragment===h.fragment);if((0,e.isEqualAuthority)(c.authority,h.authority))return _.isEqualOrParent(c.path,h.path,this._ignorePathCasing(c),"/")&&c.query===h.query&&(m||c.fragment===h.fragment)}return!1}joinPath(c,...h){return D.URI.joinPath(c,...h)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return p.posix.basename(c.path)}extname(c){return p.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let h;return c.scheme===t.Schemas.file?h=D.URI.file(p.dirname(v(c))).path:(h=p.posix.dirname(c.path),c.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),h="/")),c.with({path:h})}normalizePath(c){if(!c.path.length)return c;let h;return c.scheme===t.Schemas.file?h=D.URI.file(p.normalize(v(c))).path:h=p.posix.normalize(c.path),c.with({path:h})}relativePath(c,h){if(c.scheme!==h.scheme||!(0,e.isEqualAuthority)(c.authority,h.authority))return;if(c.scheme===t.Schemas.file){const b=p.relative(v(c),v(h));return C.isWindows?_.toSlashes(b):b}let m=c.path||"/",y=h.path||"/";if(this._ignorePathCasing(c)){let b=0;for(const f=Math.min(m.length,y.length);b<f&&!(m.charCodeAt(b)!==y.charCodeAt(b)&&m.charAt(b).toLowerCase()!==y.charAt(b).toLowerCase());b++);m=y.substr(0,b)+m.substr(b)}return p.posix.relative(m,y)}resolvePath(c,h){if(c.scheme===t.Schemas.file){const m=D.URI.file(p.resolve(v(c),h));return c.with({authority:m.authority,path:m.path})}return h=_.toPosixPath(h),c.with({path:p.posix.resolve(c.path,h)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,h){return c===h||c!==void 0&&h!==void 0&&(0,k.equalsIgnoreCase)(c,h)}hasTrailingPathSeparator(c,h=p.sep){if(c.scheme===t.Schemas.file){const m=v(c);return m.length>_.getRoot(m).length&&m[m.length-1]===h}else{const m=c.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,h=p.sep){return(0,e.hasTrailingPathSeparator)(c,h)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,h=p.sep){let m=!1;if(c.scheme===t.Schemas.file){const y=v(c);m=y!==void 0&&y.length===_.getRoot(y).length&&y[y.length-1]===h}else{h="/";const y=c.path;m=y.length===1&&y.charCodeAt(y.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(c,h)?c.with({path:c.path+"/"}):c}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(S=>S.scheme===t.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new I(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(S,c){const h=[];for(let m=0;m<S.length;m++){const y=c(S[m]);S.some((b,f)=>f===m?!1:(0,e.isEqualOrParent)(y,c(b)))||h.push(S[m])}return h}e.distinctParents=A;var R;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function c(h){const m=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(f=>{const[E,u]=f.split(":");E&&u&&m.set(E,u)});const b=h.path.substring(0,h.path.indexOf(";"));return b&&m.set(S.META_DATA_MIME,b),m}S.parseMetaData=c})(R=e.DataUri||(e.DataUri={}));function g(S,c,h){if(c){let m=S.path;return m&&m[0]!==p.posix.sep&&(m=p.posix.sep+m),S.with({scheme:h,authority:c,path:m})}return S.with({scheme:h})}e.toLocalResource=g}),define(we[13],ye([0,1,20,11,7,2,22,3]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=v;function I(Y){const z=new _.CancellationTokenSource,H=Y(z.token),q=new Promise((ee,he)=>{const Ie=z.token.onCancellationRequested(()=>{Ie.dispose(),z.dispose(),he(new t.CancellationError)});Promise.resolve(H).then(se=>{Ie.dispose(),z.dispose(),ee(se)},se=>{Ie.dispose(),z.dispose(),he(se)})});return new class{cancel(){z.cancel()}then(ee,he){return q.then(ee,he)}catch(ee){return this.then(void 0,ee)}finally(ee){return q.finally(ee)}}}e.createCancelablePromise=I;function A(Y,z,H){return new Promise((q,ee)=>{const he=z.onCancellationRequested(()=>{he.dispose(),q(H)});Y.then(q,ee).finally(()=>he.dispose())})}e.raceCancellation=A;function R(Y,z){return new Promise((H,q)=>{const ee=z.onCancellationRequested(()=>{ee.dispose(),q(new t.CancellationError)});Y.then(H,q).finally(()=>ee.dispose())})}e.raceCancellationError=R;async function g(Y){let z=-1;const H=Y.map((ee,he)=>ee.then(Ie=>(z=he,Ie))),q=await Promise.race(H);return Y.forEach((ee,he)=>{he!==z&&ee.cancel()}),q}e.raceCancellablePromises=g;function S(Y,z,H){let q;const ee=setTimeout(()=>{q?.(void 0),H?.()},z);return Promise.race([Y.finally(()=>clearTimeout(ee)),new Promise(he=>q=he)])}e.raceTimeout=S;function c(Y){return new Promise((z,H)=>{const q=Y();v(q)?q.then(z,H):z(q)})}e.asPromise=c;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(H,H).then(q)})}return new Promise((H,q)=>{this.queuedPromise.then(H,q)})}return this.activePromise=z(),new Promise((H,q)=>{this.activePromise.then(ee=>{this.activePromise=null,H(ee)},ee=>{this.activePromise=null,q(ee)})})}}e.Throttler=h;class m{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=m;class y{constructor(){this.promiseMap=new Map}queue(z,H){const ee=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(z)===ee&&this.promiseMap.delete(z)});return this.promiseMap.set(z,ee),ee}}e.SequencerByKey=y;const b=(Y,z)=>{let H=!0;const q=setTimeout(()=>{H=!1,z()},Y);return{isTriggered:()=>H,dispose:()=>{clearTimeout(q),H=!1}}},f=Y=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,Y())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(z){this.defaultDelay=z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,H=this.defaultDelay){this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ee,he)=>{this.doResolve=ee,this.doReject=he}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ee=this.task;return this.task=null,ee()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=H===e.MicrotaskDelay?f(q):b(H,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class u{constructor(z){this.delayer=new E(z),this.throttler=new h}trigger(z,H){return this.delayer.trigger(()=>this.throttler.queue(z),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class o{constructor(){this._isOpen=!1,this._promise=new Promise((z,H)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class l extends o{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(Y,z){return z?new Promise((H,q)=>{const ee=setTimeout(()=>{he.dispose(),H()},Y),he=z.onCancellationRequested(()=>{clearTimeout(ee),he.dispose(),q(new t.CancellationError)})}):I(H=>s(Y,H))}e.timeout=s;function n(Y,z=0){const H=setTimeout(Y,z);return(0,C.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=n;function r(Y){const z=[];let H=0;const q=Y.length;function ee(){return H<q?Y[H++]():null}function he(Ie){Ie!=null&&z.push(Ie);const se=ee();return se?se.then(he):Promise.resolve(z)}return Promise.resolve(null).then(he)}e.sequence=r;function i(Y,z=q=>!!q,H=null){let q=0;const ee=Y.length,he=()=>{if(q>=ee)return Promise.resolve(H);const Ie=Y[q++];return Promise.resolve(Ie()).then(fe=>z(fe)?Promise.resolve(fe):he())};return he()}e.first=i;function a(Y,z=q=>!!q,H=null){if(Y.length===0)return Promise.resolve(H);let q=Y.length;const ee=()=>{q=-1;for(const he of Y)he.cancel?.()};return new Promise((he,Ie)=>{for(const se of Y)se.then(fe=>{--q>=0&&z(fe)?(ee(),he(fe)):q===0&&he(H)}).catch(fe=>{--q>=0&&(ee(),Ie(fe))})})}e.firstParallel=a;class d{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new p.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((H,q)=>{this.outstandingPromises.push({factory:z,c:H,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const H=z.factory();H.then(z.c,z.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class w extends d{constructor(){super(1)}}e.Queue=w;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const z=new x;return this.drainers.add(z),z.p}isDrained(){for(const[,z]of this.queues)if(z.size>0)return!1;return!0}queueFor(z,H=k.extUri){const q=H.getComparisonKey(z);let ee=this.queues.get(q);return ee||(ee=new w,p.Event.once(ee.onFinished)(()=>{ee?.dispose(),this.queues.delete(q),this.onDidQueueFinish()}),this.queues.set(q,ee)),ee}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const z of this.drainers)z.complete();this.drainers.clear()}dispose(){for(const[,z]of this.queues)z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class O{constructor(z,H){this._token=-1,typeof z=="function"&&typeof H=="number"&&this.setIfNotSet(z,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},H)}setIfNotSet(z,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},H))}}e.TimeoutTimer=O;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,H){this.cancel(),this._token=setInterval(()=>{z()},H)}}e.IntervalTimer=$;class L{constructor(z,H){this.timeoutToken=-1,this.runner=z,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class T{constructor(z,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class U extends L{constructor(z,H){super(z,H);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class N extends C.Disposable{constructor(z,H){super();this.options=z,this.handler=H,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.options.maxBufferedWork)return!1}else if(this.pending+z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,D.setTimeout0)(()=>{if(z)return;const H=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,H-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.runWhenIdle=(Y,z)=>{const H=requestIdleCallback(Y,typeof z=="number"?{timeout:z}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(H))}}}}();class W{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function ie(Y,z,H){let q;for(let ee=0;ee<H;ee++)try{return await Y()}catch(he){q=he,await s(z)}throw q}e.retry=ie;class j{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,H,q){return this._pending={taskId:z,cancel:()=>q?.(),promise:H},H.then(()=>this.donePending(z),()=>this.donePending(z)),H}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let H,q;const ee=new Promise((he,Ie)=>{H=he,q=Ie});this._next={run:z,promise:ee,promiseResolve:H,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=j;class re{constructor(z,H=()=>Date.now()){this.interval=z,this.nowFn=H,this.lastIncrementTime=0,this.value=0}increment(){const z=this.nowFn();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=re;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,H)=>{this.completeCallback=z,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(H=>{this.completeCallback(z),this.resolved=!0,H()})}error(z){return new Promise(H=>{this.errorCallback(z),this.rejected=!0,H()})}cancel(){new Promise(z=>{this.errorCallback(new t.CancellationError),this.rejected=!0,z()})}}e.DeferredPromise=x;var K;(function(Y){async function z(q){let ee;const he=await Promise.all(q.map(Ie=>Ie.then(se=>se,se=>{ee||(ee=se)})));if(typeof ee!="undefined")throw ee;return he}Y.settled=z;function H(q){return new Promise(async(ee,he)=>{try{await q(ee,he)}catch(Ie){he(Ie)}})}Y.withAsyncBody=H})(K=e.Promises||(e.Promises={}));var te;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(te||(te={}));class ce{constructor(z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new p.Emitter,queueMicrotask(async()=>{const H={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(z(H)),this.resolve()}catch(q){this.reject(q)}finally{H.emitOne=void 0,H.emitMany=void 0,H.reject=void 0}})}static fromArray(z){return new ce(H=>{H.emitMany(z)})}static fromPromise(z){return new ce(async H=>{H.emitMany(await z)})}static fromPromises(z){return new ce(async H=>{await Promise.all(z.map(async q=>H.emitOne(await q)))})}static merge(z){return new ce(async H=>{await Promise.all(z.map(async q=>{for await(const ee of q)H.emitOne(ee)}))})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(z<this._results.length)return{done:!1,value:this._results[z++]};if(this._state===1)return{done:!0,value:void 0};await p.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(z,H){return new ce(async q=>{for await(const ee of z)q.emitOne(H(ee))})}map(z){return ce.map(this,z)}static filter(z,H){return new ce(async q=>{for await(const ee of z)H(ee)&&q.emitOne(ee)})}filter(z){return ce.filter(this,z)}static coalesce(z){return ce.filter(z,H=>!!H)}coalesce(){return ce.coalesce(this)}static async toPromise(z){const H=[];for await(const q of z)H.push(q);return H}toPromise(){return ce.toPromise(this)}emitOne(z){this._state===0&&(this._results.push(z),this._onStateChanged.fire())}emitMany(z){this._state===0&&(this._results=this._results.concat(z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(z){this._state===0&&(this._state=2,this._error=z,this._onStateChanged.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class oe extends ce{constructor(z,H){super(H);this._source=z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function me(Y){const z=new _.CancellationTokenSource,H=Y(z.token);return new oe(z,async q=>{const ee=z.token.onCancellationRequested(()=>{ee.dispose(),z.dispose(),q.reject(new t.CancellationError)});try{for await(const he of H){if(z.token.isCancellationRequested)return;q.emitOne(he)}ee.dispose(),z.dispose()}catch(he){ee.dispose(),z.dispose(),q.reject(he)}})}e.createCancelableAsyncIterable=me}),define(we[77],ye([0,1,13,34,29,5,3,16]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",A="[^/\\\\]",R=/\//g;function g(x){switch(x){case 0:return"";case 1:return`${A}*?`;default:return`(?:${I}|${A}+${I}|${I}${A}+)*?`}}function S(x,K){if(!x)return[];const te=[];let ce=!1,oe=!1,me="";for(const Y of x){switch(Y){case K:if(!ce&&!oe){te.push(me),me="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}me+=Y}return me&&te.push(me),te}e.splitGlobAware=S;function c(x){if(!x)return"";let K="";const te=S(x,e.GLOB_SPLIT);if(te.every(ce=>ce===e.GLOBSTAR))K=".*";else{let ce=!1;te.forEach((oe,me)=>{if(oe===e.GLOBSTAR){ce||(K+=g(2),ce=!0);return}let Y=!1,z="",H=!1,q="";for(const ee of oe){if(ee!=="}"&&Y){z+=ee;continue}if(H&&(ee!=="]"||!q)){let he;ee==="-"?he=ee:(ee==="^"||ee==="!")&&!q?he="^":ee===e.GLOB_SPLIT?he="":he=(0,D.escapeRegExpCharacters)(ee),q+=he;continue}switch(ee){case"{":Y=!0;continue;case"[":H=!0;continue;case"}":{K+=`(?:${S(z,",").map(se=>c(se)).join("|")})`,Y=!1,z="";break}case"]":K+="["+q+"]",H=!1,q="";break;case"?":K+=A;continue;case"*":K+=g(1);continue;default:K+=(0,D.escapeRegExpCharacters)(ee)}}me<te.length-1&&(te[me+1]!==e.GLOBSTAR||me+2<te.length)&&(K+=I),ce=!1})}return K}const h=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new p.LRUCache(1e4),o=function(){return!1},l=function(){return null};function s(x,K){if(!x)return l;let te;typeof x!="string"?te=x.pattern:te=x,te=te.trim();const ce=`${te}_${!!K.trimForExclusions}`;let oe=u.get(ce);if(oe)return n(oe,x);let me;if(h.test(te)){const Y=te.substr(4);oe=function(z,H){return typeof z=="string"&&z.endsWith(Y)?te:null}}else(me=m.exec(r(te,K)))?oe=i(me[1],te):(K.trimForExclusions?b:y).test(te)?oe=a(te,K):(me=f.exec(r(te,K)))?oe=d(me[1].substr(1),te,!0):(me=E.exec(r(te,K)))?oe=d(me[1],te,!1):oe=w(te);return u.set(ce,oe),n(oe,x)}function n(x,K){return typeof K=="string"?x:function(te,ce){return(0,t.isEqualOrParent)(te,K.base,!k.isLinux)?x(te.substr(K.base.length+1),ce):null}}function r(x,K){return K.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function i(x,K){const te=`/${x}`,ce=`\\${x}`,oe=function(Y,z){return typeof Y!="string"?null:z?z===x?K:null:Y===x||Y.endsWith(te)||Y.endsWith(ce)?K:null},me=[x];return oe.basenames=me,oe.patterns=[K],oe.allBasenames=me,oe}function a(x,K){const te=re(x.slice(1,-1).split(",").map(z=>s(z,K)).filter(z=>z!==l),x),ce=te.length;if(!ce)return l;if(ce===1)return te[0];const oe=function(z,H){for(let q=0,ee=te.length;q<ee;q++)if(te[q](z,H))return x;return null},me=te.find(z=>!!z.allBasenames);me&&(oe.allBasenames=me.allBasenames);const Y=te.reduce((z,H)=>H.allPaths?z.concat(H.allPaths):z,[]);return Y.length&&(oe.allPaths=Y),oe}function d(x,K,te){const ce=C.sep===C.posix.sep,oe=ce?x:x.replace(R,C.sep),me=C.sep+oe,Y=C.posix.sep+x,z=te?function(H,q){return typeof H=="string"&&(H===oe||H.endsWith(me)||!ce&&(H===x||H.endsWith(Y)))?K:null}:function(H,q){return typeof H=="string"&&(H===oe||!ce&&H===x)?K:null};return z.allPaths=[(te?"*/":"./")+x],z}function w(x){try{const K=new RegExp(`^${c(x)}$`);return function(te){return K.lastIndex=0,typeof te=="string"&&K.test(te)?x:null}}catch{return l}}function P(x,K,te){return!x||typeof K!="string"?!1:O(x)(K,void 0,te)}e.match=P;function O(x,K={}){if(!x)return o;if(typeof x=="string"||U(x)){const te=s(x,K);if(te===l)return o;const ce=function(oe,me){return!!te(oe,me)};return te.allBasenames&&(ce.allBasenames=te.allBasenames),te.allPaths&&(ce.allPaths=te.allPaths),ce}return ie(x,K)}e.parse=O;function $(x){if(!x)return;let K;return te=>(K||(K=(x()||Promise.resolve([])).then(ce=>ce?T(ce):{})),K.then(ce=>!!ce[te]))}e.hasSiblingPromiseFn=$;function L(x){if(!x)return;let K;return te=>{if(!K){const ce=x();K=ce?T(ce):{}}return!!K[te]}}e.hasSiblingFn=L;function T(x){const K={};for(const te of x)K[te]=!0;return K}function U(x){const K=x;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.isRelativePattern=U;function N(x){return x.allBasenames||[]}e.getBasenameTerms=N;function W(x){return x.allPaths||[]}e.getPathTerms=W;function ie(x,K){const te=re(Object.getOwnPropertyNames(x).map(z=>j(z,x[z],K)).filter(z=>z!==l)),ce=te.length;if(!ce)return l;if(!te.some(z=>!!z.requiresSiblings)){if(ce===1)return te[0];const z=function(ee,he){for(let Ie=0,se=te.length;Ie<se;Ie++){const fe=te[Ie](ee,he);if(fe)return fe}return null},H=te.find(ee=>!!ee.allBasenames);H&&(z.allBasenames=H.allBasenames);const q=te.reduce((ee,he)=>he.allPaths?ee.concat(he.allPaths):ee,[]);return q.length&&(z.allPaths=q),z}const oe=function(z,H,q){let ee;for(let he=0,Ie=te.length;he<Ie;he++){const se=te[he];se.requiresSiblings&&q&&(H||(H=(0,C.basename)(z)),ee||(ee=H.substr(0,H.length-(0,C.extname)(z).length)));const fe=se(z,H,ee,q);if(fe)return fe}return null},me=te.find(z=>!!z.allBasenames);me&&(oe.allBasenames=me.allBasenames);const Y=te.reduce((z,H)=>H.allPaths?z.concat(H.allPaths):z,[]);return Y.length&&(oe.allPaths=Y),oe}function j(x,K,te){if(K===!1)return l;const ce=s(x,te);if(ce===l)return l;if(typeof K=="boolean")return ce;if(K){const oe=K.when;if(typeof oe=="string"){const me=(Y,z,H,q)=>{if(!q||!ce(Y,z))return null;const ee=oe.replace("$(basename)",H),he=q(ee);return(0,_.isThenable)(he)?he.then(Ie=>Ie?x:null):he?x:null};return me.requiresSiblings=!0,me}}return ce}function re(x,K){const te=x.filter(z=>!!z.basenames);if(te.length<2)return x;const ce=te.reduce((z,H)=>{const q=H.basenames;return q?z.concat(q):z},[]);let oe;if(K){oe=[];for(let z=0,H=ce.length;z<H;z++)oe.push(K)}else oe=te.reduce((z,H)=>{const q=H.patterns;return q?z.concat(q):z},[]);const me=function(z,H){if(typeof z!="string")return null;if(!H){let ee;for(ee=z.length;ee>0;ee--){const he=z.charCodeAt(ee-1);if(he===47||he===92)break}H=z.substr(ee)}const q=ce.indexOf(H);return q!==-1?oe[q]:null};me.basenames=ce,me.patterns=oe,me.allBasenames=ce;const Y=x.filter(z=>!z.basenames);return Y.push(me),Y}}),define(we[78],ye([0,1,11,126,22,4]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(h="",m=!1){if(this.value=h,typeof this.value!="string")throw(0,_.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(h,m=0){return this.value+=R(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(y,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,m){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}}e.MarkdownString=D;function v(c){return I(c)?!c.value:Array.isArray(c)?c.every(v):!0}e.isEmptyMarkdownString=v;function I(c){return c instanceof D?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function A(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons&&c.supportHtml===h.supportHtml&&(c.baseUri===h.baseUri||!!c.baseUri&&!!h.baseUri&&(0,p.isEqual)(C.URI.from(c.baseUri),C.URI.from(h.baseUri)))}e.markdownStringEqual=A;function R(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=R;function g(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function S(c){const h=[],m=c.split("|").map(b=>b.trim());c=m[0];const y=m[1];if(y){const b=/height=(\d+)/.exec(y),f=/width=(\d+)/.exec(y),E=b?b[1]:"",u=f?f[1]:"",o=isFinite(parseInt(u)),l=isFinite(parseInt(E));o&&h.push(`width="${u}"`),l&&h.push(`height="${E}"`)}return{href:c,dimensions:h}}e.parseHrefAndDimensions=S}),define(we[79],ye([0,1,34,8,5,3,22,16,4]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(n,r,i){if(typeof n=="string"&&(n=v.URI.file(n)),i){const d=i.getWorkspaceFolder(n);if(d){const w=i.getWorkspace().folders.length>1;let P;if((0,k.isEqual)(d.uri,n)?P="":P=(0,k.relativePath)(d.uri,n),w){const O=d.name?d.name:(0,k.basename)(d.uri);P=P?O+" \u2022 "+P:O}return P}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,_.hasDriveLetter)(n.fsPath))return(0,p.normalize)(R(n.fsPath));let a=(0,p.normalize)(n.fsPath);return!C.isWindows&&r?.userHome&&(a=S(a,r.userHome.fsPath)),a}e.getPathLabel=I;function A(n){if(!n)return;typeof n=="string"&&(n=v.URI.file(n));const r=(0,k.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return C.isWindows&&(0,_.isRootOrDriveLetter)(r)?R(r):r}e.getBaseLabel=A;function R(n,r){return(0,_.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let g=Object.create(null);function S(n,r){if(C.isWindows||!n||!r)return n;let i=g.original===r?g.normalized:void 0;return i||(i=`${(0,D.rtrim)(r,p.posix.sep)}${p.posix.sep}`,g={original:r,normalized:i}),(C.isLinux?n.startsWith(i):(0,D.startsWithIgnoreCase)(n,i))&&(n=`~/${n.substr(i.length)}`),n}e.tildify=S;function c(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=c;const h="\u2026",m="\\\\",y="~";function b(n,r=p.sep){const i=new Array(n.length);let a=!1;for(let d=0;d<n.length;d++){let w=n[d];if(w===""){i[d]=`.${r}`;continue}if(!w){i[d]=w;continue}a=!0;let P="";w.indexOf(m)===0?(P=w.substr(0,w.indexOf(m)+m.length),w=w.substr(w.indexOf(m)+m.length)):w.indexOf(r)===0?(P=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length)):w.indexOf(y)===0&&(P=w.substr(0,w.indexOf(y)+y.length),w=w.substr(w.indexOf(y)+y.length));const O=w.split(r);for(let $=1;a&&$<=O.length;$++)for(let L=O.length-$;a&&L>=0;L--){a=!1;let T=O.slice(L,L+$).join(r);for(let U=0;!a&&U<n.length;U++)if(U!==d&&n[U]&&n[U].indexOf(T)>-1){const N=L+$===O.length,W=L>0&&n[U].indexOf(r)>-1?r+T:T,ie=n[U].endsWith(W);a=!N||ie}if(!a){let U="";(O[0].endsWith(":")||P!=="")&&(L===1&&(L=0,$++,T=O[0]+r+T),L>0&&(U=O[0]+r),U=P+U),L>0&&(U=U+h+r),U=U+T,L+$<O.length&&(U=U+r+h),i[d]=U}}a&&(i[d]=w)}return i}e.shorten=b;var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function E(n,r=Object.create(null)){const i=[];let a=!1,d="";for(const w of n)if(w==="$"||a&&w==="{")d&&i.push({value:d,type:f.TEXT}),d="",a=!0;else if(w==="}"&&a){const P=r[d];if(typeof P=="string")P.length&&i.push({value:P,type:f.VARIABLE});else if(P){const O=i[i.length-1];(!O||O.type!==f.SEPARATOR)&&i.push({value:P.label,type:f.SEPARATOR})}d="",a=!1}else d+=w;return d&&!a&&i.push({value:d,type:f.TEXT}),i.filter((w,P)=>{if(w.type===f.SEPARATOR){const O=i[P-1],$=i[P+1];return[O,$].every(L=>L&&(L.type===f.VARIABLE||L.type===f.TEXT)&&L.value.length>0)}return!0}).map(w=>w.value).join("")}e.template=E;function u(n,r){return C.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function o(n,r){return C.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,i=>i==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function l(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=l;function s(n){const r=n.indexOf("/")!==-1?p.posix:p.win32,i=r.basename(n),a=r.dirname(n);return i.length?{name:i,parentPath:a}:{name:a,parentPath:""}}e.splitName=s}),define(we[61],ye([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(A){return A.toJSON()}class p{constructor(R){this._uriTransformer=R}transformIncoming(R){const g=this._uriTransformer.transformIncoming(R);return g===R?R:t(_.URI.from(g))}transformOutgoing(R){const g=this._uriTransformer.transformOutgoing(R);return g===R?R:t(_.URI.from(g))}transformOutgoingURI(R){const g=this._uriTransformer.transformOutgoing(R);return g===R?R:_.URI.from(g)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=p,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function C(A,R,g){if(!A||g>200)return null;if(typeof A=="object"){if(A instanceof _.URI)return R.transformOutgoing(A);for(let S in A)if(Object.hasOwnProperty.call(A,S)){const c=C(A[S],R,g+1);c!==null&&(A[S]=c)}}return null}function k(A,R){const g=C(A,R,0);return g===null?A:g}e.transformOutgoingURIs=k;function D(A,R,g,S){if(!A||S>200)return null;if(typeof A=="object"){if(A.$mid===1)return g?_.URI.revive(R.transformIncoming(A)):R.transformIncoming(A);for(let c in A)if(Object.hasOwnProperty.call(A,c)){const h=D(A[c],R,g,S+1);h!==null&&(A[c]=h)}}return null}function v(A,R){const g=D(A,R,!1,0);return g===null?A:g}e.transformIncomingURIs=v;function I(A,R){const g=D(A,R,!0,0);return g===null?A:g}e.transformAndReviveIncomingURIs=I}),define(we[23],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(v){return _.test(v)}e.isUUID=t;const p=new Uint8Array(16),C=[];for(let v=0;v<256;v++)C.push(v.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(v){for(let I=0;I<v.length;I++)v[I]=Math.floor(Math.random()*256);return v};function D(){k(p),p[6]=p[6]&15|64,p[8]=p[8]&63|128;let v=0,I="";return I+=C[p[v++]],I+=C[p[v++]],I+=C[p[v++]],I+=C[p[v++]],I+="-",I+=C[p[v++]],I+=C[p[v++]],I+="-",I+=C[p[v++]],I+=C[p[v++]],I+="-",I+=C[p[v++]],I+=C[p[v++]],I+="-",I+=C[p[v++]],I+=C[p[v++]],I+=C[p[v++]],I+=C[p[v++]],I+=C[p[v++]],I+=C[p[v++]],I}e.generateUuid=D}),define(we[127],ye([0,1,255]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(C="utf8"){this.stringDecoder=new _.StringDecoder(C),this.remaining=null}write(C){const k=[],D=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(D.length<1)return k;let v=0,I,A=v;for(;A<D.length;)if(I=D.charCodeAt(A),I===13||I===10){if(k.push(D.substring(v,A)),A++,A<D.length){const R=I;I=D.charCodeAt(A),(R===13&&I===10||R===10&&I===13)&&A++}v=A}else A++;return this.remaining=v<D.length?D.substr(v):null,k}end(){return this.remaining}}e.LineDecoder=t}),function(){"use strict";function J(e,_,t,p){function C(c){return new Promise(h=>t.exists(c,h))}function k(c){return new Promise((h,m)=>{const y=new Date;t.utimes(c,y,y,b=>b?m(b):h())})}function D(c){return new Promise((h,m)=>t.mkdir(c,{recursive:!0},y=>y&&y.code!=="EEXIST"?m(y):h(c)))}function v(c){return new Promise((h,m)=>t.rmdir(c,{recursive:!0},y=>y&&y.code!=="ENOENT"?m(y):h()))}function I(c){return new Promise((h,m)=>t.readFile(c,"utf8",(y,b)=>y?m(y):h(b)))}function A(c,h){return new Promise((m,y)=>t.writeFile(c,h,"utf8",b=>b?y(b):m()))}function R(c){const h=_.join(c,"languagepacks.json");try{return e(h)}catch{}}function g(c,h){try{for(;h;){if(c[h])return h;{const m=h.lastIndexOf("-");if(m>0)h=h.substring(0,m);else return}}}catch(m){console.error("Resolving language pack configuration failed.",m)}}function S(c,h,m,y){if(y==="pseudo")return Promise.resolve({locale:y,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:y,availableLanguages:{}});if(y&&(y==="en"||y==="en-us"))return Promise.resolve({locale:y,availableLanguages:{}});const b=y;p.mark("code/willGenerateNls");const f=function(E){return p.mark("code/didGenerateNls"),Promise.resolve({locale:E,availableLanguages:{}})};try{if(!c)return f(b);const E=R(h);if(!E||(y=g(E,y),!y))return f(b);const u=E[y];let o;return!u||typeof u.hash!="string"||!u.translations||typeof(o=u.translations.vscode)!="string"?f(b):C(o).then(l=>{if(!l)return f(b);const s=u.hash+"."+y,n=_.join(h,"clp",s),r=_.join(n,c),i=_.join(n,"tcf.json"),a=_.join(n,"corrupted.info"),d={locale:b,availableLanguages:{"*":y},_languagePackId:s,_translationsConfigFile:i,_cacheRoot:n,_resolvedLanguagePackCoreLocation:r,_corruptedFile:a};return C(a).then(w=>{let P;return w?P=v(n):P=Promise.resolve(void 0),P.then(()=>C(r).then(O=>O?(k(r).catch(()=>{}),p.mark("code/didGenerateNls"),d):D(r).then(()=>Promise.all([I(m),I(o)])).then($=>{const L=JSON.parse($[0]),T=JSON.parse($[1]).contents,U=Object.keys(L.bundles),N=[];for(const W of U){const ie=L.bundles[W],j=Object.create(null);for(const re of ie){const x=L.keys[re],K=L.messages[re],te=T[re];let ce;if(te){ce=[];for(let oe=0;oe<x.length;oe++){const me=x[oe],Y=typeof me=="string"?me:me.key;let z=te[Y];z===void 0&&(z=K[oe]),ce.push(z)}}else ce=K;j[re]=ce}N.push(A(_.join(r,W.replace(/\//g,"!")+".nls.json"),JSON.stringify(j)))}return N.push(A(i,JSON.stringify(u.translations))),Promise.all(N)}).then(()=>(p.mark("code/didGenerateNls"),d)).catch($=>(console.error("Generating translation files failed.",$),f(y)))))})})}catch(E){return console.error("Generating translation files failed.",E),f(y)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(we[128],ye([0,129,27,43]),function(e,_,t,p){return J(e.__$__nodeRequire,_,t,p)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),_=require("fs"),t=require("../common/performance");module.exports=J(require,e,_,t)}else throw new Error("Unknown context")}(),define(we[130],ye([0,1,25]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function p(k){const D=k.replace(/\-/g,":").toLowerCase();return!t.has(D)}function C(){const k=(0,_.networkInterfaces)();for(let D in k){const v=k[D];if(v){for(const{mac:I}of v)if(p(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(we[80],ye([0,1,25,11,29,23,130]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(A){return this._virtualMachineOUIs||(this._virtualMachineOUIs=p.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(A)}value(){if(this._value===void 0){let A=0,R=0;const g=(0,_.networkInterfaces)();for(let S in g){const c=g[S];if(c)for(const{mac:h,internal:m}of c)m||(R+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(A+=1))}this._value=R>0?A/R:0}return this._value}};let D;async function v(){return D||(D=(async()=>await I()||C.generateUuid())()),D}e.getMachineId=v;async function I(){try{const A=await new Promise((g,S)=>{J(["crypto"],g,S)}),R=(0,k.getMac)();return A.createHash("sha256").update(R,"utf8").digest("hex")}catch(A){t.onUnexpectedError(A);return}}}),define(we[18],ye([0,1,27,25,131,13,34,74,5,3,22,4]),function(J,e,_,t,p,C,k,D,v,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function S(N,W=g.UNLINK){if((0,k.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return W===g.UNLINK?h(N):c(N)}async function c(N){try{const W=(0,k.randomPath)((0,t.tmpdir)());try{await _.promises.rename(N,W)}catch{return h(N)}h(W).catch(ie=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function h(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function m(N){if((0,k.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync(N,{recursive:!0})}e.rimrafSync=m;async function y(N,W){return E(await(W?b(N):(0,p.promisify)(_.readdir)(N)))}async function b(N){try{return await(0,p.promisify)(_.readdir)(N,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const W=[],ie=await y(N);for(const j of ie){let re=!1,x=!1,K=!1;try{const te=await e.Promises.lstat((0,v.join)(N,j));re=te.isFile(),x=te.isDirectory(),K=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}W.push({name:j,isFile:()=>re,isDirectory:()=>x,isSymbolicLink:()=>K})}return W}function f(N){return E(_.readdirSync(N))}e.readdirSync=f;function E(N){return N.map(W=>typeof W=="string"?I.isMacintosh?(0,D.normalizeNFC)(W):W:(W.name=I.isMacintosh?(0,D.normalizeNFC)(W.name):W.name,W))}async function u(N){const W=await y(N),ie=[];for(const j of W)await l.existsDirectory((0,v.join)(N,j))&&ie.push(j);return ie}function o(N,W=1e3){return new Promise(ie=>{let j=!1;const re=setInterval(()=>{j||(j=!0,_.access(N,x=>{j=!1,x&&(clearInterval(re),ie(void 0))}))},W)})}e.whenDeleted=o;var l;(function(N){async function W(re){let x;try{if(x=await e.Promises.lstat(re),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(re),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(I.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(re)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw te}throw K}}N.stat=W;async function ie(re){try{const{stat:x,symbolicLink:K}=await N.stat(re);return x.isFile()&&K?.dangling!==!0}catch{}return!1}N.existsFile=ie;async function j(re){try{const{stat:x,symbolicLink:K}=await N.stat(re);return x.isDirectory()&&K?.dangling!==!0}catch{}return!1}N.existsDirectory=j})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new C.ResourceQueue;function n(N,W,ie){return s.queueFor(R.URI.file(N),A.extUriBiasedIgnorePathCase).queue(()=>{const j=d(ie);return new Promise((re,x)=>i(N,W,j,K=>K?x(K):re()))})}let r=!0;function i(N,W,ie,j){if(!r)return _.writeFile(N,W,{mode:ie.mode,flag:ie.flag},j);_.open(N,ie.flag,ie.mode,(re,x)=>{if(re)return j(re);_.writeFile(x,W,K=>{if(K)return _.close(x,()=>j(K));_.fdatasync(x,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),r=!1),_.close(x,ce=>j(ce))))})})}function a(N,W,ie){const j=d(ie);if(!r)return _.writeFileSync(N,W,{mode:j.mode,flag:j.flag});const re=_.openSync(N,j.flag,j.mode);try{_.writeFileSync(re,W);try{_.fdatasyncSync(re)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),r=!1}}finally{_.closeSync(re)}}e.writeFileSync=a;function d(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function w(N,W){if(N!==W)try{await e.Promises.rename(N,W)}catch(ie){if(N.toLowerCase()!==W.toLowerCase()&&ie.code==="EXDEV"||N.endsWith("."))await P(N,W,{preserveSymlinks:!1}),await S(N,g.MOVE);else throw ie}}async function P(N,W,ie){return $(N,W,{root:{source:N,target:W},options:ie,handledSourcePaths:new Set})}const O=511;async function $(N,W,ie){if(ie.handledSourcePaths.has(N))return;ie.handledSourcePaths.add(N);const{stat:j,symbolicLink:re}=await l.stat(N);if(re){if(ie.options.preserveSymlinks)try{return await U(N,W,ie)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(re.dangling)return}return j.isDirectory()?L(N,W,j.mode&O,ie):T(N,W,j.mode&O)}async function L(N,W,ie,j){await e.Promises.mkdir(W,{recursive:!0,mode:ie});const re=await y(N);for(const x of re)await $((0,v.join)(N,x),(0,v.join)(W,x),j)}async function T(N,W,ie){await e.Promises.copyFile(N,W),await e.Promises.chmod(W,ie)}async function U(N,W,ie){let j=await e.Promises.readlink(N);(0,k.isEqualOrParent)(j,ie.root.source,!I.isLinux)&&(j=(0,v.join)(ie.root.target,j.substr(ie.root.source.length+1))),await e.Promises.symlink(j,W)}e.Promises=new class{get access(){return(0,p.promisify)(_.access)}get stat(){return(0,p.promisify)(_.stat)}get lstat(){return(0,p.promisify)(_.lstat)}get utimes(){return(0,p.promisify)(_.utimes)}get read(){return(N,W,ie,j,re)=>new Promise((x,K)=>{_.read(N,W,ie,j,re,(te,ce,oe)=>te?K(te):x({bytesRead:ce,buffer:oe}))})}get readFile(){return(0,p.promisify)(_.readFile)}get write(){return(N,W,ie,j,re)=>new Promise((x,K)=>{_.write(N,W,ie,j,re,(te,ce,oe)=>te?K(te):x({bytesWritten:ce,buffer:oe}))})}get appendFile(){return(0,p.promisify)(_.appendFile)}get fdatasync(){return(0,p.promisify)(_.fdatasync)}get truncate(){return(0,p.promisify)(_.truncate)}get rename(){return(0,p.promisify)(_.rename)}get copyFile(){return(0,p.promisify)(_.copyFile)}get open(){return(0,p.promisify)(_.open)}get close(){return(0,p.promisify)(_.close)}get symlink(){return(0,p.promisify)(_.symlink)}get readlink(){return(0,p.promisify)(_.readlink)}get chmod(){return(0,p.promisify)(_.chmod)}get mkdir(){return(0,p.promisify)(_.mkdir)}get unlink(){return(0,p.promisify)(_.unlink)}get rmdir(){return(0,p.promisify)(_.rmdir)}get realpath(){return(0,p.promisify)(_.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return u}get writeFile(){return n}get rm(){return S}get move(){return w}get copy(){return P}}}),define(we[132],ye([0,1,27,5,3,16,18]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(g){if(p.isLinux)return g;const S=(0,t.dirname)(g);if(g===S)return g;const c=((0,t.basename)(g)||g).toLowerCase();try{const m=(0,k.readdirSync)(S).filter(y=>y.toLowerCase()===c);if(m.length===1){const y=D(S);if(y)return(0,t.join)(y,m[0])}else if(m.length>1){const y=m.indexOf(c);if(y>=0){const b=D(S);if(b)return(0,t.join)(b,m[y])}}}catch{}return null}e.realcaseSync=D;async function v(g){if(p.isLinux)return g;const S=(0,t.dirname)(g);if(g===S)return g;const c=((0,t.basename)(g)||g).toLowerCase();try{const m=(await k.Promises.readdir(S)).filter(y=>y.toLowerCase()===c);if(m.length===1){const y=await v(S);if(y)return(0,t.join)(y,m[0])}else if(m.length>1){const y=m.indexOf(c);if(y>=0){const b=await v(S);if(b)return(0,t.join)(b,m[y])}}}catch{}return null}e.realcase=v;async function I(g){try{return await k.Promises.realpath(g)}catch{const c=R(g);return await k.Promises.access(c,_.constants.R_OK),c}}e.realpath=I;function A(g){try{return _.realpathSync(g)}catch{const c=R(g);return _.accessSync(c,_.constants.R_OK),c}}e.realpathSync=A;function R(g){return(0,C.rtrim)((0,t.normalize)(g),t.sep)}}),define(we[133],ye([0,1,81]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(D,v,I,A=1){let R=!1;return new Promise(g=>{const S=setTimeout(()=>{if(!R)return R=!0,g(0)},I);p(D,v,A,c=>{if(!R)return R=!0,clearTimeout(S),g(c)})})}e.findFreePort=t;function p(D,v,I,A){if(v===0)return A(0);const R=new _.Socket;R.once("connect",()=>(k(R),p(D+I,v-1,I,A))),R.once("data",()=>{}),R.once("error",g=>(k(R),g.code!=="ECONNREFUSED"?p(D+I,v-1,I,A):A(D))),R.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(D,v,I){let A=!1,R,g=1;const S=_.createServer({pauseOnConnect:!0});function c(h,m){A||(A=!0,S.removeAllListeners(),S.close(),R&&clearTimeout(R),m(h))}return new Promise(h=>{R=setTimeout(()=>{c(0,h)},I),S.on("listening",()=>{c(D,h)}),S.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&g<v?(D++,g++,S.listen(D,"127.0.0.1")):c(0,h)}),S.on("close",()=>{c(0,h)}),S.listen(D,"127.0.0.1")})}e.findFreePortFaster=C;function k(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(v){console.error(v)}}}),define(we[82],ye([0,1,25,5,18]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var v;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(v||(v={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let A;process.env.PROCESSOR_ARCHITEW6432?A=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?A=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?A=1:A=0;class R{constructor(u,o,l){this.exePath=u,this.displayName=o,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:E=!1}={}){return E?I===0?process.env["ProgramFiles(x86)"]||null:A===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:E=!1,findPreview:u=!1}={}){const o=g({useAlternateBitness:E});if(!o)return null;const l=t.join(o,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(l))return null;let s=-1,n=null;for(const a of await p.Promises.readdir(l)){let d=-1;if(u){const P=a.indexOf("-");if(P<0)continue;const O=a.substring(0,P);if(!C.test(O)||a.substring(P+1)!=="preview")continue;d=parseInt(O,10)}else{if(!C.test(a))continue;d=parseInt(a,10)}if(d<=s)continue;const w=t.join(l,a,"pwsh.exe");!await p.SymlinkSupport.existsFile(w)||(n=w,s=d)}if(!n)return null;const r=o.includes("x86")?" (x86)":"",i=u?" Preview":"";return new R(n,`PowerShell${i}${r}`,!0)}async function c({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:o,pwshMsixName:l}=E?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await p.Promises.readdir(u))if(o.test(s)){const n=t.join(u,s,"pwsh.exe");return new R(n,l)}return null}function h(){const E=t.join(_.homedir(),".dotnet","tools","pwsh.exe");return new R(E,".NET Core PowerShell Global Tool")}function m(){const E=t.join(process.env.windir,I===1&&A!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(E,"Windows PowerShell",!0)}async function*y(){let E=await S();E&&(yield E),E=await S({useAlternateBitness:!0}),E&&(yield E),E=await c(),E&&(yield E),E=h(),E&&(yield E),E=await S({findPreview:!0}),E&&(yield E),E=await c({findPreview:!0}),E&&(yield E),E=await S({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=m(),E&&(yield E)}async function*b(){for await(const E of y())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=b;async function f(){for await(const E of b())return E;return null}e.getFirstAvailablePowerShellInstallation=f}),define(we[83],ye([0,1,38,8]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function p(k){return new Promise((D,v)=>{let I;const A=new Map;function R(S,c,h,m,y){const b=A.get(c);if(S===k||b){const f={name:g(h),cmd:h,pid:S,ppid:c,load:m,mem:y};A.set(S,f),S===k&&(I=f),b&&(b.children||(b.children=[]),b.children.push(f),b.children.length>1&&(b.children=b.children.sort((E,u)=>E.pid-u.pid)))}}function g(S){const c=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,y=/--utility-sub-type=network/,b=/--crashes-directory/,f=/\\pipe\\winpty-control/,E=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(b.exec(S))return"electron-crash-reporter";if(f.exec(S))return"winpty-process";if(E.exec(S))return"console-window-host (Windows internal process)";let o=u.exec(S);if(o&&o.length===2)return o[1]==="renderer"?c.exec(S)?"shared-process":h.exec(S)?"issue-reporter":m.exec(S)?"process-explorer":"window":o[1]==="utility"&&y.exec(S)?"utility-network-service":o[1];const l=/[a-zA-Z-]+\.js/g;let s="";do o=l.exec(S),o&&(s+=o+" ");while(o);return s&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${s}`:S}if(process.platform==="win32"){const S=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substr(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substr(5):c;new Promise((c,h)=>{J(["windows-process-tree"],c,h)}).then(c=>{c.getProcessList(k,h=>{c.getProcessCpuUsage(h,m=>{const y=new Map;m.forEach(b=>{const f=S(b.commandLine||"");y.set(b.pid,{name:g(f),cmd:f,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),I=y.get(k),I?(y.forEach(b=>{const f=y.get(b.ppid);f&&(f.children||(f.children=[]),f.children.push(b))}),y.forEach(b=>{b.children&&(b.children=b.children.sort((f,E)=>f.pid-E.pid))}),D(I)):v(new Error(`Root process ${k} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let S=function(){let c=[I];const h=[];for(;c.length;){const y=c.shift();y&&(h.push(y.pid),y.children&&(c=c.concat(y.children)))}let m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);m+=" "+h.join(" "),(0,_.exec)(m,{},(y,b,f)=>{if(y||f)v(y||new Error(f.toString()));else{const E=b.toString().split(`
`);for(let u=0;u<h.length;u++){const o=A.get(h[u]);o.load=parseFloat(E[u])}if(!I){v(new Error(`Root process ${k} not found`));return}D(I)}})};(0,_.exec)("which ps",{},(c,h,m)=>{if(c||m)if(process.platform!=="linux")v(c||new Error(m.toString()));else{const y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,_.exec)(y,{},(b,f,E)=>{b||E?v(b||new Error(E.toString())):(C(f,R),S())})}else{const y=h.toString().trim(),b="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,_.exec)(`${y} ${b}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,E,u)=>{f||u&&!u.includes("screen size is bogus")?v(f||new Error(u.toString())):(C(E,R),process.platform==="linux"?S():I?D(I):v(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=p;function C(k,D){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=k.toString().split(`
`);for(const A of I){const R=v.exec(A.trim());R&&R.length===6&&D(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}});var Ae=this&&this.__decorate||function(J,e,_,t){var p=arguments.length,C=p<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,_):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(J,e,_,t);else for(var D=J.length-1;D>=0;D--)(k=J[D])&&(C=(p<3?k(C):p>3?k(e,_,C):k(e,_))||C);return p>3&&C&&Object.defineProperty(e,_,C),C};define(we[39],ye([0,1,17,13,15,20,71,11,7,2,50,16,12]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function c(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(y||(y={}));class b{constructor(K){this.buffer=K,this.pos=0}read(K){const te=this.buffer.slice(this.pos,this.pos+K);return this.pos+=te.byteLength,te}}class f{constructor(){this.buffers=[]}get buffer(){return p.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var E;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(E||(E={}));function u(x){const K=p.VSBuffer.alloc(4);return K.writeUInt32BE(x,0),K}function o(x){return x.read(4).readUInt32BE(0)}function l(x){const K=p.VSBuffer.alloc(1);return K.writeUInt8(x,0),K}const s={Undefined:l(E.Undefined),String:l(E.String),Buffer:l(E.Buffer),VSBuffer:l(E.VSBuffer),Array:l(E.Array),Object:l(E.Object)},n=typeof Buffer!="undefined";function r(x,K){if(typeof K=="undefined")x.write(s.Undefined);else if(typeof K=="string"){const te=p.VSBuffer.fromString(K);x.write(s.String),x.write(u(te.byteLength)),x.write(te)}else if(n&&Buffer.isBuffer(K)){const te=p.VSBuffer.wrap(K);x.write(s.Buffer),x.write(u(te.byteLength)),x.write(te)}else if(K instanceof p.VSBuffer)x.write(s.VSBuffer),x.write(u(K.byteLength)),x.write(K);else if(Array.isArray(K)){x.write(s.Array),x.write(u(K.length));for(const te of K)r(x,te)}else{const te=p.VSBuffer.fromString(JSON.stringify(K));x.write(s.Object),x.write(u(te.byteLength)),x.write(te)}}function i(x){switch(x.read(1).readUInt8(0)){case E.Undefined:return;case E.String:return x.read(o(x)).toString();case E.Buffer:return x.read(o(x)).buffer;case E.VSBuffer:return x.read(o(x));case E.Array:{const te=o(x),ce=[];for(let oe=0;oe<te;oe++)ce.push(i(x));return ce}case E.Object:return JSON.parse(x.read(o(x)).toString())}}class a{constructor(K,te,ce=null,oe=1e3){this.protocol=K,this.ctx=te,this.logger=ce,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(me=>this.onRawMessage(me)),this.sendResponse({type:200})}registerChannel(K,te){this.channels.set(K,te),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const te=this.send([K.type]);this.logger?.logOutgoing(te,0,1,m(K.type));return}case 201:case 202:case 204:case 203:{const te=this.send([K.type,K.id],K.data);this.logger?.logOutgoing(te,K.id,1,m(K.type),K.data);return}}}send(K,te=void 0){const ce=new f;return r(ce,K),r(ce,te),this.sendBuffer(ce.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const te=new b(K),ce=i(te),oe=i(te),me=ce[0];switch(me){case 100:return this.logger?.logIncoming(K.byteLength,ce[1],1,`${c(me)}: ${ce[2]}.${ce[3]}`,oe),this.onPromise({type:me,id:ce[1],channelName:ce[2],name:ce[3],arg:oe});case 102:return this.logger?.logIncoming(K.byteLength,ce[1],1,`${c(me)}: ${ce[2]}.${ce[3]}`,oe),this.onEventListen({type:me,id:ce[1],channelName:ce[2],name:ce[3],arg:oe});case 101:return this.logger?.logIncoming(K.byteLength,ce[1],1,`${c(me)}`),this.disposeActiveRequest({type:me,id:ce[1]});case 103:return this.logger?.logIncoming(K.byteLength,ce[1],1,`${c(me)}`),this.disposeActiveRequest({type:me,id:ce[1]})}}onPromise(K){const te=this.channels.get(K.channelName);if(!te){this.collectPendingRequest(K);return}const ce=new C.CancellationTokenSource;let oe;try{oe=te.call(this.ctx,K.name,K.arg,ce.token)}catch(z){oe=Promise.reject(z)}const me=K.id;oe.then(z=>{this.sendResponse({id:me,data:z,type:201}),this.activeRequests.delete(K.id)},z=>{z instanceof Error?this.sendResponse({id:me,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:me,data:z,type:203}),this.activeRequests.delete(K.id)});const Y=(0,I.toDisposable)(()=>ce.cancel());this.activeRequests.set(K.id,Y)}onEventListen(K){const te=this.channels.get(K.channelName);if(!te){this.collectPendingRequest(K);return}const ce=K.id,me=te.listen(this.ctx,K.name,K.arg)(Y=>this.sendResponse({id:ce,data:Y,type:204}));this.activeRequests.set(K.id,me)}disposeActiveRequest(K){const te=this.activeRequests.get(K.id);te&&(te.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let te=this.pendingRequests.get(K.channelName);te||(te=[],this.pendingRequests.set(K.channelName,te));const ce=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);te.push({request:K,timeoutTimer:ce})}flushPendingRequests(K){const te=this.pendingRequests.get(K);if(te){for(const ce of te)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.onPromise(ce.request);break;case 102:this.onEventListen(ce.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var d;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(K,te=null){this.protocol=K,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ce=>this.onBuffer(ce)),this.logger=te}getChannel(K){const te=this;return{call(ce,oe,me){return te.isDisposed?Promise.reject(D.canceled()):te.requestPromise(K,ce,oe,me)},listen(ce,oe){return te.isDisposed?v.Event.None:te.requestEvent(K,ce,oe)}}}requestPromise(K,te,ce,oe=C.CancellationToken.None){const me=this.lastRequestId++,z={id:me,type:100,channelName:K,name:te,arg:ce};if(oe.isCancellationRequested)return Promise.reject(D.canceled());let H;return new Promise((ee,he)=>{if(oe.isCancellationRequested)return he(D.canceled());const Ie=()=>{const X=B=>{switch(B.type){case 201:this.handlers.delete(me),ee(B.data);break;case 202:{this.handlers.delete(me);const V=new Error(B.data.message);V.stack=B.data.stack,V.name=B.data.name,he(V);break}case 203:this.handlers.delete(me),he(B.data);break}};this.handlers.set(me,X),this.sendRequest(z)};let se=null;this.state===y.Idle?Ie():(se=(0,t.createCancelablePromise)(X=>this.whenInitialized()),se.then(()=>{se=null,Ie()}));const fe=()=>{se?(se.cancel(),se=null):this.sendRequest({id:me,type:101}),he(D.canceled())},ve=oe.onCancellationRequested(fe);H=(0,I.combinedDisposable)((0,I.toDisposable)(fe),ve),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(K,te,ce){const oe=this.lastRequestId++,Y={id:oe,type:102,channelName:K,name:te,arg:ce};let z=null;const H=new v.Emitter({onFirstListenerAdd:()=>{z=(0,t.createCancelablePromise)(ee=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(H),this.sendRequest(Y)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(H),this.sendRequest({id:oe,type:103}))}}),q=ee=>H.fire(ee.data);return this.handlers.set(oe,q),H.event}sendRequest(K){switch(K.type){case 100:case 102:{const te=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger&&this.logger.logOutgoing(te,K.id,0,`${c(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const te=this.send([K.type,K.id]);this.logger&&this.logger.logOutgoing(te,K.id,0,c(K.type));return}}}send(K,te=void 0){const ce=new f;return r(ce,K),r(ce,te),this.sendBuffer(ce.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const te=new b(K),ce=i(te),oe=i(te),me=ce[0];switch(me){case 200:return this.logger&&this.logger.logIncoming(K.byteLength,0,0,m(me)),this.onResponse({type:ce[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(K.byteLength,ce[1],0,m(me),oe),this.onResponse({type:ce[0],id:ce[1],data:oe})}}onResponse(K){if(K.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const te=this.handlers.get(K.id);te&&te(K)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ae([k.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class P{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:te,onDidClientDisconnect:ce})=>{v.Event.once(te.onMessage)(me=>{const Y=new b(me),z=i(Y),H=new a(te,z),q=new w(te);this.channels.forEach((he,Ie)=>H.registerChannel(Ie,he));const ee={channelServer:H,channelClient:q,ctx:z};this._connections.add(ee),this._onDidAddConnection.fire(ee),ce(()=>{H.dispose(),q.dispose(),this._connections.delete(ee),this._onDidRemoveConnection.fire(ee)})})})}get connections(){const K=[];return this._connections.forEach(te=>K.push(te)),K}getChannel(K,te){const ce=this;return{call(oe,me,Y){let z;if((0,g.isFunction)(te)){let q=(0,_.getRandomElement)(ce.connections.filter(te));z=q?Promise.resolve(q):v.Event.toPromise(v.Event.filter(ce.onDidAddConnection,te))}else z=te.routeCall(ce,oe,me);const H=z.then(q=>q.channelClient.getChannel(K));return $(H).call(oe,me,Y)},listen(oe,me){if((0,g.isFunction)(te))return ce.getMulticastEvent(K,te,oe,me);const Y=te.routeEvent(ce,oe,me).then(z=>z.channelClient.getChannel(K));return $(Y).listen(oe,me)}}}getMulticastEvent(K,te,ce,oe){const me=this;let Y=new I.DisposableStore;const z=new v.Emitter({onFirstListenerAdd:()=>{Y=new I.DisposableStore;const H=new v.EventMultiplexer,q=new Map,ee=Ie=>{const fe=Ie.channelClient.getChannel(K).listen(ce,oe),ve=H.add(fe);q.set(Ie,ve)},he=Ie=>{const se=q.get(Ie);!se||(se.dispose(),q.delete(Ie))};me.connections.filter(te).forEach(ee),v.Event.filter(me.onDidAddConnection,te)(ee,void 0,Y),me.onDidRemoveConnection(he,void 0,Y),H.event(z.fire,z,Y),Y.add(H)},onLastListenerRemove:()=>{Y.dispose()}});return z.event}registerChannel(K,te){this.channels.set(K,te),this._connections.forEach(ce=>{ce.channelServer.registerChannel(K,te)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class O{constructor(K,te,ce=null){const oe=new f;r(oe,te),K.send(oe.buffer),this.channelClient=new w(K,ce),this.channelServer=new a(K,te,ce)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,te){this.channelServer.registerChannel(K,te)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function $(x){return{call(K,te,ce){return x.then(oe=>oe.call(K,te,ce))},listen(K,te){const ce=new v.Relay;return x.then(oe=>ce.input=oe.listen(K,te)),ce.event}}}e.getDelayedChannel=$;function L(x){let K=!1;return{call(te,ce,oe){return K?x.call(te,ce,oe):(0,t.timeout)(0).then(()=>K=!0).then(()=>x.call(te,ce,oe))},listen(te,ce){if(K)return x.listen(te,ce);const oe=new v.Relay;return(0,t.timeout)(0).then(()=>K=!0).then(()=>oe.input=x.listen(te,ce)),oe.event}}}e.getNextTickChannel=L;class T{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const te of K.connections)if(await Promise.resolve(this.fn(te.ctx)))return Promise.resolve(te);return await v.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=T;var U;(function(x){function K(me,Y){const z=me,H=Y&&Y.disableMarshalling,q=new Map;for(const ee in z)ce(ee)&&q.set(ee,v.Event.buffer(z[ee],!0));return new class{listen(ee,he,Ie){const se=q.get(he);if(se)return se;if(oe(he)){const fe=z[he];if(typeof fe=="function")return fe.call(z,Ie)}throw new Error(`Event not found: ${he}`)}call(ee,he,Ie){const se=z[he];if(typeof se=="function"){if(!H&&Array.isArray(Ie))for(let fe=0;fe<Ie.length;fe++)Ie[fe]=(0,A.revive)(Ie[fe]);return se.apply(z,Ie)}throw new Error(`Method not found: ${he}`)}}}x.fromService=K;function te(me,Y){const z=Y&&Y.disableMarshalling;return new Proxy({},{get(H,q){if(typeof q=="string")return Y?.properties?.has(q)?Y.properties.get(q):oe(q)?function(ee){return me.listen(q,ee)}:ce(q)?me.listen(q):async function(...ee){let he;Y&&!(0,g.isUndefinedOrNull)(Y.context)?he=[Y.context,...ee]:he=ee;const Ie=await me.call(q,he);return z?Ie:(0,A.revive)(Ie)};throw new Error(`Property not found: ${String(q)}`)}})}x.toService=te;function ce(me){return me[0]==="o"&&me[1]==="n"&&R.isUpperAsciiLetter(me.charCodeAt(2))}function oe(me){return/^onDynamic/.test(me)&&R.isUpperAsciiLetter(me.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let K=x.toString();if(K!=="[object Object]")return K}return x}function ie(x){return Array.isArray(x)?x.map(W):W(x)}function j(x,K,te,ce,oe,me,Y){Y=ie(Y);const z=N[oe],H=z[ce%z.length];let q=[`%c[${x}]%c[${String(K).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(me)?(q=q.concat(Y),q.push(")")):q.push(Y),console.log.apply(console,q)}e.logWithColors=j;class re{constructor(K,te){this._outgoingPrefix=K,this._incomingPrefix=te,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,te,ce,oe,me){this._totalOutgoing+=K,j(this._outgoingPrefix,this._totalOutgoing,K,te,ce,oe,me)}logIncoming(K,te,ce,oe,me){this._totalIncoming+=K,j(this._incomingPrefix,this._totalIncoming,K,te,ce,oe,me)}}e.IPCLogger=re}),define(we[84],ye([0,1,15,7,2,39]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let i=0;function a(w,P){if(!r.has(w)){const O=String(++i);r.set(w,O)}return r.get(w)}function d(w,P,O,$){if(!n.enableDiagnostics)return;const L=a(w,P);if($ instanceof _.VSBuffer||$ instanceof Uint8Array||$ instanceof ArrayBuffer||ArrayBuffer.isView($)){const T=_.VSBuffer.alloc($.byteLength);T.set($),n.records.push({timestamp:Date.now(),id:L,label:P,type:O,buff:T})}else n.records.push({timestamp:Date.now(),id:L,label:P,type:O,data:$})}n.traceSocketEvent=d})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function A(){return I||(I=_.VSBuffer.alloc(0)),I}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,i){if(r===0)return A();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const P=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=r),P}if(this._chunks[0].byteLength>r){const P=this._chunks[0].slice(0,r);return i&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),P}let a=_.VSBuffer.alloc(r),d=0,w=0;for(;r>0;){const P=this._chunks[w];if(P.byteLength>r){const O=P.slice(0,r);a.set(O,d),d+=r,i&&(this._chunks[w]=P.slice(r),this._totalLength-=r),r-=r}else a.set(P,d),d+=P.byteLength,i?(this._chunks.shift(),this._totalLength-=P.byteLength):w++,r-=P.byteLength}return a}}e.ChunkStream=R;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(g||(g={}));function S(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var c;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(c=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(r,i,a,d){this.type=r,this.id=i,this.ack=a,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends p.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,d=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",i),this._onMessage.fire(new h(a,d,w,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=_.VSBuffer.alloc(13);i.writeUInt8(r.type,0),i.writeUInt32BE(r.id,1),i.writeUInt32BE(r.ack,5),i.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(i,r.data)}_bufferAdd(r,i){const a=this._totalLength===0;return this._data.push(r,i),this._totalLength+=r.byteLength+i.byteLength,a}_bufferTake(){const r=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,i){this._bufferAdd(r,i)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class b extends p.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new h(1,0,0,r))}}e.Protocol=b;class f extends C.IPCClient{constructor(r,i,a=null){super(r,i,a);this.protocol=r}static fromSocket(r,i){return new f(new b(r),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=f;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class u{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],i=0,a=this._first;for(;a;)r[i++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const i=new u(r);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let i=0;i<l._HISTORY_LENGTH;i++)this.lastRuns[i]=r-1e3*i;setInterval(()=>{for(let i=l._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),i=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let d=0;d<l._HISTORY_LENGTH;d++)r-this.lastRuns[d]<=i&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class s{constructor(r,i=null,a=l.getInstance()){this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),i&&this._socketReader.acceptChunk(i)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,p.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new h(5,0,0,A());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new h(7,0,0,A());this._socketWriter.write(r)}sendResume(){const r=new h(8,0,0,A());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,i){this._isReconnecting=!0,this._socketDisposables=(0,p.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,A());this._socketWriter.write(r);const i=this._outgoingUnackMsg.toArray();for(let a=0,d=i.length;a<d;a++)this._socketWriter.write(i[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new h(6,0,0,A())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const i=this._outgoingUnackMsg.toArray();for(let a=0,d=i.length;a<d;a++)this._socketWriter.write(i[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,i,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const i=new h(2,0,0,r);this._socketWriter.write(i)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),i=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(i>=2e4&&a>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const w=Math.max(2e4-i,2e4-a,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,A());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(we[134],ye([0,1,13,7,2,12]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function D(R){const g=R;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=D;var v;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(v||(v={}));class I extends p.Disposable{constructor(g,S=Object.create(null)){super();this.database=g,this.options=S,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=new _.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((S,c)=>this.accept(c,S)),g.deleted?.forEach(S=>this.accept(S,void 0))}accept(g,S){if(this.state===v.Closed)return;let c=!1;(0,C.isUndefinedOrNull)(S)?c=this.cache.delete(g):this.cache.get(g)!==S&&(this.cache.set(g,S),c=!0),c&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,S){const c=this.cache.get(g);return(0,C.isUndefinedOrNull)(c)?S:c}getBoolean(g,S){const c=this.get(g);return(0,C.isUndefinedOrNull)(c)?S:c==="true"}getNumber(g,S){const c=this.get(g);return(0,C.isUndefinedOrNull)(c)?S:parseInt(c,10)}async set(g,S){if(this.state===v.Closed)return;if((0,C.isUndefinedOrNull)(S))return this.delete(g);const c=String(S);if(this.cache.get(g)!==c)return this.cache.set(g,c),this.pendingInserts.set(g,c),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===v.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class A{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((S,c)=>this.items.set(c,S)),g.delete&&g.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=A}),define(we[85],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(p,C){this.lineNumber=p,this.column=C}with(p=this.lineNumber,C=this.column){return p===this.lineNumber&&C===this.column?this:new _(p,C)}delta(p=0,C=0){return this.with(this.lineNumber+p,this.column+C)}equals(p){return _.equals(this,p)}static equals(p,C){return!p&&!C?!0:!!p&&!!C&&p.lineNumber===C.lineNumber&&p.column===C.column}isBefore(p){return _.isBefore(this,p)}static isBefore(p,C){return p.lineNumber<C.lineNumber?!0:C.lineNumber<p.lineNumber?!1:p.column<C.column}isBeforeOrEqual(p){return _.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,C){return p.lineNumber<C.lineNumber?!0:C.lineNumber<p.lineNumber?!1:p.column<=C.column}static compare(p,C){const k=p.lineNumber|0,D=C.lineNumber|0;if(k===D){const v=p.column|0,I=C.column|0;return v-I}return k-D}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new _(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}}e.Position=_}),define(we[51],ye([0,1,85]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(C,k,D,v){C>D||C===D&&k>v?(this.startLineNumber=D,this.startColumn=v,this.endLineNumber=C,this.endColumn=k):(this.startLineNumber=C,this.startColumn=k,this.endLineNumber=D,this.endColumn=v)}isEmpty(){return t.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return t.containsPosition(this,C)}static containsPosition(C,k){return!(k.lineNumber<C.startLineNumber||k.lineNumber>C.endLineNumber||k.lineNumber===C.startLineNumber&&k.column<C.startColumn||k.lineNumber===C.endLineNumber&&k.column>C.endColumn)}static strictContainsPosition(C,k){return!(k.lineNumber<C.startLineNumber||k.lineNumber>C.endLineNumber||k.lineNumber===C.startLineNumber&&k.column<=C.startColumn||k.lineNumber===C.endLineNumber&&k.column>=C.endColumn)}containsRange(C){return t.containsRange(this,C)}static containsRange(C,k){return!(k.startLineNumber<C.startLineNumber||k.endLineNumber<C.startLineNumber||k.startLineNumber>C.endLineNumber||k.endLineNumber>C.endLineNumber||k.startLineNumber===C.startLineNumber&&k.startColumn<C.startColumn||k.endLineNumber===C.endLineNumber&&k.endColumn>C.endColumn)}strictContainsRange(C){return t.strictContainsRange(this,C)}static strictContainsRange(C,k){return!(k.startLineNumber<C.startLineNumber||k.endLineNumber<C.startLineNumber||k.startLineNumber>C.endLineNumber||k.endLineNumber>C.endLineNumber||k.startLineNumber===C.startLineNumber&&k.startColumn<=C.startColumn||k.endLineNumber===C.endLineNumber&&k.endColumn>=C.endColumn)}plusRange(C){return t.plusRange(this,C)}static plusRange(C,k){let D,v,I,A;return k.startLineNumber<C.startLineNumber?(D=k.startLineNumber,v=k.startColumn):k.startLineNumber===C.startLineNumber?(D=k.startLineNumber,v=Math.min(k.startColumn,C.startColumn)):(D=C.startLineNumber,v=C.startColumn),k.endLineNumber>C.endLineNumber?(I=k.endLineNumber,A=k.endColumn):k.endLineNumber===C.endLineNumber?(I=k.endLineNumber,A=Math.max(k.endColumn,C.endColumn)):(I=C.endLineNumber,A=C.endColumn),new t(D,v,I,A)}intersectRanges(C){return t.intersectRanges(this,C)}static intersectRanges(C,k){let D=C.startLineNumber,v=C.startColumn,I=C.endLineNumber,A=C.endColumn,R=k.startLineNumber,g=k.startColumn,S=k.endLineNumber,c=k.endColumn;return D<R?(D=R,v=g):D===R&&(v=Math.max(v,g)),I>S?(I=S,A=c):I===S&&(A=Math.min(A,c)),D>I||D===I&&v>A?null:new t(D,v,I,A)}equalsRange(C){return t.equalsRange(this,C)}static equalsRange(C,k){return!!C&&!!k&&C.startLineNumber===k.startLineNumber&&C.startColumn===k.startColumn&&C.endLineNumber===k.endLineNumber&&C.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(C){return new _.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(C){return new _.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,k){return new t(this.startLineNumber,this.startColumn,C,k)}setStartPosition(C,k){return new t(C,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(C){return new t(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,k=C){return new t(C.lineNumber,C.column,k.lineNumber,k.column)}static lift(C){return C?new t(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,k){return!(C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<k.startColumn||k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<C.startColumn)}static areIntersecting(C,k){return!(C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<=k.startColumn||k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,k){if(C&&k){const I=C.startLineNumber|0,A=k.startLineNumber|0;if(I===A){const R=C.startColumn|0,g=k.startColumn|0;if(R===g){const S=C.endLineNumber|0,c=k.endLineNumber|0;if(S===c){const h=C.endColumn|0,m=k.endColumn|0;return h-m}return S-c}return R-g}return I-A}return(C?1:0)-(k?1:0)}static compareRangesUsingEnds(C,k){return C.endLineNumber===k.endLineNumber?C.endColumn===k.endColumn?C.startLineNumber===k.startLineNumber?C.startColumn-k.startColumn:C.startLineNumber-k.startLineNumber:C.endColumn-k.endColumn:C.endLineNumber-k.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=t}),define(we[135],ye([0,1,7,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class p{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,v){return this._map.set(D,v),this.fire([D]),(0,t.toDisposable)(()=>{this._map.get(D)===v&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,v){this._factories.get(D)?.dispose();const I=new C(this,D,v);return this._factories.set(D,I),(0,t.toDisposable)(()=>{const A=this._factories.get(D);!A||A!==I||(this._factories.delete(D),A.dispose())})}async getOrCreate(D){const v=this.get(D);if(v)return v;const I=this._factories.get(D);return!I||I.isResolved?null:(await I.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const I=this._factories.get(D);return!!(!I||I.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=p;class C extends t.Disposable{constructor(D,v,I){super();this._registry=D,this._languageId=v,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(we[136],ye([0,1,4,51,135,37]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(L){L[L.Null=0]="Null",L[L.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var D;(function(L){L[L.NotSet=-1]="NotSet",L[L.None=0]="None",L[L.Italic=1]="Italic",L[L.Bold=2]="Bold",L[L.Underline=4]="Underline",L[L.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var v;(function(L){L[L.None=0]="None",L[L.DefaultForeground=1]="DefaultForeground",L[L.DefaultBackground=2]="DefaultBackground"})(v=e.ColorId||(e.ColorId={}));var I;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var A;(function(L){L[L.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",L[L.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",L[L.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",L[L.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",L[L.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",L[L.ITALIC_MASK=1024]="ITALIC_MASK",L[L.BOLD_MASK=2048]="BOLD_MASK",L[L.UNDERLINE_MASK=4096]="UNDERLINE_MASK",L[L.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",L[L.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",L[L.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",L[L.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",L[L.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",L[L.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",L[L.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",L[L.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",L[L.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",L[L.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",L[L.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",L[L.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(A=e.MetadataConsts||(e.MetadataConsts={}));class R{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&768)>>>8}static getFontStyle(T){return(T&15360)>>>10}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){const U=this.getForeground(T);let N="mtk"+U;const W=this.getFontStyle(T);return W&1&&(N+=" mtki"),W&2&&(N+=" mtkb"),W&4&&(N+=" mtku"),W&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(T,U){const N=this.getForeground(T),W=this.getFontStyle(T);let ie=`color: ${U[N]};`;W&1&&(ie+="font-style: italic;"),W&2&&(ie+="font-weight: bold;");let j="";return W&4&&(j+=" underline"),W&8&&(j+=" line-through"),j&&(ie+=`text-decoration:${j};`),ie}static getPresentationFromMetadata(T){const U=this.getForeground(T),N=this.getFontStyle(T);return{foreground:U,italic:Boolean(N&1),bold:Boolean(N&2),underline:Boolean(N&4),strikethrough:Boolean(N&8)}}}e.TokenMetadata=R;class g{constructor(T,U,N){this._tokenBrand=void 0,this.offset=T,this.type=U,this.language=N}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=g;class S{constructor(T,U){this._tokenizationResultBrand=void 0,this.tokens=T,this.endState=U}}e.TokenizationResult=S;class c{constructor(T,U){this._encodedTokenizationResultBrand=void 0,this.tokens=T,this.endState=U}}e.EncodedTokenizationResult=c;var h;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(h=e.CompletionItemKind||(e.CompletionItemKind={}));var m;(function(L){const T=new Map;T.set(0,C.Codicon.symbolMethod),T.set(1,C.Codicon.symbolFunction),T.set(2,C.Codicon.symbolConstructor),T.set(3,C.Codicon.symbolField),T.set(4,C.Codicon.symbolVariable),T.set(5,C.Codicon.symbolClass),T.set(6,C.Codicon.symbolStruct),T.set(7,C.Codicon.symbolInterface),T.set(8,C.Codicon.symbolModule),T.set(9,C.Codicon.symbolProperty),T.set(10,C.Codicon.symbolEvent),T.set(11,C.Codicon.symbolOperator),T.set(12,C.Codicon.symbolUnit),T.set(13,C.Codicon.symbolValue),T.set(15,C.Codicon.symbolEnum),T.set(14,C.Codicon.symbolConstant),T.set(15,C.Codicon.symbolEnum),T.set(16,C.Codicon.symbolEnumMember),T.set(17,C.Codicon.symbolKeyword),T.set(27,C.Codicon.symbolSnippet),T.set(18,C.Codicon.symbolText),T.set(19,C.Codicon.symbolColor),T.set(20,C.Codicon.symbolFile),T.set(21,C.Codicon.symbolReference),T.set(22,C.Codicon.symbolCustomColor),T.set(23,C.Codicon.symbolFolder),T.set(24,C.Codicon.symbolTypeParameter),T.set(25,C.Codicon.account),T.set(26,C.Codicon.issues);function U(ie){let j=T.get(ie);return j||(console.info("No codicon found for CompletionItemKind "+ie),j=C.Codicon.symbolProperty),j}L.toIcon=U;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function W(ie,j){let re=N.get(ie);return typeof re=="undefined"&&!j&&(re=9),re}L.fromString=W})(m=e.CompletionItemKinds||(e.CompletionItemKinds={}));var y;(function(L){L[L.Deprecated=1]="Deprecated"})(y=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(L){L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var f;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function s(L){return L&&_.URI.isUri(L.uri)&&t.Range.isIRange(L.range)&&(t.Range.isIRange(L.originSelectionRange)||t.Range.isIRange(L.targetSelectionRange))}e.isLocationLink=s;var n;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var r;(function(L){L[L.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(L){const T=new Map;T.set(0,C.Codicon.symbolFile),T.set(1,C.Codicon.symbolModule),T.set(2,C.Codicon.symbolNamespace),T.set(3,C.Codicon.symbolPackage),T.set(4,C.Codicon.symbolClass),T.set(5,C.Codicon.symbolMethod),T.set(6,C.Codicon.symbolProperty),T.set(7,C.Codicon.symbolField),T.set(8,C.Codicon.symbolConstructor),T.set(9,C.Codicon.symbolEnum),T.set(10,C.Codicon.symbolInterface),T.set(11,C.Codicon.symbolFunction),T.set(12,C.Codicon.symbolVariable),T.set(13,C.Codicon.symbolConstant),T.set(14,C.Codicon.symbolString),T.set(15,C.Codicon.symbolNumber),T.set(16,C.Codicon.symbolBoolean),T.set(17,C.Codicon.symbolArray),T.set(18,C.Codicon.symbolObject),T.set(19,C.Codicon.symbolKey),T.set(20,C.Codicon.symbolNull),T.set(21,C.Codicon.symbolEnumMember),T.set(22,C.Codicon.symbolStruct),T.set(23,C.Codicon.symbolEvent),T.set(24,C.Codicon.symbolOperator),T.set(25,C.Codicon.symbolTypeParameter);function U(N){let W=T.get(N);return W||(console.info("No codicon found for SymbolKind "+N),W=C.Codicon.symbolProperty),W}L.toIcon=U})(i=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(T){this.value=T}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var d;(function(L){function T(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}L.is=T})(d=e.Command||(e.Command={}));var w;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(w=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var P;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(P=e.CommentMode||(e.CommentMode={}));var O;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(O=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new p.TokenizationRegistry;var $;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})($=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[137],ye([9,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(we[138],ye([0,1,137]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,p=t*60,C=p*24,k=C*7,D=C*30,v=C*365;function I(R,g,S){typeof R!="number"&&(R=R.getTime());const c=Math.round((new Date().getTime()-R)/1e3);if(c<-30)return(0,_.localize)(0,null,I(new Date().getTime()+c*1e3,!1));if(c<30)return(0,_.localize)(1,null);let h;return c<t?(h=c,g?h===1?S?(0,_.localize)(2,null,h):(0,_.localize)(3,null,h):S?(0,_.localize)(4,null,h):(0,_.localize)(5,null,h):h===1?S?(0,_.localize)(6,null,h):(0,_.localize)(7,null,h):S?(0,_.localize)(8,null,h):(0,_.localize)(9,null,h)):c<p?(h=Math.floor(c/t),g?h===1?S?(0,_.localize)(10,null,h):(0,_.localize)(11,null,h):S?(0,_.localize)(12,null,h):(0,_.localize)(13,null,h):h===1?S?(0,_.localize)(14,null,h):(0,_.localize)(15,null,h):S?(0,_.localize)(16,null,h):(0,_.localize)(17,null,h)):c<C?(h=Math.floor(c/p),g?h===1?S?(0,_.localize)(18,null,h):(0,_.localize)(19,null,h):S?(0,_.localize)(20,null,h):(0,_.localize)(21,null,h):h===1?S?(0,_.localize)(22,null,h):(0,_.localize)(23,null,h):S?(0,_.localize)(24,null,h):(0,_.localize)(25,null,h)):c<k?(h=Math.floor(c/C),g?h===1?(0,_.localize)(26,null,h):(0,_.localize)(27,null,h):h===1?(0,_.localize)(28,null,h):(0,_.localize)(29,null,h)):c<D?(h=Math.floor(c/k),g?h===1?S?(0,_.localize)(30,null,h):(0,_.localize)(31,null,h):S?(0,_.localize)(32,null,h):(0,_.localize)(33,null,h):h===1?S?(0,_.localize)(34,null,h):(0,_.localize)(35,null,h):S?(0,_.localize)(36,null,h):(0,_.localize)(37,null,h)):c<v?(h=Math.floor(c/D),g?h===1?S?(0,_.localize)(38,null,h):(0,_.localize)(39,null,h):S?(0,_.localize)(40,null,h):(0,_.localize)(41,null,h):h===1?S?(0,_.localize)(42,null,h):(0,_.localize)(43,null,h):S?(0,_.localize)(44,null,h):(0,_.localize)(45,null,h)):(h=Math.floor(c/v),g?h===1?S?(0,_.localize)(46,null,h):(0,_.localize)(47,null,h):S?(0,_.localize)(48,null,h):(0,_.localize)(49,null,h):h===1?S?(0,_.localize)(50,null,h):(0,_.localize)(51,null,h):S?(0,_.localize)(52,null,h):(0,_.localize)(53,null,h))}e.fromNow=I;function A(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(we[139],ye([9,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(we[36],ye([0,1,17,12,139]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(R,g){return g&&(R.stack||R.stacktrace)?p.localize(0,null,D(R),k(R.stack)||k(R.stacktrace)):D(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function D(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?p.localize(1,null,R.message):R.message||p.localize(2,null)}function v(R=null,g=!1){if(!R)return p.localize(3,null);if(Array.isArray(R)){const S=_.coalesce(R),c=v(S[0],g);return S.length>1?p.localize(4,null,c,S.length):c}if(t.isString(R))return R;if(R.detail){const S=R.detail;if(S.error)return C(S.error,g);if(S.exception)return C(S.exception,g)}return R.stack?C(R,g):R.message?R.message:p.localize(5,null)}e.toErrorMessage=v;function I(R){const g=R;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=I;function A(R,g=Object.create(null)){const S=new Error(R);return g.actions&&(S.actions=g.actions),S}e.createErrorWithActions=A}),define(we[140],ye([9,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(we[141],ye([0,1,140]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(p){switch(p){case 1:return(0,_.localize)(0,null);case 2:return(0,_.localize)(1,null);case 3:return(0,_.localize)(2,null);case 4:return(0,_.localize)(3,null);case 5:return(0,_.localize)(4,null);case 6:return(0,_.localize)(5,null);case 7:return(0,_.localize)(6,null);case 8:return(0,_.localize)(7,null);case 9:return(0,_.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(we[142],ye([9,10]),function(J,e){return J.create("vs/base/node/processes",e)}),define(we[62],ye([0,1,38,34,8,21,5,3,24,73,12,127,18,142]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function c(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(o,l){if(D.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};l&&(s.cwd=l);const n=_.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{n.once("error",i=>{r({success:!1,error:i})}),n.once("exit",(i,a)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?c(s.status):1})}else if(D.isLinux||D.isMacintosh)try{const s=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(n=>{_.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,i,a)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o){!o||(delete o.DEBUG,D.isMacintosh&&delete o.DYLD_LIBRARY_PATH,D.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=m;function y(o=v.env){return o.comspec||"cmd.exe"}e.getWindowsShell=y;class b{constructor(l,s,n,r){if(s!==void 0&&n!==void 0&&r!==void 0)this.cmd=l,this.args=s,this.shell=n,this.options=r;else{const i=l;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(v.env).forEach(a=>{i[a]=v.env[a]}),Object.keys(this.options.env).forEach(a=>{i[a]=this.options.env[a]}),this.options.env=i}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const s=l.lastIndexOf(k.sep);return s!==-1&&(l=l.substring(s+1)),b.WellKnowCommands[l]?l:"other"}start(l){return D.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(v.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(s=>{let n,r;const i=new Promise((a,d)=>{n=a,r=d});if(s){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=_.exec(a,this.options,(d,w,P)=>{this.childProcess=null;const O=d;O&&O.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:P.toString()}):this.handleExec(n,l,d,w,P)})}else{let a=null;const d=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,n,l,r);const P={terminated:this.terminateRequested};A.isNumber(w)&&(P.cmdCode=w),n(P)};if(this.shell&&D.isWindows){const w=C.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let P=!1,O=!1;const $=[];let L=this.ensureQuotes(this.cmd);$.push(L.value),P=L.quoted,this.args&&this.args.forEach(U=>{L=this.ensureQuotes(U),$.push(L.value),O=O&&L.quoted});const T=["/s","/c"];P?O?T.push('"'+$.join(" ")+'"'):$.length>1?T.push('"'+$[0]+'" '+$.slice(1).join(" ")):T.push('"'+$[0]+'"'):T.push($.join(" ")),a=_.spawn(y(),T,w)}else this.cmd&&(a=_.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(A.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),a.pid&&(this.childProcess.on("close",d),this.handleSpawn(a,n,l,r,!0)))}return i})}handleClose(l,s,n,r){}ensureQuotes(l){return b.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,h(l,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!D.isWindows)return l(!1);const s=_.spawn(y(),["/s","/c"]);s.on("error",n=>l(!0)),s.on("exit",n=>l(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class f extends b{constructor(l,s,n,r){super(l,s,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,s,n,r,i){[r,i].forEach((a,d)=>{const w=new R.LineDecoder;w.write(a).forEach($=>{s({line:$,source:d===0?0:1})});const O=w.end();O&&s({line:O,source:d===0?0:1})}),l({terminated:this.terminateRequested,error:n})}handleSpawn(l,s,n,r,i){const a=new R.LineDecoder,d=new R.LineDecoder;l.stdout.on("data",w=>{a.write(w).forEach(O=>n({line:O,source:0}))}),l.stderr.on("data",w=>{d.write(w).forEach(O=>n({line:O,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=d}handleClose(l,s,n,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&n({line:i,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}e.LineProcess=f;function E(o){let l=[],s=!1;const n=function(r){if(s){l.push(r);return}(!o.send(r,a=>{if(a&&console.error(a),s=!1,l.length>0){const d=l.slice(0);l=[],d.forEach(w=>n(w))}})||D.isWindows)&&(s=!0)};return{send:n}}e.createQueuedSender=E;var u;(function(o){async function l(s,n,r){if(k.isAbsolute(s))return s;if(n===void 0&&(n=v.cwd()),k.dirname(s)!=="."||(r===void 0&&A.isString(v.env.PATH)&&(r=v.env.PATH.split(k.delimiter)),r===void 0||r.length===0))return k.join(n,s);async function a(d){if(await g.Promises.exists(d)){let w;try{w=await g.Promises.stat(d)}catch(P){P.message.startsWith("EACCES")&&(w=await g.Promises.lstat(d))}return w?!w.isDirectory():!1}return!1}for(let d of r){let w;if(k.isAbsolute(d)?w=k.join(d,s):w=k.join(n,d,s),await a(w))return w;let P=w+".com";if(await a(P)||(P=w+".exe",await a(P)))return P}return k.join(n,s)}o.findExecutable=l})(u=e.win32||(e.win32={}))}),define(we[143],ye([0,1,25,3,82,62]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(S,c){return S===1?t.isWindows?R():C.getWindowsShell(c):I(S,c)}e.getSystemShell=k;function D(S,c){return S===1?t.isWindows?g(c):C.getWindowsShell(c):I(S,c)}e.getSystemShellSync=D;let v=null;function I(S,c){if(t.isLinux&&S===2||t.isMacintosh&&S===3)return"/bin/bash";if(!v){let h;if(t.isWindows)h="/bin/bash";else{if(h=c.SHELL,!h)try{h=(0,_.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}v=h}return v}let A=null;async function R(){return A||(A=(await(0,p.getFirstAvailablePowerShellInstallation)()).exePath),A}function g(S){if(A)return A;const c=t.isWindows&&parseFloat((0,_.release)())>=10,h=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${S.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?m:C.getWindowsShell(S)}}),define(we[86],ye([0,1,38,13,15,20,76,11,7,2,21,62,39]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends g.ChannelServer{constructor(m){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",y=>p.VSBuffer.wrap(Buffer.from(y,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=S;class c{constructor(m,y){this.modulePath=m,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new t.Delayer(b),this.child=null,this._client=null}getChannel(m){const y=this;return{call(b,f,E){return y.requestPromise(m,b,f,E)},listen(b,f){return y.requestEvent(m,b,f)}}}requestPromise(m,y,b,f=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const E=this.getCachedChannel(m),u=(0,t.createCancelablePromise)(s=>E.call(y,b,s)),o=f.onCancellationRequested(()=>u.cancel()),l=(0,I.toDisposable)(()=>u.cancel());return this.activeRequests.add(l),u.finally(()=>{o.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(m,y,b){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let f;const E=new v.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(m).listen(y,b)(E.fire,E),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return E.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,A.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,R.removeDangerousEnvVariables)(y.env),this.child=(0,_.fork)(this.modulePath,m,y);const b=new v.Emitter;v.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,k.isRemoteConsoleLog)(n)){(0,k.log)(n,`IPC Library: ${this.options.serverName}`);return}b.fire(p.VSBuffer.wrap(Buffer.from(n,"base64")))});const E=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,u=n=>this.child&&this.child.connected&&E.send(n.buffer.toString("base64")),o=b.event,l={send:u,onMessage:o};this._client=new g.ChannelClient(l);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(i=>(0,I.dispose)(i)),this.activeRequests.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:r})})}return this._client}getCachedChannel(m){let y=this.channels.get(m);return y||(y=this.client.getChannel(m),this.channels.set(m,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=c}),define(we[144],ye([9,10]),function(J,e){return J.create("vs/base/node/zip",e)}),define(we[145],ye([9,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[146],ye([9,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(we[147],ye([9,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(we[148],ye([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(we[149],ye([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(we[150],ye([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(we[151],ye([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(we[152],ye([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(we[153],ye([9,10]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(we[154],ye([9,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[155],ye([9,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(we[156],ye([9,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(we[157],ye([9,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(we[158],ye([9,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(we[159],ye([9,10]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(we[160],ye([9,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(we[161],ye([9,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(we[162],ye([9,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(we[163],ye([9,10]),function(J,e){return J.create("vs/platform/terminal/node/shellEnv",e)}),define(we[164],ye([9,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(we[165],ye([9,10]),function(J,e){return J.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(we[166],ye([9,10]),function(J,e){return J.create("vs/server/node/serverEnvironmentService",e)}),define(we[167],ye([9,10]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(we[168],ye([9,10]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[169],ye([9,10]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionPoints",e)}),define(we[170],ye([0,1,7,2]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class p{constructor(){this._onCloseEmitter=new _.Emitter,this._onReloadEmitter=new _.Emitter,this._onTerminateEmitter=new _.Emitter,this._onAttachEmitter=new _.Emitter}call(D,v,I){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:I[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:I[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:I[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:I[0],port:I[1],subId:I[2]}))}throw new Error("Method not implemented.")}listen(D,v,I){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=p,p.ChannelName="extensionhostdebugservice";class C extends t.Disposable{constructor(D){super();this.channel=D}reload(D){this.channel.call("reload",[D])}get onReload(){return this.channel.listen("reload")}close(D){this.channel.call("close",[D])}get onClose(){return this.channel.listen("close")}attachSession(D,v,I){this.channel.call("attach",[D,v,I])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(D,v){this.channel.call("terminate",[D,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(D,v){return this.channel.call("openExtensionDevelopmentHostWindow",[D,v])}}e.ExtensionHostDebugChannelClient=C}),define(we[171],ye([0,1,4]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(k){this.service=k}listen(k,D,v){throw new Error("Invalid listen")}call(k,D,v){switch(D){case"download":return this.service.download(_.URI.revive(v[0]),_.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class p{constructor(k,D){this.channel=k,this.getUriTransformer=D}async download(k,D){const v=this.getUriTransformer();v&&(k=v.transformOutgoingURI(k),D=v.transformOutgoingURI(D)),await this.channel.call("download",[k,D])}}e.DownloadServiceChannelClient=p}),define(we[172],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var _;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var t;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var p;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(p=e.EditorOpenSource||(e.EditorOpenSource={}));var C;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var k;(function(D){D.PROGRAMMATIC="api",D.NAVIGATION="code.navigation",D.JUMP="code.jump"})(k=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(we[173],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class _{constructor(p){this.machineId=p}encryption(){return new Promise((p,C)=>J(["vscode-encrypt"],p,C))}async encrypt(p){try{return(await this.encryption()).encrypt(this.machineId,p)}catch{return p}}async decrypt(p){try{return(await this.encryption()).decrypt(this.machineId,p)}catch{return p}}}e.EncryptionMainService=_}),define(we[87],ye([0,1,138,71,8,5,24,22,4]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(h,m,y){this._args=h,this.paths=m,this.productService=y}get appRoot(){return(0,C.dirname)(p.FileAccess.asFileUri("",J).fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return v.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(v.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return v.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return v.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=k.env.VSCODE_PORTABLE;return h?v.URI.file((0,C.join)(h,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,D.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,C.resolve)(h):(0,C.normalize)((0,C.join)(p.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,C.resolve)(h):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,C.resolve)(h);const m=k.env.VSCODE_EXTENSIONS;if(m)return m;const y=k.env.VSCODE_PORTABLE;return y?(0,C.join)(y,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?v.URI.parse(m):v.URI.file((0,C.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?v.URI.parse(h):v.URI.file((0,C.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return A(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,D.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return v.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Ae([t.memoize],I.prototype,"appRoot",null),Ae([t.memoize],I.prototype,"userHome",null),Ae([t.memoize],I.prototype,"userDataPath",null),Ae([t.memoize],I.prototype,"appSettingsHome",null),Ae([t.memoize],I.prototype,"tmpDir",null),Ae([t.memoize],I.prototype,"cacheHome",null),Ae([t.memoize],I.prototype,"userRoamingDataHome",null),Ae([t.memoize],I.prototype,"settingsResource",null),Ae([t.memoize],I.prototype,"userDataSyncHome",null),Ae([t.memoize],I.prototype,"userDataSyncLogResource",null),Ae([t.memoize],I.prototype,"sync",null),Ae([t.memoize],I.prototype,"machineSettingsResource",null),Ae([t.memoize],I.prototype,"globalStorageHome",null),Ae([t.memoize],I.prototype,"workspaceStorageHome",null),Ae([t.memoize],I.prototype,"keybindingsResource",null),Ae([t.memoize],I.prototype,"keyboardLayoutResource",null),Ae([t.memoize],I.prototype,"argvResource",null),Ae([t.memoize],I.prototype,"snippetsHome",null),Ae([t.memoize],I.prototype,"isExtensionDevelopment",null),Ae([t.memoize],I.prototype,"untitledWorkspacesHome",null),Ae([t.memoize],I.prototype,"installSourcePath",null),Ae([t.memoize],I.prototype,"builtinExtensionsPath",null),Ae([t.memoize],I.prototype,"extensionsPath",null),Ae([t.memoize],I.prototype,"extensionDevelopmentLocationURI",null),Ae([t.memoize],I.prototype,"extensionDevelopmentKind",null),Ae([t.memoize],I.prototype,"extensionTestsLocationURI",null),Ae([t.memoize],I.prototype,"debugExtensionHost",null),Ae([t.memoize],I.prototype,"serviceMachineIdResource",null),Ae([t.memoize],I.prototype,"telemetryLogResource",null),Ae([t.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function A(c,h){return S(c["inspect-extensions"],c["inspect-brk-extensions"],5870,h,c.debugId,c.extensionEnvironment)}e.parseExtensionHostPort=A;function R(c,h){return S(c["inspect-search"],c["inspect-brk-search"],5876,h,c.extensionEnvironment)}e.parseSearchPort=R;function g(c,h){return S(c["inspect-ptyhost"],c["inspect-brk-ptyhost"],5877,h,c.extensionEnvironment)}e.parsePtyHostPort=g;function S(c,h,m,y,b,f){const u=Number(h||c)||(y?null:m),o=u?Boolean(!!h):!1;let l;if(f)try{l=JSON.parse(f)}catch{}return{port:u,break:o,debugId:b,env:l}}}),define(we[52],ye([0,1,256,3,146]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,p.localize)(0,null),e:(0,p.localize)(1,null),t:(0,p.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,p.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,p.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,p.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,p.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,p.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,p.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,p.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,p.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,p.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,p.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,p.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,p.localize)(14,null)},category:{type:"string",cat:"e",description:(0,p.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,p.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,p.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,p.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,p.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,p.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,p.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,p.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,p.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,p.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,p.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,p.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,p.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,p.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,p.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,p.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,p.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,p.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function D(c,h,m=k){const y={},b=[],f=[];for(let l in h){const s=h[l];s.alias&&(y[l]=s.alias),s.type==="string"||s.type==="string[]"?(b.push(l),s.deprecates&&b.push(...s.deprecates)):s.type==="boolean"&&(f.push(l),s.deprecates&&f.push(...s.deprecates))}const E=_(c,{string:b,boolean:f,alias:y}),u={},o=E;u._=E._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(let l in h){const s=h[l];s.alias&&delete o[s.alias];let n=o[l];if(s.deprecates)for(const r of s.deprecates)o.hasOwnProperty(r)&&(n||(n=o[r],n&&m.onDeprecatedOption(r,s.deprecationMessage||(0,p.localize)(33,null))),delete o[r]);typeof n!="undefined"&&(s.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):s.type==="string"&&Array.isArray(n)&&(n=n.pop(),m.onMultipleValues(l,n)),u[l]=n,s.deprecationMessage&&m.onDeprecatedOption(l,s.deprecationMessage)),delete o[l]}for(let l in o)m.onUnknownOption(l);return u}e.parseArgs=D;function v(c,h){let m="";return h.args&&(Array.isArray(h.args)?m=` <${h.args.join("> <")}>`:m=` <${h.args}>`),h.alias?`-${h.alias} --${c}${m}`:`--${c}${m}`}function I(c,h){let m=0,y=[];for(const u in c){const o=c[u],l=v(u,o);m=Math.max(m,l.length),y.push([l,o.description])}let b=m+2+1;if(h-b<25)return y.reduce((u,o)=>u.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let f=h-b-1,E=[];for(const u of y){let o=u[0],l=R(u[1],f),s=A(b-o.length-2);E.push("  "+o+s+l[0]);for(let n=1;n<l.length;n++)E.push(A(b)+l[n])}return E}e.formatOptions=I;function A(c){return" ".repeat(c)}function R(c,h){let m=[];for(;c.length;){let y=c.length<h?c.length:c.lastIndexOf(" ",h),b=c.slice(0,y).trim();c=c.slice(y),m.push(b)}return m}function g(c,h,m,y,b){const f=process.stdout.isTTY&&process.stdout.columns||80,E=b?.noInputFiles!==!0?`[${(0,p.localize)(34,null)}...]`:"",u=[`${c} ${m}`];u.push(""),u.push(`${(0,p.localize)(35,null)}: ${h} [${(0,p.localize)(36,null)}]${E}`),u.push(""),b?.noPipe!==!0&&(t.isWindows?u.push((0,p.localize)(37,null,h)):u.push((0,p.localize)(38,null,h)),u.push(""));const o={};for(const l in y){const s=y[l];if(s.description&&s.cat){let n=o[s.cat];n||(o[s.cat]=n={}),n[l]=s}}for(let l in o){const s=l;let n=o[s];n&&(u.push(C[s]),u.push(...I(n,f)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=g;function S(c,h){return`${c||(0,p.localize)(39,null)}
${h||(0,p.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=S}),define(we[174],ye([0,1,257,147,52]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function k(g,S){const c={onUnknownOption:m=>{console.warn((0,t.localize)(0,null,m))},onMultipleValues:(m,y)=>{console.warn((0,t.localize)(1,null,m,y))},onDeprecatedOption:(m,y)=>{console.warn((0,t.localize)(2,null,m,y))}},h=(0,p.parseArgs)(g,p.OPTIONS,S?c:void 0);return h.goto&&h._.forEach(m=>_(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,t.localize)(3,null))),h["max-memory"]&&_(parseInt(h["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),h}function D(g){const S=g.findIndex(c=>!/^-/.test(c));if(S>-1)return[...g.slice(0,S),...g.slice(S+1)]}function v(g){let[,...S]=g;process.env.VSCODE_DEV&&(S=D(S)||[]);const c=!R(process.env);return k(S,c)}e.parseMainProcessArgv=v;function I(g){const[,,...S]=g;return k(S,!0)}e.parseCLIProcessArgv=I;function A(g,...S){const c=g.indexOf("--");return c===-1?g.push(...S):g.splice(c,0,...S),g}e.addArg=A;function R(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function J(e,_,t,p){function C(D){const v=k(D),I=[v];return e.isAbsolute(v)||I.unshift(p),e.resolve(...I)}function k(D){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,t);const A=D["user-data-dir"];if(A)return A;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(R,"AppData","Roaming")}break;case"darwin":I=e.join(_.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(_.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,t)}return{getUserDataPath:C}}if(typeof define=="function")define(we[175],ye([0,129,25,8,22,24]),function(e,_,t,p,C,k){const D=C.dirname(p.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(C.joinPath(D,"package.json").fsPath);return J(_,t,v.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),_=require("path"),t=require("os");module.exports=J(_,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(we[176],ye([0,1,25,87,175]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends t.AbstractNativeEnvironmentService{constructor(D,v){super(D,{homeDir:(0,_.homedir)(),tmpDir:(0,_.tmpdir)(),userDataDir:(0,p.getUserDataPath)(D)},v)}}e.NativeEnvironmentService=C}),define(we[177],ye([0,1,21]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const t=/^%([\w\d.-]+)%$/i;function p(C,k){const D=v=>{if(typeof v!="string")return;const I=t.exec(v);if(!I)return;const A=k[I[1]]??v;return typeof A=="string"?A:typeof A.message=="string"?A.message:v};return(0,_.cloneAndChange)(C,D)}e.localizeManifest=p}),define(we[63],ye([0,1,154]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function C(g){return g=g.trim(),g==="*"||t.test(g)}e.isValidVersionStr=C;function k(g){if(!C(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=g.match(t);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=k;function D(g){if(!g)return null;let S=g.majorBase,c=g.majorMustEqual,h=g.minorBase,m=g.minorMustEqual,y=g.patchBase,b=g.patchMustEqual;g.hasCaret&&(S===0||(m=!1),b=!1);let f=0;if(g.preRelease){const E=p.exec(g.preRelease);if(E){const[,u,o,l]=E;f=Date.UTC(Number(u),Number(o)-1,Number(l))}}return{majorBase:S,majorMustEqual:c,minorBase:h,minorMustEqual:m,patchBase:y,patchMustEqual:b,isMinimum:g.hasGreaterEquals,notBefore:f}}e.normalizeVersion=D;function v(g,S,c){let h;typeof g=="string"?h=D(k(g)):h=g;let m;S instanceof Date?m=S.getTime():typeof S=="string"&&(m=new Date(S).getTime());let y;if(typeof c=="string"?y=D(k(c)):y=c,!h||!y)return!1;let b=h.majorBase,f=h.minorBase,E=h.patchBase,u=y.majorBase,o=y.minorBase,l=y.patchBase,s=y.notBefore,n=y.majorMustEqual,r=y.minorMustEqual,i=y.patchMustEqual;return y.isMinimum?b>u?!0:b<u?!1:f>o?!0:f<o||m&&m<s?!1:E>=l:(b===1&&u===0&&(!n||!r||!i)&&(u=1,o=0,l=0,n=!0,r=!1,i=!1),b<u?!1:b>u?!n:f<o?!1:f>o?!r:E<l?!1:E>l?!i:!(m&&m<s))}e.isValidVersion=v;function I(g,S,c,h){return c.isBuiltin||typeof c.main=="undefined"?!0:R(g,S,c.engines.vscode,h)}e.isValidExtensionVersion=I;function A(g,S,c){return g==="*"||R(S,c,g)}e.isEngineValid=A;function R(g,S,c,h=[]){let m=D(k(c));if(!m)return h.push(_.localize(0,null,c)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return h.push(_.localize(1,null,c)),!1}else if(!m.majorMustEqual)return h.push(_.localize(2,null,c)),!1;return v(g,S,m)?!0:(h.push(_.localize(3,null,g,c)),!1)}}),define(we[178],ye([0,1,15,23]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function p(C,k,D){let v=D&&D.get("storage.serviceMachineId",0)||null;if(v)return v;try{const A=(await k.readFile(C.serviceMachineIdResource)).value.toString();v=(0,t.isUUID)(A)?A:null}catch{v=null}if(!v){v=(0,t.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,_.VSBuffer.fromString(v))}catch{}}return D&&D.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=p}),define(we[53],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class _{constructor(p,C=[],k=!1){this.ctor=p,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=_}),define(we[179],ye([0,1,53]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function p(k,D,v){D instanceof _.SyncDescriptor||(D=new _.SyncDescriptor(D,[],v)),t.push([k,D])}e.registerSingleton=p;function C(){return t}e.getSingletonServiceDescriptors=C}),define(we[180],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=_;class t{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const D=this.lookupOrInsertNode(C),v=this.lookupOrInsertNode(k);D.outgoing.set(this._hashFn(k),v),v.incoming.set(this._hashFn(C),D)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(let D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let D=this._nodes.get(k);return D||(D=new _(C),this._nodes.set(k,D)),D}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[k,D]of this._nodes)C.push(`${k}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,k]of this._nodes){const D=new Set([C]),v=this._findCycle(k,D);if(v)return v}}_findCycle(C,k){for(let[D,v]of C.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const I=this._findCycle(v,k);if(I)return I;k.delete(D)}}}e.Graph=t}),define(we[6],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(v){return v[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(_=e._util||(e._util={})),e.IInstantiationService=p("instantiationService");function t(k,D,v){D[_.DI_TARGET]===D?D[_.DI_DEPENDENCIES].push({id:k,index:v}):(D[_.DI_DEPENDENCIES]=[{id:k,index:v}],D[_.DI_TARGET]=D)}function p(k){if(_.serviceIds.has(k))return _.serviceIds.get(k);const D=function(v,I,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(D,v,A)};return D.toString=()=>k,_.serviceIds.set(k,D),D}e.createDecorator=p;function C(k){return k}e.refineServiceDecorator=C}),define(we[28],ye([0,1,12,4,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,p.createDecorator)("configurationService");function C(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=C;function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||_.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var D;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=v;function I(m,y){const b=Object.create(null);for(let f in m)A(b,f,m[f],y);return b}e.toValuesTree=I;function A(m,y,b,f){const E=y.split("."),u=E.pop();let o=m;for(let l=0;l<E.length;l++){let s=E[l],n=o[s];switch(typeof n){case"undefined":n=o[s]=Object.create(null);break;case"object":break;default:f(`Ignoring ${y} as ${E.slice(0,l+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[u]=b}catch{f(`Ignoring ${y} as ${E.join(".")} is ${JSON.stringify(o)}`)}else f(`Ignoring ${y} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=A;function R(m,y){const b=y.split(".");g(m,b)}e.removeFromValueTree=R;function g(m,y){const b=y.shift();if(y.length===0){delete m[b];return}if(Object.keys(m).indexOf(b)!==-1){const f=m[b];typeof f=="object"&&!Array.isArray(f)&&(g(f,y),Object.keys(f).length===0&&delete m[b])}}function S(m,y,b){function f(o,l){let s=o;for(const n of l){if(typeof s!="object"||s===null)return;s=s[n]}return s}const E=y.split("."),u=f(m,E);return typeof u=="undefined"?b:u}e.getConfigurationValue=S;function c(m,y,b){Object.keys(y).forEach(f=>{f!=="__proto__"&&(f in m?_.isObject(m[f])&&_.isObject(y[f])?c(m[f],y[f],b):b&&(m[f]=y[f]):m[f]=y[f])})}e.merge=c;function h(m,y,b){const f=m.inspect(y),E=m.inspect(b);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:f.defaultValue}e.getMigratedSettingValue=h}),define(we[88],ye([0,1,3,16,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",_.isMacintosh),C.set("isLinux",_.isLinux),C.set("isWindows",_.isWindows),C.set("isWeb",_.isWeb),C.set("isMacNative",_.isMacintosh&&!_.isWeb),C.set("isEdge",_.isEdge),C.set("isFirefox",_.isFirefox),C.set("isChrome",_.isChrome),C.set("isSafari",_.isSafari);const k=Object.prototype.hasOwnProperty;var D;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return R.INSTANCE}static true(){return g.INSTANCE}static has(T){return S.create(T)}static equals(T,U){return c.create(T,U)}static notEquals(T,U){return y.create(T,U)}static regex(T,U){return s.create(T,U)}static in(T,U){return h.create(T,U)}static not(T){return b.create(T)}static and(...T){return i.create(T,null)}static or(...T){return a.create(T,null,!0)}static greater(T,U){return E.create(T,U)}static greaterEquals(T,U){return u.create(T,U)}static smaller(T,U){return o.create(T,U)}static smallerEquals(T,U){return l.create(T,U)}static deserialize(T,U=!1){if(!!T)return this._deserializeOrExpression(T,U)}static _deserializeOrExpression(T,U){let N=T.split("||");return a.create(N.map(W=>this._deserializeAndExpression(W,U)),null,!0)}static _deserializeAndExpression(T,U){let N=T.split("&&");return i.create(N.map(W=>this._deserializeOne(W,U)),null)}static _deserializeOne(T,U){if(T=T.trim(),T.indexOf("!=")>=0){let N=T.split("!=");return y.create(N[0].trim(),this._deserializeValue(N[1],U))}if(T.indexOf("==")>=0){let N=T.split("==");return c.create(N[0].trim(),this._deserializeValue(N[1],U))}if(T.indexOf("=~")>=0){let N=T.split("=~");return s.create(N[0].trim(),this._deserializeRegexValue(N[1],U))}if(T.indexOf(" in ")>=0){let N=T.split(" in ");return h.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const N=T.split(">=");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const N=T.split(">");return E.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const N=T.split("<=");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const N=T.split("<");return o.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(T)?b.create(T.substr(1).trim()):S.create(T)}static _deserializeValue(T,U){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;let N=/^'([^']*)'$/.exec(T);return N?N[1].trim():T}static _deserializeRegexValue(T,U){if((0,t.isFalsyOrWhitespace)(T)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=T.indexOf("/"),W=T.lastIndexOf("/");if(N===W||N<0){if(U)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}let ie=T.slice(N+1,W),j=T[W+1]==="i"?"i":"";try{return new RegExp(ie,j)}catch(re){if(U)throw new Error(`bad regexp-value '${T}', parse error: ${re}`);return console.warn(`bad regexp-value '${T}', parse error: ${re}`),null}}}e.ContextKeyExpr=v;function I(L,T){const U=L?L.substituteConstants():void 0,N=T?T.substituteConstants():void 0;return!U&&!N?!0:!U||!N?!1:U.equals(N)}e.expressionsAreEqualWithConstantSubstitution=I;function A(L,T){return L.cmp(T)}class R{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class g{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class S{constructor(T,U){this.key=T,this.negated=U,this.type=2}static create(T,U=null){const N=C.get(T);return typeof N=="boolean"?N?g.INSTANCE:R.INSTANCE:new S(T,U)}cmp(T){return T.type!==this.type?this.type-T.type:w(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=C.get(this.key);return typeof T=="boolean"?T?g.INSTANCE:R.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class c{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=4}static create(T,U,N=null){if(typeof U=="boolean")return U?S.create(T,N):b.create(T,N);const W=C.get(T);return typeof W=="boolean"?U===(W?"true":"false")?g.INSTANCE:R.INSTANCE:new c(T,U,N)}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=C.get(this.key);if(typeof T=="boolean"){const U=T?"true":"false";return this.value===U?g.INSTANCE:R.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class h{constructor(T,U){this.key=T,this.valueKey=U,this.type=10,this.negated=null}static create(T,U){return new h(T,U)}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const U=T.getValue(this.valueKey),N=T.getValue(this.key);return Array.isArray(U)?U.indexOf(N)>=0:typeof N=="string"&&typeof U=="object"&&U!==null?k.call(U,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=h;class m{constructor(T){this._actual=T,this.type=11}static create(T){return new m(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new m(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class y{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=5}static create(T,U,N=null){if(typeof U=="boolean")return U?b.create(T,N):S.create(T,N);const W=C.get(T);return typeof W=="boolean"?U===(W?"true":"false")?R.INSTANCE:g.INSTANCE:new y(T,U,N)}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=C.get(this.key);if(typeof T=="boolean"){const U=T?"true":"false";return this.value===U?R.INSTANCE:g.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class b{constructor(T,U){this.key=T,this.negated=U,this.type=3}static create(T,U=null){const N=C.get(T);return typeof N=="boolean"?N?R.INSTANCE:g.INSTANCE:new b(T,U)}cmp(T){return T.type!==this.type?this.type-T.type:w(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=C.get(this.key);return typeof T=="boolean"?T?R.INSTANCE:g.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function f(L,T){if(typeof L=="string"){const U=parseFloat(L);isNaN(U)||(L=U)}return typeof L=="string"||typeof L=="number"?T(L):R.INSTANCE}class E{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=12}static create(T,U,N=null){return f(U,W=>new E(T,W,N))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=E;class u{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=13}static create(T,U,N=null){return f(U,W=>new u(T,W,N))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class o{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=14}static create(T,U,N=null){return f(U,W=>new o(T,W,N))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class l{constructor(T,U,N){this.key=T,this.value=U,this.negated=N,this.type=15}static create(T,U,N=null){return f(U,W=>new l(T,W,N))}cmp(T){return T.type!==this.type?this.type-T.type:P(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=l;class s{constructor(T,U){this.key=T,this.regexp=U,this.type=7,this.negated=null}static create(T,U){return new s(T,U)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const U=this.regexp?this.regexp.source:"",N=T.regexp?T.regexp.source:"";return U<N?-1:U>N?1:0}equals(T){if(T.type===this.type){const U=this.regexp?this.regexp.source:"",N=T.regexp?T.regexp.source:"";return this.key===T.key&&U===N}return!1}substituteConstants(){return this}evaluate(T){let U=T.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(T){this._actual=T,this.type=8}static create(T){return new n(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new n(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function r(L){let T=null;for(let U=0,N=L.length;U<N;U++){const W=L[U].substituteConstants();if(L[U]!==W&&T===null){T=[];for(let ie=0;ie<U;ie++)T[ie]=L[ie]}T!==null&&(T[U]=W)}return T===null?L:T}class i{constructor(T,U){this.expr=T,this.negated=U,this.type=6}static create(T,U){return i._normalizeArr(T,U)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const W=A(this.expr[U],T.expr[U]);if(W!==0)return W}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(T.expr[U]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:i.create(T,this.negated)}evaluate(T){for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].evaluate(T))return!1;return!0}static _normalizeArr(T,U){const N=[];let W=!1;for(const ie of T)if(!!ie){if(ie.type===1){W=!0;continue}if(ie.type===0)return R.INSTANCE;if(ie.type===6){N.push(...ie.expr);continue}N.push(ie)}if(N.length===0&&W)return g.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(A);for(let ie=1;ie<N.length;ie++)N[ie-1].equals(N[ie])&&(N.splice(ie,1),ie--);if(N.length===1)return N[0];for(;N.length>1;){const ie=N[N.length-1];if(ie.type!==9)break;N.pop();const j=N.pop(),re=N.length===0,x=a.create(ie.expr.map(K=>i.create([K,j],null)),null,re);x&&(N.push(x),N.sort(A))}return N.length===1?N[0]:new i(N,U)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(let U of this.expr)T.push(...U.keys());return T}map(T){return new i(this.expr.map(U=>U.map(T)),null)}negate(){if(!this.negated){const T=[];for(let U of this.expr)T.push(U.negate());this.negated=a.create(T,this,!0)}return this.negated}}class a{constructor(T,U){this.expr=T,this.negated=U,this.type=9}static create(T,U,N){return a._normalizeArr(T,U,N)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const W=A(this.expr[U],T.expr[U]);if(W!==0)return W}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(T.expr[U]))return!1;return!0}return!1}substituteConstants(){const T=r(this.expr);return T===this.expr?this:a.create(T,this.negated,!1)}evaluate(T){for(let U=0,N=this.expr.length;U<N;U++)if(this.expr[U].evaluate(T))return!0;return!1}static _normalizeArr(T,U,N){let W=[],ie=!1;if(T){for(let j=0,re=T.length;j<re;j++){const x=T[j];if(!!x){if(x.type===0){ie=!0;continue}if(x.type===1)return g.INSTANCE;if(x.type===9){W=W.concat(x.expr);continue}W.push(x)}}if(W.length===0&&ie)return R.INSTANCE;W.sort(A)}if(W.length!==0){if(W.length===1)return W[0];for(let j=1;j<W.length;j++)W[j-1].equals(W[j])&&(W.splice(j,1),j--);if(W.length===1)return W[0];if(N){for(let j=0;j<W.length;j++)for(let re=j+1;re<W.length;re++)O(W[j],W[re])&&(W.splice(re,1),re--);if(W.length===1)return W[0]}return new a(W,U)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(let U of this.expr)T.push(...U.keys());return T}map(T){return new a(this.expr.map(U=>U.map(T)),null)}negate(){if(!this.negated){let T=[];for(let U of this.expr)T.push(U.negate());for(;T.length>1;){const U=T.shift(),N=T.shift(),W=[];for(const j of $(U))for(const re of $(N))W.push(i.create([j,re],null));const ie=T.length===0;T.unshift(a.create(W,null,ie))}this.negated=T[0]}return this.negated}}class d extends S{constructor(T,U,N){super(T,null);this._defaultValue=U,typeof N=="object"?d._info.push({...N,key:T}):N!==!0&&d._info.push({key:T,description:N,type:U!=null?typeof U:void 0})}static all(){return d._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return c.create(this.key,T)}notEqualsTo(T){return y.create(this.key,T)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,p.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(L,T){return L<T?-1:L>T?1:0}function P(L,T,U,N){return L<U?-1:L>U?1:T<N?-1:T>N?1:0}function O(L,T){if(T.type===6&&L.type!==9&&L.type!==6){for(const W of T.expr)if(L.equals(W))return!0}const U=L.negate(),N=$(U).concat($(T));N.sort(A);for(let W=0;W<N.length;W++){const j=N[W].negate();for(let re=W+1;re<N.length;re++){const x=N[re];if(j.equals(x))return!0}}return!1}e.implies=O;function $(L){return L.type===9?L.expr:[L]}}),define(we[89],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,_.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,_.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(C,k){return this.secretVault[C]?.[k]??null}async setPassword(C,k,D){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][k]=D}async deletePassword(C,k){return this.secretVault[C]?.[k]?(delete this.secretVault[C][k],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const k=[];for(const D of Object.keys(this.secretVault[C]||{}))k.push({account:D,password:this.secretVault[C][D]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(we[181],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,_.createDecorator)(e.ID);function t(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=t;class p{async getPerformanceInfo(k,D){return{}}async getSystemInfo(k,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,D){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=p}),define(we[64],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,_.createDecorator)("downloadService")}),define(we[182],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,_.createDecorator)("encryptionMainService")}),define(we[26],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(we[19],ye([0,1,11,29,5,16,12,4,156,6]),function(J,e,_,t,p,C,k,D,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function A(j){return j.create===!0}e.isFileOpenForWriteOptions=A;var R;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var g;(function(j){j[j.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var S;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function c(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=c;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function m(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function y(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=y;function b(j){return c(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var f;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(re,x){super(re);this.code=x}}e.FileSystemProviderError=E;function u(j,re){const x=new E(j.toString(),re);return l(x,re),x}e.createFileSystemProviderError=u;function o(j){return j||u((0,v.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=o;function l(j,re){return j.name=re?`${re} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=l;function s(j){if(!j)return f.Unknown;if(j instanceof E)return j.code;const re=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!re)return f.Unknown;switch(re[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=s;function n(j){if(j instanceof P)return j.fileOperationResult;switch(s(j)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var r;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(re,x,K){this.resource=re,this.operation=x,this.target=K}isOperation(re){return this.operation===re}}e.FileOperationEvent=i;var a;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class d{constructor(re,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=re;const K=new Map;for(const te of re){const ce=K.get(te.type);switch(ce?ce.push([te.resource,te]):K.set(te.type,[[te.resource,te]]),te.type){case 1:this.rawAdded.push(te.resource);break;case 0:this.rawUpdated.push(te.resource);break;case 2:this.rawDeleted.push(te.resource);break}}for(const[te,ce]of K)switch(te){case 1:this.added=t.TernarySearchTree.forUris(()=>x),this.added.fill(ce);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>x),this.updated.fill(ce);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>x),this.deleted.fill(ce);break}}contains(re,...x){return this.doContains(re,{includeChildren:!1},...x)}affects(re,...x){return this.doContains(re,{includeChildren:!0},...x)}doContains(re,x,...K){if(!re)return!1;const te=K.length>0;return!!((!te||K.includes(1))&&(this.added?.get(re)||x.includeChildren&&this.added?.findSuperstr(re))||(!te||K.includes(0))&&(this.updated?.get(re)||x.includeChildren&&this.updated?.findSuperstr(re))||(!te||K.includes(2))&&(this.deleted?.findSubstr(re)||x.includeChildren&&this.deleted?.findSuperstr(re)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function w(j,re,x){return!j||!re||j===re||re.length>j.length?!1:(re.charAt(re.length-1)!==p.sep&&(re+=p.sep),x?(0,C.startsWithIgnoreCase)(j,re):j.indexOf(re)===0)}e.isParent=w;class P extends _.ErrorNoTelemetry{constructor(re,x,K){super(re);this.fileOperationResult=x,this.options=K}}e.FileOperationError=P;class O extends P{constructor(re,x,K){super(re,2,K);this.stat=x}}e.NotModifiedSinceFileOperationError=O;var $;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})($=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=T;async function U(j,re){if(!re.hasProvider(D.URI.from({scheme:j.scheme})))return new Promise(x=>{const K=re.onDidChangeFileSystemProviderRegistrations(te=>{te.scheme===j.scheme&&te.added&&(K.dispose(),x())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(re){return(0,k.isNumber)(re)||(re=0),re<N.KB?(0,v.localize)(1,null,re.toFixed(0)):re<N.MB?(0,v.localize)(2,null,(re/N.KB).toFixed(2)):re<N.GB?(0,v.localize)(3,null,(re/N.MB).toFixed(2)):re<N.TB?(0,v.localize)(4,null,(re/N.GB).toFixed(2)):(0,v.localize)(5,null,(re/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var W;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function ie(j){return{maxFileSize:j===0?300*N.MB:16*N.GB,maxHeapSize:j===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=ie}),define(we[183],ye([0,1,15,36,11,7,2,42,4,23,19]),function(J,e,_,t,p,C,k,D,v,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends k.Disposable{constructor(S,c){super();this.channel=S,this.extraCapabilities=c,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,c){const{buffer:h}=await this.channel.call("readFile",[S,c]);return h}readFileStream(S,c,h){const m=(0,D.newWriteableStream)(b=>_.VSBuffer.concat(b.map(f=>_.VSBuffer.wrap(f))).buffer),y=this.channel.listen("readFileStream",[S,c])(b=>{if(b instanceof _.VSBuffer)m.write(b.buffer);else{if(b==="end")m.end();else{let f=b;f instanceof Error||(f=(0,A.createFileSystemProviderError)((0,t.toErrorMessage)(f),A.FileSystemProviderErrorCode.Unknown)),m.error(f),m.end()}y.dispose()}});return h.onCancellationRequested(()=>{m.error((0,p.canceled)()),m.end(),y.dispose()}),m}writeFile(S,c,h){return this.channel.call("writeFile",[S,_.VSBuffer.wrap(c),h])}open(S,c){return this.channel.call("open",[S,c])}close(S){return this.channel.call("close",[S])}async read(S,c,h,m,y){const[b,f]=await this.channel.call("read",[S,c,y]);return h.set(b.buffer.slice(0,f),m),f}write(S,c,h,m,y){return this.channel.call("write",[S,c,_.VSBuffer.wrap(h),m,y])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,c){return this.channel.call("delete",[S,c])}rename(S,c,h){return this.channel.call("rename",[S,c,h])}copy(S,c,h){return this.channel.call("copy",[S,c,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const c=S;this._onDidChange.fire(c.map(h=>({resource:v.URI.revive(h.resource),type:h.type})))}else{const c=S;this._onDidWatchError.fire(c)}}))}watch(S,c){const h=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,h,S,c]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=R}),define(we[90],ye([0,1,15,11,157,19]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(A,R,g,S,c,h){let m;try{await D(A,R,g,S,c,h)}catch(y){m=y}finally{m&&c.errorTransformer&&(m=c.errorTransformer(m)),typeof m!="undefined"&&g.error(m),g.end()}}e.readFileIntoStream=k;async function D(A,R,g,S,c,h){v(h);const m=await A.open(R,{create:!1});try{v(h);let y=0,b=0,f=c&&typeof c.length=="number"?c.length:void 0,E=_.VSBuffer.alloc(Math.min(c.bufferSize,typeof f=="number"?f:c.bufferSize)),u=c&&typeof c.position=="number"?c.position:0,o=0;do b=await A.read(m,u,E.buffer,o,E.byteLength-o),u+=b,o+=b,y+=b,typeof f=="number"&&(f-=b),o===E.byteLength&&(await g.write(S(E)),E=_.VSBuffer.alloc(Math.min(c.bufferSize,typeof f=="number"?f:c.bufferSize)),o=0);while(b>0&&(typeof f!="number"||f>0)&&v(h)&&I(y,c));if(o>0){let l=o;typeof f=="number"&&(l=Math.min(o,f)),g.write(S(E.slice(0,l)))}}catch(y){throw(0,C.ensureFileSystemProviderError)(y)}finally{await A.close(m)}}function v(A){if(A.isCancellationRequested)throw(0,t.canceled)();return!0}function I(A,R){if(R?.limits){if(typeof R.limits.memory=="number"&&A>R.limits.memory)throw(0,C.createFileSystemProviderError)((0,p.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&A>R.limits.size)throw(0,C.createFileSystemProviderError)((0,p.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(we[54],ye([0,1,2,3,4,19]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function k(S){return S.recursive===!0}e.isRecursiveWatchRequest=k;class D extends _.Disposable{constructor(c,h,m,y){super();this.onFileChanges=c,this.onLogMessage=h,this.verboseLogging=m,this.options=y,this.watcherDisposables=this._register(new _.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new _.DisposableStore;this.watcherDisposables.value=c,this.watcher=this.createWatcher(c),this.watcher.setVerboseLogging(this.verboseLogging),c.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),c.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),c.add(this.watcher.onDidError(h=>this.onError(h)))}onError(c){this.options.restartOnError?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`):this.error(c)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.watcher?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.watcher?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${c}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D,D.MAX_RESTARTS=5;class v extends D{constructor(c,h,m){super(c,h,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class I extends D{constructor(c,h,m){super(c,h,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function A(S){return S.map(c=>({type:c.type,resource:p.URI.file(c.path)}))}e.toFileChanges=A;function R(S){const c=new g;for(const h of S)c.processEvent(h);return c.coalesce()}e.coalesceEvents=R;class g{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return t.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const h=this.mapPathToChange.get(this.toKey(c));let m=!1;if(h){const y=h.type,b=c.type;h.path!==c.path&&(c.type===2||c.type===1)?m=!0:y===1&&b===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(h)):y===2&&b===1?h.type=0:y===1&&b===0||(h.type=b)}else m=!0;m&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],h=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(c.push(m),!1):!0).sort((m,y)=>m.path.length-y.path.length).filter(m=>h.some(y=>(0,C.isParent)(m.path,y,!t.isLinux))?!1:(h.push(m.path),!0)).concat(c)}}}),define(we[184],ye([0,1,27,13,20,34,77,2,74,5,3,132,18,54]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class c extends D.Disposable{constructor(y,b,f,E){super();this.request=y,this.onDidFilesChange=b,this.onLogMessage=f,this.verboseLogging=E,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(c.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(u=>(0,k.parse)(u)),this.cts=new p.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const b=await g.Promises.stat(y);this._register(await this.doWatch(y,b.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let b=y.path;try{b=await g.Promises.realpath(y.path),y.path===b&&(b=await(0,R.realcase)(y.path)??y.path),y.path!==b&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${b})`)}catch{}return b}async doWatch(y,b){if(A.isMacintosh&&(0,C.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const f=new p.CancellationTokenSource(this.cts.token);let E=new D.DisposableStore;try{const u=(0,I.basename)(y),o=(0,_.watch)(y);E.add((0,D.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${y}'`);const l=new Set;if(b)try{for(const n of await g.Promises.readdir(y))l.add(n)}catch(n){this.error(n)}const s=new Map;E.add((0,D.toDisposable)(()=>{for(const[,n]of s)n.dispose();s.clear()})),o.on("error",(n,r)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${n}, ${r})`),this.dispose()}),o.on("change",(n,r)=>{if(f.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${r}`);let i="";if(r&&(i=r.toString(),A.isMacintosh&&(i=(0,v.normalizeNFC)(i))),!(!i||n!=="change"&&n!=="rename"))if(b)if(n==="rename"){s.get(i)?.dispose();const a=setTimeout(async()=>{if(s.delete(i),i===u&&!await g.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const d=await this.existsChildStrictCase((0,I.join)(y,i));if(f.token.isCancellationRequested)return;let w;d?l.has(i)?w=0:(w=1,l.add(i)):(l.delete(i),w=2),this.onFileChange({path:(0,I.join)(this.request.path,i),type:w})},c.FILE_DELETE_HANDLER_DELAY);s.set(i,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;l.has(i)?a=0:(a=1,l.add(i)),this.onFileChange({path:(0,I.join)(this.request.path,i),type:a})}else if(n==="rename"||i!==u){const a=setTimeout(async()=>{const d=await g.Promises.exists(y);f.token.isCancellationRequested||(d?(this.onFileChange({path:this.request.path,type:0},!0),E.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},c.FILE_DELETE_HANDLER_DELAY);E.clear(),E.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await g.Promises.exists(y)&&!f.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${u.toString()})`)}return(0,D.toDisposable)(()=>{f.dispose(!0),E.dispose()})}async onFileChange(y,b=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!b&&this.excludes.some(f=>f(y.path))?this.verboseLogging&&this.trace(` >> ignored ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,S.coalesceEvents)(f);if(E.length>0){if(this.verboseLogging)for(const o of E)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(E)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${E[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${E.length}, most recent change: ${E[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(A.isLinux)return g.Promises.exists(y);try{const b=(0,I.basename)(y);return(await g.Promises.readdir((0,I.dirname)(y))).some(E=>E===b)}catch(b){return this.trace(b),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=c,c.FILE_DELETE_HANDLER_DELAY=100,c.FILE_CHANGES_HANDLER_DELAY=50;async function h(m,y,b,f,E=512){const u=await g.Promises.open(m,"r"),o=Buffer.allocUnsafe(E),l=new p.CancellationTokenSource(f);let s,n=!1;const r={path:m,excludes:[],recursive:!1},i=new c(r,a=>{(async()=>{for(const{type:d}of a)if(d===0){if(n)return;n=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:w}=await g.Promises.read(u,o,0,E,null);if(!w||l.token.isCancellationRequested)break;y(o.slice(0,w))}}catch(w){s=new Error(w),l.dispose(!0)}finally{n=!1}}})()});return await i.ready,b(),new Promise((a,d)=>{l.token.onCancellationRequested(async()=>{i.dispose();try{await g.Promises.close(u)}catch(w){s=new Error(w)}s?d(s):a()})})}e.watchFileContents=h}),define(we[185],ye([0,1,17,7,2,3,184]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends p.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new t.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=t.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(I){const A=this.normalizeRequests(I),R=A.filter(S=>{const c=this.watchers.get(S.path);return c?!(0,_.equals)(c.request.excludes,S.excludes):!0}),g=Array.from(this.watchers.values()).filter(({request:S})=>!A.find(c=>c.path===S.path&&(0,_.equals)(c.excludes,S.excludes))).map(({request:S})=>S.path);R.length&&this.trace(`Request to start watching: ${R.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const S of g)this.stopWatching(S);for(const S of R)this.startWatching(S)}startWatching(I){const A=new k.NodeJSFileWatcherLibrary(I,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),R={request:I,instance:A};this.watchers.set(I.path,R)}async stop(){for(const[I]of this.watchers)this.stopWatching(I);this.watchers.clear()}stopWatching(I){const A=this.watchers.get(I);A&&(this.watchers.delete(I),A.instance.dispose())}normalizeRequests(I){const A=new Map;for(const R of I){const g=C.isLinux?R.path:R.path.toLowerCase();A.set(g,R)}return Array.from(A.values())}async setVerboseLogging(I){this.verboseLogging=I;for(const[,A]of this.watchers)A.instance.setVerboseLogging(I)}trace(I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I)})}toMessage(I,A){return A?`[File Watcher (node.js)] ${I} (path: ${A.request.path})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=D}),define(we[186],ye([0,1,54,185]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class p extends _.AbstractNonRecursiveWatcherClient{constructor(k,D,v){super(k,D,v);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=p}),define(we[187],ye([0,1,8,39,86,54]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends C.AbstractUniversalWatcherClient{constructor(v,I,A){super(v,I,A);this.init()}createWatcher(v){const I=v.add(new p.Client(_.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(I.onDidProcessExit(({code:A,signal:R})=>this.onError(`terminated by itself with code ${A}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(I.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(we[65],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...p){this._entries=new Map;for(let[C,k]of p)this.set(C,k)}set(p,C){const k=this._entries.get(p);return this._entries.set(p,C),k}has(p){return this._entries.has(p)}get(p){return this._entries.get(p)}}e.ServiceCollection=_}),define(we[91],ye([0,1,13,11,53,180,6,65]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class I extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class A{constructor(c=new D.ServiceCollection,h=!1,m){this._activeInstantiations=new Set,this._services=c,this._strict=h,this._parent=m,this._services.set(k.IInstantiationService,this)}createChild(c){return new A(c,this._strict,this)}invokeFunction(c,...h){let m=g.traceInvocation(c),y=!1;try{return c({get:f=>{if(y)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const E=this._getOrCreateServiceInstance(f,m);if(!E)throw new Error(`[invokeFunction] unknown service '${f}'`);return E}},...h)}finally{y=!0,m.stop()}}createInstance(c,...h){let m,y;return c instanceof p.SyncDescriptor?(m=g.traceCreation(c.ctor),y=this._createInstance(c.ctor,c.staticArguments.concat(h),m)):(m=g.traceCreation(c),y=this._createInstance(c,h,m)),m.stop(),y}_createInstance(c,h=[],m){let y=k._util.getServiceDependencies(c).sort((E,u)=>E.index-u.index),b=[];for(const E of y){let u=this._getOrCreateServiceInstance(E.id,m);u||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${E.id}.`,!1),b.push(u)}let f=y.length>0?y[0].index:h.length;if(h.length!==f){console.warn(`[createInstance] First service dependency of ${c.name} at position ${f+1} conflicts with ${h.length} static arguments`);let E=f-h.length;E>0?h=h.concat(new Array(E)):h=h.slice(0,f)}return new c(...[...h,...b])}_setServiceInstance(c,h){if(this._services.get(c)instanceof p.SyncDescriptor)this._services.set(c,h);else if(this._parent)this._parent._setServiceInstance(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let h=this._services.get(c);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):h}_getOrCreateServiceInstance(c,h){let m=this._getServiceInstanceOrDescriptor(c);return m instanceof p.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,m,h.branch(c,!0)):(h.branch(c,!1),m)}_safeCreateAndCacheServiceInstance(c,h,m){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,h,m)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,h,m){const y=new C.Graph(E=>E.id.toString());let b=0;const f=[{id:c,desc:h,_trace:m}];for(;f.length;){const E=f.pop();if(y.lookupOrInsertNode(E),b++>1e3)throw new I(y);for(let u of k._util.getServiceDependencies(E.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(u.id);if(o||this._throwIfStrict(`[createInstance] ${c} depends on ${u.id} which is NOT registered.`,!0),o instanceof p.SyncDescriptor){const l={id:u.id,desc:o,_trace:E._trace.branch(u.id,!0)};y.insertEdge(E,l),f.push(l)}}}for(;;){const E=y.roots();if(E.length===0){if(!y.isEmpty())throw new I(y);break}for(const{data:u}of E){if(this._getServiceInstanceOrDescriptor(u.id)instanceof p.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}y.removeNode(u)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,h,m=[],y,b){if(this._services.get(c)instanceof p.SyncDescriptor)return this._createServiceInstance(h,m,y,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,h,m,y,b);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(c,h=[],m,y){if(m){const b=new _.IdleValue(()=>this._createInstance(c,h,y));return new Proxy(Object.create(null),{get(f,E){if(E in f)return f[E];let u=b.value,o=u[E];return typeof o!="function"||(o=o.bind(u),f[E]=o),o},set(f,E,u){return b.value[E]=u,!0}})}else return this._createInstance(c,h,y)}_throwIfStrict(c,h){if(h&&console.warn(h),this._strict)throw new Error(c)}}e.InstantiationService=A;var R;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(R||(R={}));class g{constructor(c,h){this.type=c,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return v?new g(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(c){return v?new g(0,c.name):g._None}branch(c,h){let m=new g(2,c.toString());return this._dep.push([c,h,m]),m}stop(){let c=Date.now()-this._start;g._totals+=c;let h=!1;function m(b,f){let E=[],u=new Array(b+1).join("	");for(const[o,l,s]of f._dep)if(l&&s){h=!0,E.push(`${u}CREATES -> ${o}`);let n=m(b+1,s);n&&E.push(n)}else E.push(`${u}uses -> ${o}`);return E.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(c>2||h)&&console.log(y.join(`
`))}}e.Trace=g,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(we[188],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,_.createDecorator)("labelService")}),define(we[66],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,_.createDecorator)("localizationsService");function t(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const C of p.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}e.isValidLocalization=t}),define(we[14],ye([0,1,36,7,2,3,6]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function D(){return new Date().toISOString()}var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function I(l,s,n){switch(s){case v.Trace:l.trace(n);break;case v.Debug:l.debug(n);break;case v.Info:l.info(n);break;case v.Warning:l.warn(n);break;case v.Error:l.error(n);break;case v.Critical:l.critical(n);break;default:throw new Error("Invalid log level")}}e.log=I;function A(l){let s="";for(let n=0;n<l.length;n++){let r=l[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(n>0?" ":"")+r}return s}e.format=A;class R extends p.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class g extends R{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...n){this.checkLogLevel(v.Trace)&&this.log(v.Trace,A([s,...n]))}debug(s,...n){this.checkLogLevel(v.Debug)&&this.log(v.Debug,A([s,...n]))}info(s,...n){this.checkLogLevel(v.Info)&&this.log(v.Info,A([s,...n]))}warn(s,...n){this.checkLogLevel(v.Warning)&&this.log(v.Warning,A([s,...n]))}error(s,...n){if(this.checkLogLevel(v.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(v.Error,A(r))}else this.log(v.Error,A([s,...n]))}critical(s,...n){this.checkLogLevel(v.Critical)&&this.log(v.Critical,A([s,...n]))}flush(){}}e.AbstractMessageLogger=g;class S extends R{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!C.isWindows}trace(s,...n){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,s,...n):console.log(`[main ${D()}]`,s,...n))}debug(s,...n){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,s,...n):console.log(`[main ${D()}]`,s,...n))}info(s,...n){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,s,...n):console.log(`[main ${D()}]`,s,...n))}warn(s,...n){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,s,...n):console.warn(`[main ${D()}]`,s,...n))}error(s,...n){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,s,...n):console.error(`[main ${D()}]`,s,...n))}critical(s,...n){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,s,...n):console.error(`[main ${D()}]`,s,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class c extends R{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...n){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",s,...n)}debug(s,...n){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...n)}info(s,...n){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",s,...n)}warn(s,...n){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",s,...n)}error(s,...n){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",s,...n)}critical(s,...n){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...n)}dispose(){}flush(){}}e.ConsoleLogger=c;class h extends R{constructor(s,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(n)}trace(s,...n){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(s),...n])}debug(s,...n){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(s),...n])}info(s,...n){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(s),...n])}warn(s,...n){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(s),...n])}error(s,...n){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(s),...n])}critical(s,...n){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(s),...n])}extractMessage(s){return typeof s=="string"?s:(0,_.toErrorMessage)(s,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class m extends R{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const n of this.logServices)n.setLevel(s);super.setLevel(s)}trace(s,...n){for(const r of this.logServices)r.trace(s,...n)}debug(s,...n){for(const r of this.logServices)r.debug(s,...n)}info(s,...n){for(const r of this.logServices)r.info(s,...n)}warn(s,...n){for(const r of this.logServices)r.warn(s,...n)}error(s,...n){for(const r of this.logServices)r.error(s,...n)}critical(s,...n){for(const r of this.logServices)r.critical(s,...n)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=m;class y extends p.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...n){this.logger.trace(s,...n)}debug(s,...n){this.logger.debug(s,...n)}info(s,...n){this.logger.info(s,...n)}warn(s,...n){this.logger.warn(s,...n)}error(s,...n){this.logger.error(s,...n)}critical(s,...n){this.logger.critical(s,...n)}flush(){this.logger.flush()}}e.LogService=y;class b extends p.Disposable{constructor(s,n){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,n){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,n?.always?v.Trace:this.logLevel,n),this.loggers.set(s.toString(),r),n?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return v.Info}trace(s,...n){}debug(s,...n){}info(s,...n){}warn(s,...n){}error(s,...n){}critical(s,...n){}dispose(){}flush(){}}e.NullLogService=f;function E(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const s=u(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function u(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=u;function o(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=o});var Oe=this&&this.__param||function(J,e){return function(_,t){e(_,t,J)}};define(we[189],ye([0,1,38,13,36,7,2,8,5,18,26,14]),function(J,e,_,t,p,C,k,D,v,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends k.Disposable{constructor(c,h){super();this.environmentService=c,this.logService=h,this.processesLimiter=new t.Limiter(5)}async postUninstall(c){const h=this.parseScript(c,"uninstall");return h&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),m=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${m}`)))),I.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,m=>this.logService.error("Error while removing extension storage path",m))}parseScript(c,h){const m=`vscode:${h}`;if(c.location.scheme===D.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[m]=="string"){const y=c.manifest.scripts[m].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${m} should be a node script`),null):{script:(0,v.join)(c.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}runLifecycleHook(c,h,m,y,b){return new Promise((f,E)=>{const u=this.start(c,h,m,b);let o;const l=s=>{o&&(clearTimeout(o),o=null),s?E(s):f(void 0)};u.on("error",s=>{l((0,p.toErrorMessage)(s)||"Unknown")}),u.on("exit",(s,n)=>{l(s?`post-${h} process exited with code ${s}`:void 0)}),y&&(o=setTimeout(()=>{o=null,u.kill(),E("timed out")},5e3))})}start(c,h,m,y){const b={silent:!0,execArgv:void 0},f=(0,_.fork)(c,[`--type=extension-post-${h}`,...m],b);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const E=C.Event.fromNodeEventEmitter(f.stdout,"data"),u=C.Event.fromNodeEventEmitter(f.stderr,"data");E(s=>this.logService.info(y.identifier.id,y.manifest.version,`post-${h}`,s)),u(s=>this.logService.error(y.identifier.id,y.manifest.version,`post-${h}`,s));const o=C.Event.any(C.Event.map(E,s=>({data:`%c${s}`,format:[""]})),C.Event.map(u,s=>({data:`%c${s}`,format:["color: red"]})));return C.Event.debounce(o,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(y.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),f}getExtensionStoragePath(c){return(0,v.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};g=Ae([Oe(0,A.IEnvironmentService),Oe(1,R.ILogService)],g),e.ExtensionsLifecycle=g}),define(we[190],ye([0,1,17,13,11,7,2,5,54,14]),function(J,e,_,t,p,C,k,D,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class A extends k.Disposable{constructor(g,S){super();this.logService=g,this.options=S,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(g,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,S):this.watchNonRecursive(g,S)}watchUniversal(g,S){const c={path:this.toFilePath(g),excludes:S.excludes,recursive:S.recursive},h=(0,_.insert)(this.universalPathsToWatch,c);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,p.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,v.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const S of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const S of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(S)&&g.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,S){const c={path:this.toFilePath(g),excludes:S.excludes,recursive:!1},h=(0,_.insert)(this.nonRecursivePathsToWatch,c);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,p.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,v.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,D.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=A}),define(we[92],ye([0,1,17,13,15,20,7,124,49,2,29,8,43,22,42,155,19,90,14]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends I.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,o){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${u}`);const l=new I.DisposableStore;return this.provider.set(u,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:o}),l.add(o.onDidChangeFile(s=>this._onDidFilesChange.fire(new m.FileChangesEvent(s,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&l.add(o.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),l.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:u}))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:o}),this.provider.delete(u),(0,I.dispose)(l)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(l){o.push(l)}}),!this.provider.has(u)&&await t.Promises.settled(o)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,o){const l=this.provider.get(u.scheme);return!!(l&&l.capabilities&o)}listCapabilities(){return v.Iterable.map(this.provider,([u,o])=>({scheme:u,capabilities:o.capabilities}))}async withProvider(u){if(!(0,S.isAbsolutePath)(u))throw new m.FileOperationError((0,h.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const o=this.provider.get(u.scheme);if(!o){const l=new Error;throw l.name="ENOPRO",l.message=(0,h.localize)(1,null,u.toString()),l}return o}async withReadProvider(u){const o=await this.withProvider(u);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o)||(0,m.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const o=await this.withProvider(u);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,o){try{return await this.doResolveFile(u,o)}catch(l){throw(0,m.toFileSystemProviderErrorCode)(l)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,h.localize)(2,null,this.resourceForError(u)),1):(0,m.ensureFileSystemProviderError)(l)}}async doResolveFile(u,o){const l=await this.withProvider(u),s=this.isPathCaseSensitive(l),n=o?.resolveTo,r=o?.resolveSingleChildDescendants,i=o?.resolveMetadata,a=await l.stat(u);let d;return this.toFileStat(l,u,a,void 0,!!i,(w,P)=>(d||(d=A.TernarySearchTree.forUris(()=>!s),d.set(u,!0),n&&d.fill(!0,n)),d.get(w.resource)||d.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&r?P===1:!1))}async toFileStat(u,o,l,s,n,r){const{providerExtUri:i}=this.getExtUri(u),a={resource:o,name:i.basename(o),isFile:(l.type&m.FileType.File)!=0,isDirectory:(l.type&m.FileType.Directory)!=0,isSymbolicLink:(l.type&m.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&m.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,m.etag)({mtime:l.mtime,size:l.size}),children:void 0};if(a.isDirectory&&r(a,s)){try{const d=await u.readdir(o),w=await t.Promises.settled(d.map(async([P,O])=>{try{const $=i.joinPath(o,P),L=n?await u.stat($):{type:O};return await this.toFileStat(u,$,L,d.length,n,r)}catch($){return this.logService.trace($),null}}));a.children=(0,_.coalesce)(w)}catch(d){this.logService.trace(d),a.children=[]}return a}return a}async resolveAll(u){return t.Promises.settled(u.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async stat(u){const o=await this.withProvider(u),l=await o.stat(u);return this.toFileStat(o,u,l,void 0,!0,()=>!1)}async exists(u){const o=await this.withProvider(u);try{return!!await o.stat(u)}catch{return!1}}async canCreateFile(u,o){try{await this.doValidateCreateFile(u,o)}catch(l){return l}return!0}async doValidateCreateFile(u,o){if(!o?.overwrite&&await this.exists(u))throw new m.FileOperationError((0,h.localize)(3,null,this.resourceForError(u)),3,o)}async createFile(u,o=p.VSBuffer.fromString(""),l){await this.doValidateCreateFile(u,l);const s=await this.writeFile(u,o);return this._onDidRunOperation.fire(new m.FileOperationEvent(u,0,s)),s}async writeFile(u,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:n}=this.getExtUri(s);try{await this.validateWriteFile(s,u,l)||await this.mkdirp(s,n.dirname(u));let i;if((0,m.hasReadWriteCapability)(s)&&!(o instanceof p.VSBuffer))if((0,c.isReadableStream)(o)){const a=await(0,c.peekStream)(o,3);a.ended?i=p.VSBuffer.concat(a.buffer):i=a}else i=(0,c.peekReadable)(o,a=>p.VSBuffer.concat(a),3);else i=o;!(0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)&&i instanceof p.VSBuffer?await this.doWriteUnbuffered(s,u,l,i):await this.doWriteBuffered(s,u,l,i instanceof p.VSBuffer?(0,p.bufferToReadable)(i):i),this._onDidRunOperation.fire(new m.FileOperationEvent(u,4))}catch(r){throw new m.FileOperationError((0,h.localize)(4,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),l)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,o,l){if(!!l?.unlock&&!(u.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(o)));let n;try{n=await u.stat(o)}catch{return}if((n.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,h.localize)(6,null,this.resourceForError(o)),0,l);if(this.throwIfFileIsReadonly(o,n),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==m.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&l.mtime<n.mtime&&l.etag!==(0,m.etag)({mtime:l.mtime,size:n.size}))throw new m.FileOperationError((0,h.localize)(7,null),3,l);return n}async readFile(u,o,l){const s=await this.withReadProvider(u);return o?.atomic?this.doReadFileAtomic(s,u,o,l):this.doReadFile(s,u,o,l)}async doReadFileAtomic(u,o,l,s){return new Promise((n,r)=>{this.writeQueue.queueFor(o,this.getExtUri(u).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(u,o,l,s);n(i)}catch(i){r(i)}})})}async doReadFile(u,o,l,s){const n=await this.doReadFileStream(u,o,{...l,preferUnbuffered:!0},s);return{...n,value:await(0,p.streamToBuffer)(n.value)}}async readFileStream(u,o,l){const s=await this.withReadProvider(u);return this.doReadFileStream(s,u,o,l)}async doReadFileStream(u,o,l,s){const n=new C.CancellationTokenSource(s),r=this.validateReadFile(o,l).then(a=>a,a=>{throw n.cancel(),a});let i;try{return typeof l?.etag=="string"&&l.etag!==m.ETAG_DISABLED&&await r,l?.atomic&&(0,m.hasFileAtomicReadCapability)(u)||!((0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasFileReadStreamCapability)(u))||(0,m.hasReadWriteCapability)(u)&&l?.preferUnbuffered?i=this.readFileUnbuffered(u,o,l):(0,m.hasFileReadStreamCapability)(u)?i=this.readFileStreamed(u,o,n.token,l):i=this.readFileBuffered(u,o,n.token,l),{...await r,value:i}}catch(a){i&&await(0,c.consumeStream)(i);const d=(0,h.localize)(8,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(a).toString());throw a instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(d,a.stat,l):new m.FileOperationError(d,(0,m.toFileOperationResult)(a),l)}}readFileStreamed(u,o,l,s=Object.create(null)){const n=u.readFileStream(o,s,l);return(0,c.transform)(n,{data:r=>r instanceof p.VSBuffer?r:p.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,h.localize)(9,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},r=>p.VSBuffer.concat(r))}readFileBuffered(u,o,l,s=Object.create(null)){const n=(0,p.newWriteableBufferStream)();return(0,y.readFileIntoStream)(u,o,n,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,h.localize)(10,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},l),n}readFileUnbuffered(u,o,l){const s=(0,c.newWriteableStream)(n=>p.VSBuffer.concat(n));return(async()=>{try{let n;l?.atomic&&(0,m.hasFileAtomicReadCapability)(u)?n=await u.readFile(o,{atomic:!0}):n=await u.readFile(o),typeof l?.position=="number"&&(n=n.slice(l.position)),typeof l?.length=="number"&&(n=n.slice(0,l.length)),this.validateReadFileLimits(o,n.byteLength,l),s.end(p.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async validateReadFile(u,o){const l=await this.resolve(u,{resolveMetadata:!0});if(l.isDirectory)throw new m.FileOperationError((0,h.localize)(11,null,this.resourceForError(u)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.ETAG_DISABLED&&o.etag===l.etag)throw new m.NotModifiedSinceFileOperationError((0,h.localize)(12,null),l,o);return this.validateReadFileLimits(u,l.size,o),l}validateReadFileLimits(u,o,l){if(l?.limits){let s;if(typeof l.limits.memory=="number"&&o>l.limits.memory&&(s=9),typeof l.limits.size=="number"&&o>l.limits.size&&(s=7),typeof s=="number")throw new m.FileOperationError((0,h.localize)(13,null,this.resourceForError(u)),s)}}async canMove(u,o,l){return this.doCanMoveCopy(u,o,"move",l)}async canCopy(u,o,l){return this.doCanMoveCopy(u,o,"copy",l)}async doCanMoveCopy(u,o,l,s){if(u.toString()!==o.toString())try{const n=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,u,r,o,l,s)}catch(n){return n}return!0}async move(u,o,l){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,u,n,o,"move",!!l),i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(u,r==="move"?2:3,i)),i}async copy(u,o,l){const s=await this.withReadProvider(u),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,u,n,o,"copy",!!l),i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(u,r==="copy"?3:2,i)),i}async doMoveCopy(u,o,l,s,n,r){if(o.toString()===s.toString())return n;const{exists:i,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(u,o,l,s,n,r);if(i&&!a&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(s)),n==="copy"){if(u===l&&(0,m.hasFileFolderCopyCapability)(u))await u.copy(o,s,{overwrite:r});else{const d=await this.resolve(o);d.isDirectory?await this.doCopyFolder(u,d,l,s):await this.doCopyFile(u,o,l,s)}return n}else return u===l?(await u.rename(o,s,{overwrite:r}),n):(await this.doMoveCopy(u,o,l,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(u,o,l,s){if((0,m.hasOpenReadWriteCloseCapability)(u)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(u,o,l,s);if((0,m.hasOpenReadWriteCloseCapability)(u)&&(0,m.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(u,o,l,s);if((0,m.hasReadWriteCapability)(u)&&(0,m.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(u,o,l,s);if((0,m.hasReadWriteCapability)(u)&&(0,m.hasReadWriteCapability)(l))return this.doPipeUnbuffered(u,o,l,s)}async doCopyFolder(u,o,l,s){await l.mkdir(s),Array.isArray(o.children)&&await t.Promises.settled(o.children.map(async n=>{const r=this.getExtUri(l).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.doCopyFolder(u,await this.resolve(n.resource),l,r):this.doCopyFile(u,n.resource,l,r)}))}async doValidateMoveCopy(u,o,l,s,n,r){let i=!1;if(u===l){const{providerExtUri:d,isPathCaseSensitive:w}=this.getExtUri(u);if(w||(i=d.isEqual(o,s)),i&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!i&&d.isEqualOrParent(s,o))throw new Error((0,h.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const a=await this.exists(s);if(a&&!i){if(!r)throw new m.FileOperationError((0,h.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(u===l){const{providerExtUri:d}=this.getExtUri(u);if(d.isEqualOrParent(o,s))throw new Error((0,h.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:a,isSameResourceWithDifferentPathCase:i}}getExtUri(u){const o=this.isPathCaseSensitive(u);return{providerExtUri:o?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(o,u);const l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(u,0,l)),l}async mkdirp(u,o){const l=[],{providerExtUri:s}=this.getExtUri(u);for(;!s.isEqual(o,s.dirname(o));)try{if(((await u.stat(o)).type&m.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(o)));break}catch(n){if((0,m.toFileSystemProviderErrorCode)(n)!==m.FileSystemProviderErrorCode.FileNotFound)throw n;l.push(s.basename(o)),o=s.dirname(o)}for(let n=l.length-1;n>=0;n--){o=s.joinPath(o,l[n]);try{await u.mkdir(o)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(u,o){try{await this.doValidateDelete(u,o)}catch(l){return l}return!0}async doValidateDelete(u,o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!o?.useTrash&&!(l.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(u)));let n;try{n=await l.stat(u)}catch{}if(n)this.throwIfFileIsReadonly(u,n);else throw new m.FileOperationError((0,h.localize)(20,null,this.resourceForError(u)),1);if(!!!o?.recursive){const i=await this.resolve(u);if(i.isDirectory&&Array.isArray(i.children)&&i.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(u)))}return l}async del(u,o){const l=await this.doValidateDelete(u,o),s=!!o?.useTrash,n=!!o?.recursive;await l.delete(u,{recursive:n,useTrash:s}),this._onDidRunOperation.fire(new m.FileOperationEvent(u,1))}watch(u,o={recursive:!1,excludes:[]}){const l=new I.DisposableStore;let s=!1,n=()=>{s=!0};return l.add((0,I.toDisposable)(()=>n())),(async()=>{try{const r=await this.doWatch(u,o);s?(0,I.dispose)(r):n=()=>(0,I.dispose)(r)}catch(r){this.logService.error(r)}})(),l}async doWatch(u,o){const l=await this.withProvider(u),s=(0,D.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(u),o]);let n=this.activeWatchers.get(s);return n||(n={count:0,disposable:l.watch(u,o)},this.activeWatchers.set(s,n)),n.count+=1,(0,I.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,I.dispose)(n.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,I.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(u).providerExtUri).queue(async()=>{const n=await u.open(o,{create:!0,unlock:l?.unlock??!1});try{(0,c.isReadableStream)(s)||(0,c.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(u,n,s):await this.doWriteReadableBufferedQueued(u,n,s)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await u.close(n)}})}async doWriteStreamBufferedQueued(u,o,l){let s=0,n;if((0,c.isReadableBufferedStream)(l)){if(l.buffer.length>0){const r=p.VSBuffer.concat(l.buffer);await this.doWriteBuffer(u,o,r,r.byteLength,s,0),s+=r.byteLength}if(l.ended)return;n=l.stream}else n=l;return new Promise((r,i)=>{(0,c.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(u,o,a,a.byteLength,s,0)}catch(d){return i(d)}s+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>i(a),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(u,o,l){let s=0,n;for(;(n=l.read())!==null;)await this.doWriteBuffer(u,o,n,n.byteLength,s,0),s+=n.byteLength}async doWriteBuffer(u,o,l,s,n,r){let i=0;for(;i<s;)i+=await u.write(o,n+i,l.buffer,r+i,s-i)}async doWriteUnbuffered(u,o,l,s){return this.writeQueue.queueFor(o,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,o,l,s))}async doWriteUnbufferedQueued(u,o,l,s){let n;s instanceof p.VSBuffer?n=s:(0,c.isReadableStream)(s)?n=await(0,p.streamToBuffer)(s):(0,c.isReadableBufferedStream)(s)?n=await(0,p.bufferedStreamToBuffer)(s):n=(0,p.readableToBuffer)(s),await u.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(u,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,o,l,s))}async doPipeBufferedQueued(u,o,l,s){let n,r;try{n=await u.open(o,{create:!1}),r=await l.open(s,{create:!0,unlock:!1});const i=p.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,d=0,w=0;do w=await u.read(n,a,i.buffer,d,i.byteLength-d),await this.doWriteBuffer(l,r,i,w,a,d),a+=w,d+=w,d===i.byteLength&&(d=0);while(w>0)}catch(i){throw(0,m.ensureFileSystemProviderError)(i)}finally{await t.Promises.settled([typeof n=="number"?u.close(n):Promise.resolve(),typeof r=="number"?l.close(r):Promise.resolve()])}}async doPipeUnbuffered(u,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,o,l,s))}async doPipeUnbufferedQueued(u,o,l,s){return l.writeFile(s,await u.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,o,l,s){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,o,l,s))}async doPipeUnbufferedToBufferedQueued(u,o,l,s){const n=await l.open(s,{create:!0,unlock:!1});try{const r=await u.readFile(o);await this.doWriteBuffer(l,n,p.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await l.close(n)}}async doPipeBufferedToUnbuffered(u,o,l,s){const n=await(0,p.streamToBuffer)(this.readFileBuffered(u,o,C.CancellationToken.None));await this.doWriteUnbuffered(l,s,void 0,n)}throwIfFileSystemIsReadonly(u,o){if(u.capabilities&2048)throw new m.FileOperationError((0,h.localize)(22,null,this.resourceForError(o)),6);return u}throwIfFileIsReadonly(u,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,h.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===R.Schemas.file?u.fsPath:u.toString(!0)}};f=Ae([Oe(0,b.ILogService)],f),e.FileService=f}),define(we[55],ye([0,1,27,258,13,29,15,7,34,2,5,3,22,42,18,158,19,90,190,36,187,186]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(_)}catch(l){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(l)}`)}})();class o extends b.AbstractDiskFileSystemProvider{constructor(s,n){super(s,n);this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new C.ResourceMap(r=>g.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:n,symbolicLink:r}=await c.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(s){try{const n=await c.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async i=>{try{let a;i.isSymbolicLink()?a=(await this.stat((0,g.joinPath)(s,i.name))).type:a=this.toType(i),r.push([i.name,a])}catch(a){this.logService.trace(a)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(s,n){let r;return n?.dangling?r=m.FileType.Unknown:s.isFile()?r=m.FileType.File:s.isDirectory()?r=m.FileType.Directory:r=m.FileType.Unknown,n&&(r|=m.FileType.SymbolicLink),r}async createResourceLock(s){const n=this.toFilePath(s);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const i=new p.Barrier;return this.resourceLocks.set(s,i),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,I.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(s)===i&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(s)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),i.open()})}async readFile(s,n){let r;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const i=this.toFilePath(s);return await c.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}finally{r?.dispose()}}readFileStream(s,n,r){const i=(0,S.newWriteableStream)(a=>k.VSBuffer.concat(a.map(d=>k.VSBuffer.wrap(d))).buffer);return(0,y.readFileIntoStream)(this,s,i,a=>a.buffer,{...n,bufferSize:256*1024},r),i}async writeFile(s,n,r){let i;try{const a=this.toFilePath(s);if(!r.create||!r.overwrite){if(await c.Promises.exists(a)){if(!r.overwrite)throw(0,m.createFileSystemProviderError)((0,h.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,m.createFileSystemProviderError)((0,h.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(i,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(s,a)}finally{typeof i=="number"&&await this.close(i)}}async open(s,n){const r=this.toFilePath(s);let i;(0,m.isFileOpenForWriteOptions)(n)&&(i=await this.createResourceLock(s));let a;try{if((0,m.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await c.SymlinkSupport.stat(r);w.mode&128||await c.Promises.chmod(r,w.mode|128)}catch(w){this.logService.trace(w)}let d;if((0,m.isFileOpenForWriteOptions)(n)){if(R.isWindows)try{await c.Promises.truncate(r,0),d="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}d||(d="w")}else d="r";a=await c.Promises.open(r,d)}catch(d){throw i?.dispose(),(0,m.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(s,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(a,0),(0,m.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,s),i){const d=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,i),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),d.dispose())}return a}async close(s){const n=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await c.Promises.fdatasync(s)}catch(r){this.canFlush=!1,this.logService.error(r)}return await c.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(s)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,r,i,a){const d=this.normalizePos(s,n);let w=null;try{w=(await c.Promises.read(s,r,i,a,d)).bytesRead}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(s,d,w)}return w}normalizePos(s,n){return n===this.mapHandleToPos.get(s)?null:n}updatePos(s,n,r){const i=this.mapHandleToPos.get(s);typeof i=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,i+r):this.mapHandleToPos.delete(s)))}async write(s,n,r,i,a){return(0,p.retry)(()=>this.doWrite(s,n,r,i,a),100,3)}async doWrite(s,n,r,i,a){const d=this.normalizePos(s,n);let w=null;try{w=(await c.Promises.write(s,r,i,a,d)).bytesWritten}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),P)}finally{this.updatePos(s,d,w)}return w}async mkdir(s){try{await c.Promises.mkdir(this.toFilePath(s))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(s,n){try{const r=this.toFilePath(s);n.recursive?await c.Promises.rm(r,c.RimRafMode.MOVE):await c.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,n,r){const i=this.toFilePath(s),a=this.toFilePath(n);if(i!==a)try{await this.validateTargetDeleted(s,n,"move",r.overwrite),await c.Promises.move(i,a)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,h.localize)(2,null,(0,A.basename)(i),(0,A.basename)((0,A.dirname)(a)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(s,n,r){const i=this.toFilePath(s),a=this.toFilePath(n);if(i!==a)try{await this.validateTargetDeleted(s,n,"copy",r.overwrite),await c.Promises.copy(i,a,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,h.localize)(3,null,(0,A.basename)(i),(0,A.basename)((0,A.dirname)(a)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(s,n,r,i){const a=this.toFilePath(s),d=this.toFilePath(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,v.isEqual)(a,d,!0)),w&&r==="copy")throw(0,m.createFileSystemProviderError)((0,h.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!w&&await c.Promises.exists(d)){if(!i)throw(0,m.createFileSystemProviderError)((0,h.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(s,n,r){return new E.UniversalWatcherClient(i=>s(i),i=>n(i),r)}createNonRecursiveWatcher(s,n,r){return new u.NodeJSWatcherClient(i=>s(i),i=>n(i),r)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let n;switch(s.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(s,n)}async toFileSystemProviderWriteError(s,n){let r=this.toFileSystemProviderError(n);if(s&&r.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await c.SymlinkSupport.stat(this.toFilePath(s));i.mode&128||(r=(0,m.createFileSystemProviderError)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.logService.trace(i)}return r}}e.DiskFileSystemProvider=o}),define(we[191],ye([0,1,7,55,2,15,42,20]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends p.Disposable{constructor(R,g){super();this.provider=R,this.logService=g,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,g,S){const c=this.getUriTransformer(R);switch(g){case"stat":return this.stat(c,S[0]);case"readdir":return this.readdir(c,S[0]);case"open":return this.open(c,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(c,S[0],S[1]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(c,S[0],S[1],S[2]);case"rename":return this.rename(c,S[0],S[1],S[2]);case"copy":return this.copy(c,S[0],S[1],S[2]);case"mkdir":return this.mkdir(c,S[0]);case"delete":return this.delete(c,S[0],S[1]);case"watch":return this.watch(c,S[0],S[1],S[2],S[3]);case"unwatch":return this.unwatch(S[0],S[1])}throw new Error(`IPC Command ${g} not found`)}listen(R,g,S){const c=this.getUriTransformer(R);switch(g){case"fileChange":return this.onFileChange(c,S[0]);case"readFileStream":return this.onReadFileStream(c,S[0],S[1])}throw new Error(`Unknown event ${g}`)}stat(R,g){const S=this.transformIncoming(R,g,!0);return this.provider.stat(S)}readdir(R,g){const S=this.transformIncoming(R,g);return this.provider.readdir(S)}async readFile(R,g,S){const c=this.transformIncoming(R,g,!0),h=await this.provider.readFile(c,S);return C.VSBuffer.wrap(h)}onReadFileStream(R,g,S){const c=this.transformIncoming(R,g,!0),h=new D.CancellationTokenSource,m=new _.Emitter({onLastListenerRemove:()=>{h.cancel()}}),y=this.provider.readFileStream(c,S,h.token);return(0,k.listenStream)(y,{onData:b=>m.fire(C.VSBuffer.wrap(b)),onError:b=>m.fire(b),onEnd:()=>{m.fire("end"),m.dispose(),h.dispose()}}),m.event}writeFile(R,g,S,c){const h=this.transformIncoming(R,g);return this.provider.writeFile(h,S.buffer,c)}open(R,g,S){const c=this.transformIncoming(R,g,!0);return this.provider.open(c,S)}close(R){return this.provider.close(R)}async read(R,g,S){const c=C.VSBuffer.alloc(S),h=0,m=await this.provider.read(R,g,c.buffer,h,S);return[c,m]}write(R,g,S,c,h){return this.provider.write(R,g,S.buffer,c,h)}mkdir(R,g){const S=this.transformIncoming(R,g);return this.provider.mkdir(S)}delete(R,g,S){const c=this.transformIncoming(R,g);return this.provider.delete(c,S)}rename(R,g,S,c){const h=this.transformIncoming(R,g),m=this.transformIncoming(R,S);return this.provider.rename(h,m,c)}copy(R,g,S,c){const h=this.transformIncoming(R,g),m=this.transformIncoming(R,S);return this.provider.copy(h,m,c)}onFileChange(R,g){const S=new _.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(g,this.createSessionFileWatcher(R,S))},onLastListenerRemove:()=>{(0,p.dispose)(this.sessionToWatcher.get(g)),this.sessionToWatcher.delete(g)}});return S.event}async watch(R,g,S,c,h){const m=this.sessionToWatcher.get(g);if(m){const y=this.transformIncoming(R,c),b=m.watch(S,y,h);this.watchRequests.set(g+S,b)}}async unwatch(R,g){const S=R+g,c=this.watchRequests.get(S);c&&((0,p.dispose)(c),this.watchRequests.delete(S))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class I extends p.Disposable{constructor(R,g,S,c){super();this.uriTransformer=R,this.logService=S,this.environmentService=c,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(g)}registerListeners(R){const g=this._register(new _.Emitter);this._register(g.event(S=>{R.fire(S.map(c=>({resource:this.uriTransformer.transformOutgoingURI(c.resource),type:c.type})))})),this._register(this.fileWatcher.onDidChangeFile(S=>g.fire(S))),this._register(this.fileWatcher.onDidWatchError(S=>R.fire(S)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,g,S){const c=this.getExtraExcludes(this.environmentService);return Array.isArray(c)&&(S.excludes=[...S.excludes,...c]),this.watcherRequests.set(R,this.fileWatcher.watch(g,S)),(0,p.toDisposable)(()=>{(0,p.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=I}),define(we[93],ye([0,1,7,4,14]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(g){this.service=g,this.onDidChangeLogLevel=_.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(g,S,c){switch(S){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=C;class k{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){k.setLevel(this.channel,g)}static setLevel(g,S){return g.call("setLevel",S)}}e.LogLevelChannelClient=k;class D{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,S){throw new Error(`Event not found: ${S}`)}async call(g,S,c){switch(S){case"createLogger":this.createLogger(t.URI.revive(c[0]),c[1]);return;case"log":return this.log(t.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${S}`)}createLogger(g,S){this.loggers.set(g.toString(),this.loggerService.createLogger(g,S))}consoleLog(g,S){let c=console.log;switch(g){case p.LogLevel.Error:c=console.error;break;case p.LogLevel.Warning:c=console.warn;break;case p.LogLevel.Info:c=console.info;break}c.call(console,...S)}log(g,S){const c=this.loggers.get(g.toString());if(!c)throw new Error("Create the logger before logging");for(const[h,m]of S)(0,p.log)(c,h,m)}}e.LoggerChannel=D;class v extends p.AbstractLoggerService{constructor(g,S,c){super(g,S);this.channel=c}createConsoleMainLogger(){return new p.AdapterLogger({log:(g,S)=>{this.channel.call("consoleLog",[g,S])}})}doCreateLogger(g,S,c){return new I(this.channel,g,S,c)}}e.LoggerChannelClient=v;class I extends p.AbstractMessageLogger{constructor(g,S,c,h){super(h?.always);this.channel=g,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[S,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,S){const c=[[g,S]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(g){this.channel.call("log",[this.file,g])}}class A extends p.LogService{constructor(g,S){super(S);this.parent=g,this._register(g.onDidChangeLogLevel(c=>S.setLevel(c)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=A}),define(we[94],ye([0,1,19,14]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function p(D,v,I,A,R){try{const g=await new Promise((c,h)=>{J(["spdlog"],c,h)});g.setFlushOn(t.LogLevel.Trace);const S=await g.createAsyncRotatingLogger(D,v,I,A);return R&&S.clearFormatters(),S}catch(g){console.error(g)}return null}function C(D,v,I){switch(v){case t.LogLevel.Trace:D.trace(I);break;case t.LogLevel.Debug:D.debug(I);break;case t.LogLevel.Info:D.info(I);break;case t.LogLevel.Warning:D.warn(I);break;case t.LogLevel.Error:D.error(I);break;case t.LogLevel.Critical:D.critical(I);break;default:throw new Error("Invalid log level")}}class k extends t.AbstractMessageLogger{constructor(v,I,A,R,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(v,I,A,R),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(v,I,A,R){const g=A?6:1,S=30/g*_.ByteSize.MB,c=await p(v,I,S,g,R);if(c){this._logger=c,this._logger.setLevel(this.getLevel());for(const{level:h,message:m}of this.buffer)C(this._logger,h,m);this.buffer=[]}}log(v,I){this._logger?C(this._logger,v,I):this.getLevel()<=v&&this.buffer.push({level:v,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(we[192],ye([0,1,75,159,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var k;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function I(c,h){return h-c}v.compare=I;const A=Object.create(null);A[v.Error]=(0,t.localize)(0,null),A[v.Warning]=(0,t.localize)(1,null),A[v.Info]=(0,t.localize)(2,null);function R(c){return A[c]||""}v.toString=R;function g(c){switch(c){case _.default.Error:return v.Error;case _.default.Warning:return v.Warning;case _.default.Info:return v.Info;case _.default.Ignore:return v.Hint}}v.fromSeverity=g;function S(c){switch(c){case v.Error:return _.default.Error;case v.Warning:return _.default.Warning;case v.Info:return _.default.Info;case v.Hint:return _.default.Ignore}}v.toSeverity=S}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(v){const I="";function A(g){return R(g,!0)}v.makeKey=A;function R(g,S){let c=[I];return g.source?c.push(g.source.replace("\xA6","\\\xA6")):c.push(I),g.code?typeof g.code=="string"?c.push(g.code.replace("\xA6","\\\xA6")):c.push(g.code.value.replace("\xA6","\\\xA6")):c.push(I),g.severity!==void 0&&g.severity!==null?c.push(k.toString(g.severity)):c.push(I),g.message&&S?c.push(g.message.replace("\xA6","\\\xA6")):c.push(I),g.startLineNumber!==void 0&&g.startLineNumber!==null?c.push(g.startLineNumber.toString()):c.push(I),g.startColumn!==void 0&&g.startColumn!==null?c.push(g.startColumn.toString()):c.push(I),g.endLineNumber!==void 0&&g.endLineNumber!==null?c.push(g.endLineNumber.toString()):c.push(I),g.endColumn!==void 0&&g.endColumn!==null?c.push(g.endColumn.toString()):c.push(I),c.push(I),c.join("\xA6")}v.makeKeyOptionalMessage=R})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(we[193],ye([0,1,7,75,6]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,p.createDecorator)("notificationService");var C;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new v,this.onDidClose=_.Event.None,this.onDidChangeVisibility=_.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=D;class v{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=v}),define(we[44],ye([0,1,8,3,24,22]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const D=t.globals.vscode.context.configuration();if(D)k=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const D=(0,C.dirname)(_.FileAccess.asFileUri("",J));k=J.__$__nodeRequire((0,C.joinPath)(D,"product.json").fsPath);const v=J.__$__nodeRequire((0,C.joinPath)(D,"package.json").fsPath);p.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),Object.assign(k,{version:v.version})}else k={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/N)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","octref.vetur","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:[],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookEditor","notebookEditorEdit","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textDocumentNotebook","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver","notebookEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookConcatTextDocument","notebookContentProvider","notebookCellExecutionState","notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookEditorEdit","notebookLiveShare","notebookMessaging","notebookMime","textDocumentNotebook"],"GitHub.codespaces":["contribMenuBarHome","contribRemoteHelp","contribViewsRemote","notebookEditor","resolvers","terminalDataWriteEvent","treeViewReveal"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","resolvers","textSearchProvider"],"ms-vscode.vscode-github-issue-notebooks":["notebookEditor"],"tanhakabir.rest-book":["notebookEditor"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote"],"ms-vscode-remote.remote-ssh":["resolvers","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-containers":["resolvers","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation"],"GitHub.copilot":["inlineCompletions","textDocumentNotebook"],"GitHub.copilot-nightly":["inlineCompletions","textDocumentNotebook"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"GitHub.remotehub-insiders":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-python.gather":["notebookEditor","notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookConcatTextDocument","notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookEditorEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","textDocumentNotebook","quickPickSortByLabel"],"dbaeumer.vscode-eslint":["tabs","notebookEditor","notebookCellExecutionState"],"azure-sphere-tools-ui":["resolvers"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.85",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.15",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.65.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.14",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.65.2",commit:"c722ca6c7eed3d7987c0d5c3df5c45f6b15e77d1",date:"2022-03-10T14:20:26.300Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(we[30],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,_.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(we[194],ye([0,1,89,7,2,14,3,26,30]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let I=class Lt extends p.Disposable{constructor(R,g,S,c){super();this.isRunningOnServer=R,this.logService=g,this.environmentMainService=S,this.productService=c,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(R,g){const S=await this.withKeytar(),c=await S.getPassword(R,g);if(c)try{let{content:h,hasNextChunk:m}=JSON.parse(c);if(!h||!m)return c;let y=1;for(;m;){const b=await S.getPassword(R,`${g}-${y}`),f=JSON.parse(b);h+=f.content,m=f.hasNextChunk,y++}return h}catch{return c}return c}async setPassword(R,g,S){const c=await this.withKeytar(),h=3,m=async(y,b,f)=>{let E=0,u;for(;E<h;)try{await c.setPassword(y,b,f);return}catch(o){u=o,this.logService.warn("Error attempting to set a password: ",o),E++,await new Promise(l=>setTimeout(l,200))}throw u};if(k.isWindows&&S.length>Lt.MAX_PASSWORD_LENGTH){let y=0,b=0,f=!0;for(;f;){const E=S.substring(y,y+Lt.PASSWORD_CHUNK_SIZE);y+=Lt.PASSWORD_CHUNK_SIZE,f=S.length-y>0;const u={content:E,hasNextChunk:f};await m(R,b?`${g}-${b}`:g,JSON.stringify(u)),b++}}else await m(R,g,S);this._onDidChangePassword.fire({service:R,account:g})}async deletePassword(R,g){const c=await(await this.withKeytar()).deletePassword(R,g);return c&&this._onDidChangePassword.fire({service:R,account:g}),c}async findPassword(R){return(await this.withKeytar()).findPassword(R)}async findCredentials(R){return(await this.withKeytar()).findCredentials(R)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new _.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((R,g)=>{J(["keytar"],R,g)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(R){if(!this.isRunningOnServer)throw R;this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${R.message}`),this._keytarCache=new _.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof _.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};I.MAX_PASSWORD_LENGTH=2500,I.PASSWORD_CHUNK_SIZE=I.MAX_PASSWORD_LENGTH-100,I=Ae([Oe(1,C.ILogService),Oe(2,D.INativeEnvironmentService),Oe(3,v.IProductService)],I),e.CredentialsMainService=I}),define(we[35],ye([0,1,117,12]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class p{constructor(){this.data=new Map}add(k,D){_.ok(t.isString(k)),_.ok(t.isObject(D)),_.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new p}),define(we[195],ye([0,1,7,35]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function p(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class C{constructor(){this._onDidChangeSchema=new _.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,I){this.schemasById[p(v)]=I,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;t.Registry.add(e.Extensions.JSONContribution,k)}),define(we[45],ye([0,1,17,7,12,145,195,35]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const A=D.Registry.as(k.Extensions.JSONContribution);class R{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,o=!0){this.registerConfigurations([u],o)}registerConfigurations(u,o=!0){const l=this.doRegisterConfigurations(u,o);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(u){const o=this.doDeregisterConfigurations(u);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:u,remove:o}){const l=[];l.push(...this.doDeregisterConfigurations(o)),l.push(...this.doRegisterConfigurations(u,!1)),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,_.distinct)(l)})}registerDefaultConfigurations(u){const o=[],l=[];for(const{overrides:s,source:n}of u)for(const r in s)if(o.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const i={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:n,value:i});const a={type:"object",default:i,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:i,source:p.isString(n)?void 0:n};l.push(...c(r)),this.configurationProperties[r]=a,this.defaultLanguageConfigurationOverridesNode.properties[r]=a}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:n});const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const o=[];for(const{overrides:l,source:s}of u)for(const n in l){const r=this.configurationDefaultsOverrides.get(n),i=p.isString(s)?s:s?.id,a=p.isString(r?.source)?r?.source:r?.source?.id;if(i===a)if(o.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const d=this.configurationProperties[n];d&&(this.updatePropertyDefaultValue(n,d),this.updateSchema(n,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const o of u)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,o){const l=[];return u.forEach(s=>{l.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),l}doDeregisterConfigurations(u){const o=[],l=s=>{if(s.properties)for(const n in s.properties)o.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,s.properties[n]);s.allOf&&s.allOf.forEach(n=>l(n))};for(const s of u){l(s);const n=this.configurationContributors.indexOf(s);n!==-1&&this.configurationContributors.splice(n,1)}return o}validateAndRegisterProperties(u,o=!0,l,s,n=3){n=p.isUndefinedOrNull(u.scope)?n:u.scope;let r=[],i=u.properties;if(i)for(let d in i){if(o&&b(d)){delete i[d];continue}const w=i[d];if(w.source=l,w.defaultDefaultValue=i[d].default,this.updatePropertyDefaultValue(d,w),e.OVERRIDE_PROPERTY_REGEX.test(d)?w.scope=void 0:(w.scope=p.isUndefinedOrNull(w.scope)?n:w.scope,w.restricted=p.isUndefinedOrNull(w.restricted)?!!s?.includes(d):w.restricted),i[d].hasOwnProperty("included")&&!i[d].included){this.excludedConfigurationProperties[d]=i[d],delete i[d];continue}else this.configurationProperties[d]=i[d];!i[d].deprecationMessage&&i[d].markdownDeprecationMessage&&(i[d].deprecationMessage=i[d].markdownDeprecationMessage),r.push(d)}let a=u.allOf;if(a)for(let d of a)r.push(...this.validateAndRegisterProperties(d,o,l,s,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const o=l=>{let s=l.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let n=l.allOf;n&&n.forEach(o)};o(u)}updateSchema(u,o){switch(e.allSettings.properties[u]=o,o.scope){case 1:e.applicationSettings.properties[u]=o;break;case 2:e.machineSettings.properties[u]=o;break;case 6:e.machineOverridableSettings.properties[u]=o;break;case 3:e.windowSettings.properties[u]=o;break;case 4:e.resourceSettings.properties[u]=o;break;case 5:e.resourceSettings.properties[u]=o,this.resourceLanguageSettingsSchema.properties[u]=o;break}}removeFromSchema(u,o){switch(delete e.allSettings.properties[u],o.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const o=`[${u}]`,l={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,l),e.allSettings.properties[o]=l,e.applicationSettings.properties[o]=l,e.machineSettings.properties[o]=l,e.machineOverridableSettings.properties[o]=l,e.windowSettings.properties[o]=l,e.resourceSettings.properties[o]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,o){const l=this.configurationDefaultsOverrides.get(u);let s=l?.value,n=l?.source;p.isUndefined(s)&&(s=o.defaultDefaultValue,n=void 0),p.isUndefined(s)&&(s=m(o.type)),o.default=s,o.defaultValueSource=n}}const g="\\[([^\\]]+)\\]",S=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(E){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(E)){let o=S.exec(E);for(;o?.length;){const l=o[1].trim();l&&u.push(l),o=S.exec(E)}}return(0,_.distinct)(u)}e.overrideIdentifiersFromKey=c;function h(E){return E.reduce((u,o)=>`${u}[${o}]`,"")}e.keyFromOverrideIdentifiers=h;function m(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const y=new R;D.Registry.add(e.Extensions.Configuration,y);function b(E){return E.trim()?e.OVERRIDE_PROPERTY_REGEX.test(E)?C.localize(7,null,E):y.getConfigurationProperties()[E]!==void 0?C.localize(8,null,E):null:C.localize(6,null)}e.validateProperty=b;function f(){const E=[],u=y.getConfigurationProperties();for(const o of Object.keys(u))E.push([o,u[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=f}),define(we[196],ye([0,1,17,7,59,2,29,21,12,4,28,45,35]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(s={},n=[],r=[]){this._contents=s,this._keys=n,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,A.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,n){const r=this.getContentsForOverrideIdentifer(n);return r?s?(0,A.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const r of this.overrides)r.identifiers.includes(s)&&n.push(...r.keys);return _.distinct(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return _.distinct(s)}override(s){let n=this.overrideConfigurations.get(s);return n||(n=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,n)),n}merge(...s){const n=D.deepClone(this.contents),r=D.deepClone(this.overrides),i=[...this.keys];for(const a of s){this.mergeContents(n,a.contents);for(const d of a.overrides){const[w]=r.filter(P=>_.equals(P.identifiers,d.identifiers));w?(this.mergeContents(w.contents,d.contents),w.keys.push(...d.keys),w.keys=_.distinct(w.keys)):r.push(D.deepClone(d))}for(const d of a.keys)i.indexOf(d)===-1&&i.push(d)}return new S(n,i,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const n=this.getContentsForOverrideIdentifer(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const i of _.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[i],d=n[i];d&&(typeof a=="object"&&typeof d=="object"?(a=D.deepClone(a),this.mergeContents(a,d)):a=d),r[i]=a}return new S(r,this.keys,this.overrides)}mergeContents(s,n){for(const r of Object.keys(n)){if(r in s&&v.isObject(s[r])&&v.isObject(n[r])){this.mergeContents(s[r],n[r]);continue}s[r]=D.deepClone(n[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?D.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let n=null,r=null;const i=a=>{a&&(r?this.mergeContents(r,a):r=D.deepClone(a))};for(const a of this.overrides)_.equals(a.identifiers,[s])?n=a.contents:a.identifiers.includes(s)&&i(a.contents);return i(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,n){this.addKey(s),(0,A.addToValueTree)(this.contents,s,n,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,A.removeFromValueTree)(this.contents,s)}addKey(s){let n=this.keys.length;for(let r=0;r<n;r++)s.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,s)}removeKey(s){let n=this.keys.indexOf(s);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=S;class c extends S{constructor(s={}){const n=g.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(n),i=Object.create(null),a=[];for(const d in n){const w=s[d],P=w!==void 0?w:n[d].default;(0,A.addToValueTree)(i,d,P,O=>console.error(`Conflict in default settings: ${O}`))}for(const d of Object.keys(i))R.OVERRIDE_PROPERTY_REGEX.test(d)&&a.push({identifiers:(0,R.overrideIdentifiersFromKey)(d),keys:Object.keys(i[d]),contents:(0,A.toValuesTree)(i[d],w=>console.error(`Conflict in default settings file: ${w}`))});super(i,r,a)}}e.DefaultConfigurationModel=c;class h{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,n){if(!v.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,n)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,n){this._raw=s;const{contents:r,keys:i,overrides:a,restricted:d}=this.doParseRaw(s,n);this._configurationModel=new S(r,i,a),this._restrictedConfigurations=d||[]}doParseContent(s){let n={},r=null,i=[],a=[],d=[];function w(O){Array.isArray(i)?i.push(O):r!==null&&(i[r]=O)}let P={onObjectBegin:()=>{let O={};w(O),a.push(i),i=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let O=[];w(O),a.push(i),i=O,r=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:w,onError:(O,$,L)=>{d.push({error:O,offset:$,length:L})}};if(s)try{p.visit(s,P),n=i[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(s,n){const r=g.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),i=this.filter(s,r,!0,n);s=i.raw;const a=(0,A.toValuesTree)(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),d=Object.keys(s),w=this.toOverrides(s,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:a,keys:d,overrides:w,restricted:i.restricted}}filter(s,n,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:s,restricted:[]};const a={},d=[];for(let w in s)if(R.OVERRIDE_PROPERTY_REGEX.test(w)&&r){const P=this.filter(s[w],n,!1,i);a[w]=P.raw,d.push(...P.restricted)}else{const P=n[w],O=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&d.push(w),(O===void 0||i.scopes===void 0||i.scopes.includes(O))&&(i.skipRestricted&&P?.restricted||(a[w]=s[w]))}return{raw:a,restricted:d}}toOverrides(s,n){const r=[];for(const i of Object.keys(s))if(R.OVERRIDE_PROPERTY_REGEX.test(i)){const a={};for(const d in s[i])a[d]=s[i][d];r.push({identifiers:(0,R.overrideIdentifiersFromKey)(i),keys:Object.keys(a),contents:(0,A.toValuesTree)(a,n)})}return r}}e.ConfigurationModelParser=h;class m extends C.Disposable{constructor(s,n,r,i){super();this.userSettingsResource=s,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class y{constructor(s,n,r=new S,i=new S,a=new k.ResourceMap,d=new S,w=new k.ResourceMap,P=!0){this._defaultConfiguration=s,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=d,this._memoryConfigurationByResource=w,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(s,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(s)}updateValue(s,n,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new S,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(s):i.setValue(s,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,n,r){const i=this.getConsolidateConfigurationModel(n,r),a=this.getFolderConfigurationModelForResource(n.resource,r),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,w=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),P=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),O=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),$=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),L=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,T=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(s):a.freeze().getValue(s):void 0,U=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(s):d.getValue(s),N=i.getValue(s),W=_.distinct(_.flatten(i.overrides.map(ie=>ie.identifiers))).filter(ie=>i.getOverrideValue(s,ie)!==void 0);return{defaultValue:w,userValue:P,userLocalValue:O,userRemoteValue:$,workspaceValue:L,workspaceFolderValue:T,memoryValue:U,value:N,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,workspaceFolder:T!==void 0?{value:a?.freeze().getValue(s),override:n.overrideIdentifier?a?.freeze().getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:d.getValue(s),override:n.overrideIdentifier?d.getOverrideValue(s,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(s){const n=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,n){this._folderConfigurations.set(s,n),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const r=[];if(!n){const{added:i,updated:a,removed:d}=u(this._defaultConfiguration,s);n=[...i,...a,...d]}for(const i of n)for(const a of(0,R.overrideIdentifiersFromKey)(i)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=s.getKeysForOverrideIdentifier(a),P=[...w.filter(O=>d.indexOf(O)===-1),...d.filter(O=>w.indexOf(O)===-1),...d.filter(O=>!D.equals(this._defaultConfiguration.override(a).getValue(O),s.override(a).getValue(O)))];r.push([a,P])}return this.updateDefaultConfiguration(s),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:r,removed:i,overrides:a}=u(this.localUserConfiguration,s),d=[...n,...r,...i];return d.length&&this.updateLocalUserConfiguration(s),{keys:d,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:r,removed:i,overrides:a}=u(this.remoteUserConfiguration,s);let d=[...n,...r,...i];return d.length&&this.updateRemoteUserConfiguration(s),{keys:d,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:r,removed:i,overrides:a}=u(this.workspaceConfiguration,s);let d=[...n,...r,...i];return d.length&&this.updateWorkspaceConfiguration(s),{keys:d,overrides:a}}compareAndUpdateFolderConfiguration(s,n){const r=this.folderConfigurations.get(s),{added:i,updated:a,removed:d,overrides:w}=u(r,n);let P=[...i,...a,...d];return(P.length||!r)&&this.updateFolderConfiguration(s,n),{keys:P,overrides:w}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:i,removed:a,overrides:d}=u(n,void 0);return{keys:[...r,...i,...a],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,n){let r=this.getConsolidatedConfigurationModelForResource(s,n);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&s){const i=n.getFolder(s);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const a=this._memoryConfigurationByResource.get(s);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let n=this._foldersConsolidatedConfigurations.get(s);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(s);i?(n=r.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(s,n)):n=r}return n}getFolderConfigurationModelForResource(s,n){if(n&&s){const r=n.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,n)=>{const{contents:r,overrides:i,keys:a}=this._folderConfigurations.get(n);return s.push([n,{contents:r,overrides:i,keys:a}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>s.add(n)),this.userConfiguration.freeze().keys.forEach(n=>s.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i))),[...n.values()]}static parse(s){const n=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),i=this.parseConfigurationModel(s.workspace),a=s.folders.reduce((d,w)=>(d.set(I.URI.revive(w[0]),this.parseConfigurationModel(w[1])),d),new k.ResourceMap);return new y(n,r,new S,i,a,new S,new k.ResourceMap,!1)}static parseConfigurationModel(s){return new S(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=y;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,n=new Map;for(const i of l)i.keys.forEach(a=>s.add(a)),i.overrides.forEach(([a,d])=>{const w=(0,k.getOrSet)(n,a,new Set);d.forEach(P=>w.add(P))});const r=[];return n.forEach((i,a)=>r.push([a,[...i.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=b;class f{constructor(s,n,r,i){this.change=s,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;s.keys.forEach(w=>a.add(w)),s.overrides.forEach(([,w])=>w.forEach(P=>a.add(P))),this.affectedKeys=[...a.values()];const d=new S;this.affectedKeys.forEach(w=>d.setValue(w,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(s,n,this.currentWorkspace);return!D.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(s,n){let r=(0,A.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(s=s[i],!s)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=f;class E extends f{constructor(s,n,r,i){super({keys:s.allKeys(),overrides:[]},void 0,s,n);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=E;function u(l,s){const{added:n,removed:r,updated:i}=o(s,l),a=[],d=l?.getAllOverrideIdentifiers()||[],w=s?.getAllOverrideIdentifiers()||[];if(s){const P=w.filter(O=>!d.includes(O));for(const O of P)a.push([O,s.getKeysForOverrideIdentifier(O)])}if(l){const P=d.filter(O=>!w.includes(O));for(const O of P)a.push([O,l.getKeysForOverrideIdentifier(O)])}if(s&&l){for(const P of d)if(w.includes(P)){const O=o({contents:l.getOverrideValue(void 0,P)||{},keys:l.getKeysForOverrideIdentifier(P)},{contents:s.getOverrideValue(void 0,P)||{},keys:s.getKeysForOverrideIdentifier(P)});a.push([P,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:r,updated:i,overrides:a}}function o(l,s){const n=l?s?l.keys.filter(a=>s.keys.indexOf(a)===-1):[...l.keys]:[],r=s?l?s.keys.filter(a=>l.keys.indexOf(a)===-1):[...s.keys]:[],i=[];if(l&&s){for(const a of s.keys)if(l.keys.indexOf(a)!==-1){const d=(0,A.getConfigurationValue)(s.contents,a),w=(0,A.getConfigurationValue)(l.contents,a);D.equals(d,w)||i.push(a)}}return{added:n,removed:r,updated:i}}}),define(we[95],ye([0,1,13,7,2,22,28,196,45,35]),function(J,e,_,t,p,C,k,D,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class A extends p.Disposable{constructor(g,S){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,S)),this.configuration=new D.Configuration(new D.DefaultConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new _.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:c})=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new D.Configuration(new D.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,S){const c=typeof g=="string"?g:void 0,h=(0,k.isConfigurationOverrides)(g)?g:(0,k.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(c,h,void 0)}updateValue(g,S,c,h){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const S=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(c,S,1)}onDidDefaultConfigurationChange(g){const S=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new D.DefaultConfigurationModel,g);this.trigger(c,S,6)}trigger(g,S,c){const h=new D.ConfigurationChangeEvent(g,{data:S},this.configuration);h.source=c,h.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=A}),define(we[96],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var t;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class p extends Error{constructor(k,D=t.Unknown,v){super(k);this._message=k,this._code=D,this._detail=v,this.isHandled=D===t.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype)}static isTemporarilyNotAvailable(k){return k instanceof p&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof p&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof p&&k.isHandled}}e.RemoteAuthorityResolverError=p}),define(we[197],ye([0,1,8]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===_.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function p(C){if(!C)return;const k=C.indexOf("+");return k<0?C:C.substr(0,k)}e.getRemoteName=p}),define(we[40],ye([0,1,16,6,197]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=C;function k(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));class v{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,c){if(typeof S=="undefined"||S===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof S=="string"||typeof c=="string"){let h=typeof S=="string"?S:S.value,m=typeof c=="string"?c:c.value;return _.equalsIgnoreCase(h,m)}return S._lower===c._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=v;function I(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function A(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=A;function R(g,S){if(S){const c=`onResolveRemoteAuthority:${(0,p.getRemoteName)(S)}`;return g.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=R,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[31],ye([0,1,16,40]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function p(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:(0,_.compareIgnoreCase)(c.id,h.id)===0}e.areSameExtensions=p;class C{constructor(h,m){this.version=m,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof C?p(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=C;function k(c,h){return`${c}.${h}`}e.getExtensionId=k;function D(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function v(c,h){return D(k(c,h))}e.getGalleryExtensionId=v;function I(c,h){const m=[],y=b=>{for(const f of m)if(f.some(E=>p(h(E),h(b))))return f;return null};for(const b of c){const f=y(b);f?f.push(b):m.push([b])}return m}e.groupByExtension=I;function A(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function R(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=R,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function g(c){const h=new Set;if(c.malicious)for(const m of c.malicious)h.add(m.id);return h}e.getMaliciousExtensionsSet=g;function S(c,h){const m=[],y=h.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const b=y.shift();if(b&&m.every(f=>!p(f.identifier,{id:b}))){const f=c.filter(E=>p(E.identifier,{id:b}));f.length===1&&(m.push(f[0]),y.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=S}),define(we[32],ye([0,1,8,149,31,6]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const k=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function D(o){const l=k.exec(o);return l&&l[1]?[(0,p.adoptToGalleryExtensionId)(l[1]),l[2]]:[(0,p.adoptToGalleryExtensionId)(o),void 0]}e.getIdAndVersion=D;var v;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(v=e.TargetPlatform||(e.TargetPlatform={}));function I(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function R(o,l){switch(o){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function g(o,l){return l==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function S(o,l,s){return g(l,s)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===s?!0:c(s).includes(o)}e.isTargetPlatformCompatible=S;function c(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function h(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=h;var m;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var y;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var b;(function(o){o.Install="install",o.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var f;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var E;(function(o){o.Unsupported="Unsupported",o.UnsupportedPreRelease="UnsupportedPreRelease",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(l,s){super(l);this.code=s,this.name=s}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=_.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(we[97],ye([0,1,20,11,79,8,56,4,150,32,31,40]),function(J,e,_,t,p,C,k,D,v,I,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const g=m=>(0,v.localize)(0,null,m),S=(0,v.localize)(1,null,"ms-dotnettools.csharp");function c(m,y){return y?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}let h=class{constructor(y,b){this.extensionManagementService=y,this.extensionGalleryService=b}get location(){}async listExtensions(y,b,f=console){let E=await this.extensionManagementService.getInstalled(1);const u=R.EXTENSION_CATEGORIES.map(l=>l.toLowerCase());if(b&&b!==""){if(u.indexOf(b.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}E=E.filter(l=>l.manifest.categories?l.manifest.categories.map(n=>n.toLowerCase()).indexOf(b.toLowerCase())>-1:!1)}else if(b===""){f.log("Possible Categories: "),u.forEach(l=>{f.log(l)});return}this.location&&f.log((0,v.localize)(2,null,this.location)),E=E.sort((l,s)=>l.identifier.id.localeCompare(s.identifier.id));let o;for(let l of E)o!==l.identifier.id&&(o=l.identifier.id,f.log(c(l.manifest,y)))}async installExtensions(y,b,f,E,u=console){const o=[],l=[];y.length&&u.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),n=(a,d)=>{const w=s.find(P=>(0,A.areSameExtensions)(P.identifier,{id:a}));if(w){if(!d&&!E)return u.log((0,v.localize)(5,null,a,w.manifest.version,a)),!1;if(d&&w.manifest.version===d)return u.log((0,v.localize)(6,null,`${a}@${d}`)),!1}return!0},r=[],i=[];for(const a of y)if(a instanceof D.URI)r.push(a);else{const[d,w]=(0,I.getIdAndVersion)(a);n(d,w)&&i.push({id:d,version:w,installOptions:{...f,isBuiltin:!1}})}for(const a of b){const[d,w]=(0,I.getIdAndVersion)(a);n(d,w)&&i.push({id:d,version:w,installOptions:{...f,isBuiltin:!0}})}if(r.length&&await Promise.all(r.map(async a=>{try{const d=await this.installVSIX(a,{...f,isBuiltin:!1},E,u);d&&l.push(d)}catch(d){u.error(d.message||d.stack||d),o.push(a.toString())}})),i.length){const a=await this.getGalleryExtensions(i);await Promise.all(i.map(async d=>{const w=a.get(d.id.toLowerCase());if(w)try{const P=await this.installFromGallery(d,w,s,E,u);P&&l.push(P)}catch(P){u.error(P.message||P.stack||P),o.push(d.id)}else u.error(`${g(d.version?`${d.id}@${d.version}`:d.id)}
${S}`),o.push(d.id)}))}if(o.length)throw new Error((0,v.localize)(7,null,o.join(", ")))}async installVSIX(y,b,f,E){const u=await this.extensionManagementService.getManifest(y);if(!u)throw new Error("Invalid vsix");if(await this.validateVSIX(u,f,E))try{return await this.extensionManagementService.install(y,b),E.log((0,v.localize)(8,null,(0,p.getBaseLabel)(y))),u}catch(l){if((0,t.isCancellationError)(l))return E.log((0,v.localize)(9,null,(0,p.getBaseLabel)(y))),null;throw l}return null}async getGalleryExtensions(y){const b=new Map,f=y.some(u=>u.installOptions.installPreReleaseVersion),E=await this.extensionGalleryService.getExtensions(y.map(u=>({...u,preRelease:f})),_.CancellationToken.None);for(const u of E)b.set(u.identifier.id.toLowerCase(),u);return b}async installFromGallery({id:y,version:b,installOptions:f},E,u,o,l){const s=await this.extensionGalleryService.getManifest(E,_.CancellationToken.None);if(s&&!this.validateExtensionKind(s,l))return null;const n=u.find(r=>(0,A.areSameExtensions)(r.identifier,E.identifier));if(n){if(E.version===n.manifest.version)return l.log((0,v.localize)(10,null,b?`${y}@${b}`:y)),null;l.log((0,v.localize)(11,null,y,E.version))}try{return f.isBuiltin?l.log(b?(0,v.localize)(12,null,y,b):(0,v.localize)(13,null,y)):l.log(b?(0,v.localize)(14,null,y,b):(0,v.localize)(15,null,y)),await this.extensionManagementService.installFromGallery(E,{...f,installGivenVersion:!!b}),l.log((0,v.localize)(16,null,y,E.version)),s}catch(r){if((0,t.isCancellationError)(r))return l.log((0,v.localize)(17,null,y)),null;throw r}}validateExtensionKind(y,b){return!0}async validateVSIX(y,b,f){const E={id:(0,A.getGalleryExtensionId)(y.publisher,y.name)},o=(await this.extensionManagementService.getInstalled(1)).find(l=>(0,A.areSameExtensions)(E,l.identifier)&&(0,k.gt)(l.manifest.version,y.version));return o&&!b?(f.log((0,v.localize)(18,null,o.identifier.id,o.manifest.version,y.version)),!1):this.validateExtensionKind(y,f)}async uninstallExtensions(y,b,f=console){const E=async o=>{if(o instanceof D.URI){const l=await this.extensionManagementService.getManifest(o);return c(l)}return o},u=[];for(const o of y){const l=await E(o),n=(await this.extensionManagementService.getInstalled()).filter(r=>(0,A.areSameExtensions)(r.identifier,{id:l}));if(!n.length)throw new Error(`${this.notInstalled(l)}
${S}`);if(n.some(r=>r.type===0)){f.log((0,v.localize)(19,null,l));return}if(!b&&n.some(r=>r.isBuiltin)){f.log((0,v.localize)(20,null,l));return}f.log((0,v.localize)(21,null,l));for(const r of n)await this.extensionManagementService.uninstall(r),u.push(r);this.location?f.log((0,v.localize)(22,null,l,this.location)):f.log((0,v.localize)(23,null,l))}}async locateExtension(y,b=console){const f=await this.extensionManagementService.getInstalled();y.forEach(E=>{f.forEach(u=>{if(u.identifier.id===E&&u.location.scheme===C.Schemas.file){b.log(u.location.fsPath);return}})})}notInstalled(y){return this.location?(0,v.localize)(24,null,y,this.location):(0,v.localize)(25,null,y)}};h=Ae([Oe(0,I.IExtensionManagementService),Oe(1,I.IExtensionGalleryService)],h),e.ExtensionManagementCLIService=h}),define(we[198],ye([0,1,7,2,21,4,61,32]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(h,m){return C.URI.revive(m?m.transformIncoming(h):h)}function I(h,m){return m?m.transformOutgoingURI(h):h}function A(h,m){m=m||k.DefaultURITransformer;const y=h.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...h,manifest:void 0},m),manifest:y}}function R(h,m){return m?(0,p.cloneAndChange)(h,y=>y instanceof C.URI?m.transformOutgoingURI(y):void 0):h}class g{constructor(m,y){this.service=m,this.getUriTransformer=y,this.onInstallExtension=_.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=_.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=_.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=_.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,y){const b=this.getUriTransformer(m);switch(y){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return _.Event.map(this.onDidInstallExtensions,f=>f.map(E=>({...E,local:E.local?R(E.local,b):E.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,y,b){const f=this.getUriTransformer(m);switch(y){case"zip":return this.service.zip(A(b[0],f)).then(E=>I(E,f));case"unzip":return this.service.unzip(v(b[0],f));case"install":return this.service.install(v(b[0],f),b[1]);case"getManifest":return this.service.getManifest(v(b[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(A(b[0],f),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(A(b[0],f));case"getInstalled":return this.service.getInstalled(b[0]).then(E=>E.map(u=>R(u,f)));case"updateMetadata":return this.service.updateMetadata(A(b[0],f),b[1]).then(E=>R(E,f));case"updateExtensionScope":return this.service.updateExtensionScope(A(b[0],f),b[1]).then(E=>R(E,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class S extends t.Disposable{constructor(m){super();this.channel=m,this._onInstallExtension=this._register(new _.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new _.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new _.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new _.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(y=>this._onInstallExtension.fire({identifier:y.identifier,source:this.isUriComponents(y.source)?C.URI.revive(y.source):y.source}))),this._register(this.channel.listen("onDidInstallExtensions")(y=>this._onDidInstallExtensions.fire(y.map(b=>({...b,local:b.local?A(b.local,null):b.local,source:this.isUriComponents(b.source)?C.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(y=>this._onUninstallExtension.fire(y))),this._register(this.channel.listen("onDidUninstallExtension")(y=>this._onDidUninstallExtension.fire(y)))}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const y=await this.getTargetPlatform();return m.allTargetPlatforms.some(b=>(0,D.isTargetPlatformCompatible)(b,m.allTargetPlatforms,y))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(y=>C.URI.revive(y)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,y){return Promise.resolve(this.channel.call("install",[m,y])).then(b=>A(b,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,y){return Promise.resolve(this.channel.call("installFromGallery",[m,y])).then(b=>A(b,null))}uninstall(m,y){return Promise.resolve(this.channel.call("uninstall",[m,y]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null){return Promise.resolve(this.channel.call("getInstalled",[m])).then(y=>y.map(b=>A(b,null)))}updateMetadata(m,y){return Promise.resolve(this.channel.call("updateMetadata",[m,y])).then(b=>A(b,null))}updateExtensionScope(m,y){return Promise.resolve(this.channel.call("updateExtensionScope",[m,y])).then(b=>A(b,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class c{constructor(m){this.service=m}listen(m,y){throw new Error("Invalid listen")}call(m,y,b){switch(y){case"getConfigBasedTips":return this.service.getConfigBasedTips(C.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=c}),define(we[199],ye([0,1,13,11,2,3,22,56,4,23,18,26,32,31,19,14]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let y=class extends p.Disposable{constructor(f,E,u,o){super();this.fileService=E,this.extensionGalleryService=u,this.logService=o,this.extensionsDownloadDir=v.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,E){await this.cleanUpPromise;const u=this.getName(f),o=(0,k.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(o)){const l=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(l)||await this.extensionGalleryService.download(f,l,E);try{await this.rename(l,o,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(l)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,l.path),s}}return o}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,E,u){try{await A.Promises.rename(f.fsPath,E.fsPath)}catch(o){if(C.isWindows&&o&&o.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${f} to ${E} with 'EPERM' error. Trying again...`),this.rename(f,E,u);throw o}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const E=[],u=[];for(const s of f.children){const n=this.parse(s.name);n&&u.push([n,s])}const o=(0,S.groupByExtension)(u,([s])=>s),l=[];for(const s of o)s.sort((n,r)=>D.rcompare(n[0].version,r[0].version)),E.push(...s.slice(1).map(n=>n[1].resource)),l.push(s[0][1]);l.sort((s,n)=>s.mtime-n.mtime),E.push(...l.slice(0,Math.max(0,l.length-this.cache)).map(s=>s.resource)),await _.Promises.settled(E.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new S.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,I.generateUuid)()}parse(f){const E=m.exec(f);return E&&E[1]&&E[2]?new S.ExtensionIdentifierWithVersion({id:E[1]},E[2]):null}};y=Ae([Oe(0,R.INativeEnvironmentService),Oe(1,c.IFileService),Oe(2,g.IExtensionGalleryService),Oe(3,h.ILogService)],y),e.ExtensionsDownloader=y}),define(we[200],ye([0,1,2,5,18,40]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends _.Disposable{constructor(v,I){super();this.environmentService=v,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(A=>this.onDidInstallExtensions(A))),this._register(I.onDidUninstallExtension(A=>this.onDidUnInstallExtension(A)))}onDidInstallExtensions(v){v.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(v){v.error||this.invalidate()}invalidate(){p.Promises.rm(this.extensionsManifestCache,p.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(we[98],ye([0,1,67,17,13,2,8,5,18,26,32,31,66,14]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let c=class extends C.Disposable{constructor(y,b,f){super();this.extensionManagementService=y,this.logService=f,this.cache=this._register(new h(b,f)),this.extensionManagementService.registerParticipant({postInstall:async E=>this.postInstallExtension(E),postUninstall:async E=>this.postUninstallExtension(E)})}async getLanguageIds(){const y=await this.cache.getLanguagePacks(),b=["en",...Object.keys(y)];return(0,t.distinct)(b)}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const b=await this.cache.getLanguagePacks();Object.keys(b).some(f=>b[f]&&b[f].extensions.some(E=>(0,R.areSameExtensions)(E.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,b]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(b);return!(0,t.equals)(Object.keys(y),Object.keys(f))}};c=Ae([Oe(0,A.IExtensionManagementService),Oe(1,I.INativeEnvironmentService),Oe(2,S.ILogService)],c),e.LocalizationsService=c;let h=class extends C.Disposable{constructor(y,b){super();this.logService=b,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new p.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(b=>{Object.keys(b).forEach(f=>delete b[f]),this.createLanguagePacksFromExtensions(b,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...b){for(const f of b)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,f);Object.keys(y).forEach(f=>this.updateHash(y[f]))}createLanguagePacksFromExtension(y,b){const f=b.identifier,E=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const u of E)if(b.location.scheme===k.Schemas.file&&(0,g.isValidLocalization)(u)){let o=y[u.languageId];o||(o={hash:"",extensions:[],translations:{}},y[u.languageId]=o);let l=o.extensions.filter(s=>(0,R.areSameExtensions)(s.extensionIdentifier,f))[0];l?l.version=b.manifest.version:o.extensions.push({extensionIdentifier:f,version:b.manifest.version});for(const s of u.translations)o.translations[s.id]=(0,D.join)(b.location.fsPath,s.path)}}updateHash(y){if(y){const b=(0,_.createHash)("md5");for(const f of y.extensions)b.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);y.hash=b.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let b=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(b=y(f),f)).then(f=>{for(const u of Object.keys(f))f[u]||delete f[u];this.languagePacks=f,this.initializedCache=!0;const E=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",E),v.Promises.writeFile(this.languagePacksFilePath,E)}).then(()=>b,f=>this.logService.error(f))})}};h=Ae([Oe(0,I.INativeEnvironmentService),Oe(1,S.ILogService)],h)}),define(we[46],ye([0,1,15,160,45,6,35]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function D(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=D;function v(c){return c.res.statusCode===204}async function I(c){if(!D(c))throw new Error("Server returned "+c.res.statusCode);return v(c)?null:(await(0,_.streamToBuffer)(c.stream)).toString()}e.asText=I;async function A(c){if(!D(c))throw new Error("Server returned "+c.res.statusCode);if(v(c))return null;const m=(await(0,_.streamToBuffer)(c.stream)).toString();try{return JSON.parse(m)}catch(y){throw y.message+=`:
`+m,y}}e.asJson=A;function R(c){S(c)}e.updateProxyConfigurationsScope=R;let g;function S(c){const h=k.Registry.as(p.Extensions.Configuration),m=g;g={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[g],remove:m?[m]:[]})}S(2)}),define(we[201],ye([0,1,20,8,19,46]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(v,I){this.requestService=v,this.fileService=I}async download(v,I,A=_.CancellationToken.None){if(v.scheme===t.Schemas.file||v.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(v,I);return}const R={type:"GET",url:v.toString()},g=await this.requestService.request(R,A);if(g.res.statusCode===200)await this.fileService.writeFile(I,g.stream);else{const S=await(0,C.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${S}`)}}};k=Ae([Oe(0,C.IRequestService),Oe(1,p.IFileService)],k),e.DownloadService=k}),define(we[202],ye([0,1,15,20]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class p{constructor(D){this.service=D}listen(D,v){throw new Error("Invalid listen")}call(D,v,I){switch(v){case"request":return this.service.request(I[0],t.CancellationToken.None).then(async({res:A,stream:R})=>{const g=await(0,_.streamToBuffer)(R);return[{statusCode:A.statusCode,headers:A.headers},g]})}throw new Error("Invalid call")}}e.RequestChannel=p;class C{constructor(D){this.channel=D}async request(D,v){return C.request(this.channel,D,v)}static async request(D,v,I){const[A,R]=await D.call("request",[v]);return{res:A,stream:(0,_.bufferToStream)(R)}}}e.RequestChannelClient=C}),define(we[203],ye([0,1,68,12]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function p(k,D){return k.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:k.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function C(k,D,v={}){const I=(0,_.parse)(k),A=v.proxyUrl||p(I,D);if(!A)return null;const R=(0,_.parse)(A);if(!/^https?:$/.test(R.protocol||""))return null;const g={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(v.strictSSL)?v.strictSSL:!0};return I.protocol==="http:"?new(await new Promise((S,c)=>{J(["http-proxy-agent"],S,c)}))(g):new(await new Promise((S,c)=>{J(["https-proxy-agent"],S,c)}))(g)}e.getProxyAgent=C}),define(we[204],ye([0,1,13,7,2,43,12,134,6]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var A;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(A=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class S extends p.Disposable{constructor(y={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new _.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new p.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,_.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,p.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,b){b===I?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:b,target:this.getKeyTargets(y)[b]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,b,f){return this.getStorage(b)?.get(y,f)}getBoolean(y,b,f){return this.getStorage(b)?.getBoolean(y,f)}getNumber(y,b,f){return this.getStorage(b)?.getNumber(y,f)}store(y,b,f,E){if((0,k.isUndefinedOrNull)(b)){this.remove(y,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,f,E),this.getStorage(f)?.set(y,b)})}remove(y,b){this.withPausedEmitters(()=>{this.updateKeyTarget(y,b,void 0),this.getStorage(b)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,b){const f=[],E=this.getKeyTargets(y);for(const u of Object.keys(E))E[u]===b&&f.push(u);return f}updateKeyTarget(y,b,f){const E=this.getKeyTargets(b);typeof f=="number"?E[y]!==f&&(E[y]=f,this.getStorage(b)?.set(I,JSON.stringify(E))):typeof E[y]=="number"&&(delete E[y],this.getStorage(b)?.set(I,JSON.stringify(E)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const b=this.get(I,y);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=A.NONE){this._onWillSaveState.fire({reason:y});const b=this.getStorage(0),f=this.getStorage(1);switch(y){case A.NONE:await _.Promises.settled([b?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await _.Promises.settled([b?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const y=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(y,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class c extends S{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}e.InMemoryStorageService=c;async function h(m,y,b,f){const E=i=>{try{return JSON.parse(i)}catch{return i}},u=new Map,o=new Map;m.forEach((i,a)=>{u.set(a,i),o.set(a,E(i))});const l=new Map,s=new Map;y.forEach((i,a)=>{l.set(a,i),s.set(a,E(i))}),console.group(`Storage: Global (path: ${b})`);let n=[];u.forEach((i,a)=>{n.push({key:a,value:i})}),console.table(n),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${f})`);let r=[];l.forEach((i,a)=>{r.push({key:a,value:i})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=h}),define(we[205],ye([0,1,3,24,4,23]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(I){if(_.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function D(I,A,R,g,S,c,h,m,y,b){const f=Object.create(null);f["common.machineId"]=h,f.sessionID=(0,C.generateUuid)()+Date.now(),f.commitHash=S,f.version=c,f["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,_.PlatformToString)(_.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=g,f["common.product"]=b||"desktop";const E=v(m||[]);E&&(f["common.msftInternal"]=E);let u=0;const o=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),_.isLinuxSnap&&(f["common.snap"]="true");const l=k(R);l&&(f["common.platformDetail"]=l);try{const s=await I.readFile(p.URI.file(y));f["common.source"]=s.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=D;function v(I){const A=t.env.USERDNSDOMAIN;if(!A)return!1;const R=A.toLowerCase();return I.some(g=>R===g)}e.verifyMicrosoftInternalDomain=v}),define(we[206],ye([0,1,17,11,2,21]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(v){function I(A,R){return A.callstack<R.callstack?-1:A.callstack>R.callstack?1:0}v.compare=I})(k=e.ErrorEvent||(e.ErrorEvent={}));class D{constructor(I,A=D.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new p.DisposableStore,this._telemetryService=I,this._flushDelay=A;const R=t.errorHandler.addListener(g=>this._onErrorEvent(g));this._disposables.add((0,p.toDisposable)(R)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(I){if(!I||(I.detail&&I.detail.stack&&(I=I.detail),I instanceof t.ErrorNoTelemetry))return;let A=Array.isArray(I.stack)?I.stack.join(`
`):I.stack,R=I.message?I.message:(0,C.safeStringify)(I);!A||this._enqueue({msg:R,callstack:A})}_enqueue(I){const A=(0,_.binarySearch)(this._buffer,I,k.compare);A<0?(I.count=1,this._buffer.splice(~A,0,I)):(this._buffer[A].count||(this._buffer[A].count=0),this._buffer[A].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let I of this._buffer)this._telemetryService.publicLogError2("UnhandledError",I);this._buffer.length=0}}e.default=D,D.ERROR_FLUSH_TIMEOUT=5*1e3}),define(we[207],ye([0,1,2]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends _.Disposable{constructor(C,k){super();this.telemetryService=C,this.telemetryAppender=k}async call(C,k,D){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:v}=D;return this.telemetryService.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:I}=D;return this.telemetryAppender?this.telemetryAppender.log(v,I):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${k} not found`)}listen(C,k,D){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(we[33],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,_.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,_.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var p;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(p=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(we[208],ye([0,1,25,49,13,59,8,5,3,4,80,18,83,181,19,30,33]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function b(l,s){const n=`${l}::${s.join(":")}`,r=y.get(n);if(r)return r;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,d=new Map,w=2e4;function P($,L,T,U){const N=L.substring($.length+1);return p.Promises.withAsyncBody(async W=>{let ie;try{ie=await R.Promises.readdir(L,{withFileTypes:!0})}catch{W();return}if(U.count>=w){U.count+=ie.length,U.maxReached=!0,W();return}let j=ie.length;if(j===0){W();return}let re=ie;U.count+ie.length>w&&(U.maxReached=!0,j=w-U.count,re=ie.slice(0,j)),U.count+=ie.length;for(const x of re)if(x.isDirectory()){if(T.includes(x.name)||await P($,(0,D.join)(L,x.name),T,U),--j==0){W();return}}else{const K=x.name.lastIndexOf(".");if(K>=0){const te=x.name.substring(K+1);te&&a.set(te,(a.get(te)??0)+1)}for(const te of i)te.relativePathPattern?.test(N)!==!1&&te.filePattern.test(x.name)&&d.set(te.tag,(d.get(te.tag)??0)+1);if(--j==0){W();return}}})}const O=p.Promises.withAsyncBody(async $=>{const L={count:0,maxReached:!1};await P(l,l,s,L);const T=await u(l);$({configFiles:f(d),fileTypes:f(a),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:T})});return y.set(n,O),O}e.collectWorkspaceStats=b;function f(l){return[...t.Iterable.map(l.entries(),([s,n])=>({name:s,count:n}))].sort((s,n)=>n.count-s.count)}function E(){const l={os:`${_.type()} ${_.arch()} ${_.release()}`,memory:`${(_.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},s=_.cpus();return s&&s.length>0&&(l.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),l}e.getMachineInfo=E;async function u(l){try{const s=new Map,n=(0,D.join)(l,".vscode","launch.json"),r=await R.Promises.readFile(n),i=[],a=(0,C.parse)(r.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,C.getNodeType)(a)==="object"&&a.configurations)for(const d of a.configurations){const w=d.type;w&&(s.has(w)?s.set(w,s.get(w)+1):s.set(w,1))}return f(s)}catch{return[]}}e.collectLaunchConfigs=u;let o=class{constructor(s,n){this.telemetryService=s,this.productService=n}formatMachineInfo(s){const n=[];return n.push(`OS Version:       ${s.os}`),n.push(`CPUs:             ${s.cpus}`),n.push(`Memory (System):  ${s.memory}`),n.push(`VM:               ${s.vmHint}`),n.join(`
`)}formatEnvironment(s){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${_.type()} ${_.arch()} ${_.release()}`);const r=_.cpus();return r&&r.length>0&&n.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),n.push(`Memory (System):  ${(_.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||n.push(`Load (avg):       ${_.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${s.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(s,n){return Promise.all([(0,g.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async r=>{let[i,a]=r,d=this.formatProcessList(s,i);return n.forEach(w=>{if((0,S.isRemoteDiagnosticError)(w))d+=`
${w.errorMessage}`,a+=`
${w.errorMessage}`;else if(d+=`

Remote: ${w.hostName}`,w.processes&&(d+=`
${this.formatProcessList(s,w.processes)}`),w.workspaceMetadata){a+=`
|  Remote: ${w.hostName}`;for(const P of Object.keys(w.workspaceMetadata)){const O=w.workspaceMetadata[P];let $=`${O.fileCount} files`;O.maxFilesReached&&($=`more than ${$}`),a+=`|    Folder (${P}): ${$}`,a+=this.formatWorkspaceStats(O)}}}),{processInfo:d,workspaceInfo:a}})}async getSystemInfo(s,n){const{memory:r,vmHint:i,os:a,cpus:d}=E(),w={os:a,memory:r,cpus:d,vmHint:i,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:n};return v.isWindows||(w.load=`${_.loadavg().map(P=>Math.round(P)).join(", ")}`),v.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(s,n){const r=[];return(0,g.listProcesses)(s.mainPID).then(async i=>(r.push(""),r.push(this.formatEnvironment(s)),r.push(""),r.push(this.formatProcessList(s,i)),s.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(s))),n.forEach(a=>{if((0,S.isRemoteDiagnosticError)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.formatMachineInfo(a.machineInfo)),a.processes&&r.push(this.formatProcessList(s,a.processes)),a.workspaceMetadata)for(const d of Object.keys(a.workspaceMetadata)){const w=a.workspaceMetadata[d];let P=`${w.fileCount} files`;w.maxFilesReached&&(P=`more than ${P}`),r.push(`Folder (${d}): ${P}`),r.push(this.formatWorkspaceStats(w))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(s){const n=[],r=60;let i=0;const a=(O,$)=>{const L=` ${O}(${$})`;i+L.length>r?(n.push(d),d="|                 ",i=d.length):i+=L.length,d+=L};let d="|      File types:";const w=10;let P=s.fileTypes.length>w?w:s.fileTypes.length;for(let O=0;O<P;O++){const $=s.fileTypes[O];a($.name,$.count)}if(n.push(d),s.configFiles.length>=0&&(d="|      Conf files:",i=0,s.configFiles.forEach(O=>{a(O.name,O.count)}),n.push(d)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach($=>{O+=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`}),n.push(O)}return n.join(`
`)}expandGPUFeatures(s){const n=Math.max(...Object.keys(s).map(r=>r.length));return Object.keys(s).map(r=>`${r}:  ${" ".repeat(n-r.length)}  ${s[r]}`).join(`
                  `)}formatWorkspaceMetadata(s){const n=[],r=[];return s.windows.forEach(i=>{i.folderURIs.length===0||!!i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const d=I.URI.revive(a);if(d.scheme===k.Schemas.file){const w=d.fsPath;r.push(b(w,["node_modules",".git"]).then(P=>{let O=`${P.fileCount} files`;P.maxFilesReached&&(O=`more than ${O}`),n.push(`|    Folder (${(0,D.basename)(w)}): ${O}`),n.push(this.formatWorkspaceStats(P))}).catch(P=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${P.toString()})`)}))}else n.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}formatProcessList(s,n){const r=new Map;s.windows.forEach(a=>r.set(a.pid,a.title));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(s.mainPID,r,i,n,0),i.join(`
`)}formatProcessItem(s,n,r,i,a){const d=a===0;let w;d?w=i.pid===s?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(a)} ${i.name}`,i.name==="window"&&(w=`${w} (${n.get(i.pid)})`));const P=process.platform==="win32"?i.mem:_.totalmem()*(i.mem/100);r.push(`${i.load.toFixed(0).padStart(5," ")}	${(P/c.ByteSize.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(i.children)&&i.children.forEach(O=>this.formatProcessItem(s,n,r,O,a+1))}async getWorkspaceFileExtensions(s){const n=new Set;for(const{uri:r}of s.folders){const i=I.URI.revive(r);if(i.scheme!==k.Schemas.file)continue;const a=i.fsPath;try{(await b(a,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(s){for(const{uri:n}of s.folders){const r=I.URI.revive(n);if(r.scheme!==k.Schemas.file)continue;const i=r.fsPath;try{const a=await b(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),a.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:d.name,count:d.count})}),a.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:d.name,count:d.count})}),a.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};o=Ae([Oe(0,m.ITelemetryService),Oe(1,h.IProductService)],o),e.DiagnosticsService=o}),define(we[209],ye([0,1,17,13,20,11,7,2,3,12,4,148,32,31,14,30,33]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=class extends D.Disposable{constructor(l,s,n,r){super();this.galleryService=l,this.telemetryService=s,this.logService=n,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(l){const s=await this.getTargetPlatform();return l.allTargetPlatforms.some(n=>(0,g.isTargetPlatformCompatible)(n,l.allTargetPlatforms,s))}async installFromGallery(l,s={}){try{if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(R.localize(0,null),g.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(l,!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,s)}catch(n){throw E(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(l),void 0,n),this.logService.error("Failed to install extension.",l.identifier.id),this.logService.error(n),f(n)}}async uninstall(l,s={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,s)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const s=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...l.identifier,preRelease:l.preRelease}],{targetPlatform:s,compatible:!0},p.CancellationToken.None);if(!n)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const l=new Date().getTime();return(!this.extensionsControlManifest||l-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=l),this.extensionsControlManifest}registerParticipant(l){this.participants.push(l)}async installExtension(l,s,n){if(!A.URI.isUri(s)){let w=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(w)return this.logService.info("Extensions is already requested to install",s.identifier.id),w.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],a=this.createInstallExtensionTask(l,s,n);A.URI.isUri(s)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(a.identifier,l.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:s}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:l});let d=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,l,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:O,manifest:$}of P)if(d=d||!!$.extensionDependencies?.some(L=>(0,S.areSameExtensions)({id:L},a.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const L=this.createInstallExtensionTask($,O,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(L.identifier,$.version).key(),L),this._onInstallExtension.fire({identifier:L.identifier,source:O}),this.logService.info("Installing extension:",L.identifier.id),r.push({task:L,manifest:$})}}catch(P){if(A.URI.isUri(a.source))(0,_.isNonEmptyArray)(l.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,P.message),(0,_.isNonEmptyArray)(l.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),P}const w=r.reduce((P,{task:O,manifest:$})=>(P.set(O.identifier.id.toLowerCase(),{task:O,manifest:$}),P),new Map);for(;w.size;){let P;const O=[...w.values()].filter(({manifest:$})=>!$.extensionDependencies?.some(L=>w.has(L.toLowerCase())));O.length?P=w.size===1?O:O.filter(({task:$})=>!($===a&&!d)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:$})=>$.identifier.id)),P=[...w.values()]),await this.joinAllSettled(P.map(async({task:$})=>{const L=new Date().getTime(),T=(0,I.isUndefined)(n.operation)?$.operation:n.operation;try{const U=await $.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(U,$.source,n,p.CancellationToken.None))),!A.URI.isUri($.source)&&(E(this.telemetryService,T===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)($.source),new Date().getTime()-L,void 0),v.isWeb&&T!==3))try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}i.push({local:U,identifier:$.identifier,operation:T,source:$.source})}catch(U){throw A.URI.isUri($.source)||E(this.telemetryService,T===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)($.source),new Date().getTime()-L,U),this.logService.error("Error while installing the extension:",$.identifier.id),U}finally{w.delete($.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:P})=>(0,S.areSameExtensions)(P,a.identifier))[0].local}catch(w){if(r.forEach(({task:P})=>P.cancel()),i.length)try{const P=await Promise.allSettled(i.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<P.length;O++){const $=P[O],{identifier:L}=i[O];$.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",L.id):this.logService.warn("Rollback: Error while uninstalling extension",L.id,(0,C.getErrorMessage)($.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(P),i.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(r.map(({task:P})=>({identifier:P.identifier,operation:2,source:P.source}))),w}finally{for(const{task:w,manifest:P}of r)if(!A.URI.isUri(w.source)){const O=new S.ExtensionIdentifierWithVersion(w.identifier,P.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(l){const s=[],n=[],r=await Promise.allSettled(l);for(const i of r)i.status==="fulfilled"?s.push(i.value):n.push(i.reason);if(n.length)throw b(n);return s}async getAllDepsAndPackExtensionsToInstall(l,s,n,r){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const a=[l,...i.map(P=>P.identifier)],d=[],w=async(P,O)=>{const $=O.extensionDependencies||[],L=[...$];if(O.extensionPack){const T=n?i.find(U=>(0,S.areSameExtensions)(U.identifier,P)):void 0;for(const U of O.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(N=>(0,S.areSameExtensions)({id:N},{id:U}))||L.every(N=>!(0,S.areSameExtensions)({id:N},{id:U}))&&L.push(U)}if(L.length){const T=[...a,...d.map(N=>N.gallery.identifier)],U=L.filter(N=>T.every(W=>!(0,S.areSameExtensions)(W,{id:N})));if(U.length){const N=await this.galleryService.getExtensions(U.map(W=>({id:W,preRelease:r})),p.CancellationToken.None);for(const W of N){if(T.find(re=>(0,S.areSameExtensions)(re,W.identifier)))continue;const ie=$.some(re=>(0,S.areSameExtensions)({id:re},W.identifier));let j;try{j=await this.checkAndGetCompatibleVersion(W,!0,r)}catch(re){if(re instanceof g.ExtensionManagementError&&re.code===g.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ie){this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw re}d.push({gallery:j.extension,manifest:j.manifest}),await w(j.extension.identifier,j.manifest)}}}};return await w(l,s),i=await this.getInstalled(),d.filter(P=>!i.some(O=>(0,S.areSameExtensions)(O.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(l,s,n){const r=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(r).has(l.identifier.id))throw new g.ExtensionManagementError(R.localize(3,null,l.identifier.id),g.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[l.identifier.id])throw new g.ExtensionManagementError(R.localize(4,null,l.identifier.id,r.unsupportedPreReleaseExtensions[l.identifier.id].displayName),g.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(l)){const d=await this.getTargetPlatform();throw new g.ExtensionManagementError(R.localize(5,null,l.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(d)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const i=await this.getCompatibleVersion(l,s,n);if(i){if(n&&s&&l.hasPreReleaseVersion&&!i.properties.isPreReleaseVersion)throw new g.ExtensionManagementError(R.localize(6,null,l.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&l.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([l.identifier],p.CancellationToken.None))[0]?new g.ExtensionManagementError(R.localize(7,null,l.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.ExtensionManagementError(R.localize(8,null,l.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",i.identifier.id);const a=await this.galleryService.getManifest(i,p.CancellationToken.None);if(a===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(a.version!==i.version)throw new g.ExtensionManagementError(`Cannot install '${l.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:i,manifest:a}}async getCompatibleVersion(l,s,n){const r=await this.getTargetPlatform();let i=null;return s&&l.hasPreReleaseVersion&&l.properties.isPreReleaseVersion!==n&&(i=(await this.galleryService.getExtensions([{...l.identifier,preRelease:n}],{targetPlatform:r,compatible:!0},p.CancellationToken.None))[0]||null),!i&&await this.galleryService.isExtensionCompatible(l,n,r)&&(i=l),!i&&s&&(i=await this.galleryService.getCompatibleExtension(l,n,r)),i}async unininstallExtension(l,s){const n=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),n.waitUntilTaskIsFinished();const r=(w,P)=>{const O=this.createUninstallExtensionTask(w,P);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),O},i=(w,P)=>{P?this.logService.error("Failed to uninstall extension:",w.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),E(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(w),void 0,P),this._onDidUninstallExtension.fire({identifier:w.identifier,error:P?.code})},a=[],d=[];try{a.push(r(l,{}));const w=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(l,w);for(const O of P)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):a.push(r(O,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(a.map(P=>P.extension),w,l),await this.joinAllSettled(a.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(P.extension,s,p.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch{}i(P.extension)}catch(O){const $=O instanceof g.ExtensionManagementError?O:new g.ExtensionManagementError((0,C.getErrorMessage)(O),g.ExtensionManagementErrorCode.Internal);throw i(P.extension,$),$}finally{d.push(P)}}))}catch(w){const P=w instanceof g.ExtensionManagementError?w:new g.ExtensionManagementError((0,C.getErrorMessage)(w),g.ExtensionManagementErrorCode.Internal);for(const O of a){try{O.cancel()}catch{}d.includes(O)||i(O.extension,P)}throw P}finally{for(const w of a)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(l,s,n){for(const r of l){const i=this.getDependents(r,s);if(i.length){const a=i.filter(d=>!l.some(w=>(0,S.areSameExtensions)(w.identifier,d.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,n))}}}getDependentsErrorMessage(l,s,n){return n===l?s.length===1?R.localize(9,null,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?R.localize(10,null,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):R.localize(11,null,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?R.localize(12,null,n.manifest.displayName||n.manifest.name,l.manifest.displayName||l.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?R.localize(13,null,n.manifest.displayName||n.manifest.name,l.manifest.displayName||l.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):R.localize(14,null,n.manifest.displayName||n.manifest.name,l.manifest.displayName||l.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(l,s,n=[]){if(n.indexOf(l)!==-1)return[];n.push(l);const r=l.manifest.extensionPack?l.manifest.extensionPack:[];if(r.length){const i=s.filter(d=>!d.isBuiltin&&r.some(w=>(0,S.areSameExtensions)({id:w},d.identifier))),a=[];for(const d of i)a.push(...this.getAllPackExtensionsToUninstall(d,s,n));return[...i,...a]}return[]}getDependents(l,s){return s.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(r=>(0,S.areSameExtensions)({id:r},l.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",l),l}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};y=Ae([Oe(0,g.IExtensionGalleryService),Oe(1,m.ITelemetryService),Oe(2,c.ILogService),Oe(3,h.IProductService)],y),e.AbstractExtensionManagementService=y;function b(o){const l=Array.isArray(o)?o:[o];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((s,n)=>new Error(`${s.message}${s.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=b;function f(o){if(o instanceof g.ExtensionManagementError)return o;const l=new g.ExtensionManagementError(o.message,g.ExtensionManagementErrorCode.Internal);return l.stack=o.stack,l}function E(o,l,s,n,r){const i=r?r instanceof g.ExtensionManagementError?r.code:g.ExtensionManagementErrorCode.Internal:void 0;o.publicLogError(l,{...s,success:!r,duration:n,errorcode:i})}e.reportTelemetry=E;class u{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(l=>new Promise((s,n)=>{const r=l.onCancellationRequested(()=>{r.dispose(),n((0,C.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=u}),define(we[41],ye([0,1,21,12,28,33]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(b,f){return Promise.resolve(void 0)}publicLog2(b,f){return this.publicLog(b,f)}publicLogError(b,f){return Promise.resolve(void 0)}publicLogError2(b,f){return this.publicLogError(b,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class D{async publicLog(b,f,E){}async publicLogError(b,f,E){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(y,b){return b.onDidChangeConfiguration(f=>{f.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(f.source),configurationKeys:c(f.sourceConfig)})})}e.configurationTelemetry=v;function I(y,b){return!(b.disableTelemetry||!y.enableTelemetry||b.extensionTestsLocationURI)}e.supportsTelemetry=I;function A(y){const b=y.getValue(C.TELEMETRY_SETTING_ID),f=y.getValue("telemetry.enableCrashReporter");if(y.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=A;function R(y){const b=Object.create(null),f=Object.create(null),E=Object.create(null);S(y,E);for(let u in E){u=u.length>150?u.substr(u.length-149):u;const o=E[u];typeof o=="number"?f[u]=o:typeof o=="boolean"?f[u]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${o.length}`),b[u]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(b[u]=o)}return{properties:b,measurements:f}}e.validateTelemetryData=R;function g(y){if(!y)return"none";let b="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{y.indexOf(`${E}+`)===0&&(b=E)}),b}e.cleanRemoteAuthority=g;function S(y,b,f=0,E){if(!!y)for(let u of Object.getOwnPropertyNames(y)){const o=y[u],l=E?E+u:u;Array.isArray(o)?b[l]=(0,_.safeStringify)(o):o instanceof Date?b[l]=o.toISOString():(0,t.isObject)(o)?f<2?S(o,b,f+1,l+"."):b[l]=(0,_.safeStringify)(o):b[l]=o}}function c(y){if(!y)return[];const b=[];return h(b,"",y),b}function h(y,b,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(E=>h(y,b?`${b}.${E}`:E,f[E])):y.push(b)}function m(y){return[y.appRoot,y.extensionsPath,y.userHome.fsPath,y.tmpDir.fsPath,y.userDataPath]}e.getPiiPathsFromEnvironment=m}),define(we[210],ye([0,1,178,41]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function p(C,k,D,v,I,A){const R={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${k.nameShort})`},g=await(0,_.getServiceMachineId)(D,I,A);return(0,t.supportsTelemetry)(k,D)&&(0,t.getTelemetryLevel)(v)===3&&(R["X-Market-User-Id"]=g),R}e.resolveMarketplaceHeaders=p}),define(we[99],ye([0,1,17,20,11,21,3,24,12,4,28,26,32,31,63,19,14,30,46,210,204,33]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const o=k.isWeb?"web":(0,g.getTargetPlatform)(k.platform,D.arch);var l;(function(H){H[H.None=0]="None",H[H.IncludeVersions=1]="IncludeVersions",H[H.IncludeFiles=2]="IncludeFiles",H[H.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",H[H.IncludeSharedAccounts=8]="IncludeSharedAccounts",H[H.IncludeVersionProperties=16]="IncludeVersionProperties",H[H.ExcludeNonValidated=32]="ExcludeNonValidated",H[H.IncludeInstallationTargets=64]="IncludeInstallationTargets",H[H.IncludeAssetUri=128]="IncludeAssetUri",H[H.IncludeStatistics=256]="IncludeStatistics",H[H.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",H[H.Unpublished=4096]="Unpublished",H[H.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(l||(l={}));function s(...H){return String(H.reduce((q,ee)=>q|ee,0))}var n;(function(H){H[H.Tag=1]="Tag",H[H.ExtensionId=4]="ExtensionId",H[H.Category=5]="Category",H[H.ExtensionName=7]="ExtensionName",H[H.Target=8]="Target",H[H.Featured=9]="Featured",H[H.SearchText=10]="SearchText",H[H.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class w{constructor(q=d){this.state=q}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(q,ee=this.state.pageSize){return new w({...this.state,pageNumber:q,pageSize:ee})}withFilter(q,...ee){const he=[...this.state.criteria,...ee.length?ee.map(Ie=>({filterType:q,value:Ie})):[{filterType:q}]];return new w({...this.state,criteria:he})}withSortBy(q){return new w({...this.state,sortBy:q})}withSortOrder(q){return new w({...this.state,sortOrder:q})}withFlags(...q){return new w({...this.state,flags:q.reduce((ee,he)=>ee|he,0)})}withAssetTypes(...q){return new w({...this.state,assetTypes:q})}get raw(){const{criteria:q,pageNumber:ee,pageSize:he,sortBy:Ie,sortOrder:se,flags:fe,assetTypes:ve}=this.state;return{filters:[{criteria:q,pageNumber:ee,pageSize:he,sortBy:Ie,sortOrder:se}],assetTypes:ve,flags:fe}}get searchText(){const q=this.state.criteria.filter(ee=>ee.filterType===n.SearchText)[0];return q&&q.value?q.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(q=>String(q.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function P(H,q){const ee=(H||[]).filter(he=>he.statisticName===q)[0];return ee?ee.value:0}function O(H){const q="Microsoft.VisualStudio.Code.Translation.";return H.files.filter(he=>he.assetType.indexOf(q)===0).reduce((he,Ie)=>{const se=U(H,Ie.assetType);return se&&he.push([Ie.assetType.substring(q.length),se]),he},[])}function $(H){if(H.properties){const q=H.properties.filter(Ie=>Ie.key===r.Repository),ee=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),he=q.filter(Ie=>ee.test(Ie.value))[0];return he?{uri:he.value,fallbackUri:he.value}:null}return U(H,r.Repository)}function L(H){return{uri:`${H.fallbackAssetUri}/${r.VSIX}?redirect=true${H.targetPlatform?`&targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${r.VSIX}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}}function T(H){const q=U(H,r.Icon);if(q)return q;const ee=g.DefaultIconPath;return{uri:ee,fallbackUri:ee}}function U(H,q){return H.files.filter(he=>he.assetType===q)[0]?{uri:`${H.assetUri}/${q}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${q}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}:null}function N(H,q){const ee=H.properties?H.properties.filter(Ie=>Ie.key===q):[],he=ee.length>0&&ee[0].value;return he?he.split(",").map(Ie=>(0,S.adoptToGalleryExtensionId)(Ie)):[]}function W(H){const q=H.properties?H.properties.filter(ee=>ee.key===i.Engine):[];return q.length>0&&q[0].value||""}function ie(H){const q=H.properties?H.properties.filter(ee=>ee.key===i.PreRelease):[];return q.length>0&&q[0].value==="true"}function j(H){const q=H.properties?H.properties.filter(he=>he.key===i.LocalizedLanguages):[],ee=q.length>0&&q[0].value||"";return ee?ee.split(","):[]}function re(H){return H.indexOf("preview")!==-1}function x(H){return H.targetPlatform?(0,g.toTargetPlatform)(H.targetPlatform):"undefined"}function K(H){const q=(0,_.distinct)(H.versions.map(x)),ee=!!H.tags?.includes(g.WEB_EXTENSION_TAG),he=q.indexOf("web");return ee?he===-1&&q.push("web"):he!==-1&&q.splice(he,1),q}function te(H,q){const ee=(0,g.getFallbackTargetPlarforms)(q);for(let he=0;he<H.length;he++){const Ie=H[he];if(Ie.version===H[he-1]?.version){let se=he;const fe=x(Ie);if(fe===q)for(;se>0&&H[se-1].version===Ie.version;)se--;else if(ee.includes(fe))for(;se>0&&H[se-1].version===Ie.version&&x(H[se-1])!==q;)se--;se!==he&&(H.splice(he,1),H.splice(se,0,Ie))}}return H}e.sortExtensionVersions=te;function ce(H,q,ee){H.telemetryData={index:q,querySource:ee}}function oe(H,q,ee){const he=H.versions[0],Ie={manifest:U(q,r.Manifest),readme:U(q,r.Details),changelog:U(q,r.Changelog),license:U(q,r.License),repository:$(q),download:L(q),icon:T(q),coreTranslations:O(q)};return{identifier:{id:(0,S.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},name:H.extensionName,version:q.version,displayName:H.displayName,publisherId:H.publisher.publisherId,publisher:H.publisher.publisherName,publisherDisplayName:H.publisher.displayName,publisherDomain:H.publisher.domain?{link:H.publisher.domain,verified:!!H.publisher.isDomainVerified}:void 0,description:H.shortDescription||"",installCount:P(H.statistics,"install"),rating:P(H.statistics,"averagerating"),ratingCount:P(H.statistics,"ratingcount"),categories:H.categories||[],tags:H.tags||[],releaseDate:Date.parse(H.releaseDate),lastUpdated:Date.parse(H.lastUpdated),allTargetPlatforms:ee,assets:Ie,properties:{dependencies:N(q,i.Dependency),extensionPack:N(q,i.ExtensionPack),engine:W(q),localizedLanguages:j(q),targetPlatform:x(q),isPreReleaseVersion:ie(q)},hasPreReleaseVersion:ie(he),hasReleaseVersion:!0,preview:re(H.flags)}}let me=class{constructor(q,ee,he,Ie,se,fe,ve,X){this.requestService=ee,this.logService=he,this.environmentService=Ie,this.telemetryService=se,this.fileService=fe,this.productService=ve,this.configurationService=X;const B=ve.extensionsGallery;this.extensionsGalleryUrl=B&&B.serviceUrl,this.extensionsControlUrl=B&&B.controlUrl,this.commonHeadersPromise=(0,f.resolveMarketplaceHeaders)(ve.version,ve,this.environmentService,this.configurationService,this.fileService,q)}api(q=""){return`${this.extensionsGalleryUrl}${q}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(q,ee,he){const Ie=t.CancellationToken.isCancellationToken(ee)?{}:ee,se=t.CancellationToken.isCancellationToken(ee)?ee:he,fe=[],ve=[],X=[],B=[];let V=!0;for(const pe of q){pe.uuid?ve.push(pe.uuid):fe.push(pe.id);const Pe=!!(pe.version||pe.preRelease);X.push({id:pe.id,uuid:pe.uuid,includePreRelease:Pe}),pe.version&&B.push({id:pe.id,uuid:pe.uuid,version:pe.version}),V=V&&!!pe.hasPreRelease&&!Pe}if(!ve.length&&!fe.length)return[];let Q=new w().withPage(1,q.length);ve.length&&(Q=Q.withFilter(n.ExtensionId,...ve)),fe.length&&(Q=Q.withFilter(n.ExtensionName,...fe)),(Ie.queryAllVersions||V)&&(Q=Q.withFlags(Q.flags,l.IncludeVersions));const{extensions:ue}=await this.queryGalleryExtensions(Q,{targetPlatform:Ie.targetPlatform??o,includePreRelease:X,versions:B,compatible:!!Ie.compatible},se);return Ie.source&&ue.forEach((pe,Pe)=>ce(pe,Pe,Ie.source)),ue}async getCompatibleExtension(q,ee,he){if((0,g.isNotWebExtensionInWebTargetPlatform)(q.allTargetPlatforms,he))return null;if(await this.isExtensionCompatible(q,ee,he))return q;const Ie=new w().withFlags(l.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,q.identifier.uuid),{extensions:se}=await this.queryGalleryExtensions(Ie,{targetPlatform:he,compatible:!0,includePreRelease:ee},t.CancellationToken.None);return se[0]||null}async isExtensionCompatible(q,ee,he){if(!(0,g.isTargetPlatformCompatible)(q.properties.targetPlatform,q.allTargetPlatforms,he)||!ee&&q.properties.isPreReleaseVersion)return!1;let Ie=q.properties.engine;if(!Ie){const se=await this.getManifest(q,t.CancellationToken.None);if(!se)throw new Error("Manifest was not found");Ie=se.engines.vscode}return(0,c.isEngineValid)(Ie,this.productService.version,this.productService.date)}async isValidVersion(q,ee,he,Ie,se){if(!(0,g.isTargetPlatformCompatible)(x(q),Ie,se)||ee!=="any"&&ie(q)!==(ee==="prerelease"))return!1;if(he){const fe=await this.getEngine(q);if(!(0,c.isEngineValid)(fe,this.productService.version,this.productService.date))return!1}return!0}async query(q,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let he=q.text||"";const Ie=(0,C.getOrDefault)(q,V=>V.pageSize,50);let se=new w().withPage(1,Ie);he?(he=he.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,Q,ue)=>(se=se.withFilter(n.Category,ue||Q),"")),he=he.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(V,Q,ue)=>(se=se.withFilter(n.Tag,ue||Q),"")),he=he.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(n.Featured),"")),he=he.trim(),he&&(he=he.length<200?he:he.substring(0,200),se=se.withFilter(n.SearchText,he)),se=se.withSortBy(0)):q.ids?se=se.withFilter(n.ExtensionId,...q.ids):q.names?se=se.withFilter(n.ExtensionName,...q.names):se=se.withSortBy(4),typeof q.sortBy=="number"&&(se=se.withSortBy(q.sortBy)),typeof q.sortOrder=="number"&&(se=se.withSortOrder(q.sortOrder));const fe=async(V,Q)=>{const{extensions:ue,total:pe}=await this.queryGalleryExtensions(V,{targetPlatform:o,compatible:!1,includePreRelease:!!q.includePreRelease},Q);return ue.forEach((Pe,Re)=>ce(Pe,(V.pageNumber-1)*V.pageSize+Re,q.source)),{extensions:ue,total:pe}},{extensions:ve,total:X}=await fe(se,ee),B=async(V,Q)=>{if(Q.isCancellationRequested)throw new p.CancellationError;const{extensions:ue}=await fe(se.withPage(V+1),Q);return ue};return{firstPage:ve,total:X,pageSize:se.pageSize,getPage:B}}async queryGalleryExtensions(q,ee,he){const Ie=q.flags;!!(q.flags&l.IncludeLatestVersionOnly)&&!!(q.flags&l.IncludeVersions)&&(q=q.withFlags(q.flags&~l.IncludeVersions,l.IncludeLatestVersionOnly)),!(q.flags&l.IncludeLatestVersionOnly)&&!(q.flags&l.IncludeVersions)&&(q=q.withFlags(q.flags,l.IncludeLatestVersionOnly)),ee.versions?.length&&(q=q.withFlags(q.flags&~l.IncludeLatestVersionOnly,l.IncludeVersions)),q=q.withFlags(q.flags,l.IncludeAssetUri,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeStatistics,l.IncludeVersionProperties);const{galleryExtensions:se,total:fe}=await this.queryRawGalleryExtensions(q,he);if(!(q.flags&l.IncludeLatestVersionOnly)){const V=[];for(const Q of se){const ue=await this.toGalleryExtensionWithCriteria(Q,ee,!0);ue&&V.push(ue)}return{extensions:V,total:fe}}const X=[],B=new Map;for(let V=0;V<se.length;V++){const Q=se[V],ue={id:(0,S.getGalleryExtensionId)(Q.publisher.publisherName,Q.extensionName),uuid:Q.extensionId},pe=(0,v.isBoolean)(ee.includePreRelease)?ee.includePreRelease:!!ee.includePreRelease.find(Re=>(0,S.areSameExtensions)(Re,ue))?.includePreRelease;let Pe=await this.toGalleryExtensionWithCriteria(Q,ee,!1);!Pe||Pe.properties.isPreReleaseVersion&&(!pe||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==ee.targetPlatform&&Pe.hasPreReleaseVersion?B.set(Q.extensionId,V):X.push([V,Pe])}if(B.size){const V=new Date().getTime(),Q=new w().withFlags(Ie&~l.IncludeLatestVersionOnly,l.IncludeVersions).withPage(1,B.size).withFilter(n.ExtensionId,...B.keys()),{extensions:ue}=await this.queryGalleryExtensions(Q,ee,he);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-V,count:B.size});for(const pe of ue){const Pe=B.get(pe.identifier.uuid);X.push([Pe,pe])}}return{extensions:X.sort((V,Q)=>V[0]-Q[0]).map(([,V])=>V),total:fe}}async toGalleryExtensionWithCriteria(q,ee,he){const Ie={id:(0,S.getGalleryExtensionId)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},se=ee.versions?.find(B=>(0,S.areSameExtensions)(B,Ie))?.version,fe=(0,v.isBoolean)(ee.includePreRelease)?ee.includePreRelease:!!ee.includePreRelease.find(B=>(0,S.areSameExtensions)(B,Ie))?.includePreRelease,ve=K(q),X=te(q.versions,ee.targetPlatform);if(ee.compatible&&he&&(0,g.isNotWebExtensionInWebTargetPlatform)(ve,ee.targetPlatform))return null;for(let B=0;B<X.length;B++){const V=X[B];if(!(se&&V.version!==se)){if(await this.isValidVersion(V,fe?"any":"release",ee.compatible,ve,ee.targetPlatform))return oe(q,V,ve);if(se&&V.version===se)return null}}return se||ee.compatible?null:oe(q,q.versions[0],ve)}async queryRawGalleryExtensions(q,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");q=q.withFlags(q.flags,l.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(l.Unpublished));const he=await this.commonHeadersPromise,Ie=JSON.stringify(q.raw),se={...he,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Ie.length)},fe=new Date().getTime();let ve,X,B=0;try{if(ve=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Ie,headers:se},ee),ve.res.statusCode&&ve.res.statusCode>=400&&ve.res.statusCode<500)return{galleryExtensions:[],total:B};const V=await(0,b.asJson)(ve);if(V){const Q=V.results[0],ue=Q.extensions,pe=Q.resultMetadata&&Q.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return B=pe&&pe.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ue,total:B}}return{galleryExtensions:[],total:B}}catch(V){throw X=V,V}finally{this.telemetryService.publicLog2("galleryService:query",{...q.telemetryData,requestBodySize:String(Ie.length),duration:new Date().getTime()-fe,success:!!ve&&(0,b.isSuccess)(ve),responseBodySize:ve?.res.headers["Content-Length"],statusCode:ve?String(ve.res.statusCode):void 0,errorCode:X?(0,p.isCancellationError)(X)?"canceled":(0,p.getErrorMessage)(X).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(B)})}}async reportStatistic(q,ee,he,Ie){if(!this.isEnabled())return;const se=k.isWeb?this.api(`/itemName/${q}.${ee}/version/${he}/statType/${Ie==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${q}/extensions/${ee}/${he}/stats?statType=${Ie}`),fe=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",X={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:se,headers:X},t.CancellationToken.None)}catch{}}async download(q,ee,he){this.logService.trace("ExtensionGalleryService#download",q.identifier.id);const Ie=(0,S.getGalleryExtensionTelemetryData)(q),se=new Date().getTime(),fe=V=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Ie,duration:V}),ve=he===2?"install":he===3?"update":"",X=ve?{uri:`${q.assets.download.uri}${I.URI.parse(q.assets.download.uri).query?"&":"?"}${ve}=true`,fallbackUri:`${q.assets.download.fallbackUri}${I.URI.parse(q.assets.download.fallbackUri).query?"&":"?"}${ve}=true`}:q.assets.download,B=await this.getAsset(X);await this.fileService.writeFile(ee,B.stream),fe(new Date().getTime()-se)}async getReadme(q,ee){if(q.assets.readme){const he=await this.getAsset(q.assets.readme,{},ee);return await(0,b.asText)(he)||""}return""}async getManifest(q,ee){if(q.assets.manifest){const he=await this.getAsset(q.assets.manifest,{},ee),Ie=await(0,b.asText)(he);return Ie?JSON.parse(Ie):null}return null}async getManifestFromRawExtensionVersion(q,ee){const he=U(q,r.Manifest);if(!he)throw new Error("Manifest was not found");const Ie={"Accept-Encoding":"gzip"},se=await this.getAsset(he,{headers:Ie});return await(0,b.asJson)(se)}async getCoreTranslation(q,ee){const he=q.assets.coreTranslations.filter(Ie=>Ie[0]===ee.toUpperCase())[0];if(he){const Ie=await this.getAsset(he[1]),se=await(0,b.asText)(Ie);return se?JSON.parse(se):null}return null}async getChangelog(q,ee){if(q.assets.changelog){const he=await this.getAsset(q.assets.changelog,{},ee);return await(0,b.asText)(he)||""}return""}async getAllCompatibleVersions(q,ee,he){let Ie=new w().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1);q.identifier.uuid?Ie=Ie.withFilter(n.ExtensionId,q.identifier.uuid):Ie=Ie.withFilter(n.ExtensionName,q.identifier.id);const{galleryExtensions:se}=await this.queryRawGalleryExtensions(Ie,t.CancellationToken.None);if(!se.length)return[];const fe=K(se[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(fe,he))return[];const ve=[],X=new Set;return await Promise.all(se[0].versions.map(async B=>{try{if(X.has(B.version))return;await this.isValidVersion(B,ee?"any":"release",!0,fe,he)&&(ve.push({version:B.version,date:B.lastUpdated,isPreReleaseVersion:ie(B)}),X.add(B.version))}catch{}})),ve}async getAsset(q,ee={},he=t.CancellationToken.None){const Ie=await this.commonHeadersPromise,se={type:"GET"},fe={...Ie,...ee.headers||{}};ee={...ee,...se,headers:fe};const ve=q.uri,X=q.fallbackUri,B={...ee,url:ve};try{const V=await this.requestService.request(B,he);if(V.res.statusCode===200)return V;const Q=await(0,b.asText)(V);throw new Error(`Expected 200, got back ${V.res.statusCode} instead.

${Q}`)}catch(V){if((0,p.isCancellationError)(V))throw V;const Q=(0,p.getErrorMessage)(V);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ve,message:Q});const ue={...ee,url:X};return this.requestService.request(ue,he)}}async getEngine(q){let ee=W(q);if(!ee){const he=await this.getManifestFromRawExtensionVersion(q,t.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ee=he.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const q=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(q.res.statusCode!==200)throw new Error("Could not get extensions report.");const ee=await(0,b.asJson)(q),he=[],Ie={};if(ee){for(const se of ee.malicious)he.push({id:se});if(ee.unsupported)for(const se of Object.keys(ee.unsupported)){const fe=ee.unsupported[se];(0,v.isBoolean)(fe)||(Ie[se.toLowerCase()]=fe.preReleaseExtension)}if(ee.migrateToPreRelease)for(const[se,fe]of Object.entries(ee.migrateToPreRelease))(!fe.engine||(0,c.isEngineValid)(fe.engine,this.productService.version,this.productService.date))&&(Ie[se.toLowerCase()]=fe)}return{malicious:he,unsupportedPreReleaseExtensions:Ie}}};me=Ae([Oe(1,b.IRequestService),Oe(2,m.ILogService),Oe(3,R.IEnvironmentService),Oe(4,u.ITelemetryService),Oe(5,h.IFileService),Oe(6,y.IProductService),Oe(7,A.IConfigurationService)],me);let Y=class extends me{constructor(q,ee,he,Ie,se,fe,ve,X){super(q,ee,he,Ie,se,fe,ve,X)}};Y=Ae([Oe(0,E.IStorageService),Oe(1,b.IRequestService),Oe(2,m.ILogService),Oe(3,R.IEnvironmentService),Oe(4,u.ITelemetryService),Oe(5,h.IFileService),Oe(6,y.IProductService),Oe(7,A.IConfigurationService)],Y),e.ExtensionGalleryService=Y;let z=class extends me{constructor(q,ee,he,Ie,se,fe,ve){super(void 0,q,ee,he,Ie,se,fe,ve)}};z=Ae([Oe(0,b.IRequestService),Oe(1,m.ILogService),Oe(2,R.IEnvironmentService),Oe(3,u.ITelemetryService),Oe(4,h.IFileService),Oe(5,y.IProductService),Oe(6,A.IConfigurationService)],z),e.ExtensionGalleryServiceWithNoStorageService=z}),define(we[211],ye([0,1,2,21,3,16,161,28,45,44,35,33,41]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(m,y){this._configurationService=y,this._experimentProperties={},this._disposables=new _.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(b),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,y){this._experimentProperties[m]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let y=m.sessionID,b=m["common.machineId"],f=m["common.firstSessionDate"],E=m["common.msftInternal"];return{sessionId:y,machineId:b,firstSessionDate:f,msftInternal:E}}dispose(){this._disposables.dispose()}_log(m,y,b,f){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(E=>{b=(0,t.mixin)(b,E),b=(0,t.mixin)(b,this._experimentProperties),b=(0,t.cloneAndChange)(b,u=>{if(typeof u=="string")return this._cleanupInfo(u,f)}),this._appenders.forEach(u=>u.log(m,b))},E=>{console.error(E)})}publicLog(m,y,b){return this._log(m,3,y,b)}publicLog2(m,y,b){return this.publicLog(m,y,b)}publicLogError(m,y){return this.sendErrorTelemetry?this._log(m,2,y,!0):Promise.resolve(void 0)}publicLogError2(m,y){return this.publicLogError(m,y)}_anonymizeFilePaths(m){let y=m;const b=[];for(let o of this._cleanupPatterns)for(;;){const l=o.exec(m);if(!l)break;b.push([l.index,o.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(y="";;){const o=E.exec(m);if(!o)break;!f.test(o[0])&&b.every(([l,s])=>o.index<l||o.index>=s)&&(y+=m.substring(u,o.index)+"<REDACTED: user-file-path>",u=E.lastIndex)}return u<m.length&&(y+=m.substr(u)),y}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const y=m.toLowerCase(),b=/@[a-zA-Z0-9-.]+/,f=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,E=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return f.test(y)?"<REDACTED: secret>":b.test(y)?"<REDACTED: email>":E.test(y)?"<REDACTED: token>":m}_cleanupInfo(m,y){let b=m;y&&(b=this._anonymizeFilePaths(b));for(let f of this._cleanupPatterns)b=b.replace(f,"");return b=this._removePropertiesWithPossibleUserInfo(b),b}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=Ae([Oe(1,D.IConfigurationService)],S),e.TelemetryService=S;function c(){const h=(0,k.localize)(0,null,I.default.nameLong),m=I.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=p.isWeb?"":(0,k.localize)(3,null),b=(0,k.localize)(4,null),f=(0,k.localize)(5,null),E=(0,k.localize)(6,null),u=(0,k.localize)(7,null),o=`
|       | ${b} | ${f} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,k.localize)(8,null);return`
${h} ${m} ${y}

&nbsp;

${u}
${o}

&nbsp;

${l}
`}A.Registry.as(v.Extensions.Configuration).registerConfiguration({id:R.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[R.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),A.Registry.as(v.Extensions.Configuration).registerConfiguration({id:R.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[R.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,k.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,k.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${R.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(we[212],ye([0,1,28,6,33,211,41]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let D=class extends C.TelemetryService{constructor(I,A,R){super(I,R);this._telemetryCache=[],this._injectedTelemetryLevel=A}publicLog(I,A,R){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:I,data:A,anonymizeFilePaths:R,eventType:"usage"}),Promise.resolve()):this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(I,A,R)}publicLog2(I,A,R){return this.publicLog(I,A,R)}publicLogError(I,A){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:I,data:A,eventType:"error"}),Promise.resolve()):this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(I,A)}publicLogError2(I,A){return this.publicLogError(I,A)}async flushTelemetryCache(){if(this._telemetryCache?.length!==0){for(const I of this._telemetryCache)I.eventType==="usage"?await this.publicLog(I.eventName,I.data,I.anonymizeFilePaths):await this.publicLogError(I.eventName,I.data);this._telemetryCache=[]}}async updateInjectedTelemetryLevel(I){if(I===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");if(this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,I):I,this._injectedTelemetryLevel===0)this._telemetryCache=[],this.dispose();else return this.flushTelemetryCache()}};D=Ae([Oe(2,_.IConfigurationService)],D),e.ServerTelemetryService=D,e.ServerNullTelemetryService=new class extends k.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(p.ITelemetryService)}),define(we[213],ye([0,1,11,21,41]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function C(D,v){const I=await new Promise((R,g)=>{J(["applicationinsights"],R,g)});let A;return I.defaultClient?(A=new I.TelemetryClient(D),A.channel.setUseDiskRetryCaching(!0)):(I.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),A=I.defaultClient),D.indexOf("AIF-")===0&&(A.config.endpointUrl=v?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),A}class k{constructor(v,I,A,R,g){this._eventPrefix=v,this._defaultData=I,this.testCollector=R,this.mirrored=g,this._defaultData||(this._defaultData=Object.create(null)),typeof A=="function"?this._aiClient=A():this._aiClient=A,this._asyncAIClient=null}_withAIClient(v){if(!!this._aiClient){if(typeof this._aiClient!="string"){v(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=C(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(I=>{v(I)},I=>{(0,_.onUnexpectedError)(I),console.error(I)})}}log(v,I){if(!!this._aiClient){I=(0,t.mixin)(I,this._defaultData),I=(0,p.validateTelemetryData)(I),this.testCollector&&(I.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(A=>A.trackEvent({name:this._eventPrefix+"/"+v,properties:I.properties,measurements:I.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(v=>{this._withAIClient(I=>{try{I.flush({callback:()=>{this._aiClient=void 0,v(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(we[214],ye([0,1,11,206]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class p extends t.default{installErrorListeners(){(0,_.setUnexpectedErrorHandler)(D=>console.error(D));const k=[];process.on("unhandledRejection",(D,v)=>{k.push(v),setTimeout(()=>{const I=k.indexOf(v);I>=0&&v.catch(A=>{k.splice(I,1),(0,_.isCancellationError)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A.stack&&console.warn(`stack trace: ${A.stack}`),D&&(0,_.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const v=k.indexOf(D);v>=0&&k.splice(v,1)}),process.on("uncaughtException",D=>{(0,_.onUnexpectedError)(D)})}}e.default=p}),define(we[215],ye([0,1,13,20,7,2,14]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends C.Disposable{constructor(I,A){super();this._logService=A,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new p.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((A,R)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,A),this._onCreateRequest.fire({requestId:g,...I});const S=new t.CancellationTokenSource;(0,_.timeout)(this._timeout,S.token).then(()=>R(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,C.toDisposable)(()=>S.cancel())])})}acceptReply(I,A){const R=this._pendingRequests.get(I);R?(this._pendingRequests.delete(I),(0,C.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),R(A)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};D=Ae([Oe(1,k.ILogService)],D),e.RequestStore=D}),define(we[100],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var p;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",h.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",h.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(p=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(C=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var D;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(D=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,_.createDecorator)("ptyService");var v;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions"})(v=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var A;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(A=e.TerminalLocation||(e.TerminalLocation={}));var R;(function(h){h.TerminalView="view",h.Editor="editor"})(R=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(g=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var c;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(c=e.ProfileSource||(e.ProfileSource={}))}),define(we[69],ye([0,1,38,5,163,20,36,11,3,23,143,174,13]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let c;async function h(y,b,f){return b["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(f)&&!b["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(f)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),c||(c=g.Promises.withAsyncBody(async(E,u)=>{const o=new C.CancellationTokenSource,l=setTimeout(()=>{o.dispose(!0),u(new Error((0,p.localize)(0,null)))},S);try{E(await m(y,o.token))}catch(s){!(0,D.isCancellationError)(s)&&!o.token.isCancellationRequested?u(new Error((0,p.localize)(1,null,(0,k.toErrorMessage)(s)))):E({})}finally{clearTimeout(l),o.dispose()}})),c)}e.getResolvedShellEnv=h;async function m(y,b){const f=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",f);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",E);const u=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(u+"(.*)"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",l);const s=await(0,A.getSystemShell)(v.OS,l);return y.trace("getUnixShellEnvironment#shell",s),new Promise((n,r)=>{if(b.isCancellationRequested)return r((0,D.canceled)());const i=(0,t.basename)(s);let a,d;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(i)?(a=`& '${process.execPath}' ${w} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,d=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,i==="tcsh"?d=["-ic"]:d=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),a);const P=(0,_.spawn)(s,[...d,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});b.onCancellationRequested(()=>(P.kill(),r((0,D.canceled)()))),P.on("error",L=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(L)),r(L)});const O=[];P.stdout.on("data",L=>O.push(L));const $=[];P.stderr.on("data",L=>$.push(L)),P.on("close",(L,T)=>{const U=Buffer.concat(O).toString("utf8");y.trace("getUnixShellEnvironment#raw",U);const N=Buffer.concat($).toString("utf8");if(N.trim()&&y.trace("getUnixShellEnvironment#stderr",N),L||T)return r(new Error((0,p.localize)(2,null,L,T)));const W=o.exec(U),ie=W?W[1]:"{}";try{const j=JSON.parse(ie);f?j.ELECTRON_RUN_AS_NODE=f:delete j.ELECTRON_RUN_AS_NODE,E?j.ELECTRON_NO_ATTACH_CONSOLE=E:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",j),n(j)}catch(j){y.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(j)),r(j)}})})}}),define(we[216],ye([0,1,25,21,5,3,24,12,18]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const R=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let g=0;return R&&R.length===4&&(g=parseInt(R[3])),g}e.getWindowsBuildNumber=I;async function A(R,g,S,c=k.env,h=v.Promises.exists){if(p.isAbsolute(R))return await h(R)?R:void 0;if(g===void 0&&(g=k.cwd()),p.dirname(R)!=="."){const f=p.join(g,R);return await h(f)?f:void 0}const y=(0,t.getCaseInsensitive)(c,"PATH");if(S===void 0&&(0,D.isString)(y)&&(S=y.split(p.delimiter)),S===void 0||S.length===0){const f=p.join(g,R);return await h(f)?f:void 0}for(let f of S){let E;if(p.isAbsolute(f)?E=p.join(f,R):E=p.join(g,f,R),await h(E))return E;if(C.isWindows){let u=E+".com";if(await h(u)||(u=E+".exe",await h(u)))return u}}const b=p.join(g,R);return await h(b)?b:void 0}e.findExecutable=A}),define(we[217],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(we[101],ye([0,1,37,7,2,6,35,217]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var v;(function(m){function y(b){return b&&typeof b=="object"&&typeof b.id=="string"}m.isThemeColor=y})(v=e.ThemeColor||(e.ThemeColor={}));function I(m){return{id:m}}e.themeColorFromId=I;var A;(function(m){function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||v.isThemeColor(n.color))}m.isThemeIcon=y;const b=new RegExp(`^\\$\\((${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const r=b.exec(n);if(!r)return;let[,i]=r;return{id:i}}m.fromString=f;function E(n){return{id:n}}m.fromId=E;function u(n,r){let i=n.id;const a=i.lastIndexOf("~");return a!==-1&&(i=i.substring(0,a)),r&&(i=`${i}~${r}`),{id:i}}m.modify=u;function o(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}m.getModifier=o;function l(n,r){return n.id===r.id&&n.color?.id===r.color?.id}m.isEqual=l;function s(n,r){return{id:n.id,color:r?I(r):void 0}}m.asThemeIcon=s,m.asClassNameArray=_.CSSIcon.asClassNameArray,m.asClassName=_.CSSIcon.asClassName,m.asCSSSelector=_.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=_.Codicon.file,e.FolderThemeIcon=_.Codicon.folder;function R(m){switch(m){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,p.toDisposable)(()=>{const b=this.themingParticipants.indexOf(y);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new g;k.Registry.add(e.Extensions.ThemingContribution,S);function c(m){return S.onColorThemeChange(m)}e.registerThemingParticipant=c;class h extends p.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,b){let f=this.theme.getColor(y);return f&&b&&(f=b(f,this.theme)),f?f.toString():null}}e.Themable=h}),define(we[218],ye([0,1,37,4,101]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function C(R,g){const S=R.map(c=>({name:c.profileName,description:k(c)}));return g&&S.push(...g.map(c=>({name:c.title,description:D(c)}))),{values:S.map(c=>c.name),markdownDescriptions:S.map(c=>c.description)}}e.createProfileSchemaEnums=C;function k(R){let g=`$(${p.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:_.Codicon.terminal.id}) ${R.profileName}
- path: ${R.path}`;return R.args&&(typeof R.args=="string"?g+=`
- args: "${R.args}"`:g+=`
- args: [${R.args.length===0?"":`'${R.args.join("','")}'`}]`),R.overrideName!==void 0&&(g+=`
- overrideName: ${R.overrideName}`),R.color&&(g+=`
- color: ${R.color}`),R.env&&(g+=`
- env: ${JSON.stringify(R.env)}`),g}function D(R){return`$(${p.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:_.Codicon.terminal.id}) ${R.title}
- extensionIdenfifier: ${R.extensionIdentifier}`}function v(R,g){if(!R&&!g)return!0;if(typeof R=="string"&&typeof g=="string")return R===g;if(Array.isArray(R)&&Array.isArray(g)){if(R.length!==g.length)return!1;for(let S=0;S<R.length;S++)if(R[S]!==g[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=v;function I(R,g){if(!R&&!g)return!0;if(!R||!g)return!1;if(p.ThemeIcon.isThemeIcon(R)&&p.ThemeIcon.isThemeIcon(g))return R.id===g.id&&R.color===g.color;if(typeof R=="object"&&R&&"light"in R&&"dark"in R&&typeof g=="object"&&g&&"light"in g&&"dark"in g){const S=R,c=g;if((t.URI.isUri(S.light)||A(S.light))&&(t.URI.isUri(S.dark)||A(S.dark))&&(t.URI.isUri(c.light)||A(c.light))&&(t.URI.isUri(c.dark)||A(c.dark)))return S.light.path===c.light.path&&S.dark.path===c.dark.path}if(t.URI.isUri(R)&&t.URI.isUri(g)||A(R)||A(g)){const S=R,c=g;return S.path===c.path&&S.scheme===c.scheme}return!1}e.terminalIconsEqual=I;function A(R){return R?typeof R.path=="string"&&typeof R.scheme=="string":!1}e.isUriComponents=A}),define(we[219],ye([0,1,37,162,45,35,218]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const D={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(_.Codicon.getAll(),E=>E.id),markdownEnumDescriptions:Array.from(_.Codicon.getAll(),E=>`$(${E.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},I={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...D}},A=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),c=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),m={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:c},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,t.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,t.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:A},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function y(){C.Registry.as(p.Extensions.Configuration).registerConfiguration(m),f()}e.registerTerminalPlatformConfiguration=y;let b;function f(E,u){const o=C.Registry.as(p.Extensions.Configuration);let l;E&&(l=(0,k.createProfileSchemaEnums)(E?.profiles,u));const s=b;b={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:E?.os===3?l?.values:void 0,markdownEnumDescriptions:E?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:E?.os===2?l?.values:void 0,markdownEnumDescriptions:E?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:E?.os===1?l?.values:void 0,markdownEnumDescriptions:E?.os===1?l?.markdownDescriptions:void 0}}},o.updateConfigurations({add:[b],remove:s?[s]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(we[220],ye([0,1,38,37,5,3,18,82,216,101]),function(J,e,_,t,p,C,k,D,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let A,R=!0;function g(l,s,n,r,i=process.env,a,d,w,P){return a=a||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},C.isWindows?S(n,a,i,d,r.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),P,w):E(a,d,n,l&&typeof l=="object"?{...l}:r.getValue(C.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(C.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,w,i)}e.detectAvailableProfiles=g;async function S(l,s,n,r,i,a,d,w,P){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),$=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let L=!1;(0,v.getWindowsBuildNumber)()>=16299&&(L=!0),await m(w);const T=new Map;l&&(T.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Windows PowerShell",{path:`${$}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),T.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),T.set("Command Prompt",{path:`${$}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(a,T);const U=await c(T.entries(),d,s,n,r,P);if(l||!l&&i)try{const N=await b(`${$}\\${L?"wsl":"bash"}.exe`,d);for(const W of N)(!a||!(W.profileName in a))&&U.push(W)}catch{R&&(r?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return U}async function c(l,s,n,r=process.env,i,a){const d=[];for(const[w,P]of l){if(P===null)continue;let O,$,L;if("source"in P){const N=A?.get(P.source);if(!N)continue;O=N.paths,$=P.args||N.args,P.icon?L=h(P.icon):N.icon&&(L=N.icon)}else O=Array.isArray(P.path)?P.path:[P.path],$=C.isWindows||Array.isArray(P.args)?P.args:void 0,L=h(P.icon);const T=await a?.(O)||O.slice(),U=await o(w,s,T,n,r,$,P.env,P.overrideName,P.isAutoDetected,i);U?(U.isAutoDetected=P.isAutoDetected,U.icon=L,U.color=P.color,d.push(U)):i?.trace("profile not validated",w,O)}return d}function h(l){return typeof l=="string"?{id:l}:l}async function m(l){A&&!l||(A=new Map,A.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),A.set("PowerShell",{profileName:"PowerShell",paths:l||await y(),icon:I.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function y(){const l=[];for await(const s of(0,D.enumeratePowerShellInstallations)())l.push(s.exePath);return l}async function b(l,s){const n=[],r=await new Promise((d,w)=>{_.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,O)=>{if(P)return w("Problem occurred when getting wsl distros");d(O)})});if(!r)return[];const i=new RegExp(/[\r?\n]/),a=r.split(i).filter(d=>d.trim().length>0&&d!=="");for(const d of a){if(d===""||d.startsWith("docker-desktop"))continue;const w=`${d} (WSL)`,P={profileName:w,path:l,args:["-d",`${d}`],isDefault:w===s,icon:f(d),isAutoDetected:!1};n.push(P)}return n}function f(l){return l.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):l.includes("Debian")?I.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function E(l,s,n,r,i,a,d,w){const P=new Map;if(n){const O=(await l.readFile("/etc/shells")).toString(),$=a||O.split(`
`).filter(T=>T.trim().indexOf("#")!==0&&T.trim().length>0),L=new Map;for(const T of $){let U=(0,p.basename)(T),N=L.get(U)||0;N++,N>1&&(U=`${U} (${N})`),L.set(U,N),P.set(U,{path:T,isAutoDetected:!0})}}return u(r,P),await c(P.entries(),i,l,w,s,d)}function u(l,s){if(!!l)for(const[n,r]of Object.entries(l))r===null||!("path"in r)&&!("source"in r)?s.delete(n):(r.icon=r.icon||s.get(n)?.icon,s.set(n,r))}async function o(l,s,n,r,i,a,d,w,P,O){if(n.length===0)return Promise.resolve(void 0);const $=n.shift();if($==="")return o(l,s,n,r,i,a,d,w,P);const L={profileName:l,path:$,args:a,env:d,overrideName:w,isAutoDetected:P,isDefault:l===s};if((0,p.basename)($)===$){const U=i.PATH?i.PATH.split(p.delimiter):void 0,N=await(0,v.findExecutable)($,void 0,U,void 0,r.existsFile);return N?(L.path=N,L.isFromPath=!0,L):o(l,s,n,r,i,a)}return await r.existsFile((0,p.normalize)($))?L:o(l,s,n,r,i,a,d,w,P)}}),define(we[221],ye([0,1,7,2,8,3,39,86,28,26,87,69,14,93,215,100,219,220]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var b;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let f=0,E=class extends t.Disposable{constructor(o,l,s,n){super();this._reconnectConstants=o,this._configurationService=l,this._environmentService=s,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new _.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new _.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new _.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new _.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new _.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new _.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new _.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new _.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new _.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new _.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new _.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new _.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new c.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(C.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:f,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},l=(0,A.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);l&&(l.break&&l.port?o.debugBrk=l.port:!l.break&&l.port&&(o.debug=l.port));const s=new D.Client(p.FileAccess.asFileUri("bootstrap-fork",J).fsPath,o);this._onPtyHostStart.fire(),k.ProxyChannel.toService(s.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(s.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=b.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const r=s.getChannel(h.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const i=k.ProxyChannel.toService(s.getChannel(h.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(a=>this._onProcessData.fire(a))),this._register(i.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(i.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(i.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(i.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(i.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(i.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[s,i]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,l,s,n,r,i,a,d,w,P,O){const $=setTimeout(()=>this._handleUnresponsiveCreateProcess(),h.HeartbeatConstants.CreateProcessTimeout),L=await this._proxy.createProcess(o,l,s,n,r,i,a,d,w,P,O);return clearTimeout($),f=Math.max(f,L),L}updateTitle(o,l,s){return this._proxy.updateTitle(o,l,s)}updateIcon(o,l,s){return this._proxy.updateIcon(o,l,s)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,l){return this._proxy.shutdown(o,l)}input(o,l){return this._proxy.input(o,l)}processBinary(o,l){return this._proxy.processBinary(o,l)}resize(o,l,s){return this._proxy.resize(o,l,s)}acknowledgeDataEvent(o,l){return this._proxy.acknowledgeDataEvent(o,l)}setUnicodeVersion(o,l){return this._proxy.setUnicodeVersion(o,l)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}installAutoReply(o,l){return this._proxy.installAutoReply(o,l)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(o){return this._proxy.uninstallAutoReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,l,s,n=!1){const r=await this._shellEnv;return(0,y.detectAvailableProfiles)(l,s,n,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,l){return this._proxy.requestDetachInstance(o,l)}async acceptDetachInstanceReply(o,l){return this._proxy.acceptDetachInstanceReply(o,l)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o,l){return this._proxy.reviveTerminalProcesses(o,l)}async refreshProperty(o,l){return this._proxy.refreshProperty(o,l)}async updateProperty(o,l,s){return this._proxy.updateProperty(o,l,s)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,l){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:l})}async acceptPtyHostResolvedVariables(o,l){this._resolveVariablesRequestStore.acceptReply(o,l)}};E=Ae([Oe(1,v.IConfigurationService),Oe(2,I.IEnvironmentService),Oe(3,g.ILogService)],E),e.PtyHostService=E}),define(we[47],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,_.createDecorator)("IUriIdentityService")}),define(we[222],ye([0,1,7,2,4,26,31,19,14,47]),function(J,e,_,t,p,C,k,D,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let A=class extends t.Disposable{constructor(g,S,c,h,m){super();this.extensionsManagementService=g,this.logService=h,this.uriIdentityService=m,this._onDidChangeExtensionsByAnotherSource=this._register(new _.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(b=>this.onInstallExtension(b))),this._register(g.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(g.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const y=p.URI.file(c.extensionsPath);this._register(S.watch(y)),this._register(_.Event.filter(S.onDidFilesChange,b=>b.rawChanges.some(f=>this.doesChangeAffects(f,y)))(()=>this.onDidChange()))}doesChangeAffects(g,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),S)?this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(g.type!==1&&g.type!==2||this.uriIdentityService.extUri.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const S of g)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(S=>!(0,k.areSameExtensions)(S,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,k.areSameExtensions)(S,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),S=g.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(m=>(0,k.areSameExtensions)(m,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),c=this.installedExtensions.filter(h=>this.installingExtensions.some(m=>(0,k.areSameExtensions)(m,h))?!1:g.every(m=>!(0,k.areSameExtensions)(m.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=g.map(h=>h.identifier),(S.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:c})}}};A=Ae([Oe(1,D.IFileService),Oe(2,C.INativeEnvironmentService),Oe(3,v.ILogService),Oe(4,I.IUriIdentityService)],A),e.ExtensionsWatcher=A}),define(we[102],ye([0,1,47,179,19,22,121,7,2]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(g){this.uri=g,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let A=class{constructor(g){this._fileService=g,this._dispooables=new v.DisposableStore,this._limit=2**16;const S=new Map,c=h=>{let m=S.get(h.scheme);return m===void 0&&(m=g.hasProvider(h)&&!this._fileService.hasCapability(h,1024),S.set(h.scheme,m)),m};this._dispooables.add(D.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(h=>{S.delete(h.scheme)})),this.extUri=new C.ExtUri(c),this._canonicalUris=new k.SkipList((h,m)=>this.extUri.compare(h,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,C.normalizePath)(g));let S=this._canonicalUris.get(g);return S?S.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new I(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((c,h)=>c[1].touch<h[1].touch?1:c[1].touch>h[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let c=0;c<S;c++)this._canonicalUris.set(g[c][0],g[c][1].touch())}};A=Ae([Oe(0,p.IFileService)],A),e.UriIdentityService=A,(0,t.registerSingleton)(_.IUriIdentityService,A,!0)}),define(we[103],ye([0,1,164,5,29,22,4,6,8]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function I(l){const s=l;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=I;function A(l){if(l.configuration)return{id:l.id,configPath:l.configuration};if(l.folders.length===1)return{id:l.id,uri:l.folders[0].uri}}e.toWorkspaceIdentifier=A;function R(l){const s=l;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=R;function g(l){const s=l;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const n=l;if(n?.configPath)return{id:n.id,configPath:k.URI.revive(n.configPath)};if(l?.id)return{id:l.id}}e.reviveIdentifier=g;var S;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function c(l){const s=l;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=c;function h(l){const s=l;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=h;class m{constructor(s,n,r,i,a){this._id=s,this._transient=r,this._configuration=i,this._ignorePathCasing=a,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=n}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s.with({scheme:s.scheme,authority:s.authority,path:s.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class y{constructor(s,n){this.raw=n,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,C.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function b(l){return new y({uri:l,index:0,name:(0,C.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,_.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(l,s){return C.extUriBiasedIgnorePathCase.isEqualOrParent(l,s.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function u(l){let s;return k.URI.isUri(l)?s=l:s=l.configuration,s?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=u;function o(l){return(typeof l=="string"?(0,t.extname)(l):(0,C.extname)(l))===f}e.hasWorkspaceFileExtension=o}),define(we[223],ye([0,1,7,13]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function p(k){let D=0,v=0,I=0;k>=1e3&&(I=Math.floor(k/1e3),k-=I*1e3),I>=60&&(v=Math.floor(I/60),I-=v*60),v>=60&&(D=Math.floor(v/60),v-=D*60);const A=D?`${D}h`:"",R=v?`${v}m`:"",g=I?`${I}s`:"",S=k?`${k}ms`:"";return`${A}${R}${g}${S}`}e.printTime=p;class C{constructor(D,v,I,A){this._logService=D,this._reconnectionToken=v,this._onClose=new _.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=I,this.protocol=A,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${p(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${p(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${p(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(D){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${D}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${p(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const D=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),D.end(),this._onClose.fire(void 0)}acceptReconnection(D,v,I){this._remoteAddress=D,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(v,I),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(we[104],ye([0,1,27,8,5,128,44]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const D=p.join(t.FileAccess.asFileUri("",J).fsPath,"nls.metadata.json"),v=new Map;function I(g){return new Promise(S=>_.exists(g,S))}function A(g,S){return I(D).then(c=>{if(!c||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let h=`${g}||${S}`,m=v.get(h);return m||(m=C.getNLSConfiguration(k.default.commit,S,D,g).then(y=>(R.is(y)&&(y._languagePackSupport=!0),y)),v.set(h,m)),m})}e.getNLSConfiguration=A;var R;(function(g){function S(c){let h=c;return h&&typeof h._languagePackId=="string"}g.is=S})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(we[224],ye([0,1,225,27,5,23,8,18]),function(J,e,_,t,p,C,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z-]+$/;var I;(function(y){y[y.None=0]="None",y[y.Optional=1]="Optional",y[y.Mandatory=2]="Mandatory"})(I=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class A{constructor(){this.type=0}validate(b){return!0}}e.NoneServerConnectionToken=A;class R{constructor(b){this.value=b,this.type=1}validate(b){return b===this.value}}e.OptionalServerConnectionToken=R;class g{constructor(b){this.value=b,this.type=2}validate(b){return b===this.value}}e.MandatoryServerConnectionToken=g;class S{constructor(b){this.message=b}}e.ServerConnectionTokenParseError=S;async function c(y,b){const f=y["without-connection-token"],E=y["connection-token"],u=y["connection-token-file"],o=y.compatibility==="1.63";if(f)return typeof E!="undefined"||typeof u!="undefined"?new S("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new A;if(typeof u!="undefined"){if(typeof E!="undefined")return new S("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=t.readFileSync(u).toString().replace(/\r?\n$/,"")}catch{return new S(`Unable to read the connection token file at '${u}'.`)}return v.test(l)?new g(l):new S(`The connection token defined in '${u} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof E!="undefined"?v.test(E)?o?new R(E):new g(E):new S(`The connection token '${E} does not adhere to the characters 0-9, a-z, A-Z or -.`):o?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await b())):new g(await b())}e.parseServerConnectionToken=c;async function h(y){return c(y,async()=>{if(!y["user-data-dir"])return(0,C.generateUuid)();const f=p.join(y["user-data-dir"],"token");try{const o=(await D.Promises.readFile(f)).toString().replace(/\r?\n$/,"");if(v.test(o))return o}catch{}const E=(0,C.generateUuid)();try{await D.Promises.writeFile(f,E,{mode:384})}catch{}return E})}e.determineServerConnectionToken=h;function m(y,b,f){if(y.validate(f.query[k.connectionTokenQueryName]))return!0;const E=_.parse(b.headers.cookie||"");return y.validate(E[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=m}),define(we[48],ye([0,1,166,176,52,6,26]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:_.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:_.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:_.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:_.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:_.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:_.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:_.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:_.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:_.localize(8,null)},"user-data-dir":p.OPTIONS["user-data-dir"],driver:p.OPTIONS.driver,"disable-telemetry":p.OPTIONS["disable-telemetry"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:p.OPTIONS.log,logsPath:p.OPTIONS.logsPath,"force-disable-user-env":p.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL."},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":p.OPTIONS["extensions-dir"],"extensions-download-dir":p.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":p.OPTIONS["builtin-extensions-dir"],"install-extension":p.OPTIONS["install-extension"],"install-builtin-extension":p.OPTIONS["install-builtin-extension"],"uninstall-extension":p.OPTIONS["uninstall-extension"],"list-extensions":p.OPTIONS["list-extensions"],"locate-extension":p.OPTIONS["locate-extension"],"show-versions":p.OPTIONS["show-versions"],category:p.OPTIONS.category,force:p.OPTIONS.force,"do-not-sync":p.OPTIONS["do-not-sync"],"pre-release":p.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:_.localize(9,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:p.OPTIONS.help,version:p.OPTIONS.version,compatibility:{type:"string"},_:p.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(k.IEnvironmentService);class D extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=D}),define(we[226],ye([0,1,27,68,131,225,67,34,60,3,14,48,5,8,23,30,46,20,4,15,12]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const u={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(r,i,a,d){i.writeHead(a,{"Content-Type":"text/plain"}),i.end(d)}e.serveError=o;async function l(r,i,a,d,w=Object.create(null)){try{const P=await p.promisify(_.stat)(d),O=`W/"${[P.ino,P.size,P.mtime.getTime()].join("-")}"`;if(i.headers["if-none-match"]===O)return a.writeHead(304),a.end();w["Content-Type"]=u[(0,g.extname)(d)]||(0,v.getMediaMime)(d)||"text/plain",w.Etag=O,a.writeHead(200,w),_.createReadStream(d).pipe(a)}catch(P){return P.code!=="ENOENT"&&(r.error(P),console.error(P.toString())),a.writeHead(404,{"Content-Type":"text/plain"}),a.end("Not found")}}e.serveFile=l;const s=(0,g.dirname)(S.FileAccess.asFileUri("",J).fsPath);let n=class{constructor(i,a,d,w,P){this._connectionToken=i,this._environmentService=a,this._logService=d,this._requestService=w,this._productService=P,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?b.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0}async handle(i,a,d){try{const w=d.pathname;return w==="/favicon.ico"||w==="/manifest.json"||w==="/code-192.png"||w==="/code-512.png"?l(this._logService,i,a,(0,g.join)(s,"resources","server",w.substr(1))):/^\/static\//.test(w)?this._handleStatic(i,a,d):w==="/"?this._handleRoot(i,a,d):w==="/callback"?this._handleCallback(a):/^\/web-extension-resource\//.test(w)?this._handleWebExtensionResource(i,a,d):o(i,a,404,"Not found.")}catch(w){return this._logService.error(w),console.error(w.toString()),o(i,a,500,"Internal Server Error.")}}async _handleStatic(i,a,d){const w=Object.create(null),P=decodeURIComponent(d.pathname),O=(0,g.normalize)(P.substr("/static/".length)),$=(0,g.join)(s,O);return(0,D.isEqualOrParent)($,s,!I.isLinux)?l(this._logService,i,a,$,w):o(i,a,400,"Bad request.")}_getResourceURLTemplateAuthority(i){const a=i.authority.indexOf(".");return a!==-1?i.authority.substring(a+1):void 0}async _handleWebExtensionResource(i,a,d){if(!this._webExtensionResourceUrlTemplate)return o(i,a,500,"No extension gallery service configured.");const w=decodeURIComponent(d.pathname),P=(0,g.normalize)(w.substr("/web-extension-resource/".length)),O=b.URI.parse(P).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:P.substring(0,P.indexOf("/")),path:P.substring(P.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(O))return o(i,a,403,"Request Forbidden");const $={},L=j=>{const re=i.headers[j];re&&((0,E.isString)(re)||re[0])?$[j]=(0,E.isString)(re)?re:re[0]:j!==j.toLowerCase()&&L(j.toLowerCase())};L("X-Client-Name"),L("X-Client-Version"),L("X-Machine-Id"),L("X-Client-Commit");const T=await this._requestService.request({type:"GET",url:O.toString(!0),headers:$},y.CancellationToken.None),U=T.res.statusCode||500;if(U!==200){let j=null;try{j=await(0,m.asText)(T)}catch{}return o(i,a,U,j||`Request failed with status ${U}`)}const N=Object.create(null),W=j=>{const re=T.res.headers[j];re?N[j]=re:j!==j.toLowerCase()&&W(j.toLowerCase())};W("Cache-Control"),W("Content-Type"),a.writeHead(200,N);const ie=await(0,f.streamToBuffer)(T.stream);return a.end(ie.buffer)}async _handleRoot(i,a,d){if(!i.headers.host)return o(i,a,400,"Bad request.");const w=d.query[S.connectionTokenQueryName];if(typeof w=="string"){const ie=Object.create(null);ie["Set-Cookie"]=C.serialize(S.connectionTokenCookieName,w,{sameSite:"lax",maxAge:60*60*24*7});const j=Object.create(null);for(let x in d.query)x!==S.connectionTokenQueryName&&(j[x]=d.query[x]);const re=t.format({pathname:"/",query:j});return ie.Location=re,a.writeHead(302,ie),a.end()}const P=i.headers.host;function O(ie){return ie.replace(/"/g,"&quot;")}let $;this._environmentService.driverHandle&&($=!1);const L=S.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",J).fsPath,T=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,c.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,U=(await p.promisify(_.readFile)(L)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",O(JSON.stringify({remoteAuthority:P,_wrapWebWorkerExtHostInIframe:$,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:P,path:`web-extension-resource/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0}}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>T?O(JSON.stringify(T)):""),N=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(U).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${P};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),W={"Content-Type":"text/html","Content-Security-Policy":N};return this._connectionToken.type!==0&&(W["Set-Cookie"]=C.serialize(S.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),a.writeHead(200,W),a.end(U)}_getScriptCspHashes(i){const a=/<script>([\s\S]+?)<\/script>/img,d=[];let w;for(;w=a.exec(i);){const P=k.createHash("sha256"),O=w[1].replace(/\r\n/g,`
`),$=P.update(Buffer.from(O)).digest().toString("base64");d.push(`'sha256-${$}'`)}return d}async _handleCallback(i){const a=S.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",J).fsPath,d=(await p.promisify(_.readFile)(a)).toString(),w=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(d).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return i.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":w}),i.end(d)}};n=Ae([Oe(1,R.IServerEnvironmentService),Oe(2,A.ILogService),Oe(3,m.IRequestService),Oe(4,h.IProductService)],n),e.WebClientServer=n}),define(we[227],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class t{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=t}),define(we[105],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var _;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(_=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,p=(b,f)=>{const E={controllerId:f};return t.set(b,E),E};e.createPrivateApiFor=p;const C=b=>t.get(b);e.getPrivateApiFor=C;const k=(b,f,E,u)=>{let o=E;return{enumerable:!0,configurable:!1,get(){return o},set(l){if(!u(o,l)){const s=o;o=l,b.listener?.({op:3,key:f,value:l,previous:s})}}}},D=(b,f)=>b===f,v={range:(b,f)=>b===f?!0:!b||!f?!1:b.isEqual(f),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(b,f)=>!(b.length!==f.length||b.some(E=>!f.find(u=>E.id===u.id)))},I=Object.keys(v),A=(b,f)=>({range:k(b,"range",void 0,v.range),label:k(b,"label",f,v.label),description:k(b,"description",void 0,v.description),sortText:k(b,"sortText",void 0,v.sortText),canResolveChildren:k(b,"canResolveChildren",!1,v.canResolveChildren),busy:k(b,"busy",!1,v.busy),error:k(b,"error",void 0,v.error),tags:k(b,"tags",[],v.tags)}),R=(b,f)=>{const E=new Map;for(const u of I)v[u](b[u],f[u])||E.set(u,f[u]);return E};e.diffTestItems=R;class g extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=g;class S extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=S;class c extends Error{constructor(f,E,u){super(`TestItem with ID "${f}" is from controller "${E}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=c;const h=b=>{const f=(0,e.getPrivateApiFor)(b);let E=new Map;return{get size(){return E.size},forEach(u,o){for(const l of E.values())u.call(o,l,this)},replace(u){const o=new Map,l=new Set(E.keys()),s={op:4,ops:[]};for(const n of u){if(!(n instanceof m))throw new S(n.id);const r=(0,e.getPrivateApiFor)(n).controllerId;if(r!==f.controllerId)throw new c(n.id,r,f.controllerId);if(o.has(n.id))throw new g(n.id);o.set(n.id,n),l.delete(n.id),s.ops.push({op:0,item:n})}for(const n of l.keys())s.ops.push({op:1,id:n});f.listener?.(s),E=o},add(u){if(!(u instanceof m))throw new S(u.id);E.set(u.id,u),f.listener?.({op:0,item:u})},delete(u){E.delete(u)&&f.listener?.({op:1,id:u})},get(u){return E.get(u)},toJSON(){return Array.from(E.values())},[Symbol.iterator](){return E.values()}}};class m{constructor(f,E,u,o){if(E.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(E)} symbol`);const l=(0,e.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:E,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof y?void 0:l.parent}},children:{value:h(this),enumerable:!0,writable:!1},...A(l,u)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=m;class y extends m{constructor(f,E){super(f,f,E,void 0)}}e.TestItemRootImpl=y});var yt=this&&this.__classPrivateFieldSet||function(J,e,_,t,p){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?p.call(J,_):p?p.value=_:e.set(J,_),_},tt=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(we[106],ye([0,1,17,11,78,29,60,16,12,4,23,19,96]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";var S,c,h,m,y,b,f,E,u,o,l,s,n,r,i,a,d,w,P,O;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function $(M){function F(){return Reflect.construct(M,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(M,"name")),Object.setPrototypeOf(F,M),Object.setPrototypeOf(F.prototype,M.prototype),F}let L=y=class{constructor(F){S.set(this,void 0),yt(this,S,F,"f")}static from(...F){let Z=F;return new y(function(){if(Z){for(const Se of Z)Se&&typeof Se.dispose=="function"&&Se.dispose();Z=void 0}})}dispose(){typeof tt(this,S,"f")=="function"&&(tt(this,S,"f").call(this),yt(this,S,void 0,"f"))}};S=new WeakMap,L=y=Ae([$],L),e.Disposable=L;let T=b=class{constructor(F,Z){if(F<0)throw(0,t.illegalArgument)("line must be non-negative");if(Z<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=F,this._character=Z}static Min(...F){if(F.length===0)throw new TypeError;let Z=F[0];for(let Se=1;Se<F.length;Se++){const ze=F[Se];ze.isBefore(Z)&&(Z=ze)}return Z}static Max(...F){if(F.length===0)throw new TypeError;let Z=F[0];for(let Se=1;Se<F.length;Se++){const ze=F[Se];ze.isAfter(Z)&&(Z=ze)}return Z}static isPosition(F){if(!F)return!1;if(F instanceof b)return!0;let{line:Z,character:Se}=F;return typeof Z=="number"&&typeof Se=="number"}static of(F){if(F instanceof b)return F;if(this.isPosition(F))return new b(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,Z=0){if(F===null||Z===null)throw(0,t.illegalArgument)();let Se;return typeof F=="undefined"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,Z=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&Z===0?this:new b(this.line+Se,this.character+Z)}with(F,Z=this.character){if(F===null||Z===null)throw(0,t.illegalArgument)();let Se;return typeof F=="undefined"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,Z=typeof F.character=="number"?F.character:this.character),Se===this.line&&Z===this.character?this:new b(Se,Z)}toJSON(){return{line:this.line,character:this.character}}};T=b=Ae([$],T),e.Position=T;let U=f=class{constructor(F,Z,Se,ze){let Ke,Xe;if(typeof F=="number"&&typeof Z=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ke=new T(F,Z),Xe=new T(Se,ze)):T.isPosition(F)&&T.isPosition(Z)&&(Ke=T.of(F),Xe=T.of(Z)),!Ke||!Xe)throw new Error("Invalid arguments");Ke.isBefore(Xe)?(this._start=Ke,this._end=Xe):(this._start=Xe,this._end=Ke)}static isRange(F){return F instanceof f?!0:F?T.isPosition(F.start)&&T.isPosition(F.end):!1}static of(F){if(F instanceof f)return F;if(this.isRange(F))return new f(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(F){return f.isRange(F)?this.contains(F.start)&&this.contains(F.end):T.isPosition(F)?!(T.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const Z=T.Max(F.start,this._start),Se=T.Min(F.end,this._end);if(!Z.isAfter(Se))return new f(Z,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const Z=T.Min(F.start,this._start),Se=T.Max(F.end,this.end);return new f(Z,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,Z=this.end){if(F===null||Z===null)throw(0,t.illegalArgument)();let Se;return F?T.isPosition(F)?Se=F:(Se=F.start||this.start,Z=F.end||this.end):Se=this.start,Se.isEqual(this._start)&&Z.isEqual(this.end)?this:new f(Se,Z)}toJSON(){return[this.start,this.end]}};U=f=Ae([$],U),e.Range=U;let N=E=class extends U{constructor(F,Z,Se,ze){let Ke,Xe;if(typeof F=="number"&&typeof Z=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ke=new T(F,Z),Xe=new T(Se,ze)):T.isPosition(F)&&T.isPosition(Z)&&(Ke=T.of(F),Xe=T.of(Z)),!Ke||!Xe)throw new Error("Invalid arguments");super(Ke,Xe);this._anchor=Ke,this._active=Xe}static isSelection(F){return F instanceof E?!0:F?U.isRange(F)&&T.isPosition(F.anchor)&&T.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=E=Ae([$],N),e.Selection=N;class W{constructor(F,Z,Se){if(typeof F!="string"||F.length===0)throw(0,t.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,t.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,t.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(Z),this.connectionToken=Se}}e.ResolvedAuthority=W;class ie extends Error{constructor(F,Z=g.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F);this._message=F,this._code=Z,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ie.prototype)}static NotAvailable(F,Z){return new ie(F,g.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(F){return new ie(F,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ie;var j;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var re;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(re=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=u=class{constructor(F,Z){this._range=F,this._newText=Z}static isTextEdit(F){return F instanceof u?!0:F?U.isRange(F)&&typeof F.newText=="string":!1}static replace(F,Z){return new u(F,Z)}static insert(F,Z){return u.replace(new U(F,F),Z)}static delete(F){return u.replace(F,"")}static setEndOfLine(F){const Z=new u(new U(new T(0,0),new T(0,0)),"");return Z.newEol=F,Z}get range(){return this._range}set range(F){if(F&&!U.isRange(F))throw(0,t.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,t.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,t.illegalArgument)("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=u=Ae([$],x),e.TextEdit=x;var K;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,Z,Se,ze){this._edits.push({_type:1,from:F,to:Z,options:Se,metadata:ze})}createFile(F,Z,Se){this._edits.push({_type:1,from:void 0,to:F,options:Z,metadata:Se})}deleteFile(F,Z,Se){this._edits.push({_type:1,from:F,to:void 0,options:Z,metadata:Se})}replaceNotebookMetadata(F,Z,Se){this._edits.push({_type:3,metadata:Se,uri:F,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(F,Z,Se,ze,Ke){let Xe,Je,st=[],at;if(kt.isNotebookRange(Z)&&bt.isNotebookCellDataArray(Se)&&!bt.isNotebookCellDataArray(ze)?(Xe=Z.start,Je=Z.end,st=Se,at=ze):typeof Z=="number"&&typeof Se=="number"&&bt.isNotebookCellDataArray(ze)&&(Xe=Z,Je=Se,st=ze,at=Ke),Xe===void 0||Je===void 0)throw new Error("Invalid arguments");(Xe!==Je||st.length>0)&&this._edits.push({_type:5,uri:F,index:Xe,count:Je-Xe,cells:st,metadata:at})}replaceNotebookCellMetadata(F,Z,Se,ze){this._edits.push({_type:3,metadata:ze,uri:F,edit:{editType:8,index:Z,metadata:Se}})}replace(F,Z,Se,ze){this._edits.push({_type:2,uri:F,edit:new x(Z,Se),metadata:ze})}insert(F,Z,Se,ze){this.replace(F,new U(Z,Z),Se,ze)}delete(F,Z,Se){this.replace(F,Z,"",Se)}has(F){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===F.toString())}set(F,Z){if(Z)for(const Se of Z)Se&&this._edits.push({_type:2,uri:F,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const ze=this._edits[Se];ze._type===2&&ze.uri.toString()===F.toString()&&(this._edits[Se]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(F){const Z=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===F.toString()&&Z.push(Se.edit);return Z}entries(){const F=new C.ResourceMap;for(let Z of this._edits)if(Z._type===2){let Se=F.get(Z.uri);Se||(Se=[Z.uri,[]],F.set(Z.uri,Se)),Se[1].push(Z.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Ae([$],te),e.WorkspaceEdit=te;let ce=o=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof o?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=o._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,Z=this._tabstop++){if(typeof F=="function"){const Se=new o;Se._tabstop=this._tabstop,F(Se),this._tabstop=Se._tabstop,F=Se.value}else F=o._escape(F);return this.value+="${",this.value+=Z,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,Z=this._tabstop++){const Se=F.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,Z){if(typeof Z=="function"){const Se=new o;Se._tabstop=this._tabstop,Z(Se),this._tabstop=Se._tabstop,Z=Se.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ce=o=Ae([$],ce),e.SnippetString=ce;var oe;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var me;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(me=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=l=class{constructor(F,Z){if(this.uri=F,Z)if(U.isRange(Z))this.range=U.of(Z);else if(T.isPosition(Z))this.range=new U(Z,Z);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof l?!0:F?U.isRange(F.range)&&I.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=l=Ae([$],Y),e.Location=Y;let z=class{constructor(F,Z){this.location=F,this.message=Z}static is(F){return F?typeof F.message=="string"&&F.location&&U.isRange(F.location.range)&&I.URI.isUri(F.location.uri):!1}static isEqual(F,Z){return F===Z?!0:!F||!Z?!1:F.message===Z.message&&F.location.range.isEqual(Z.location.range)&&F.location.uri.toString()===Z.location.uri.toString()}};z=Ae([$],z),e.DiagnosticRelatedInformation=z;let H=class{constructor(F,Z,Se=me.Error){if(!U.isRange(F))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=F,this.message=Z,this.severity=Se}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,Z){return F===Z?!0:!F||!Z?!1:F.message===Z.message&&F.severity===Z.severity&&F.code===Z.code&&F.severity===Z.severity&&F.source===Z.source&&F.range.isEqual(Z.range)&&(0,_.equals)(F.tags,Z.tags)&&(0,_.equals)(F.relatedInformation,Z.relatedInformation,z.isEqual)}};H=Ae([$],H),e.Diagnostic=H;let q=class{constructor(F,Z){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=Z}};q=Ae([$],q),e.Hover=q;var ee;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(ee=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let he=class{constructor(F,Z=ee.Text){this.range=F,this.kind=Z}toJSON(){return{range:this.range,kind:ee[this.kind]}}};he=Ae([$],he),e.DocumentHighlight=he;var Ie;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var se;(function(M){M[M.Deprecated=1]="Deprecated"})(se=e.SymbolTag||(e.SymbolTag={}));let fe=s=class{constructor(F,Z,Se,ze,Ke){this.name=F,this.kind=Z,this.containerName=Ke,typeof Se=="string"&&(this.containerName=Se),ze instanceof Y?this.location=ze:Se instanceof U&&(this.location=new Y(ze,Se)),s.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};fe=s=Ae([$],fe),e.SymbolInformation=fe;let ve=n=class{constructor(F,Z,Se,ze,Ke){this.name=F,this.detail=Z,this.kind=Se,this.range=ze,this.selectionRange=Ke,this.children=[],n.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children&&F.children.forEach(n.validate)}};ve=n=Ae([$],ve),e.DocumentSymbol=ve;var X;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let B=class{constructor(F,Z){this.title=F,this.kind=Z}};B=Ae([$],B),e.CodeAction=B;let V=r=class{constructor(F){this.value=F}append(F){return new r(this.value?this.value+r.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+r.sep)}};V.sep=".",V=r=Ae([$],V),e.CodeActionKind=V,V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll");let Q=class{constructor(F,Z){if(this.range=F,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Q=Ae([$],Q),e.SelectionRange=Q;class ue{constructor(F,Z,Se,ze,Ke,Xe){this.kind=F,this.name=Z,this.detail=Se,this.uri=ze,this.range=Ke,this.selectionRange=Xe}}e.CallHierarchyItem=ue;class pe{constructor(F,Z){this.fromRanges=Z,this.from=F}}e.CallHierarchyIncomingCall=pe;class Pe{constructor(F,Z){this.fromRanges=Z,this.to=F}}e.CallHierarchyOutgoingCall=Pe;var Re;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Re=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Fe=class{constructor(F,Z){this.range=F,this.command=Z}get isResolved(){return!!this.command}};Fe=Ae([$],Fe),e.CodeLens=Fe;let Ue=i=class{constructor(F,Z=!1){c.set(this,void 0),yt(this,c,new p.MarkdownString(F,{supportThemeIcons:Z}),"f")}static isMarkdownString(F){return F instanceof i?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return tt(this,c,"f").value}set value(F){tt(this,c,"f").value=F}get isTrusted(){return tt(this,c,"f").isTrusted}set isTrusted(F){tt(this,c,"f").isTrusted=F}get supportThemeIcons(){return tt(this,c,"f").supportThemeIcons}set supportThemeIcons(F){tt(this,c,"f").supportThemeIcons=F}get supportHtml(){return tt(this,c,"f").supportHtml}set supportHtml(F){tt(this,c,"f").supportHtml=F}get baseUri(){return tt(this,c,"f").baseUri}set baseUri(F){tt(this,c,"f").baseUri=F}appendText(F){return tt(this,c,"f").appendText(F),this}appendMarkdown(F){return tt(this,c,"f").appendMarkdown(F),this}appendCodeblock(F,Z){return tt(this,c,"f").appendCodeblock(Z??"",F),this}};c=new WeakMap,Ue=i=Ae([$],Ue),e.MarkdownString=Ue;let ae=class{constructor(F,Z){this.label=F,this.documentation=Z}};ae=Ae([$],ae),e.ParameterInformation=ae;let ge=class{constructor(F,Z){this.label=F,this.documentation=Z,this.parameters=[]}};ge=Ae([$],ge),e.SignatureInformation=ge;let de=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};de=Ae([$],de),e.SignatureHelp=de;var Te;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(Te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Me;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(Me=e.InlayHintKind||(e.InlayHintKind={}));let He=class{constructor(F){this.value=F}};He=Ae([$],He),e.InlayHintLabelPart=He;let Be=class{constructor(F,Z,Se){this.position=F,this.label=Z,this.kind=Se}};Be=Ae([$],Be),e.InlayHint=Be;var je;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(M){M[M.Deprecated=1]="Deprecated"})(ne=e.CompletionItemTag||(e.CompletionItemTag={}));let be=class{constructor(F,Z){this.label=F,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};be=Ae([$],be),e.CompletionItem=be;let ke=class{constructor(F=[],Z=!1){this.items=F,this.isIncomplete=Z}};ke=Ae([$],ke),e.CompletionList=ke;let Le=class{constructor(F,Z,Se){this.insertText=F,this.range=Z,this.command=Se}};Le=Ae([$],Le),e.InlineSuggestion=Le;let Ne=class{constructor(F){this.items=F}};Ne=Ae([$],Ne),e.InlineSuggestions=Ne;var Qe;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(Qe=e.ViewColumn||(e.ViewColumn={}));var $e;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})($e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ve;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(Ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(Ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xe;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(xe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var et;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(et=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var rt;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(rt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(M){function F(Z){switch(Z){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=F}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let nt=class{constructor(F,Z){if(Z&&!I.URI.isUri(Z))throw(0,t.illegalArgument)("target");if(!U.isRange(F)||F.isEmpty)throw(0,t.illegalArgument)("range");this.range=F,this.target=Z}};nt=Ae([$],nt),e.DocumentLink=nt;let pt=class{constructor(F,Z,Se,ze){this.red=F,this.green=Z,this.blue=Se,this.alpha=ze}};pt=Ae([$],pt),e.Color=pt;let gt=class{constructor(F,Z){if(Z&&!(Z instanceof pt))throw(0,t.illegalArgument)("color");if(!U.isRange(F)||F.isEmpty)throw(0,t.illegalArgument)("range");this.range=F,this.color=Z}};gt=Ae([$],gt),e.ColorInformation=gt;let dt=class{constructor(F){if(!F||typeof F!="string")throw(0,t.illegalArgument)("label");this.label=F}};dt=Ae([$],dt),e.ColorPresentation=dt;var St;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(St=e.ColorFormat||(e.ColorFormat={}));var Dt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Pt{constructor(F,Z,Se){if(this.startIndex=F,this.length=Z,this.tooltip=Se,typeof F!="number"||F<0)throw(0,t.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,t.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Pt;var Ft;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class Ot{constructor(F){this.options=F,typeof F!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=Ot;var Ee;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var Ce;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Ce=e.TaskPanelKind||(e.TaskPanelKind={}));let le=a=class{constructor(F,Z){if(this.label=Z,typeof F!="string"||typeof Z!="string")throw(0,t.illegalArgument)("name");this._id=F}static from(F){switch(F){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};le.Clean=new a("clean","Clean"),le.Build=new a("build","Build"),le.Rebuild=new a("rebuild","Rebuild"),le.Test=new a("test","Test"),le=a=Ae([$],le),e.TaskGroup=le;function G(M){let F="";for(let Z=0;Z<M.length;Z++)F+=M[Z].replace(/,/g,",,")+",";return F}let De=class{constructor(F,Z,Se){if(typeof F!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=F,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=Se):this._options=Z)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,t.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)F.push(Z);return G(F)}};De=Ae([$],De),e.ProcessExecution=De;let _e=class{constructor(F,Z,Se){if(this._args=[],Array.isArray(Z)){if(!F)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,t.illegalArgument)("command");this._command=F,this._args=Z,this._options=Se}else{if(typeof F!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=F,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,t.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)F.push(typeof Z=="string"?Z:Z.value);return G(F)}};_e=Ae([$],_e),e.ShellExecution=_e;var We;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(We=e.ShellQuoting||(e.ShellQuoting={}));var Ge;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(Ge=e.TaskScope||(e.TaskScope={}));class it{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=it;let ot=d=class{constructor(F,Z,Se,ze,Ke,Xe){this.__deprecated=!1,this._definition=this.definition=F;let Je;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=Se,this.execution=ze,Je=Ke,this.__deprecated=!0):Z===Ge.Global||Z===Ge.Workspace?(this.target=Z,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ke,Je=Xe):(this.target=Z,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ke,Je=Xe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof De?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof _e?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const Z=this._definition.type;(d.EmptyType===Z||d.ProcessType===Z||d.ShellType===Z||d.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};ot.ExtensionCallbackType="customExecution",ot.ProcessType="process",ot.ShellType="shell",ot.EmptyType="$empty",ot=d=Ae([$],ot),e.Task=ot;var Et;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(F,Z=lt.None){this.collapsibleState=Z,I.URI.isUri(F)?this.resourceUri=F:this.label=F}};ct=Ae([$],ct),e.TreeItem=ct;var lt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(lt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(F){this.value=F}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ut=Ae([$],ut),e.TreeDataTransferItem=ut;let Nt=class{constructor(){this._items=new Map}get(F){return this._items.get(F)}set(F,Z){this._items.set(F,Z)}forEach(F){this._items.forEach(F)}};Nt=Ae([$],Nt),e.TreeDataTransfer=Nt;let wt=class{constructor(F,Z){this.id=F,this.color=Z}};wt=Ae([$],wt),e.ThemeIcon=wt,wt.File=new wt("file"),wt.Folder=new wt("folder");let Mt=class{constructor(F){this.id=F}};Mt=Ae([$],Mt),e.ThemeColor=Mt;var fn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(fn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ut=class{constructor(F,Z){if(typeof F!="string"&&(!F||!I.URI.isUri(F)&&!I.URI.isUri(F.uri)))throw(0,t.illegalArgument)("base");if(typeof Z!="string")throw(0,t.illegalArgument)("pattern");typeof F=="string"?this.baseUri=I.URI.file(F):I.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=Z}get base(){return this._base}set base(F){this._base=F,this._baseUri=I.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ut=Ae([$],Ut),e.RelativePattern=Ut;let Ct=class{constructor(F,Z,Se,ze){this.enabled=typeof F=="boolean"?F:!0,typeof Z=="string"&&(this.condition=Z),typeof Se=="string"&&(this.hitCondition=Se),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Ct=Ae([$],Ct),e.Breakpoint=Ct;let Bt=class extends Ct{constructor(F,Z,Se,ze,Ke){super(Z,Se,ze,Ke);if(F===null)throw(0,t.illegalArgument)("location");this.location=F}};Bt=Ae([$],Bt),e.SourceBreakpoint=Bt;let zt=class extends Ct{constructor(F,Z,Se,ze,Ke){super(Z,Se,ze,Ke);this.functionName=F}};zt=Ae([$],zt),e.FunctionBreakpoint=zt;let $t=class extends Ct{constructor(F,Z,Se,ze,Ke,Xe,Je){super(ze,Ke,Xe,Je);if(!Z)throw(0,t.illegalArgument)("dataId");this.label=F,this.dataId=Z,this.canPersist=Se}};$t=Ae([$],$t),e.DataBreakpoint=$t;let Wt=class{constructor(F,Z,Se){this.command=F,this.args=Z||[],this.options=Se}};Wt=Ae([$],Wt),e.DebugAdapterExecutable=Wt;let jt=class{constructor(F,Z){this.port=F,this.host=Z}};jt=Ae([$],jt),e.DebugAdapterServer=jt;let Ht=class{constructor(F){this.path=F}};Ht=Ae([$],Ht),e.DebugAdapterNamedPipeServer=Ht;let qt=class{constructor(F){this.implementation=F}};qt=Ae([$],qt),e.DebugAdapterInlineImplementation=qt;let Vt=class{constructor(F,Z){this.range=F,this.expression=Z}};Vt=Ae([$],Vt),e.EvaluatableExpression=Vt;var hn;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let xt=class{constructor(F,Z){this.range=F,this.text=Z}};xt=Ae([$],xt),e.InlineValueText=xt;let Gt=class{constructor(F,Z,Se=!0){this.range=F,this.variableName=Z,this.caseSensitiveLookup=Se}};Gt=Ae([$],Gt),e.InlineValueVariableLookup=Gt;let Kt=class{constructor(F,Z){this.range=F,this.expression=Z}};Kt=Ae([$],Kt),e.InlineValueEvaluatableExpression=Kt;let Qt=class{constructor(F,Z){this.frameId=F,this.stoppedLocation=Z}};Qt=Ae([$],Qt),e.InlineValueContext=Qt;var dn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(dn=e.FileChangeType||(e.FileChangeType={}));let Yt=w=class extends Error{constructor(F,Z=R.FileSystemProviderErrorCode.Unknown,Se){super(I.URI.isUri(F)?F.toString(!0):F);this.code=Se?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(F){return new w(F,R.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(F){return new w(F,R.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(F){return new w(F,R.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(F){return new w(F,R.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(F){return new w(F,R.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(F){return new w(F,R.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Yt=w=Ae([$],Yt),e.FileSystemError=Yt;let Xt=class{constructor(F,Z,Se){this.start=F,this.end=Z,this.kind=Se}};Xt=Ae([$],Xt),e.FoldingRange=Xt;var mn;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gn;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(gn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var vn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(vn=e.CommentMode||(e.CommentMode={}));var pn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(pn=e.CommentThreadState||(e.CommentThreadState={}));class wn{constructor(F,Z=[]){this.tokenTypes=F,this.tokenModifiers=Z}}e.SemanticTokensLegend=wn;function yn(M){return typeof M=="undefined"||(0,v.isStringArray)(M)}class Jt{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let Z=0,Se=F.tokenTypes.length;Z<Se;Z++)this._tokenTypeStrToInt.set(F.tokenTypes[Z],Z);for(let Z=0,Se=F.tokenModifiers.length;Z<Se;Z++)this._tokenModifierStrToInt.set(F.tokenModifiers[Z],Z)}}push(F,Z,Se,ze,Ke){if(typeof F=="number"&&typeof Z=="number"&&typeof Se=="number"&&typeof ze=="number"&&(typeof Ke=="number"||typeof Ke=="undefined"))return typeof Ke=="undefined"&&(Ke=0),this._pushEncoded(F,Z,Se,ze,Ke);if(U.isRange(F)&&typeof Z=="string"&&yn(Se))return this._push(F,Z,Se);throw(0,t.illegalArgument)()}_push(F,Z,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const ze=F.start.line,Ke=F.start.character,Xe=F.end.character-F.start.character,Je=this._tokenTypeStrToInt.get(Z);let st=0;if(Se)for(const at of Se){if(!this._tokenModifierStrToInt.has(at))throw new Error("`tokenModifier` is not in the provided legend");const ht=this._tokenModifierStrToInt.get(at);st|=1<<ht>>>0}this._pushEncoded(ze,Ke,Xe,Je,st)}_pushEncoded(F,Z,Se,ze,Ke){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const st=this._data.length/5|0;let at=0,ht=0;for(let mt=0;mt<st;mt++){let vt=this._data[5*mt],_t=this._data[5*mt+1];vt===0?(vt=at,_t+=ht):vt+=at,this._data[5*mt]=vt,this._data[5*mt+1]=_t,at=vt,ht=_t}}let Xe=F,Je=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ke,this._prevLine=F,this._prevChar=Z}static _sortAndDeltaEncode(F){let Z=[];const Se=F.length/5|0;for(let Je=0;Je<Se;Je++)Z[Je]=Je;Z.sort((Je,st)=>{const at=F[5*Je],ht=F[5*st];if(at===ht){const mt=F[5*Je+1],vt=F[5*st+1];return mt-vt}return at-ht});const ze=new Uint32Array(F.length);let Ke=0,Xe=0;for(let Je=0;Je<Se;Je++){const st=5*Z[Je],at=F[st+0],ht=F[st+1],mt=F[st+2],vt=F[st+3],_t=F[st+4],un=at-Ke,xn=un===0?ht-Xe:ht,Rt=5*Je;ze[Rt+0]=un,ze[Rt+1]=xn,ze[Rt+2]=mt,ze[Rt+3]=vt,ze[Rt+4]=_t,Ke=at,Xe=ht}return ze}build(F){return this._dataIsSortedAndDeltaEncoded?new Zt(new Uint32Array(this._data),F):new Zt(Jt._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Jt;class Zt{constructor(F,Z){this.resultId=Z,this.data=F}}e.SemanticTokens=Zt;class En{constructor(F,Z,Se){this.start=F,this.deleteCount=Z,this.data=Se}}e.SemanticTokensEdit=En;class bn{constructor(F,Z){this.resultId=Z,this.edits=F}}e.SemanticTokensEdits=bn;var Sn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Tt=class{constructor(){}};Tt.Back={iconPath:new wt("arrow-left")},Tt=Ae([$],Tt),e.QuickInputButtons=Tt;var Cn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Cn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var In;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(In=e.ExtensionKind||(e.ExtensionKind={}));class Dn{constructor(F,Z,Se){this.badge=F,this.tooltip=Z,this.color=Se}static validate(F){if(F.badge){let Z=(0,D.nextCharLength)(F.badge,0);if(Z<F.badge.length&&(Z+=(0,D.nextCharLength)(F.badge,Z)),F.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Dn;let en=class{constructor(F){this.kind=F}};en=Ae([$],en),e.ColorTheme=en;var Pn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class kt{constructor(F,Z){if(F<0)throw(0,t.illegalArgument)("start must be positive");if(Z<0)throw(0,t.illegalArgument)("end must be positive");F<=Z?(this._start=F,this._end=Z):(this._start=Z,this._end=F)}static isNotebookRange(F){return F instanceof kt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(F){let Z=this._start,Se=this._end;return F.start!==void 0&&(Z=F.start),F.end!==void 0&&(Se=F.end),Z===this._start&&Se===this._end?this:new kt(Z,Se)}}e.NotebookRange=kt;class bt{constructor(F,Z,Se,ze,Ke,Xe,Je){this.kind=F,this.value=Z,this.languageId=Se,this.mime=ze,this.outputs=Ke??[],this.metadata=Xe,this.executionSummary=Je,bt.validate(this)}static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(Z=>bt.isNotebookCellData(Z))}static isNotebookCellData(F){return!0}}e.NotebookCellData=bt;class kn{constructor(F){this.cells=F}}e.NotebookData=kn;class ft{constructor(F,Z){this.data=F,this.mime=Z;const Se=(0,k.normalizeMimeType)(Z,!0);if(!Se)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}static isNotebookCellOutputItem(F){return F instanceof ft?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const Z={name:F.name,message:F.message,stack:F.stack};return ft.json(Z,"application/vnd.code.notebook.error")}static stdout(F){return ft.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ft.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,Z="application/octet-stream"){return new ft(F,Z)}static text(F,Z=k.Mimes.text){const Se=tt(ft,h,"f",m).encode(String(F));return new ft(Se,Z)}static json(F,Z="application/json"){const Se=JSON.stringify(F,void 0,"	");return ft.text(Se,Z)}}e.NotebookCellOutputItem=ft,h=ft,m={value:new TextEncoder};class At{constructor(F,Z,Se){this.items=At.ensureUniqueMimeTypes(F,!0),typeof Z=="string"?(this.id=Z,this.metadata=Se):(this.id=(0,A.generateUuid)(),this.metadata=Z??Se)}static isNotebookCellOutput(F){return F instanceof At?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&(0,v.isArray)(F.items)}static ensureUniqueMimeTypes(F,Z=!1){const Se=new Set,ze=new Set;for(let Ke=0;Ke<F.length;Ke++){const Xe=F[Ke],Je=(0,k.normalizeMimeType)(Xe.mime);if(!Se.has(Je)){Se.add(Je);continue}ze.add(Ke),Z&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return ze.size===0?F:F.filter((Ke,Xe)=>!ze.has(Xe))}}e.NotebookCellOutput=At;var _n;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(_n=e.NotebookCellKind||(e.NotebookCellKind={}));var Rn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(Rn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Tn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Tn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var An;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(An=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ln{constructor(F,Z){this.text=F,this.alignment=Z}}e.NotebookCellStatusBarItem=Ln;var Fn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(Fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class On{constructor(F,Z=[]){this.uri=F,this.provides=(0,_.asArray)(Z)}}e.NotebookRendererScript=On;let tn=class{constructor(F,Z){this.label=F,this.timestamp=Z}};tn=Ae([$],tn),e.TimelineItem=tn;var Nn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Nn=e.ExtensionMode||(e.ExtensionMode={}));var Mn;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(Mn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Un;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(Un=e.StandardTokenType||(e.StandardTokenType={}));class Bn{constructor(F,Z){this.ranges=F,this.wordPattern=Z}}e.LinkedEditingRanges=Bn;class zn{constructor(F,Z){this._port=F,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=zn;var $n;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})($n=e.TestResultState||(e.TestResultState={}));var Wn;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(Wn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let nn=class{constructor(F=void 0,Z=void 0,Se=void 0){this.include=F,this.exclude=Z,this.profile=Se}};nn=Ae([$],nn),e.TestRunRequest=nn;let rn=P=class{constructor(F){this.message=F}static diff(F,Z,Se){const ze=new P(F);return ze.expectedOutput=Z,ze.actualOutput=Se,ze}};rn=P=Ae([$],rn),e.TestMessage=rn;let sn=class{constructor(F){this.id=F}};sn=Ae([$],sn),e.TestTag=sn;let It=class{constructor(F,Z){this.covered=F,this.total=Z}};It=Ae([$],It),e.CoveredCount=It;let on=O=class{constructor(F,Z,Se,ze){this.uri=F,this.statementCoverage=Z,this.branchCoverage=Se,this.functionCoverage=ze}static fromDetails(F,Z){const Se=new It(0,0),ze=new It(0,0),Ke=new It(0,0);for(const Je of Z)if("branches"in Je){Se.total+=1,Se.covered+=Je.executionCount>0?1:0;for(const st of Je.branches)ze.total+=1,ze.covered+=st.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=Je.executionCount>0?1:0;const Xe=new O(F,Se,ze.total>0?ze:void 0,Ke.total>0?Ke:void 0);return Xe.detailedCoverage=Z,Xe}};on=O=Ae([$],on),e.FileCoverage=on;let an=class{constructor(F,Z,Se=[]){this.executionCount=F,this.location=Z,this.branches=Se}};an=Ae([$],an),e.StatementCoverage=an;let ln=class{constructor(F,Z){this.executionCount=F,this.location=Z}};ln=Ae([$],ln),e.BranchCoverage=ln;let cn=class{constructor(F,Z){this.executionCount=F,this.location=Z}};cn=Ae([$],cn),e.FunctionCoverage=cn;var jn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(jn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vn{constructor(F,Z,Se,ze,Ke,Xe){this.kind=F,this.name=Z,this.detail=Se,this.uri=ze,this.range=Ke,this.selectionRange=Xe}}e.TypeHierarchyItem=Vn}),define(we[57],ye([0,1,61]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(C){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:C,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function p(C){return new _.URITransformer(t(C))}e.createURITransformer=p}),define(we[228],ye([0,1,4,57,55,5,191]),function(J,e,_,t,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class D extends k.AbstractDiskFileSystemProviderChannel{constructor(A,R){super(new p.DiskFileSystemProvider(A),A);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(A){let R=this.uriTransformerCache.get(A.remoteAuthority);return R||(R=(0,t.createURITransformer)(A.remoteAuthority),this.uriTransformerCache.set(A.remoteAuthority,R)),R}transformIncoming(A,R,g=!1){if(g&&R.path==="/vscode-resource"&&R.query){const S=JSON.parse(R.query).requestResourcePath;return _.URI.from({scheme:"file",path:S})}return _.URI.revive(A.transformIncoming(R))}createSessionFileWatcher(A,R){return new v(A,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=D;class v extends k.AbstractSessionFileWatcher{constructor(A,R,g,S){super(A,R,g,S)}getRecursiveWatcherOptions(A){const R=A.args["file-watcher-polling"];if(R){const g=R.split(C.delimiter),S=Number(g[0]);if(S>0)return{usePolling:g.length>1?g.slice(1):!0,pollingInterval:S}}}getExtraExcludes(A){if(A.extensionsPath)return[C.posix.join(A.extensionsPath,"**")]}}}),define(we[107],ye([0,1,167,12,4,2,6,35,19,17,8]),function(J,e,_,t,p,C,k,D,v,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,_.localize)(0,null),providerDisplayName:(0,_.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(W){W[W.PROGRAMMATIC=1]="PROGRAMMATIC",W[W.USER=2]="USER",W[W.EDIT=3]="EDIT",W[W.NAVIGATION=4]="NAVIGATION",W[W.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var g;(function(W){W[W.IDENTICAL=1]="IDENTICAL",W[W.SIMILAR=2]="SIMILAR",W[W.DIFFERENT=3]="DIFFERENT"})(g=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(W){const ie=W;return!!ie&&typeof ie.getSelection=="function"&&!!ie.onDidChangeSelection}e.isEditorPaneWithSelection=S;function c(W,ie,j){for(const re of j.visibleEditorPanes)if(re.group.id===ie&&W.matches(re.input))return re.getViewState()}e.findViewStateForEditor=c;function h(W){if(l(W))return!1;const ie=W;return p.URI.isUri(ie?.resource)}e.isResourceEditorInput=h;function m(W){if(l(W))return!1;const ie=W;return ie?.original!==void 0&&ie.modified!==void 0}e.isResourceDiffEditorInput=m;function y(W){if(l(W)||m(W))return!1;const ie=W;return ie?.primary!==void 0&&ie.secondary!==void 0}e.isResourceSideBySideEditorInput=y;function b(W){if(l(W))return!1;const ie=W;return ie?ie.resource===void 0||ie.resource.scheme===A.Schemas.untitled||ie.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=b;var f;(function(W){W[W.SHORT=0]="SHORT",W[W.MEDIUM=1]="MEDIUM",W[W.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var E;(function(W){W[W.EXPLICIT=1]="EXPLICIT",W[W.AUTO=2]="AUTO",W[W.FOCUS_CHANGE=3]="FOCUS_CHANGE",W[W.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(E=e.SaveReason||(e.SaveReason={}));var u;(function(W){W[W.None=0]="None",W[W.Readonly=2]="Readonly",W[W.Untitled=4]="Untitled",W[W.Singleton=8]="Singleton",W[W.RequiresTrust=16]="RequiresTrust",W[W.CanSplitInGroup=32]="CanSplitInGroup",W[W.ForceDescription=64]="ForceDescription"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends C.Disposable{}e.AbstractEditorInput=o;function l(W){return W instanceof o}e.isEditorInput=l;function s(W){const ie=W;return p.URI.isUri(ie?.preferredResource)}function n(W){const ie=W;return l(ie?.primary)&&l(ie?.secondary)}e.isSideBySideEditorInput=n;function r(W){const ie=W;return l(ie?.modified)&&l(ie?.original)}e.isDiffEditorInput=r;function i(W){return l(W?.editor)}e.isEditorInputWithOptions=i;function a(W){const ie=W;return i(W)&&ie?.group!==void 0}e.isEditorInputWithOptionsAndGroup=a;function d(W){const ie=W;return typeof ie?.groupId=="number"&&l(ie.editor)}e.isEditorIdentifier=d;var w;(function(W){W[W.UNKNOWN=0]="UNKNOWN",W[W.REPLACE=1]="REPLACE",W[W.MOVE=2]="MOVE",W[W.UNPIN=3]="UNPIN"})(w=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(W){W[W.GROUP_ACTIVE=0]="GROUP_ACTIVE",W[W.GROUP_INDEX=1]="GROUP_INDEX",W[W.GROUP_LOCKED=2]="GROUP_LOCKED",W[W.EDITOR_OPEN=3]="EDITOR_OPEN",W[W.EDITOR_CLOSE=4]="EDITOR_CLOSE",W[W.EDITOR_MOVE=5]="EDITOR_MOVE",W[W.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",W[W.EDITOR_LABEL=7]="EDITOR_LABEL",W[W.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",W[W.EDITOR_PIN=9]="EDITOR_PIN",W[W.EDITOR_STICKY=10]="EDITOR_STICKY",W[W.EDITOR_DIRTY=11]="EDITOR_DIRTY",W[W.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var O;(function(W){W[W.PRIMARY=1]="PRIMARY",W[W.SECONDARY=2]="SECONDARY",W[W.BOTH=3]="BOTH",W[W.ANY=4]="ANY"})(O=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(ie,j){if(!ie)return;if(j?.supportSideBySide){const{primary:x,secondary:K}=this.getSideEditors(ie);if(x&&K){if(j?.supportSideBySide===O.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===O.ANY)return this.getOriginalUri(x,{filterByScheme:j.filterByScheme})??this.getOriginalUri(K,{filterByScheme:j.filterByScheme});ie=j.supportSideBySide===O.PRIMARY?x:K}}if(m(ie)||y(ie))return;const re=s(ie)?ie.preferredResource:ie.resource;return!re||!j||!j.filterByScheme?re:this.filterUri(re,j.filterByScheme)}getSideEditors(ie){return n(ie)||y(ie)?{primary:ie.primary,secondary:ie.secondary}:r(ie)||m(ie)?{primary:ie.modified,secondary:ie.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ie,j){if(!ie)return;if(j?.supportSideBySide){const{primary:x,secondary:K}=this.getSideEditors(ie);if(x&&K){if(j?.supportSideBySide===O.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===O.ANY)return this.getCanonicalUri(x,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:j.filterByScheme});ie=j.supportSideBySide===O.PRIMARY?x:K}}if(m(ie)||y(ie))return;const re=ie.resource;return!re||!j||!j.filterByScheme?re:this.filterUri(re,j.filterByScheme)}filterUri(ie,j){if(Array.isArray(j)){if(j.some(re=>ie.scheme===re))return ie}else if(j===ie.scheme)return ie}}e.EditorResourceAccessor=new $;var L;(function(W){W[W.LEFT=0]="LEFT",W[W.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class T{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ie){const j=this.instantiationService=ie.get(k.IInstantiationService);for(const[re,x]of this.editorSerializerConstructors)this.createEditorSerializer(re,x,j);this.editorSerializerConstructors.clear()}createEditorSerializer(ie,j,re){const x=re.createInstance(j);this.editorSerializerInstances.set(ie,x)}registerFileEditorFactory(ie){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ie}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ie,j){if(this.editorSerializerConstructors.has(ie)||this.editorSerializerInstances.has(ie))throw new Error(`A editor serializer with type ID '${ie}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ie,j,this.instantiationService):this.editorSerializerConstructors.set(ie,j),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(ie),this.editorSerializerInstances.delete(ie)})}getEditorSerializer(ie){return this.editorSerializerInstances.get(typeof ie=="string"?ie:ie.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new T);async function U(W,ie){if(!W||!W.length)return[];const j=await Promise.all(W.map(async re=>{const x=p.URI.revive(re.fileUri);if(!x||!await ie.canHandleResource(x))return;let te=re.exists,ce=re.type;if(typeof te!="boolean"||typeof ce!="number")try{ce=(await ie.stat(x)).isDirectory?v.FileType.Directory:v.FileType.Unknown,te=!0}catch{te=!1}if(!te&&re.openOnlyIfExists||ce===v.FileType.Directory)return;const oe={selection:te?re.selection:void 0,pinned:!0,override:re.editorOverrideId};let me;return te?me={resource:x,options:oe}:me={resource:x,options:oe,forceUntitled:!0},me}));return(0,I.coalesce)(j)}e.pathsToEditors=U;var N;(function(W){W[W.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",W[W.SEQUENTIAL=1]="SEQUENTIAL"})(N=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[229],ye([0,1,77,49,60,8,5,3,88]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var I;(function(i){i[i.Markup=1]="Markup",i[i.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",p.Mimes.latex,p.Mimes.markdown,"image/png","image/jpeg",p.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[p.Mimes.latex,p.Mimes.markdown,"application/json",p.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(i){i[i.Running=1]="Running",i[i.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var R;(function(i){i[i.Unconfirmed=1]="Unconfirmed",i[i.Pending=2]="Pending",i[i.Executing=3]="Executing"})(R=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var g;(function(i){i[i.WithHardKernelDependency=0]="WithHardKernelDependency",i[i.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",i[i.Pure=2]="Pure",i[i.Never=3]="Never"})(g=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var S;(function(i){i.Always="always",i.Never="never",i.Optional="optional"})(S=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var c;(function(i){i[i.ModelChange=1]="ModelChange",i[i.Move=2]="Move",i[i.ChangeLanguage=5]="ChangeLanguage",i[i.Initialize=6]="Initialize",i[i.ChangeCellMetadata=7]="ChangeCellMetadata",i[i.Output=8]="Output",i[i.OutputItem=9]="OutputItem",i[i.ChangeCellContent=10]="ChangeCellContent",i[i.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",i[i.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",i[i.ChangeCellMime=13]="ChangeCellMime",i[i.Unknown=100]="Unknown"})(c=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(i){i[i.Handle=0]="Handle",i[i.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(i){i[i.Replace=1]="Replace",i[i.Output=2]="Output",i[i.Metadata=3]="Metadata",i[i.CellLanguage=4]="CellLanguage",i[i.DocumentMetadata=5]="DocumentMetadata",i[i.Move=6]="Move",i[i.OutputItems=7]="OutputItems",i[i.PartialMetadata=8]="PartialMetadata",i[i.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var y;(function(i){i.scheme=C.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function d(T,U){return T.with({scheme:i.scheme,fragment:`ch${U.toString().padStart(7,"0")}${T.scheme!==C.Schemas.file?T.scheme:""}`})}i.generate=d;function w(T){if(T.scheme!==i.scheme)return;const U=a.exec(T.fragment);return U?{handle:Number(U[1]),notebook:T.with({scheme:T.fragment.substring(U[0].length)||C.Schemas.file,fragment:null})}:void 0}i.parse=w;function P(T,U){return T.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${U??""},${T.scheme!==C.Schemas.file?T.scheme:""}`})}i.generateCellOutputUri=P;function O(T){if(T.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const U=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(T.fragment);if(!U)return;const N=U[1]&&U[1]!==""?U[1]:void 0,W=U[2];return{outputId:N,notebook:T.with({scheme:W||C.Schemas.file,fragment:null})}}i.parseCellOutputUri=O;function $(T,U,N){return T.with({scheme:N,fragment:`ch${U.toString().padStart(7,"0")}${T.scheme!==C.Schemas.file?T.scheme:""}`})}i.generateCellUri=$;function L(T,U){if(T.scheme!==U)return;const N=a.exec(T.fragment);return N?{handle:Number(N[1]),notebook:T.with({scheme:T.fragment.substring(N[0].length)||C.Schemas.file,fragment:null})}:void 0}i.parseCellUri=L})(y=e.CellUri||(e.CellUri={}));const b=i=>D.isWindows?i.replace(/\//g,"\\"):i;class f{constructor(a=[],d=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=d,this.order=[...new Set(a)].map(w=>({pattern:w,matches:_.parse(b(w))}))}sort(a){const d=new Map(t.Iterable.map(a,P=>[P,b(P)]));let w=[];for(const{matches:P}of this.order)for(const[O,$]of d)if(P($)){w.push(O),d.delete(O);break}return d.size&&(w=w.concat([...d.keys()].sort((P,O)=>this.defaultOrder.indexOf(P)-this.defaultOrder.indexOf(O)))),w}prioritize(a,d){const w=this.findIndex(a);if(w===-1){this.order.unshift({pattern:a,matches:_.parse(b(a))});return}const P=new Set(d.map($=>this.findIndex($,w)));P.delete(-1);const O=Array.from(P).sort();this.order.splice(w+1,0,...O.map($=>this.order[$]));for(let $=O.length-1;$>=0;$--)this.order.splice(O[$],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,d=this.order.length){const w=b(a);for(let P=0;P<d;P++)if(this.order[P].matches(w))return P;return-1}}e.MimeTypeDisplayOrder=f;function E(i,a,d,w=(P,O)=>P===O){const P=[];function O(T,U,N){if(U===0&&N.length===0)return;const W=P[P.length-1];W&&W.start+W.deleteCount===T?(W.deleteCount+=U,W.toInsert.push(...N)):P.push({start:T,deleteCount:U,toInsert:N})}let $=0,L=0;for(;;){if($===i.length){O($,0,a.slice(L));break}if(L===a.length){O($,i.length-$,[]);break}const T=i[$],U=a[L];if(w(T,U)){$+=1,L+=1;continue}d(U)?(O($,1,[]),$+=1):(O($,0,[U]),L+=1)}return P}e.diff=E,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(i){i.default="default",i.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(i){const a=i;return!!((typeof a.include=="string"||_.isRelativePattern(a.include))&&(typeof a.exclude=="string"||_.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=o;function l(i,a,d){if(Array.isArray(i.viewType)&&i.viewType.indexOf(a)>=0||i.viewType===a)return!0;if(i.filenamePattern){const w=o(i.filenamePattern)?i.filenamePattern.include:i.filenamePattern,P=o(i.filenamePattern)?i.filenamePattern.exclude:void 0;if(_.match(w,(0,k.basename)(d.fsPath).toLowerCase()))return!(P&&_.match(P,(0,k.basename)(d.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class s{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let d=0;d<this.textModel.cells.length;d++)a[d]=this.textModel.cells[d].getHashValue();return a}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var n;(function(i){i[i.Left=1]="Left",i[i.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(a){return`${r._prefix}${a}`}static parse(a){if(a.startsWith(r._prefix))return a.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(we[108],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,_.createDecorator)("environmentVariableService");var t;(function(p){p[p.Replace=1]="Replace",p[p.Append=2]="Append",p[p.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(we[230],ye([0,1,3,108]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class p{constructor(v){this.map=new Map,v.forEach((I,A)=>{const R=I.map.entries();let g=R.next();for(;!g.done;){const S=g.value[0];let c=this.map.get(S);if(c||(c=[],this.map.set(S,c)),c.length>0&&c[0].type===t.EnvironmentVariableMutatorType.Replace){g=R.next();continue}const h=g.value[1];c.unshift({extensionIdentifier:A,value:h.value,type:h.type}),g=R.next()}})}applyToProcessEnvironment(v,I){let A;_.isWindows&&(A={},Object.keys(v).forEach(R=>A[R.toLowerCase()]=R)),this.map.forEach((R,g)=>{const S=_.isWindows&&A[g.toLowerCase()]||g;R.forEach(c=>{const h=I?I(c.value):c.value;switch(c.type){case t.EnvironmentVariableMutatorType.Append:v[S]=(v[S]||"")+h;break;case t.EnvironmentVariableMutatorType.Prepend:v[S]=h+(v[S]||"");break;case t.EnvironmentVariableMutatorType.Replace:v[S]=h;break}})})}diff(v){const I=new Map,A=new Map,R=new Map;if(v.map.forEach((g,S)=>{const c=this.map.get(S),h=C(g,c);h&&I.set(S,h)}),this.map.forEach((g,S)=>{const c=v.map.get(S),h=C(g,c);h&&R.set(S,h)}),this.map.forEach((g,S)=>{const c=v.map.get(S),h=k(g,c);h&&A.set(S,h)}),!(I.size===0&&A.size===0&&R.size===0))return{added:I,changed:A,removed:R}}}e.MergedEnvironmentVariableCollection=p;function C(D,v){if(!v)return D;const I=new Set;v.forEach(R=>I.add(R.extensionIdentifier));const A=[];return D.forEach(R=>{I.has(R.extensionIdentifier)||A.push(R)}),A.length===0?void 0:A}function k(D,v){if(!v)return;const I=new Map;v.forEach(R=>I.set(R.extensionIdentifier,R));const A=[];return D.forEach(R=>{const g=I.get(R.extensionIdentifier);g&&(R.type!==g.type||R.value!==g.value)&&A.push(g)}),A.length===0?void 0:A}}),define(we[109],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(p){return[...p.entries()]}e.serializeEnvironmentVariableCollection=_;function t(p){return new Map(p)}e.deserializeEnvironmentVariableCollection=t}),define(we[231],ye([0,1,5,73,3,16]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.injectShellIntegrationArgs=e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function k(a,d){if(!!d)if(p.isWindows)for(const w in d){let P=w;for(const $ in a)if(w.toLowerCase()===$.toLowerCase()){P=$;break}const O=d[w];O!==void 0&&D(a,P,O)}else Object.keys(d).forEach(w=>{const P=d[w];P!==void 0&&D(a,w,P)})}e.mergeEnvironments=k;function D(a,d,w){typeof w=="string"?a[d]=w:delete a[d]}function v(a,d,w,P){a.TERM_PROGRAM="vscode",d&&(a.TERM_PROGRAM_VERSION=d),R(a,P)&&(a.LANG=g(w)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=v;function I(a,d){if(!!d)for(const w of Object.keys(d)){const P=d[w];P&&(a[w]=P)}}function A(a,d){return Object.keys(d).forEach(w=>{const P=d[w];if(typeof P=="string")try{d[w]=a(P)}catch{d[w]=P}}),d}function R(a,d){if(d==="on")return!0;if(d==="auto"){const w=a.LANG;return!w||w.search(/\.UTF\-8$/)===-1&&w.search(/\.utf8$/)===-1&&w.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function g(a){const d=a?a.split("-"):[],w=d.length;if(w===0)return"en_US.UTF-8";if(w===1){const P={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};d[0]in P&&d.push(P[d[0]])}else d[1]=d[1].toUpperCase();return d.join("_")+".UTF-8"}e.getLangEnvVariable=g;function S(a,d,w,P,O,$){if(a.cwd){const T=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,U=c(T,w);return h(U||T)}let L;return!a.ignoreConfigurationCwd&&O&&(w&&(O=c(O,w,$)),O&&(_.isAbsolute(O)?L=O:P&&(L=_.join(P.fsPath,O)))),L||(L=P?P.fsPath:d||""),h(L)}e.getCwd=S;function c(a,d,w){if(d)try{return d(a)}catch(P){w?.error("Could not resolve terminal cwd",P);return}return a}function h(a){return p.OS===1&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function m(a,d,w){if(!!w)return P=>w.resolveWithEnvironment(d,a,P)}e.createVariableResolver=m;function y(a,d,w,P,O,$,L,T=p.platform){let U;L&&(U=f(a,"automationShell",T)),U||(U=f(a,"shell",T));let N=U||d;if(T===3&&!w&&P){const W=_.join(P,"Sysnative").replace(/\//g,"\\").toLowerCase();N&&N.toLowerCase().indexOf(W)===0&&(N=_.join(P,"System32",N.substr(W.length+1)))}if(N&&T===3&&(N=N.replace(/\//g,"\\")),O)try{N=O(N)}catch(W){$.error("Could not resolve shell",W)}return N}e.getDefaultShell=y;function b(a,d,w,P,O=p.platform){if(d&&f(a,"automationShell",O))return[];const $=O===3?"windows":O===1?"osx":"linux";let L=a(`terminal.integrated.shellArgs.${$}`);if(!L)return[];if(typeof L=="string"&&O===3)return w?w(L):L;if(w){const T=[];for(const U of L)try{T.push(w(U))}catch(N){P.error(`Could not resolve terminal.integrated.shellArgs.${$}`,N),T.push(U)}L=T}return L}e.getDefaultShellArgs=b;function f(a,d,w=p.platform){return a(`terminal.integrated.${d}.${w===3?"windows":w===1?"osx":"linux"}`)}function E(a,d,w,P,O,$){const L={};if(a.strictEnv)I(L,a.env);else{I(L,$);const T={...d};w&&(T&&A(w,T),a.env&&A(w,a.env)),(0,t.sanitizeProcessEnvironment)(L,"VSCODE_IPC_HOOK_CLI"),k(L,T),k(L,a.env),v(L,P,p.locale,O)}return L}e.createTerminalEnvironment=E;var u;(function(a){a.WindowsPwsh="windows-pwsh",a.WindowsPwshLogin="windows-pwsh-login",a.Pwsh="pwsh",a.PwshLogin="pwsh-login",a.Zsh="zsh",a.ZshLogin="zsh-login",a.Bash="bash"})(u=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(u.WindowsPwsh,["-noexit"," -command",'. "${execInstallFolder}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{0}']),e.shellIntegrationArgs.set(u.WindowsPwshLogin,["-l","-noexit"," -command",'. "${execInstallFolder}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{0}']),e.shellIntegrationArgs.set(u.Pwsh,["-noexit","-command",'. "${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{0}']),e.shellIntegrationArgs.set(u.PwshLogin,["-l","-noexit","-command",'. "${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(u.Zsh,["-i"]),e.shellIntegrationArgs.set(u.ZshLogin,["-il"]),e.shellIntegrationArgs.set(u.Bash,["--init-file","${execInstallFolder}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const o=["-login","-l"],l=["-nol","-nologo"];function s(a,d,w,P,O,$){if(!P||!O.executable||O.isFeatureTerminal)return{args:O.args,enableShellIntegration:!1};const L=O.args,T=_.basename(O.executable).toLowerCase();let U;if($===1){if(T==="pwsh.exe"&&(!L||r(L)?U=e.shellIntegrationArgs.get(u.WindowsPwsh):n(L)?U=e.shellIntegrationArgs.get(u.WindowsPwshLogin):a.warn(`Shell integration cannot be enabled when custom args ${L} are provided for ${T} on Windows.`)),U){const W=d.getValue("terminal.integrated.shellIntegration.showWelcome")?"":" -HideWelcome";U=[...U],U[U.length-1]=(0,C.format)(U[U.length-1],W)}}else{switch(T){case"bash":{!L||L.length===0?U=e.shellIntegrationArgs.get(u.Bash):i(L)&&(w.VSCODE_SHELL_LOGIN="1",U=e.shellIntegrationArgs.get(u.Bash)),d.getValue("terminal.integrated.shellIntegration.showWelcome")||(w.VSCODE_SHELL_HIDE_WELCOME="1");break}case"pwsh":{if(!L||r(L)?U=e.shellIntegrationArgs.get(u.Pwsh):n(L)&&(U=e.shellIntegrationArgs.get(u.PwshLogin)),U){const W=d.getValue("terminal.integrated.shellIntegration.showWelcome")?"":" -HideWelcome";U=[...U],U[U.length-1]=(0,C.format)(U[U.length-1],W)}break}case"zsh":{!L||L.length===0?U=e.shellIntegrationArgs.get(u.Zsh):i(L)?U=e.shellIntegrationArgs.get(u.ZshLogin):(L===e.shellIntegrationArgs.get(u.Zsh)||L===e.shellIntegrationArgs.get(u.ZshLogin))&&(U=L),w._ZDOTDIR="1",d.getValue("terminal.integrated.shellIntegration.showWelcome")||(w.VSCODE_SHELL_HIDE_WELCOME="1");break}}U||a.warn(`Shell integration cannot be enabled when custom args ${L} are provided for ${T}.`)}return{args:U||L,enableShellIntegration:U!==void 0}}e.injectShellIntegrationArgs=s;function n(a){return typeof a=="string"?o.includes(a.toLowerCase()):a.length===1&&o.includes(a[0].toLowerCase())||a.length===2&&(o.includes(a[0].toLowerCase())||o.includes(a[1].toLowerCase()))&&(l.includes(a[0].toLowerCase())||l.includes(a[1].toLowerCase()))}function r(a){return typeof a=="string"?l.includes(a.toLowerCase()):a.length===0||a?.length===1&&l.includes(a[0].toLowerCase())}function i(a){return a==="string"&&o.includes(a.toLowerCase())||typeof a!="string"&&a.length===1&&o.includes(a[0].toLowerCase())}}),define(we[232],ye([0,1,4,51]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var p;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(p=e.TestResultState||(e.TestResultState={}));var C;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(r){r.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),r.deserialize=i=>({range:t.Range.lift(i.range),uri:_.URI.revive(i.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var D;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var v;(function(r){r.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&k.serialize(i.location)}),r.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&k.deserialize(i.location)})})(v=e.ITestErrorMessage||(e.ITestErrorMessage={}));var I;(function(r){r.serialize=i=>({message:i.message,type:1,offset:i.offset,location:i.location&&k.serialize(i.location)}),r.deserialize=i=>({message:i.message,type:1,offset:i.offset,location:i.location&&k.deserialize(i.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var A;(function(r){r.serialize=i=>i.type===0?v.serialize(i):I.serialize(i),r.deserialize=i=>i.type===0?v.deserialize(i):I.deserialize(i)})(A=e.ITestMessage||(e.ITestMessage={}));var R;(function(r){r.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(A.serialize)}),r.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(A.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const g="\0",S=(r,i)=>r+g+i;e.namespaceTestTag=S;const c=r=>{const i=r.indexOf(g);return{ctrlId:r.slice(0,i),tagId:r.slice(i+1)}};e.denamespaceTestTag=c;var h;(function(r){r.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),r.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?_.URI.revive(i.uri):void 0,range:i.range?t.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(h=e.ITestItem||(e.ITestItem={}));var m;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(m=e.TestItemExpandState||(e.TestItemExpandState={}));var y;(function(r){r.serialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:h.serialize(i.item)}),r.deserialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:h.deserialize(i.item)})})(y=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(r){r.serialize=i=>{let a;return i.item&&(a={},i.item.label!==void 0&&(a.label=i.item.label),i.item.tags!==void 0&&(a.tags=i.item.tags),i.item.busy!==void 0&&(a.busy=i.item.busy),i.item.uri!==void 0&&(a.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(a.range=i.item.range?.toJSON()),i.item.description!==void 0&&(a.description=i.item.description),i.item.error!==void 0&&(a.error=i.item.error),i.item.sortText!==void 0&&(a.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:a}},r.deserialize=i=>{let a;return i.item&&(a={},i.item.label!==void 0&&(a.label=i.item.label),i.item.tags!==void 0&&(a.tags=i.item.tags),i.item.busy!==void 0&&(a.busy=i.item.busy),i.item.range!==void 0&&(a.range=i.item.range?t.Range.lift(i.item.range):null),i.item.description!==void 0&&(a.description=i.item.description),i.item.error!==void 0&&(a.error=i.item.error),i.item.sortText!==void 0&&(a.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:a}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(r,i)=>{i.expand!==void 0&&(r.expand=i.expand),i.item!==void 0&&(r.item=r.item?Object.assign(r.item,i.item):i.item)};e.applyTestItemUpdate=f;var E;(function(r){r.serialize=(i,a)=>({...y.serialize(i),children:a,ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(R.serialize)})})(E=e.TestResultItem||(e.TestResultItem={}));var u;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var o;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(r){r.deserialize=i=>i.op===0?{op:i.op,item:y.deserialize(i.item)}:i.op===1?{op:i.op,item:b.deserialize(i.item)}:i,r.serialize=i=>i.op===0?{op:i.op,item:y.serialize(i.item)}:i.op===1?{op:i.op,item:b.serialize(i.item)}:i})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(i){}update(i){}remove(i,a){}complete(){}}e.IncrementalChangeCollector=s;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const a=this.createChangeCollector();for(const d of i)switch(d.op){case 0:{const w=y.deserialize(d.item);if(w.parent){if(this.items.has(w.parent)){const P=this.items.get(w.parent);P.children.add(w.item.extId);const O=this.createItem(w,P);this.items.set(w.item.extId,O),a.add(O)}}else{const P=this.createItem(w);this.roots.add(P),this.items.set(w.item.extId,P),a.add(P)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=b.deserialize(d.item),P=this.items.get(w.extId);if(!P)break;w.expand!==void 0&&(P.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(P,w),a.update(P);break}case 2:{const w=this.items.get(d.itemId);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const P=[[d.itemId]];for(;P.length;)for(const O of P.pop()){const $=this.items.get(O);$&&(P.push($.children),this.items.delete(O),a.remove($,$!==w),$.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d.itemId);break;case 3:this.updatePendingRoots(d.amount);break;case 5:this._tags.set(d.tag.id,d.tag);break;case 6:this._tags.delete(d.id);break}a.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=n}),define(we[233],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var _;(function(C){C.Delimiter="\0"})(_=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class p{constructor(k,D=k.length){if(this.path=k,this.viewEnd=D,k.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,D,v=k.parent){if(k.id===D)return new p([D]);let I=[k.id];for(let A=v;A&&A.id!==D;A=A.parent)I.push(A.id);return I.push(D),new p(I.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const D=k.indexOf("\0");return D===-1?k:k.slice(0,D)}static fromString(k){return new p(k.split("\0"))}static join(k,D){return new p([...k.path,D])}static joinToString(k,D){return k.toString()+"\0"+D}static compare(k,D){return k===D?0:D.startsWith(k+"\0")?2:k.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new p(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new p(this.path,k)}compare(k){if(typeof k=="string")return p.compare(this.toString(),k);for(let D=0;D<k.viewEnd&&D<this.viewEnd;D++)if(k.path[D]!==this.path[D])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=p}),define(we[234],ye([0,1,28,6]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(_.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(we[235],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,_.createDecorator)("configurationResolverService")}),define(we[236],ye([0,1,5,24,12,21,3,79,168]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(R,g,S,c){this._contributedVariables=new Map,this._context=R,this._labelService=g,this._userHomePromise=S,c&&(this._envVariablesPromise=c.then(h=>this.prepareEnv(h)))}prepareEnv(R){if(k.isWindows){const g=Object.create(null);return Object.keys(R).forEach(S=>{g[S.toLowerCase()]=R[S]}),g}return R}resolveWithEnvironment(R,g,S){return this.recursiveResolve({env:this.prepareEnv(R)},g?g.uri:void 0,S)}async resolveAsync(R,g){const S={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(S,R?R.uri:void 0,g)}async resolveAnyBase(R,g,S,c){const h=C.deepClone(g);k.isWindows&&h.windows?Object.keys(h.windows).forEach(y=>h[y]=h.windows[y]):k.isMacintosh&&h.osx?Object.keys(h.osx).forEach(y=>h[y]=h.osx[y]):k.isLinux&&h.linux&&Object.keys(h.linux).forEach(y=>h[y]=h.linux[y]),delete h.windows,delete h.osx,delete h.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,R?R.uri:void 0,h,S,c)}async resolveAnyAsync(R,g,S){return this.resolveAnyBase(R,g,S)}async resolveAnyMap(R,g,S){const c=new Map;return{newConfig:await this.resolveAnyBase(R,g,S,c),resolvedVariables:c}}resolveWithInteractionReplace(R,g,S,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(R,g,S,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(R,g){if(this._contributedVariables.has(R))throw new Error("Variable "+R+" is contributed twice.");this._contributedVariables.set(R,g)}recursiveResolve(R,g,S,c,h){if(p.isString(S))return this.resolveString(R,g,S,c,h);if(p.isArray(S))return S.map(m=>this.recursiveResolve(R,g,m,c,h));if(p.isObject(S)){let m=Object.create(null);return Object.keys(S).forEach(y=>{const b=this.resolveString(R,g,y,c,h);m[b]=this.recursiveResolve(R,g,S[y],c,h)}),m}return S}resolveString(R,g,S,c,h){return S.replace(I.VARIABLE_REGEXP,(y,b)=>{if(b.includes(I.VARIABLE_LHS))return y;let f=this.evaluateSingleVariable(R,y,b,g,c);return h&&h.set(b,f),f!==y&&p.isString(f)&&f.match(I.VARIABLE_REGEXP)&&(f=this.resolveString(R,g,f,c,h)),f})}fsPath(R){return this._labelService?this._labelService.getUriLabel(R,{noPrefix:!0}):R.fsPath}evaluateSingleVariable(R,g,S,c,h){let m;const y=S.split(":");y.length>1&&(S=y[0],m=y[1]);const b=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,v.localize)(0,null,g))},f=()=>{const u=b();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,v.localize)(1,null,g,_.basename(u)))},E=()=>{if(m){const u=this._context.getFolderUri(m);if(u)return u;throw new Error((0,v.localize)(2,null,g,m))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,v.localize)(3,null,g)):new Error((0,v.localize)(4,null,g))};switch(S){case"env":if(m){if(R.env){const u=R.env[k.isWindows?m.toLowerCase():m];if(p.isString(u))return u}return""}throw new Error((0,v.localize)(5,null,g));case"config":if(m){const u=this._context.getConfigurationValue(c,m);if(p.isUndefinedOrNull(u))throw new Error((0,v.localize)(6,null,g,m));if(p.isObject(u))throw new Error((0,v.localize)(7,null,g,m));return u}throw new Error((0,v.localize)(8,null,g));case"command":return this.resolveFromMap(g,m,h,"command");case"input":return this.resolveFromMap(g,m,h,"input");default:switch(S){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(E()));case"cwd":return c||m?(0,D.normalizeDriveLetter)(this.fsPath(E())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(E()));case"userHome":{if(R.userHome)return R.userHome;throw new Error((0,v.localize)(9,null,g))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new Error((0,v.localize)(10,null,g))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new Error((0,v.localize)(11,null,g))}case"file":return b();case"fileWorkspaceFolder":return f();case"relativeFile":return c||m?_.relative(this.fsPath(E()),b()):b();case"relativeFileDirname":{const u=_.dirname(b());if(c||m){const o=_.relative(this.fsPath(E()),u);return o.length===0?".":o}return u}case"fileDirname":return _.dirname(b());case"fileExtname":return _.extname(b());case"fileBasename":return _.basename(b());case"fileBasenameNoExtension":{const u=_.basename(b());return u.slice(0,u.length-_.extname(u).length)}case"fileDirnameBasename":return _.basename(_.dirname(b()));case"execPath":{const u=this._context.getExecPath();return u||g}case"execInstallFolder":{const u=this._context.getAppRoot();return u||g}case"pathSeparator":return _.sep;default:try{const u=m?`${S}:${m}`:S;return this.resolveFromMap(g,u,h,void 0)}catch{return g}}}}resolveFromMap(R,g,S,c){if(g&&S){const h=c===void 0?S[g]:S[c+":"+g];if(typeof h=="string")return h;throw new Error((0,v.localize)(12,null,R))}return R}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[237],ye([0,1,6,107]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var p;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(p=e.GroupDirection||(e.GroupDirection={}));var C;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var D;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function I(c){const h=c;return(0,t.isEditorInput)(h?.editor)&&(0,t.isEditorInput)(h?.replacement)}e.isEditorReplacement=I;var A;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function g(c){const h=c;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=g;function S(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(we[110],ye([0,1,6,237]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function p(C){const k=C;return typeof C=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=p}),define(we[238],ye([0,1,17,15,78,120,50,21,12,4,51,136,172,192,105,229,232,233,110,106]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(Ee){function Ce(G){const{selectionStartLineNumber:De,selectionStartColumn:_e,positionLineNumber:We,positionColumn:Ge}=G,it=new f.Position(De-1,_e-1),ot=new f.Position(We-1,Ge-1);return new f.Selection(it,ot)}Ee.to=Ce;function le(G){const{anchor:De,active:_e}=G;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:_e.line+1,positionColumn:_e.character+1}}Ee.from=le})(E=e.Selection||(e.Selection={}));var u;(function(Ee){function Ce(G){if(!G)return;const{start:De,end:_e}=G;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:_e.line+1,endColumn:_e.character+1}}Ee.from=Ce;function le(G){if(!G)return;const{startLineNumber:De,startColumn:_e,endLineNumber:We,endColumn:Ge}=G;return new f.Range(De-1,_e-1,We-1,Ge-1)}Ee.to=le})(u=e.Range||(e.Range={}));var o;(function(Ee){function Ce(le){switch(le){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 3:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}Ee.to=Ce})(o=e.TokenType||(e.TokenType={}));var l;(function(Ee){function Ce(G){return new f.Position(G.lineNumber-1,G.column-1)}Ee.to=Ce;function le(G){return{lineNumber:G.line+1,column:G.character+1}}Ee.from=le})(l=e.Position||(e.Position={}));var s;(function(Ee){function Ce(De,_e){return(0,_.coalesce)((0,_.asArray)(De).map(We=>le(We,_e)))}Ee.from=Ce;function le(De,_e){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:G(De.scheme,_e),pattern:ne.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function G(De,_e){return _e&&typeof De=="string"?_e.transformOutgoingScheme(De):De}})(s=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Ee){function Ce(G){switch(G){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}Ee.from=Ce;function le(G){switch(G){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}Ee.to=le})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(Ee){function Ce(G){let De;return G.code&&((0,v.isString)(G.code)||(0,v.isNumber)(G.code)?De=String(G.code):De={value:String(G.code.value),target:G.code.target}),{...u.from(G.range),message:G.message,source:G.source,code:De,severity:a.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(i.from),tags:Array.isArray(G.tags)?(0,_.coalesce)(G.tags.map(n.from)):void 0}}Ee.from=Ce;function le(G){const De=new f.Diagnostic(u.to(G),G.message,a.to(G.severity));return De.source=G.source,De.code=(0,v.isString)(G.code)?G.code:G.code?.value,De.relatedInformation=G.relatedInformation&&G.relatedInformation.map(i.to),De.tags=G.tags&&(0,_.coalesce)(G.tags.map(n.to)),De}Ee.to=le})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(Ee){function Ce(G){return{...u.from(G.location.range),message:G.message,resource:G.location.uri}}Ee.from=Ce;function le(G){return new f.DiagnosticRelatedInformation(new f.Location(G.resource,u.to(G)),G.message)}Ee.to=le})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(Ee){function Ce(G){switch(G){case f.DiagnosticSeverity.Error:return S.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return S.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return S.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return S.MarkerSeverity.Hint}return S.MarkerSeverity.Error}Ee.from=Ce;function le(G){switch(G){case S.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case S.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case S.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case S.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}Ee.to=le})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(Ee){function Ce(G){return typeof G=="number"&&G>=f.ViewColumn.One?G-1:G===f.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}Ee.from=Ce;function le(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=le})(d=e.ViewColumn||(e.ViewColumn={}));function w(Ee){return typeof Ee.range!="undefined"}function P(Ee){return Ee.length===0?!0:!!w(Ee[0])}e.isDecorationOptionsArr=P;var O;(function(Ee){function Ce(Ge){return Ge.map(Ee.from)}Ee.fromMany=Ce;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function G(Ge){let it;if(le(Ge)){const{language:lt,value:ut}=Ge;it={value:"```"+lt+`
`+ut+"\n```\n"}}else f.MarkdownString.isMarkdownString(Ge)?it={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?it={value:Ge}:it={value:""};const ot=Object.create(null);it.uris=ot;const Et=lt=>{try{let ut=I.URI.parse(lt,!0);ut=ut.with({query:De(ut.query,ot)}),ot[lt]=ut}catch{}return""},ct=new C.marked.Renderer;return ct.link=Et,ct.image=lt=>typeof lt=="string"?Et(p.parseHrefAndDimensions(lt).href):"",(0,C.marked)(it.value,{renderer:ct}),it}Ee.from=G;function De(Ge,it){if(!Ge)return Ge;let ot;try{ot=(0,k.parse)(Ge)}catch{}if(!ot)return Ge;let Et=!1;return ot=(0,D.cloneAndChange)(ot,ct=>{if(I.URI.isUri(ct)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[lt]=ct,Et=!0,lt}else return}),Et?JSON.stringify(ot):Ge}function _e(Ge){const it=new f.MarkdownString(Ge.value,Ge.supportThemeIcons);return it.isTrusted=Ge.isTrusted,it.supportHtml=Ge.supportHtml,it.baseUri=Ge.baseUri?I.URI.from(Ge.baseUri):void 0,it}Ee.to=_e;function We(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Ee.from(Ge)}Ee.fromStrict=We})(O=e.MarkdownString||(e.MarkdownString={}));function $(Ee){return P(Ee)?Ee.map(Ce=>({range:u.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?O.fromMany(Ce.hoverMessage):Ce.hoverMessage?O.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Ee.map(Ce=>({range:u.from(Ce)}))}e.fromRangeOrRangeWithMessage=$;function L(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?I.URI.file(Ee):Ee}e.pathOrURIToURI=L;var T;(function(Ee){function Ce(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?L(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}Ee.from=Ce})(T=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Ee){function Ce(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?L(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?T.from(le.before):void 0,after:le.after?T.from(le.after):void 0}}Ee.from=Ce})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var N;(function(Ee){function Ce(le){if(typeof le=="undefined")return le;switch(le){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ce})(N=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Ee){function Ce(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?N.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?U.from(le.light):void 0,dark:le.dark?U.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?L(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?T.from(le.before):void 0,after:le.after?T.from(le.after):void 0}}Ee.from=Ce})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(Ee){function Ce(G){return{text:G.newText,eol:G.newEol&&Me.from(G.newEol),range:u.from(G.range)}}Ee.from=Ce;function le(G){const De=new f.TextEdit(u.to(G.range),G.text);return De.newEol=typeof G.eol=="undefined"?void 0:Me.to(G.eol),De}Ee.to=le})(ie=e.TextEdit||(e.TextEdit={}));var j;(function(Ee){function Ce(G,De){const _e={edits:[]};if(G instanceof f.WorkspaceEdit)for(let We of G._allEntries())We._type===1?_e.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata}):We._type===2?_e.edits.push({_type:2,resource:We.uri,edit:ie.from(We.edit),modelVersionId:De?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?_e.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(We.uri)}):We._type===5&&_e.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:De?.getNotebookDocumentVersion(We.uri),edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Ve.from)}});return _e}Ee.from=Ce;function le(G){const De=new f.WorkspaceEdit;for(const _e of G.edits)_e.edit?De.replace(I.URI.revive(_e.resource),u.to(_e.edit.range),_e.edit.text):De.renameFile(I.URI.revive(_e.oldUri),I.URI.revive(_e.newUri),_e.options);return De}Ee.to=le})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var re;(function(Ee){const Ce=Object.create(null);Ce[f.SymbolKind.File]=0,Ce[f.SymbolKind.Module]=1,Ce[f.SymbolKind.Namespace]=2,Ce[f.SymbolKind.Package]=3,Ce[f.SymbolKind.Class]=4,Ce[f.SymbolKind.Method]=5,Ce[f.SymbolKind.Property]=6,Ce[f.SymbolKind.Field]=7,Ce[f.SymbolKind.Constructor]=8,Ce[f.SymbolKind.Enum]=9,Ce[f.SymbolKind.Interface]=10,Ce[f.SymbolKind.Function]=11,Ce[f.SymbolKind.Variable]=12,Ce[f.SymbolKind.Constant]=13,Ce[f.SymbolKind.String]=14,Ce[f.SymbolKind.Number]=15,Ce[f.SymbolKind.Boolean]=16,Ce[f.SymbolKind.Array]=17,Ce[f.SymbolKind.Object]=18,Ce[f.SymbolKind.Key]=19,Ce[f.SymbolKind.Null]=20,Ce[f.SymbolKind.EnumMember]=21,Ce[f.SymbolKind.Struct]=22,Ce[f.SymbolKind.Event]=23,Ce[f.SymbolKind.Operator]=24,Ce[f.SymbolKind.TypeParameter]=25;function le(De){return typeof Ce[De]=="number"?Ce[De]:6}Ee.from=le;function G(De){for(const _e in Ce)if(Ce[_e]===De)return Number(_e);return f.SymbolKind.Property}Ee.to=G})(re=e.SymbolKind||(e.SymbolKind={}));var x;(function(Ee){function Ce(G){switch(G){case f.SymbolTag.Deprecated:return 1}}Ee.from=Ce;function le(G){switch(G){case 1:return f.SymbolTag.Deprecated}}Ee.to=le})(x=e.SymbolTag||(e.SymbolTag={}));var K;(function(Ee){function Ce(G){return{name:G.name,kind:re.from(G.kind),tags:G.tags&&G.tags.map(x.from),containerName:G.containerName,location:Y.from(G.location)}}Ee.from=Ce;function le(G){const De=new f.SymbolInformation(G.name,re.to(G.kind),G.containerName,Y.to(G.location));return De.tags=G.tags&&G.tags.map(x.to),De}Ee.to=le})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(Ee){function Ce(G){const De={name:G.name||"!!MISSING: name!!",detail:G.detail,range:u.from(G.range),selectionRange:u.from(G.selectionRange),kind:re.from(G.kind),tags:G.tags?.map(x.from)??[]};return G.children&&(De.children=G.children.map(Ce)),De}Ee.from=Ce;function le(G){const De=new f.DocumentSymbol(G.name,G.detail,re.to(G.kind),u.to(G.range),u.to(G.selectionRange));return(0,_.isNonEmptyArray)(G.tags)&&(De.tags=G.tags.map(x.to)),G.children&&(De.children=G.children.map(le)),De}Ee.to=le})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(Ee){function Ce(G){const De=new f.CallHierarchyItem(re.to(G.kind),G.name,G.detail||"",I.URI.revive(G.uri),u.to(G.range),u.to(G.selectionRange));return De._sessionId=G._sessionId,De._itemId=G._itemId,De}Ee.to=Ce;function le(G,De,_e){if(De=De??G._sessionId,_e=_e??G._itemId,De===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:_e,name:G.name,detail:G.detail,kind:re.from(G.kind),uri:G.uri,range:u.from(G.range),selectionRange:u.from(G.selectionRange),tags:G.tags?.map(x.from)}}Ee.from=le})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(Ee){function Ce(le){return new f.CallHierarchyIncomingCall(ce.to(le.from),le.fromRanges.map(G=>u.to(G)))}Ee.to=Ce})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(Ee){function Ce(le){return new f.CallHierarchyOutgoingCall(ce.to(le.to),le.fromRanges.map(G=>u.to(G)))}Ee.to=Ce})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Y;(function(Ee){function Ce(G){return{range:G.range&&u.from(G.range),uri:G.uri}}Ee.from=Ce;function le(G){return new f.Location(I.URI.revive(G.uri),u.to(G.range))}Ee.to=le})(Y=e.location||(e.location={}));var z;(function(Ee){function Ce(G){const De=G,_e=G;return{originSelectionRange:De.originSelectionRange?u.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:_e.uri,range:u.from(De.targetRange?De.targetRange:_e.range),targetSelectionRange:De.targetSelectionRange?u.from(De.targetSelectionRange):void 0}}Ee.from=Ce;function le(G){return{targetUri:I.URI.revive(G.uri),targetRange:u.to(G.range),targetSelectionRange:G.targetSelectionRange?u.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?u.to(G.originSelectionRange):void 0}}Ee.to=le})(z=e.DefinitionLink||(e.DefinitionLink={}));var H;(function(Ee){function Ce(G){return{range:u.from(G.range),contents:O.fromMany(G.contents)}}Ee.from=Ce;function le(G){return new f.Hover(G.contents.map(O.to),u.to(G.range))}Ee.to=le})(H=e.Hover||(e.Hover={}));var q;(function(Ee){function Ce(G){return{range:u.from(G.range),expression:G.expression}}Ee.from=Ce;function le(G){return new f.EvaluatableExpression(u.to(G.range),G.expression)}Ee.to=le})(q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ee;(function(Ee){function Ce(G){if(G instanceof f.InlineValueText)return{type:"text",range:u.from(G.range),text:G.text};if(G instanceof f.InlineValueVariableLookup)return{type:"variable",range:u.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ce;function le(G){switch(G.type){case"text":return{range:u.to(G.range),text:G.text};case"variable":return{range:u.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:u.to(G.range),expression:G.expression}}}Ee.to=le})(ee=e.InlineValue||(e.InlineValue={}));var he;(function(Ee){function Ce(G){return{frameId:G.frameId,stoppedLocation:u.from(G.stoppedLocation)}}Ee.from=Ce;function le(G){return new f.InlineValueContext(G.frameId,u.to(G.stoppedLocation))}Ee.to=le})(he=e.InlineValueContext||(e.InlineValueContext={}));var Ie;(function(Ee){function Ce(G){return{range:u.from(G.range),kind:G.kind}}Ee.from=Ce;function le(G){return new f.DocumentHighlight(u.to(G.range),G.kind)}Ee.to=le})(Ie=e.DocumentHighlight||(e.DocumentHighlight={}));var se;(function(Ee){function Ce(le){switch(le){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}Ee.to=Ce})(se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var fe;(function(Ee){function Ce(le){return{triggerKind:se.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}Ee.to=Ce})(fe=e.CompletionContext||(e.CompletionContext={}));var ve;(function(Ee){function Ce(G){switch(G){case f.CompletionItemTag.Deprecated:return 1}}Ee.from=Ce;function le(G){switch(G){case 1:return f.CompletionItemTag.Deprecated}}Ee.to=le})(ve=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(Ee){const Ce=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function le(_e){return Ce.get(_e)??9}Ee.from=le;const G=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function De(_e){return G.get(_e)??f.CompletionItemKind.Property}Ee.to=De})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var B;(function(Ee){function Ce(le,G){const De=new f.CompletionItem(le.label);return De.insertText=le.insertText,De.kind=X.to(le.kind),De.tags=le.tags?.map(ve.to),De.detail=le.detail,De.documentation=p.isMarkdownString(le.documentation)?O.to(le.documentation):le.documentation,De.sortText=le.sortText,De.filterText=le.filterText,De.preselect=le.preselect,De.commitCharacters=le.commitCharacters,A.Range.isIRange(le.range)?De.range=u.to(le.range):typeof le.range=="object"&&(De.range={inserting:u.to(le.range.insert),replacing:u.to(le.range.replace)}),De.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?De.insertText=new f.SnippetString(le.insertText):(De.insertText=le.insertText,De.textEdit=De.range instanceof f.Range?new f.TextEdit(De.range,De.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(De.additionalTextEdits=le.additionalTextEdits.map(_e=>ie.to(_e))),De.command=G&&le.command?G.fromInternal(le.command):void 0,De}Ee.to=Ce})(B=e.CompletionItem||(e.CompletionItem={}));var V;(function(Ee){function Ce(G){return{label:G.label,documentation:O.fromStrict(G.documentation)}}Ee.from=Ce;function le(G){return{label:G.label,documentation:p.isMarkdownString(G.documentation)?O.to(G.documentation):G.documentation}}Ee.to=le})(V=e.ParameterInformation||(e.ParameterInformation={}));var Q;(function(Ee){function Ce(G){return{label:G.label,documentation:O.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(V.from):[],activeParameter:G.activeParameter}}Ee.from=Ce;function le(G){return{label:G.label,documentation:p.isMarkdownString(G.documentation)?O.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(V.to):[],activeParameter:G.activeParameter}}Ee.to=le})(Q=e.SignatureInformation||(e.SignatureInformation={}));var ue;(function(Ee){function Ce(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Q.from):[]}}Ee.from=Ce;function le(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Q.to):[]}}Ee.to=le})(ue=e.SignatureHelp||(e.SignatureHelp={}));var pe;(function(Ee){function Ce(le,G){const De=new f.InlayHint(l.to(G.position),typeof G.label=="string"?G.label:G.label.map(Pe.to.bind(void 0,le)),G.kind&&Re.to(G.kind));return De.tooltip=p.isMarkdownString(G.tooltip)?O.to(G.tooltip):G.tooltip,De.paddingLeft=G.paddingLeft,De.paddingRight=G.paddingRight,De}Ee.to=Ce})(pe=e.InlayHint||(e.InlayHint={}));var Pe;(function(Ee){function Ce(le,G){const De=new f.InlayHintLabelPart(G.label);return De.tooltip=p.isMarkdownString(G.tooltip)?O.to(G.tooltip):G.tooltip,R.Command.is(G.command)&&(De.command=le.fromInternal(G.command)),G.location&&(De.location=Y.to(G.location)),De}Ee.to=Ce})(Pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Re;(function(Ee){function Ce(G){return G}Ee.from=Ce;function le(G){return G}Ee.to=le})(Re=e.InlayHintKind||(e.InlayHintKind={}));var Fe;(function(Ee){function Ce(G){return{range:u.from(G.range),url:G.target,tooltip:G.tooltip}}Ee.from=Ce;function le(G){let De;if(G.url)try{De=typeof G.url=="string"?I.URI.parse(G.url,!0):I.URI.revive(G.url)}catch{}return new f.DocumentLink(u.to(G.range),De)}Ee.to=le})(Fe=e.DocumentLink||(e.DocumentLink={}));var Ue;(function(Ee){function Ce(G){const De=new f.ColorPresentation(G.label);return G.textEdit&&(De.textEdit=ie.to(G.textEdit)),G.additionalTextEdits&&(De.additionalTextEdits=G.additionalTextEdits.map(_e=>ie.to(_e))),De}Ee.to=Ce;function le(G){return{label:G.label,textEdit:G.textEdit?ie.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(De=>ie.from(De)):void 0}}Ee.from=le})(Ue=e.ColorPresentation||(e.ColorPresentation={}));var ae;(function(Ee){function Ce(G){return new f.Color(G[0],G[1],G[2],G[3])}Ee.to=Ce;function le(G){return[G.red,G.green,G.blue,G.alpha]}Ee.from=le})(ae=e.Color||(e.Color={}));var ge;(function(Ee){function Ce(G){return{range:u.from(G.range)}}Ee.from=Ce;function le(G){return new f.SelectionRange(u.to(G.range))}Ee.to=le})(ge=e.SelectionRange||(e.SelectionRange={}));var de;(function(Ee){function Ce(le){switch(le){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}Ee.to=Ce})(de=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(Ee){function Ce(G){switch(G){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ce;function le(G){switch(G){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}Ee.to=le})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Me;(function(Ee){function Ce(G){if(G===f.EndOfLine.CRLF)return 1;if(G===f.EndOfLine.LF)return 0}Ee.from=Ce;function le(G){if(G===1)return f.EndOfLine.CRLF;if(G===0)return f.EndOfLine.LF}Ee.to=le})(Me=e.EndOfLine||(e.EndOfLine={}));var He;(function(Ee){function Ce(le){if(typeof le=="object")return le.viewId;switch(le){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ce})(He=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(Ee){function Ce(le){const G={start:le.start+1,end:le.end+1};return le.kind&&(G.kind=je.from(le.kind)),G}Ee.from=Ce})(Be=e.FoldingRange||(e.FoldingRange={}));var je;(function(Ee){function Ce(le){if(le)switch(le){case f.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}Ee.from=Ce})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var qe;(function(Ee){function Ce(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?u.from(le.selection):void 0,override:typeof le.override=="boolean"?g.EditorResolution.DISABLED:void 0}}Ee.from=Ce})(qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ne;(function(Ee){function Ce(_e){return _e instanceof f.RelativePattern?_e.toJSON():typeof _e=="string"?_e:le(_e)||G(_e)?new f.RelativePattern(_e.baseUri??_e.base,_e.pattern).toJSON():_e}Ee.from=Ce;function le(_e){const We=_e;return We?I.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function G(_e){const We=_e;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function De(_e){return typeof _e=="string"?_e:new f.RelativePattern(I.URI.revive(_e.baseUri),_e.pattern)}Ee.to=De})(ne=e.GlobPattern||(e.GlobPattern={}));var be;(function(Ee){function Ce(le){if(le){if(Array.isArray(le))return le.map(Ce);if(typeof le=="string")return le;{const G=le;return{language:G.language,scheme:G.scheme,pattern:ne.from(G.pattern),exclusive:G.exclusive}}}else return}Ee.from=Ce})(be=e.LanguageSelector||(e.LanguageSelector={}));var ke;(function(Ee){function Ce(G){return{start:G.start,end:G.end}}Ee.from=Ce;function le(G){return new f.NotebookRange(G.start,G.end)}Ee.to=le})(ke=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Ee){function Ce(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ee.to=Ce;function le(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ee.from=le})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ne;(function(Ee){function Ce(le){if(le===h.NotebookCellExecutionState.Executing)return f.NotebookCellExecutionState.Executing;if(le===h.NotebookCellExecutionState.Pending)return f.NotebookCellExecutionState.Pending;if(le===h.NotebookCellExecutionState.Unconfirmed)return f.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${le}`)}Ee.to=Ce})(Ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Qe;(function(Ee){function Ce(G){switch(G){case f.NotebookCellKind.Markup:return h.CellKind.Markup;case f.NotebookCellKind.Code:default:return h.CellKind.Code}}Ee.from=Ce;function le(G){switch(G){case h.CellKind.Markup:return f.NotebookCellKind.Markup;case h.CellKind.Code:default:return f.NotebookCellKind.Code}}Ee.to=le})(Qe=e.NotebookCellKind||(e.NotebookCellKind={}));var $e;(function(Ee){function Ce(G){const De={metadata:G.metadata??Object.create(null),cells:[]};for(let _e of G.cells)f.NotebookCellData.validate(_e),De.cells.push(Ve.from(_e));return De}Ee.from=Ce;function le(G){const De=new f.NotebookData(G.cells.map(Ve.to));return(0,v.isEmptyObject)(G.metadata)||(De.metadata=G.metadata),De}Ee.to=le})($e=e.NotebookData||(e.NotebookData={}));var Ve;(function(Ee){function Ce(G){return{cellKind:Qe.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Le.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(xe.from):[]}}Ee.from=Ce;function le(G){return new f.NotebookCellData(Qe.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(xe.to):void 0,G.metadata,G.internalMetadata?Le.to(G.internalMetadata):void 0)}Ee.to=le})(Ve=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(Ee){function Ce(G){return{mime:G.mime,valueBytes:t.VSBuffer.wrap(G.data)}}Ee.from=Ce;function le(G){return new f.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}Ee.to=le})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var xe;(function(Ee){function Ce(G){return{outputId:G.id,items:G.items.map(Ye.from),metadata:G.metadata}}Ee.from=Ce;function le(G){const De=G.items.map(Ye.to);return new f.NotebookCellOutput(De,G.outputId,G.metadata)}Ee.to=le})(xe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ze;(function(Ee){function Ce(De){return G(De)?{include:(0,v.withNullAsUndefined)(ne.from(De.include)),exclude:(0,v.withNullAsUndefined)(ne.from(De.exclude))}:(0,v.withNullAsUndefined)(ne.from(De))}Ee.from=Ce;function le(De){return G(De)?{include:ne.to(De.include),exclude:ne.to(De.exclude)}:ne.to(De)}Ee.to=le;function G(De){const _e=De;return _e?!!_e.include&&!!_e.exclude:!1}})(Ze=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var et;(function(Ee){function Ce(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?T.from(le.top):void 0}}Ee.from=Ce})(et=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var rt;(function(Ee){function Ce(le,G,De){const _e=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(_e,De),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}Ee.from=Ce})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(Ee){function Ce(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}Ee.from=Ce})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var pt;(function(Ee){function Ce(G){return{uri:G.uri,provides:G.provides}}Ee.from=Ce;function le(G){return new f.NotebookRendererScript(I.URI.revive(G.uri),G.provides)}Ee.to=le})(pt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var gt;(function(Ee){function Ce(G){return{message:O.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:u.from(G.location.range),uri:G.location.uri}}}Ee.from=Ce;function le(G){const De=new f.TestMessage(typeof G.message=="string"?G.message:O.to(G.message));return De.actualOutput=G.actual,De.expectedOutput=G.expected,De.location=G.location?Y.to(G.location):void 0,De}Ee.to=le})(gt=e.TestMessage||(e.TestMessage={}));var dt;(function(Ee){Ee.namespace=m.namespaceTestTag,Ee.denamespace=m.denamespaceTestTag})(dt=e.TestTag||(e.TestTag={}));var St;(function(Ee){function Ce(_e){const We=(0,c.getPrivateApiFor)(_e).controllerId;return{extId:y.TestId.fromExtHostTestItem(_e,We).toString(),label:_e.label,uri:I.URI.revive(_e.uri),busy:!1,tags:_e.tags.map(Ge=>dt.namespace(We,Ge.id)),range:A.Range.lift(u.from(_e.range)),description:_e.description||null,sortText:_e.sortText||null,error:_e.error&&O.fromStrict(_e.error)||null}}Ee.from=Ce;function le(_e){return{parent:void 0,error:void 0,id:y.TestId.fromString(_e.extId).localId,label:_e.label,uri:I.URI.revive(_e.uri),tags:(_e.tags||[]).map(We=>{const{tagId:Ge}=dt.denamespace(We);return new f.TestTag(Ge)}),range:u.to(_e.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:_e.description||void 0,sortText:_e.sortText||void 0}}Ee.toPlain=le;function G(_e){const We=y.TestId.fromString(_e.extId),Ge=new c.TestItemImpl(We.controllerId,We.localId,_e.label,I.URI.revive(_e.uri)||void 0);return Ge.range=u.to(_e.range||void 0),Ge.description=_e.description||void 0,Ge.sortText=_e.sortText||void 0,Ge}function De(_e){let We;for(const Ge of _e.tests){const it=G(Ge.item);(0,c.getPrivateApiFor)(it).parent=We,We=it}return We}Ee.toItemFromContext=De})(St=e.TestItem||(e.TestItem={})),function(Ee){function Ce(G){return{id:G.id}}Ee.from=Ce;function le(G){return new f.TestTag(G.id)}Ee.to=le}(dt=e.TestTag||(e.TestTag={}));var Dt;(function(Ee){const Ce=(G,De)=>{const _e={...St.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(Ge=>Ge.type===0).map(gt.to)})),children:G.children.map(We=>De.get(We)).filter(v.isDefined).map(We=>Ce(We,De))};for(const We of _e.children)We.parent=_e;return _e};function le(G){const De=[],_e=new Map;for(const We of G.items)_e.set(We.item.extId,We),G.request.targets.some(Ge=>Ge.controllerId===We.controllerId&&Ge.testIds.includes(We.item.extId))&&De.push(We);return{completedAt:G.completedAt,results:De.map(We=>Ce(We,_e))}}Ee.to=le})(Dt=e.TestResults||(e.TestResults={}));var Pt;(function(Ee){function Ce(_e){return{covered:_e.covered,total:_e.covered}}function le(_e){return"line"in _e?l.from(_e):u.from(_e)}function G(_e){return"branches"in _e?{count:_e.executionCount,location:le(_e.location),type:1,branches:_e.branches.length?_e.branches.map(We=>({count:We.executionCount,location:We.location&&le(We.location)})):void 0}:{type:0,count:_e.executionCount,location:le(_e.location)}}Ee.fromDetailed=G;function De(_e){return{uri:_e.uri,statement:Ce(_e.statementCoverage),branch:_e.branchCoverage&&Ce(_e.branchCoverage),function:_e.functionCoverage&&Ce(_e.functionCoverage),details:_e.detailedCoverage?.map(G)}}Ee.fromFile=De})(Pt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(Ee){function Ce(le){switch(le){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}Ee.to=Ce})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(Ee){function Ce(G){const De=new f.TypeHierarchyItem(re.to(G.kind),G.name,G.detail||"",I.URI.revive(G.uri),u.to(G.range),u.to(G.selectionRange));return De._sessionId=G._sessionId,De._itemId=G._itemId,De}Ee.to=Ce;function le(G,De,_e){if(De=De??G._sessionId,_e=_e??G._itemId,De===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:_e,kind:re.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:u.from(G.range),selectionRange:u.from(G.selectionRange),tags:G.tags?.map(x.from)}}Ee.from=le})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[239],ye([0,1,12,234,14,96,103,109,235,107,110,8,188,108]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let c=class{constructor(m,y,b,f,E,u,o,l,s,n){this._remoteAuthority=m,this._channel=y,this._configurationService=b,this._workspaceContextService=f,this._resolverService=E,this._environmentVariableService=u,this._remoteAuthorityResolverService=o,this._logService=l,this._editorService=s,this._labelService=n}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(m,y,b,f,E,u,o){await this._configurationService.whenRemoteConfigurationLoaded();const l=Object.create(null),s=b?(0,_.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(b)):void 0;let n;try{n=(await this._resolverService.resolveAnyMap(s,{shellLaunchConfig:m,configuration:y})).resolvedVariables}catch(L){this._logService.error(L)}if(n)for(const[L,T]of n.entries())(/^config:/.test(L)||L==="selectedText"||L==="lineNumber")&&(l[L]=T);const r=[];for(const[L,T]of this._environmentVariableService.collections.entries())r.push([L,(0,D.serializeEnvironmentVariableCollection)(T.map)]);const i=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),a=i.options&&i.options.extensionHostEnv,d=this._workspaceContextService.getWorkspace(),w=d.folders,P=b?this._workspaceContextService.getWorkspaceFolder(b):null,O=I.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:I.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.userData,R.Schemas.vscodeRemote]}),$={configuration:y,resolvedVariables:l,envVariableCollections:r,shellLaunchConfig:m,workspaceId:d.id,workspaceName:this._labelService.getWorkspaceLabel(d),workspaceFolders:w,activeWorkspaceFolder:P,activeFileResource:O,shouldPersistTerminal:f,cols:E,rows:u,unicodeVersion:o,resolverEnv:a};return await this._channel.call("$createProcess",$)}requestDetachInstance(m,y){return this._channel.call("$requestDetachInstance",[m,y])}acceptDetachInstanceReply(m,y){return this._channel.call("$acceptDetachInstanceReply",[m,y])}attachToProcess(m){return this._channel.call("$attachToProcess",[m])}detachFromProcess(m){return this._channel.call("$detachFromProcess",[m])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(m,y){return this._channel.call("$processBinary",[m,y])}start(m){return this._channel.call("$start",[m])}input(m,y){return this._channel.call("$input",[m,y])}acknowledgeDataEvent(m,y){return this._channel.call("$acknowledgeDataEvent",[m,y])}setUnicodeVersion(m,y){return this._channel.call("$setUnicodeVersion",[m,y])}shutdown(m,y){return this._channel.call("$shutdown",[m,y])}resize(m,y,b){return this._channel.call("$resize",[m,y,b])}getInitialCwd(m){return this._channel.call("$getInitialCwd",[m])}getCwd(m){return this._channel.call("$getCwd",[m])}orphanQuestionReply(m){return this._channel.call("$orphanQuestionReply",[m])}sendCommandResult(m,y,b){return this._channel.call("$sendCommandResult",[m,y,b])}installAutoReply(m,y){return this._channel.call("$installAutoReply",[m,y])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(m){return this._channel.call("$getDefaultSystemShell",[m])}getProfiles(m,y,b){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,m,y,b])}acceptPtyHostResolvedVariables(m,y){return this._channel.call("$acceptPtyHostResolvedVariables",[m,y])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(m){return this._channel.call("$getWslPath",[m])}setTerminalLayoutInfo(m){const b={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:m?m.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",b)}updateTitle(m,y,b){return this._channel.call("$updateTitle",[m,y,b])}updateIcon(m,y,b){return this._channel.call("$updateIcon",[m,y,b])}refreshProperty(m,y){return this._channel.call("$refreshProperty",[m,y])}updateProperty(m,y,b){return this._channel.call("$updateProperty",[m,y,b])}getTerminalLayoutInfo(){const y={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",y)}reviveTerminalProcesses(m,y){return this._channel.call("$reviveTerminalProcesses",[m,y])}serializeTerminalState(m){return this._channel.call("$serializeTerminalState",[m])}};c=Ae([Oe(2,t.IWorkbenchConfigurationService),Oe(3,k.IWorkspaceContextService),Oe(4,v.IConfigurationResolverService),Oe(5,S.IEnvironmentVariableService),Oe(6,C.IRemoteAuthorityResolverService),Oe(7,p.ILogService),Oe(8,A.IEditorService),Oe(9,g.ILabelService)],c),e.RemoteTerminalChannelClient=c}),define(we[240],ye([0,1,193,169,5,56,59,17,141,12,4,31,63,40]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=e.Logger=e.Translations=void 0;const c="package.json";var h;(function(s){function n(r,i){if(r===i)return!0;let a=Object.keys(r),d=new Set;for(let w of Object.keys(i))d.add(w);if(a.length!==d.size)return!1;for(let w of a){if(r[w]!==i[w])return!1;d.delete(w)}return d.size===0}s.equals=n})(h=e.Translations||(e.Translations={}));class m{constructor(n){this._messageHandler=n}error(n,r){this._messageHandler(_.Severity.Error,n,r)}warn(n,r){this._messageHandler(_.Severity.Warning,n,r)}info(n,r){this._messageHandler(_.Severity.Info,n,r)}}e.Logger=m;class y{constructor(n,r,i,a,d,w){this._ourVersion=n,this._ourProductDate=r,this._host=i,this._absoluteFolderPath=a,this._isBuiltin=d,this._isUnderDevelopment=w,this._absoluteManifestPath=p.join(a,c)}_error(n,r){this._host.log.error(n,r)}_warn(n,r){this._host.log.warn(n,r)}_info(n,r){this._host.log.info(n,r)}}class b extends y{static _fastParseJSON(n,r){try{return JSON.parse(n)}catch{return k.parse(n,r)}}parse(){return this._host.readFile(this._absoluteManifestPath).then(n=>{const r=[],i=b._fastParseJSON(n,r);if(k.getNodeType(i)!=="object")this._error(this._absoluteFolderPath,t.localize(0,null,this._absoluteManifestPath));else{if(r.length===0)return i.__metadata&&(i.uuid=i.__metadata.id),i.isUserBuiltin=!!i.__metadata?.isBuiltin,delete i.__metadata,i;r.forEach(a=>{this._error(this._absoluteFolderPath,t.localize(1,null,this._absoluteManifestPath,a.offset,a.length,(0,v.getParseErrorMessage)(a.error)))})}return null},n=>(n.code==="ENOENT"||this._error(this._absoluteFolderPath,t.localize(2,null,this._absoluteManifestPath,n.message)),null))}}class f extends y{constructor(n,r,i,a,d,w,P){super(n,r,i,a,d,w);this._nlsConfig=P}replaceNLS(n){const r=($,L)=>{L.forEach(T=>{this._error(this._absoluteFolderPath,t.localize(3,null,$,(0,v.getParseErrorMessage)(T.error)))})},i=$=>{this._error(this._absoluteFolderPath,t.localize(4,null,$))};let a=p.extname(this._absoluteManifestPath),d=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-a.length);const w=`${n.publisher}.${n.name}`;let P=this._nlsConfig.translations[w],O;return P?O=this._host.readFile(P).then($=>{let L=[],T=k.parse($,L);return L.length>0?(r(P,L),{values:void 0,default:`${d}.nls.json`}):k.getNodeType(T)!=="object"?(i(P),{values:void 0,default:`${d}.nls.json`}):{values:T.contents?T.contents.package:void 0,default:`${d}.nls.json`}},$=>({values:void 0,default:`${d}.nls.json`})):O=this._host.existsFile(d+".nls"+a).then($=>{if(!!$)return f.findMessageBundles(this._host,this._nlsConfig,d).then(L=>L.localized?this._host.readFile(L.localized).then(T=>{let U=[],N=k.parse(T,U);return U.length>0?(r(L.localized,U),{values:void 0,default:L.original}):k.getNodeType(N)!=="object"?(i(L.localized),{values:void 0,default:L.original}):{values:N,default:L.original}},T=>({values:void 0,default:L.original})):{values:void 0,default:L.original},L=>{})}),O.then($=>{if($===void 0)return n;let L=[];return this.resolveOriginalMessageBundle($.default,L).then(T=>{if(L.length>0)return r($.default,L),n;if(k.getNodeType($)!=="object")return i($.default),n;const U=$.values||Object.create(null);return f._replaceNLStrings(this._nlsConfig,n,U,T,this._host.log,this._absoluteFolderPath),n})},$=>n)}resolveOriginalMessageBundle(n,r){return new Promise((i,a)=>{n?this._host.readFile(n).then(d=>{i(k.parse(d,r))},d=>{i(null)}):i(null)})}static findMessageBundles(n,r,i){return new Promise((a,d)=>{function w(P,O){let $=`${P}.nls.${O}.json`;n.existsFile($).then(L=>{L&&a({localized:$,original:`${P}.nls.json`});let T=O.lastIndexOf("-");T===-1?a({localized:`${P}.nls.json`,original:null}):(O=O.substring(0,T),w(P,O))})}if(r.devMode||r.pseudo||!r.locale)return a({localized:i+".nls.json",original:null});w(i,r.locale)})}static _replaceNLStrings(n,r,i,a,d,w){function P(O,$,L){const T=O[$];if(I.isString(T)){const U=T,N=U.length;if(N>1&&U[0]==="%"&&U[N-1]==="%"){const W=U.substr(1,N-2);let ie=i[W];ie===void 0&&a&&(ie=a[W]);let j=typeof ie=="string"?ie:typeof ie?.message=="string"?ie.message:void 0;j!==void 0?(n.pseudo&&(j="\uFF3B"+j.replace(/[aouei]/g,"$&$&")+"\uFF3D"),O[$]=L&&($==="title"||$==="category")&&a?{value:j,original:a[W]}:j):d.warn(w,t.localize(5,null,W))}}else if(I.isObject(T))for(let U in T)T.hasOwnProperty(U)&&(U==="commands"?P(T,U,!0):P(T,U,L));else if(I.isArray(T))for(let U=0;U<T.length;U++)P(T,U,L)}for(let O in r)r.hasOwnProperty(O)&&P(r,O)}}class E extends y{validate(n){let r=n;r.isBuiltin=this._isBuiltin,r.isUserBuiltin=!this._isBuiltin&&!!r.isUserBuiltin,r.isUnderDevelopment=this._isUnderDevelopment;let i=[];return E.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,r,i)?(i.forEach(a=>{this._warn(this._absoluteFolderPath,a)}),r.publisher||(r.publisher=S.UNDEFINED_PUBLISHER),r.id=(0,R.getExtensionId)(r.publisher,r.name),r.identifier=new S.ExtensionIdentifier(r.id),r.extensionLocation=A.URI.file(this._absoluteFolderPath),r):(i.forEach(a=>{this._error(this._absoluteFolderPath,a)}),null)}static isValidExtensionDescription(n,r,i,a,d){return E.baseIsValidExtensionDescription(i,a,d)?C.valid(a.version)?(0,g.isValidExtensionVersion)(n,r,a,d):(d.push(t.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(n,r,i){if(!r)return i.push(t.localize(7,null)),!1;if(typeof r.publisher!="undefined"&&typeof r.publisher!="string")return i.push(t.localize(8,null)),!1;if(typeof r.name!="string")return i.push(t.localize(9,null,"name")),!1;if(typeof r.version!="string")return i.push(t.localize(10,null,"version")),!1;if(!r.engines)return i.push(t.localize(11,null,"engines")),!1;if(typeof r.engines.vscode!="string")return i.push(t.localize(12,null,"engines.vscode")),!1;if(typeof r.extensionDependencies!="undefined"&&!E._isStringArray(r.extensionDependencies))return i.push(t.localize(13,null,"extensionDependencies")),!1;if(typeof r.activationEvents!="undefined"){if(!E._isStringArray(r.activationEvents))return i.push(t.localize(14,null,"activationEvents")),!1;if(typeof r.main=="undefined"&&typeof r.browser=="undefined")return i.push(t.localize(15,null,"activationEvents","main")),!1}if(typeof r.extensionKind!="undefined"&&typeof r.main=="undefined"&&i.push(t.localize(16,null,"extensionKind")),typeof r.main!="undefined"){if(typeof r.main!="string")return i.push(t.localize(17,null,"main")),!1;{const a=p.join(n,r.main);a.startsWith(n)||i.push(t.localize(18,null,a,n))}if(typeof r.activationEvents=="undefined")return i.push(t.localize(19,null,"activationEvents","main")),!1}if(typeof r.browser!="undefined"){if(typeof r.browser!="string")return i.push(t.localize(20,null,"browser")),!1;{const a=p.join(n,r.browser);a.startsWith(n)||i.push(t.localize(21,null,a,n))}if(typeof r.activationEvents=="undefined")return i.push(t.localize(22,null,"activationEvents","browser")),!1}return!0}static _isStringArray(n){if(!Array.isArray(n))return!1;for(let r=0,i=n.length;r<i;r++)if(typeof n[r]!="string")return!1;return!0}}class u{constructor(n,r,i,a,d,w,P,O,$){this.ourVersion=n,this.ourProductDate=r,this.commit=i,this.locale=a,this.devMode=d,this.absoluteFolderPath=w,this.isBuiltin=P,this.isUnderDevelopment=O,this.translations=$}static createNLSConfig(n){return{devMode:n.devMode,locale:n.locale,pseudo:n.locale==="pseudo",translations:n.translations}}static equals(n,r){return n.ourVersion===r.ourVersion&&n.ourProductDate===r.ourProductDate&&n.commit===r.commit&&n.locale===r.locale&&n.devMode===r.devMode&&n.absoluteFolderPath===r.absoluteFolderPath&&n.isBuiltin===r.isBuiltin&&n.isUnderDevelopment===r.isUnderDevelopment&&n.mtime===r.mtime&&h.equals(n.translations,r.translations)}}e.ExtensionScannerInput=u;class o{constructor(n,r){this._host=n,this.root=r}resolveExtensions(){return this._host.readDirsInDir(this.root).then(n=>n.map(r=>({name:r,path:p.join(this.root,r)})))}}class l{static scanExtension(n,r,i,a,d,w,P){return a=p.normalize(a),new b(n,r,i,a,d,w).parse().then($=>$===null?null:new f(n,r,i,a,d,w,P).replaceNLS($)).then($=>$===null?null:new E(n,r,i,a,d,w).validate($))}static async scanExtensions(n,r,i=null){const a=n.absoluteFolderPath,d=n.isBuiltin,w=n.isUnderDevelopment;i||(i=new o(r,a));try{let P={};if(!d)try{const U=await r.readFile(p.join(a,".obsolete"));P=JSON.parse(U)}catch{}let O=await i.resolveExtensions();O.sort((U,N)=>U.name<N.name?-1:1),d||(O=O.filter(U=>U.name.indexOf(".")!==0));const $=u.createNLSConfig(n);let L=await Promise.all(O.map(U=>this.scanExtension(n.ourVersion,n.ourProductDate,r,U.path,d,w,$))),T=D.coalesce(L);return T=T.filter(U=>U!==null&&!P[new R.ExtensionIdentifierWithVersion({id:(0,R.getGalleryExtensionId)(U.publisher,U.name)},U.version).key()]),d||(T=(0,R.groupByExtension)(T,N=>({id:N.identifier.value,uuid:N.uuid})).map(N=>N.sort((W,ie)=>C.rcompare(W.version,ie.version))[0])),T.sort((U,N)=>U.extensionLocation.fsPath<N.extensionLocation.fsPath?-1:1),T}catch(P){return r.log.error(a,P),[]}}static scanOneOrMultipleExtensions(n,r){const i=n.absoluteFolderPath,a=n.isBuiltin,d=n.isUnderDevelopment;return r.existsFile(p.join(i,c)).then(w=>{if(w){const P=u.createNLSConfig(n);return this.scanExtension(n.ourVersion,n.ourProductDate,r,i,a,d,P).then(O=>O===null?[]:[O])}return this.scanExtensions(n,r)},w=>(r.log.error(i,w),[]))}static scanSingleExtension(n,r){const i=n.absoluteFolderPath,a=n.isBuiltin,d=n.isUnderDevelopment,w=u.createNLSConfig(n);return this.scanExtension(n.ourVersion,n.ourProductDate,r,i,a,d,w)}static mergeBuiltinExtensions(n,r){return Promise.all([n,r]).then(([i,a])=>{let d=Object.create(null);for(let P=0,O=i.length;P<O;P++)d[S.ExtensionIdentifier.toKey(i[P].identifier)]=i[P];for(let P=0,O=a.length;P<O;P++)d[S.ExtensionIdentifier.toKey(a[P].identifier)]=a[P];let w=Object.keys(d).map(P=>d[P]);return w.sort((P,O)=>{const $=p.basename(P.extensionLocation.fsPath),L=p.basename(O.extensionLocation.fsPath);return $<L?-1:$>L?1:0}),w})}}e.ExtensionScanner=l}),define(we[241],ye([0,1,3,43,4,57,165,8,240,40,61,104,88,83,208,5,24,18]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let b=null;function f(){return b||(b=(0,h.normalize)((0,h.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))),b}let E=null;function u(){return E||(E=(0,h.normalize)((0,h.join)(D.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),E}class o{constructor(s,n,r,i,a){if(this._connectionToken=s,this.environmentService=n,this.logService=i,this.productService=a,this._logger=new class{error(w,P){i.error(w,P)}warn(w,P){i.warn(w,P)}info(w,P){i.info(w,P)}},this._extensionScannerHost={log:this._logger,readFile:w=>y.Promises.readFile(w,"utf8"),existsFile:w=>y.SymlinkSupport.existsFile(w),readDirsInDir:w=>y.Promises.readDirsInDir(w)},n.args["install-builtin-extension"]){const w={isMachineScoped:!!n.args["do-not-sync"],installPreReleaseVersion:!!n.args["pre-release"]};this.whenExtensionsReady=r.installExtensions([],n.args["install-builtin-extension"],w,!!n.args.force).then(null,P=>{i.error(P)})}else this.whenExtensionsReady=Promise.resolve();const d=n.args["install-extension"];if(d){const w=d.map(P=>/\.vsix$/i.test(P)?p.URI.file((0,h.isAbsolute)(P)?P:(0,h.join)((0,m.cwd)(),P)):P);this.whenExtensionsReady.then(()=>r.installExtensions(w,[],{isMachineScoped:!!n.args["do-not-sync"],installPreReleaseVersion:!!n.args["pre-release"]},!!n.args.force)).then(null,P=>{i.error(P)})}}async call(s,n,r){switch(n){case"getEnvironmentData":{const i=r,a=(0,C.createURITransformer)(i.remoteAuthority);let d=await this._getEnvironmentData();return d=(0,A.transformOutgoingURIs)(d,a),d}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const i=r,a=i.language;this.logService.trace(`Scanning extensions using UI language: ${a}`);const d=(0,C.createURITransformer)(i.remoteAuthority),w=i.extensionDevelopmentPath&&i.extensionDevelopmentPath.map($=>p.URI.revive(d.transformIncoming($))),P=w?w.filter($=>$.scheme===D.Schemas.file).map($=>$.fsPath):void 0;let O=await this._scanExtensions(a,P);return O=(0,A.transformOutgoingURIs)(O,d),this.logService.trace("Scanned Extensions",O),o._massageWhenConditions(O),O}case"scanSingleExtension":{await this.whenExtensionsReady;const i=r,a=i.language,d=i.isBuiltin,w=(0,C.createURITransformer)(i.remoteAuthority),P=p.URI.revive(w.transformIncoming(i.extensionLocation)),O=P.scheme===D.Schemas.file?P.fsPath:null;if(!O)return null;const $=await this._getTranslations(a);let L=await this._scanSingleExtension(O,d,a,$);return L?(L=(0,A.transformOutgoingURIs)(L,w),o._massageWhenConditions([L]),L):null}case"getDiagnosticInfo":{const i=r,a={machineInfo:(0,c.getMachineInfo)()},d=i.includeProcesses?(0,S.listProcesses)(process.pid):Promise.resolve();let w=[];const P={};if(i.folders){const O=(0,C.createURITransformer)("");w=i.folders.map(L=>p.URI.revive(O.transformIncoming(L))).filter(L=>L.scheme==="file").map(L=>(0,c.collectWorkspaceStats)(L.fsPath,["node_modules",".git"]).then(T=>{P[(0,h.basename)(L.fsPath)]=T}))}return Promise.all([d,...w]).then(([O,$])=>(a.processes=O||void 0,a.workspaceMetadata=i.folders?P:void 0,a))}}throw new Error(`IPC Command ${n} not found`)}listen(s,n,r){throw new Error("Not supported")}static _massageWhenConditions(s){const n=(P,O)=>P.replace(/file/g,"vscode-remote"),r=P=>{let O="";return O+=P.global?"g":"",O+=P.ignoreCase?"i":"",O+=P.multiline?"m":"",new RegExp(n(P.source,!0),O)},i=new class{mapDefined(P){return g.ContextKeyDefinedExpr.create(P)}mapNot(P){return g.ContextKeyNotExpr.create(P)}mapEquals(P,O){return P==="resourceScheme"&&typeof O=="string"?g.ContextKeyEqualsExpr.create(P,n(O,!1)):g.ContextKeyEqualsExpr.create(P,O)}mapNotEquals(P,O){return P==="resourceScheme"&&typeof O=="string"?g.ContextKeyNotEqualsExpr.create(P,n(O,!1)):g.ContextKeyNotEqualsExpr.create(P,O)}mapGreater(P,O){return g.ContextKeyGreaterExpr.create(P,O)}mapGreaterEquals(P,O){return g.ContextKeyGreaterEqualsExpr.create(P,O)}mapSmaller(P,O){return g.ContextKeySmallerExpr.create(P,O)}mapSmallerEquals(P,O){return g.ContextKeySmallerEqualsExpr.create(P,O)}mapRegex(P,O){return P==="resourceScheme"&&O?g.ContextKeyRegexExpr.create(P,r(O)):g.ContextKeyRegexExpr.create(P,O)}mapIn(P,O){return g.ContextKeyInExpr.create(P,O)}},a=P=>{if(!P||!P.when||!/resourceScheme/.test(P.when))return;const O=g.ContextKeyExpr.deserialize(P.when);if(!O)return;const $=O.map(i);P.when=$.serialize()},d=P=>{if(Array.isArray(P))for(let O of P)a(O);else a(P)},w=P=>{for(let O in P)d(P[O])};s.forEach(P=>{P.contributes&&(P.contributes.menus&&w(P.contributes.menus),P.contributes.keybindings&&d(P.contributes.keybindings),P.contributes.views&&w(P.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:p.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:p.URI.file(this.environmentService.logsPath),extensionsPath:p.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:p.URI.file((0,h.join)(this.environmentService.logsPath,`exthost${o._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:_.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this.environmentService.args["use-host-proxy"]}}async _getTranslations(s){const n=await(0,R.getNLSConfiguration)(s,this.environmentService.userDataPath);if(R.InternalNLSConfiguration.is(n))try{const r=await y.Promises.readFile(n._translationsConfigFile,"utf8");return JSON.parse(r)}catch{return Object.create(null)}else return Object.create(null)}async _scanExtensions(s,n){const r=await this._getTranslations(s),[i,a,d]=await Promise.all([this._scanBuiltinExtensions(s,r),this._scanInstalledExtensions(s,r),this._scanDevelopedExtensions(s,r,n)]);let w=new Map;i.forEach(O=>{!O||w.set(I.ExtensionIdentifier.toKey(O.identifier),O)}),a.forEach(O=>{!O||(w.has(I.ExtensionIdentifier.toKey(O.identifier))&&console.warn(k.localize(0,null,w.get(I.ExtensionIdentifier.toKey(O.identifier)).extensionLocation.fsPath,O.extensionLocation.fsPath)),w.set(I.ExtensionIdentifier.toKey(O.identifier),O))}),d.forEach(O=>{!O||w.set(I.ExtensionIdentifier.toKey(O.identifier),O)});const P=[];return w.forEach(O=>P.push(O)),P}_scanDevelopedExtensions(s,n,r){if(r){const i=r.map(a=>v.ExtensionScanner.scanOneOrMultipleExtensions(new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,s,!0,a,!1,!0,n),this._extensionScannerHost));return Promise.all(i).then(a=>{let d=[];for(let w of a)d=d.concat(w);return d})}return Promise.resolve([])}_scanBuiltinExtensions(s,n){const r=this.productService.version,i=this.productService.commit,a=this.productService.date,d=!!process.env.VSCODE_DEV,w=new v.ExtensionScannerInput(r,a,i,s,d,f(),!0,!1,n),P=v.ExtensionScanner.scanExtensions(w,this._extensionScannerHost);let O=P;if(d){class ${constructor(W){this.builtInExtensions=W}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(W=>({name:W.name,path:(0,h.join)(u(),W.name)})))}}const L=Promise.resolve(this.productService.builtInExtensions||[]),T=new v.ExtensionScannerInput(r,a,i,s,d,u(),!0,!1,{}),U=L.then(N=>new $(N)).then(N=>v.ExtensionScanner.scanExtensions(T,this._extensionScannerHost,N));O=v.ExtensionScanner.mergeBuiltinExtensions(P,U)}return O}_scanInstalledExtensions(s,n){const r=!!process.env.VSCODE_DEV,i=new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,s,r,this.environmentService.extensionsPath,!1,!1,n);return v.ExtensionScanner.scanExtensions(i,this._extensionScannerHost)}_scanSingleExtension(s,n,r,i){const a=!!process.env.VSCODE_DEV,d=new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,r,a,s,n,!1,i);return v.ExtensionScanner.scanSingleExtension(d,this._extensionScannerHost)}}e.RemoteAgentEnvironmentChannel=o,o._namePool=1}),define(we[111],ye([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const t=[];function p(D){const v=new _(D);return t[v.nid]=v,v}e.createProxyIdentifier=p;function C(D){return t[D].sid}e.getStringIdentifierForProxy=C;class k{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=k}),define(we[242],ye([0,1,50,4,111]),function(J,e,_,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var C;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(b){b[b.Singular=0]="Singular",b[b.Diff=1]="Diff",b[b.SidebySide=2]="SidebySide",b[b.Other=3]="Other"})(k=e.TabKind||(e.TabKind={}));var D;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var v;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(v=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class g{static mixin(f){return f._id=g._n++,f}}e.IdObject=g,g._n=0;var S;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.command="m",b.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(b){b[b.File=1]="File",b[b.Text=2]="Text",b[b.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(b){if(b&&b.edits)for(const f of b.edits)typeof f.resource=="object"?f.resource=t.URI.revive(f.resource):(f.newUri=t.URI.revive(f.newUri),f.oldUri=t.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,_.revive)(f.metadata));return b}e.reviveWorkspaceEditDto=m;var y;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createProxyIdentifier)("ExtHostTelemetry")}});var yt=this&&this.__classPrivateFieldSet||function(J,e,_,t,p){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?p.call(J,_):p?p.value=_:e.set(J,_),_},tt=this&&this.__classPrivateFieldGet||function(J,e,_,t){if(_==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?t:_==="a"?t.call(J):t?t.value:e.get(J)};define(we[243],ye([0,1,12,106,238,21,242,17,14,50,51,85,4,2,6,227,105,15,111,36]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(i,a){E.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,yt(this,E,i.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new o(this,d=>{const w=this._apiCommands.get(d);return w?.result===s.Void?w:void 0},a),this._argumentProcessors=[{processArgument(d){return(0,I.revive)(d)}},{processArgument(d){return(0,C.cloneAndChange)(d,function(w){if(A.Range.isIRange(w))return p.Range.to(w);if(R.Position.isIPosition(w))return p.Position.to(w);if(A.Range.isIRange(w.range)&&g.URI.isUri(w.uri))return p.location.to(w);if(w instanceof y.VSBuffer)return w.buffer.buffer;if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const a=this.registerCommand(!1,i.id,async(...d)=>{const w=i.args.map((O,$)=>{if(!O.validate(d[$]))throw new Error(`Invalid argument '${O.name}' when running '${i.id}', received: ${d[$]}`);return O.convert(d[$])}),P=await this.executeCommand(i.internalId,...w);return i.result.convert(P,d,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new t.Disposable(()=>{a.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,a,d,w,P,O){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:d,thisArg:w,description:P,extension:O}),i&&tt(this,E,"f").$registerCommand(a),new t.Disposable(()=>{this._commands.delete(a)&&i&&tt(this,E,"f").$unregisterCommand(a)})}executeCommand(i,...a){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,a,!0)}async _doExecuteCommand(i,a,d){if(this._commands.has(i))return this._executeContributedCommand(i,a,!1);{let w=!1;const P=(0,C.cloneAndChange)(a,function(O){if(O instanceof t.Position)return p.Position.from(O);if(O instanceof t.Range)return p.Range.from(O);if(O instanceof t.Location)return p.location.from(O);if(t.NotebookRange.isNotebookRange(O))return p.NotebookRange.from(O);if(O instanceof ArrayBuffer)return w=!0,y.VSBuffer.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return w=!0,y.VSBuffer.wrap(O);if(!Array.isArray(O))return O});try{const O=await tt(this,E,"f").$executeCommand(i,w?new b.SerializableObjectWithBuffers(P):P,d);return(0,I.revive)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this._doExecuteCommand(i,a,!1);throw O}}}async _executeContributedCommand(i,a,d){const w=this._commands.get(i);if(!w)throw new Error("Unknown command");let{callback:P,thisArg:O,description:$}=w;if($)for(let L=0;L<$.args.length;L++)try{(0,_.validateConstraint)(a[L],$.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${$.args[L].name}' - ${$.args[L].description}`)}try{return await P.apply(O,a)}catch(L){if(i===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...a);T&&(i=T.command)}throw this._logService.error(L,i,w.extension?.identifier),d?new class extends Error{constructor(){super((0,f.toErrorMessage)(L));this.id=i,this.source=w.extension?.displayName??w.extension?.name}}:L}}$executeContributedCommand(i,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(a=a.map(d=>this._argumentProcessors.reduce((w,P)=>P.processArgument(w),d)),this._executeContributedCommand(i,a,!0)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),tt(this,E,"f").$getCommands().then(a=>(i&&(a=a.filter(d=>d[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[a,d]of this._commands){let{description:w}=d;w&&(i[a]=w)}return Promise.resolve(i)}};E=new WeakMap,u=Ae([Oe(0,h.IExtHostRpcService),Oe(1,v.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class o{constructor(i,a,d){this._commands=i,this._lookupApiCommand=a,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,a){if(!i)return;const d={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return d;const w=this._lookupApiCommand(i.command);if(w)d.id=w.internalId,d.arguments=w.args.map((P,O)=>P.convert(i.arguments&&i.arguments[O]));else if((0,D.isNonEmptyArray)(i.arguments)){const P=++this._cachIdPool;this._cache.set(P,i),a.add((0,S.toDisposable)(()=>{this._cache.delete(P),this._logService.trace("CommandsConverter#DISPOSE",P)})),d.$ident=P,d.id=this.delegatingCommandId,d.arguments=[P],this._logService.trace("CommandsConverter#CREATE",i.command,P)}return d}fromInternal(i){return typeof i.$ident=="number"?this._cache.get(i.$ident):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const a=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class l{constructor(i,a,d,w){this.name=i,this.description=a,this.validate=d,this.convert=w}optional(){return new l(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,a){return new l(i??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",r=>g.URI.isUri(r),r=>r),l.Position=new l("position","A position in a text document",r=>t.Position.isPosition(r),p.Position.from),l.Range=new l("range","A range in a text document",r=>t.Range.isRange(r),p.Range.from),l.Selection=new l("selection","A selection in a text document",r=>t.Selection.isSelection(r),p.Selection.from),l.Number=new l("number","",r=>typeof r=="number",r=>r),l.String=new l("string","",r=>typeof r=="string",r=>r),l.CallHierarchyItem=new l("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,p.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,p.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",r=>r instanceof m.TestItemImpl,p.TestItem.from);class s{constructor(i,a){this.description=i,this.convert=a}}e.ApiCommandResult=s,s.Void=new s("no result",r=>r);class n{constructor(i,a,d,w,P){this.id=i,this.internalId=a,this.description=d,this.args=w,this.result=P}}e.ApiCommand=n}),define(we[244],ye([0,1,76]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function t(C,k,D=null){const v=(0,_.parse)(k).args;let I=v.shift();if(typeof I=="string")switch(k.severity||(k.severity="info"),D&&(/^\[/.test(D)||(D=`[${D}]`),/ $/.test(D)||(D=`${D} `),I=D+I),k.severity){case"log":case"info":C.info(I,...v);break;case"warn":C.warn(I,...v);break;case"error":C.error(I,...v);break}}e.logRemoteEntry=t;function p(C,k,D){const v=(0,_.parse)(k).args,I=v.shift();typeof I!="string"||k.severity!=="error"||(/^\[/.test(D)||(D=`[${D}]`),/ $/.test(D)||(D=`${D} `),C.error(D+I,...v))}e.logRemoteEntryIfError=p}),define(we[112],ye([0,1,6]),function(J,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(we[245],ye([0,1,11,2,8,183]),function(J,e,_,t,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends C.DiskFileSystemProviderClient{static register(v,I,A){const R=v.getConnection();if(!R)return t.Disposable.None;const g=new t.DisposableStore,S=(async()=>{try{const c=await v.getRawEnvironment();c?I.registerProvider(p.Schemas.vscodeRemote,g.add(new k(c,R))):A.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(c){A.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,_.getErrorMessage)(c))}})();return g.add(I.onWillActivateFileSystemProvider(c=>{c.scheme===p.Schemas.vscodeRemote&&c.join(S)})),g}constructor(v,I){super(I.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=k}),define(we[70],ye([0,1,27,13,5,12,18,144,259,260]),function(J,e,_,t,p,C,k,D,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class A extends Error{constructor(o,l){let s=l.message;switch(o){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s);this.type=o,this.cause=l}}e.ExtractError=A;function R(u){const o=u.externalFileAttributes>>16||33188;return[448,56,7].map(l=>o&l).reduce((l,s)=>l+s,o&61440)}function g(u){if(u instanceof A)return u;let o;return/end of central directory record signature not found/.test(u.message)&&(o="CorruptZip"),new A(o,u)}function S(u,o,l,s,n,r){const i=p.dirname(o),a=p.join(s,i);if(!a.startsWith(s))return Promise.reject(new Error(D.localize(0,null,o)));const d=p.join(s,o);let w;return r.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(k.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((P,O)=>{if(!r.isCancellationRequested)try{w=(0,_.createWriteStream)(d,{mode:l}),w.once("close",()=>P()),w.once("error",O),u.once("error",O),u.pipe(w)}catch($){O($)}}))}function c(u,o,l,s){let n=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{n.cancel(),u.close()}),new Promise((i,a)=>{const d=new t.Sequencer,w=P=>{P.isCancellationRequested||(r++,u.readEntry())};u.once("error",a),u.once("close",()=>n.then(()=>{s.isCancellationRequested||u.entryCount===r?i():a(new A("Incomplete",new Error(D.localize(1,null,r,u.entryCount))))},a)),u.readEntry(),u.on("entry",P=>{if(s.isCancellationRequested)return;if(!l.sourcePathRegex.test(P.fileName)){w(s);return}const O=P.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(O)){const T=p.join(o,O);n=(0,t.createCancelablePromise)(U=>k.Promises.mkdir(T,{recursive:!0}).then(()=>w(U)).then(void 0,a));return}const $=m(u,P),L=R(P);n=(0,t.createCancelablePromise)(T=>d.queue(()=>$.then(U=>S(U,O,L,o,l,T).then(()=>w(T)))).then(null,a))})})}function h(u,o=!1){return new Promise((l,s)=>{(0,v.open)(u,o?{lazyEntries:!0}:void 0,(n,r)=>{n?s(g(n)):l((0,C.assertIsDefined)(r))})})}function m(u,o){return new Promise((l,s)=>{u.openReadStream(o,(n,r)=>{n?s(g(n)):l((0,C.assertIsDefined)(r))})})}function y(u,o){return new Promise((l,s)=>{const n=new I.ZipFile;o.forEach(i=>{i.contents?n.addBuffer(typeof i.contents=="string"?Buffer.from(i.contents,"utf8"):i.contents,i.path):i.localPath&&n.addFile(i.localPath,i.path)}),n.end();const r=(0,_.createWriteStream)(u);n.outputStream.pipe(r),n.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>l(u))})}e.zip=y;function b(u,o,l={},s){const n=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let r=h(u,!0);return l.overwrite&&(r=r.then(i=>k.Promises.rm(o).then(()=>i))),r.then(i=>c(i,o,{sourcePathRegex:n},s))}e.extract=b;function f(u,o){return h(u).then(l=>new Promise((s,n)=>{l.on("entry",r=>{r.fileName===o&&m(l,r).then(i=>s(i),i=>n(i))}),l.once("close",()=>n(new Error(D.localize(2,null,o))))}))}function E(u,o){return f(u,o).then(l=>new Promise((s,n)=>{const r=[];l.once("error",n),l.on("data",i=>r.push(i)),l.on("end",()=>s(Buffer.concat(r)))}))}e.buffer=E}),define(we[246],ye([0,1,70,152]),function(J,e,_,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function p(C){return(0,_.buffer)(C,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=p}),define(we[247],ye([0,1,17,13,11,2,8,5,3,22,56,4,23,18,70,153,26,32,31,177,40,19,14,30]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E,u,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let s=class extends C.Disposable{constructor(r,i,a,d,w){super();this.beforeRemovingExtension=r,this.fileService=i,this.logService=a,this.environmentService=d,this.productService=w,this._devSystemExtensionsPath=null,this.systemExtensionsPath=d.builtinExtensionsPath,this.extensionsPath=d.extensionsPath,this.uninstalledPath=D.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const i=[];(r===null||r===0)&&i.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(a).message,y.ExtensionManagementErrorCode.Internal)))),(r===null||r===1)&&i.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(a).message,y.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(i);return(0,_.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[i,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(d=>!i[new b.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).key()]),r&&(a=(0,b.groupByExtension)(a,w=>w.identifier).map(w=>w.sort((P,O)=>A.rcompare(P.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(r,i,a,d){const w=r.key(),P=D.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),O=D.join(this.extensionsPath,w);try{await S.Promises.rm(O)}catch{try{await S.Promises.rm(O)}catch{}throw new y.ExtensionManagementError((0,h.localize)(0,null,O,r.id),y.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,i,P,d);let $=await this.scanExtension(R.URI.file(P),1);if(!$)throw new Error((0,h.localize)(1,null,P));await this.storeMetadata($,{...a,installedTimestamp:Date.now()});try{await this.rename(r,P,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(L){try{await S.Promises.rm(P)}catch{}if(L.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,p.getErrorMessage)(L)}. Deleted from extracted location`,P),L}try{$=await this.scanExtension(R.URI.file(O),1)}catch{}if($)return $;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(r,i){return this.setMetadata(r,i),await this.storeMetadata(r,{...i,installedTimestamp:r.installedTimestamp}),r}async storeMetadata(r,i){i.isMachineScoped=i.isMachineScoped||void 0,i.isBuiltin=i.isBuiltin||void 0,i.installedTimestamp=i.installedTimestamp||void 0;const a=D.join(r.location.fsPath,"package.json"),d=await S.Promises.readFile(a,"utf8"),{manifest:w}=await this.parseManifest(d);return w.__metadata=i,await S.Promises.writeFile(a,JSON.stringify(w,null,"	")),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const i=r.map(a=>new b.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{i.forEach(d=>a[d.key()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(d=>delete d[r.key()]);const a=(await this.scanExtensions(1)).find(d=>new b.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).equals(r))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let i;try{i=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(d){if(d.code!=="ENOENT")throw d}let a={};if(i)try{a=JSON.parse(i)}catch{}return r&&(r(a),Object.keys(a).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await S.Promises.rm(this.uninstalledPath)),a})}async removeExtension(r,i){this.logService.trace(`Deleting ${i} extension from disk`,r.identifier.id,r.location.fsPath),await S.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(i=>delete i[new b.ExtensionIdentifierWithVersion(r.identifier,r.manifest.version).key()])}async extractAtLocation(r,i,a,d){this.logService.trace(`Started extracting the extension from ${i} to ${a}`);try{await S.Promises.rm(a)}catch(w){throw new y.ExtensionManagementError(this.joinErrors(w).message,y.ExtensionManagementErrorCode.Delete)}try{await(0,c.extract)(i,a,{sourcePath:"extension",overwrite:!0},d),this.logService.info(`Extracted extension to ${a}:`,r.id)}catch(w){try{await S.Promises.rm(a)}catch{}let P=y.ExtensionManagementErrorCode.Extract;throw w instanceof c.ExtractError&&(w.type==="CorruptZip"?P=y.ExtensionManagementErrorCode.CorruptZip:w.type==="Incomplete"&&(P=y.ExtensionManagementErrorCode.IncompleteZip)),new y.ExtensionManagementError(w.message,P)}}async rename(r,i,a,d){try{await S.Promises.rename(i,a)}catch(w){if(v.isWindows&&w&&w.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${i} to ${a} with 'EPERM' error. Trying again...`,r.id),this.rename(r,i,a,d);throw new y.ExtensionManagementError(w.message||(0,h.localize)(3,null,i,a),w.code||y.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return r;const i=this.scanDevSystemExtensions(),[a,d]=await Promise.all([r,i]);return[...a,...d]}async scanExtensionsInDir(r,i){const a=new t.Limiter(10),d=await this.fileService.resolve(R.URI.file(r));return d.children?(await Promise.all(d.children.filter(P=>P.isDirectory).map(P=>a.queue(async()=>i===1&&(0,I.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,i))))).filter(P=>P&&P.identifier):[]}async scanExtension(r,i){try{const a=await this.fileService.resolve(r);if(a.children){const{manifest:d,metadata:w}=await this.readManifest(r.fsPath),P=a.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T))?.resource,O=a.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T))?.resource,$={id:(0,b.getGalleryExtensionId)(d.publisher,d.name)},L={type:i,identifier:$,manifest:d,location:r,readmeUrl:P,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:i===0};return this.setMetadata(L,w),L}}catch(a){i!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const r=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){const r=this.getDevSystemExtensionsList();if(r.length){const i=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",i.length),i.filter(a=>r.some(d=>(0,b.areSameExtensions)(a.identifier,{id:d})))}else return[]}setMetadata(r,i){r.publisherDisplayName=i?.publisherDisplayName||null,r.publisherId=i?.publisherId||null,r.identifier.uuid=i?.id,r.isMachineScoped=!!i?.isMachineScoped,r.isPreReleaseVersion=!!i?.isPreReleaseVersion,r.preRelease=!!i?.preRelease,r.isBuiltin=r.type===0||!!i?.isBuiltin,r.installedTimestamp=i?.installedTimestamp}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),i=await this.scanAllUserExtensions(),a=new Set;for(const P of i)r[new b.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||a.add(P.identifier.id.toLowerCase());const d=(0,b.groupByExtension)(i,P=>P.identifier);await t.Promises.settled(d.map(async P=>{const O=P.sort(($,L)=>A.rcompare($.manifest.version,L.manifest.version))[0];a.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const w=i.filter(P=>r[new b.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await t.Promises.settled(w.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const r=await this.scanAllUserExtensions(),i=[],a=(0,b.groupByExtension)(r,d=>d.identifier);i.push(...(0,_.flatten)(a.map(d=>d.sort((w,P)=>A.rcompare(w.manifest.version,P.manifest.version)).slice(1)))),await t.Promises.settled(i.map(d=>this.removeExtension(d,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,d)=>new Error(`${a.message}${a.message?",":""}${d instanceof Error?d.message:d}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=D.normalize(D.join(k.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(r){const i=[S.Promises.readFile(D.join(r,"package.json"),"utf8").then(P=>this.parseManifest(P)),S.Promises.readFile(D.join(r,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:a,metadata:d},w]=await Promise.all(i);return{manifest:(0,f.localizeManifest)(a,w),metadata:d}}parseManifest(r){return new Promise((i,a)=>{try{const d=JSON.parse(r);d.publisher||(d.publisher=E.UNDEFINED_PUBLISHER);const w=d.__metadata||null;i({manifest:d,metadata:w})}catch{a(new Error((0,h.localize)(4,null)))}})}};s=Ae([Oe(1,u.IFileService),Oe(2,o.ILogService),Oe(3,m.INativeEnvironmentService),Oe(4,l.IProductService)],s),e.ExtensionsScanner=s}),define(we[113],ye([0,1,36,11,8,5,3,24,22,56,12,4,23,18,70,151,64,26,209,32,31,199,189,246,200,247,222,63,19,6,14,30,33,47]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E,u,o,l,s,n,r,i,a,d,w,P,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let L=class extends b.AbstractExtensionManagementService{constructor(j,re,x,K,te,ce,oe,me,Y){super(j,re,x,me);this.environmentService=K,this.downloadService=te,this.fileService=oe;const z=this._register(ce.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(ce.createInstance(n.ExtensionsScanner,q=>z.postUninstall(q))),this.manifestCache=this._register(new s.ExtensionsManifestCache(K,this)),this.extensionsDownloader=this._register(ce.createInstance(u.ExtensionsDownloader));const H=this._register(new r.ExtensionsWatcher(this,oe,K,x,Y));this._register(H.onDidChangeExtensionsByAnotherSource(({added:q,removed:ee})=>{q.length&&this._onDidInstallExtensions.fire(q.map(he=>({identifier:he.identifier,operation:1,local:he}))),ee.forEach(he=>this._onDidUninstallExtension.fire({identifier:he}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const j=await this.isAlpineLinux(),re=(0,f.getTargetPlatform)(j?"alpine":k.platform,D.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",re),re})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let j;try{j=(await this.fileService.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{j=(await this.fileService.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(x){this.logService.debug("Error while getting the os-release file.",(0,t.getErrorMessage)(x))}}return!!j&&(j.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const re=await this.collectFiles(j),x=await(0,c.zip)((0,v.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)()).fsPath,re);return R.URI.file(x)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const re=await this.downloadVsix(j),x=C.resolve(re.fsPath);return(0,l.getManifest)(x)}getInstalled(j=null){return this.extensionsScanner.scanExtensions(j)}async install(j,re={}){this.logService.trace("ExtensionManagementService#install",j.toString());const x=await this.downloadVsix(j),K=await(0,l.getManifest)(C.resolve(x.fsPath));if(K.engines&&K.engines.vscode&&!(0,i.isEngineValid)(K.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,E.getGalleryExtensionId)(K.publisher,K.name),this.productService.version));return this.installExtension(K,x,re)}async updateMetadata(j,re){this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id);const x={...j.manifest.__metadata||{},...re};return re.isPreReleaseVersion&&(x.preRelease=!0),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,x),this.manifestCache.invalidate(),j}async updateExtensionScope(j,re){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},isMachineScoped:re}),this.manifestCache.invalidate(),j}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(j){if(j.scheme===p.Schemas.file)return j;const re=(0,v.joinPath)(this.environmentService.tmpDir,(0,g.generateUuid)());return await this.downloadService.download(j,re),re}createInstallExtensionTask(j,re,x){return R.URI.isUri(re)?new N(j,re,x,this.galleryService,this.extensionsScanner,this.logService):new U(re,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(j,re){return new W(j,re,this.extensionsScanner)}async collectFiles(j){const re=async K=>{let te=await S.Promises.readdir(K);te=te.map(me=>C.join(K,me));const ce=await Promise.all(te.map(me=>S.Promises.stat(me)));let oe=Promise.resolve([]);return ce.forEach((me,Y)=>{const z=te[Y];me.isFile()&&(oe=oe.then(H=>[...H,z])),me.isDirectory()&&(oe=oe.then(H=>re(z).then(q=>[...H,...q])))}),oe};return(await re(j.location.fsPath)).map(K=>({path:`extension/${C.relative(j.location.fsPath,K)}`,localPath:K}))}};L=Ae([Oe(0,f.IExtensionGalleryService),Oe(1,O.ITelemetryService),Oe(2,w.ILogService),Oe(3,y.INativeEnvironmentService),Oe(4,m.IDownloadService),Oe(5,d.IInstantiationService),Oe(6,a.IFileService),Oe(7,P.IProductService),Oe(8,$.IUriIdentityService)],L),e.ExtensionManagementService=L;class T extends b.AbstractExtensionTask{constructor(j,re,x,K){super();this.identifier=j,this.source=re,this.extensionsScanner=x,this.logService=K,this._operation=2}get operation(){return this._operation}async installExtension(j,re){try{const x=await this.unsetUninstalledAndGetLocal(j.identifierWithVersion);if(x)return j.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},...j.metadata}):x}catch{throw k.isMacintosh?new f.ExtensionManagementError(h.localize(1,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(h.localize(2,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(j,re)}async unsetUninstalledAndGetLocal(j){if(!await this.isUninstalled(j))return null;this.logService.trace("Removing the extension from uninstalled list:",j.id);const x=await this.extensionsScanner.setInstalled(j);return this.logService.info("Removed the extension from uninstalled list:",j.id),x}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.key()]}async extract({zipPath:j,identifierWithVersion:re,metadata:x},K){let te=await this.extensionsScanner.extractUserExtension(re,j,x,K);return this.logService.info("Extracting completed.",re.id),te}}class U extends T{constructor(j,re,x,K,te){super(j.identifier,j,K,te);this.gallery=j,this.options=re,this.extensionsDownloader=x}async doRun(j){const x=(await this.extensionsScanner.scanExtensions(null)).find(te=>(0,E.areSameExtensions)(te.identifier,this.gallery.identifier));x&&(this._operation=3);const K=await this.downloadInstallableExtension(this.gallery,this._operation);K.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,K.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin,K.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,K.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,A.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:x?.preRelease);try{const te=await this.installExtension(K,j);return x&&I.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x),te}catch(te){throw await this.deleteDownloadedVSIX(K.zipPath),te}}async deleteDownloadedVSIX(j){try{await this.extensionsDownloader.delete(R.URI.file(j))}catch(re){this.logService.warn("Error while deleting the downloaded vsix",j.toString(),(0,t.getErrorMessage)(re))}}async downloadInstallableExtension(j,re){const x={id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName};let K;try{this.logService.trace("Started downloading extension:",j.identifier.id),K=(await this.extensionsDownloader.downloadExtension(j,re)).fsPath,this.logService.info("Downloaded extension:",j.identifier.id,K)}catch(te){throw new f.ExtensionManagementError((0,b.joinErrors)(te).message,f.ExtensionManagementErrorCode.Download)}try{const te=await(0,l.getManifest)(K);return{zipPath:K,identifierWithVersion:new E.ExtensionIdentifierWithVersion(j.identifier,te.version),metadata:x}}catch(te){throw await this.deleteDownloadedVSIX(K),new f.ExtensionManagementError((0,b.joinErrors)(te).message,f.ExtensionManagementErrorCode.Invalid)}}}class N extends T{constructor(j,re,x,K,te,ce){super({id:(0,E.getGalleryExtensionId)(j.publisher,j.name)},re,te,ce);this.manifest=j,this.location=re,this.options=x,this.galleryService=K}async doRun(j){const re=new E.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),K=(await this.extensionsScanner.scanExtensions(1)).find(ce=>(0,E.areSameExtensions)(this.identifier,ce.identifier)),te=await this.getMetadata(this.identifier.id,this.manifest.version,j);if(te.isMachineScoped=this.options.isMachineScoped||K?.isMachineScoped,te.isBuiltin=this.options.isBuiltin||K?.isBuiltin,K)if(this._operation=3,re.equals(new E.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version)))try{await this.extensionsScanner.removeExtension(K,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(K.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(K);else{const ce=await this.unsetUninstalledAndGetLocal(re);if(ce)try{await this.extensionsScanner.removeExtension(ce,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:C.resolve(this.location.fsPath),identifierWithVersion:re,metadata:te},j)}async getMetadata(j,re,x){try{let[K]=await this.galleryService.getExtensions([{id:j,version:re}],x);if(K||([K]=await this.galleryService.getExtensions([{id:j}],x)),K)return{id:K.identifier.uuid,publisherDisplayName:K.publisherDisplayName,publisherId:K.publisherId,isPreReleaseVersion:K.properties.isPreReleaseVersion,preRelease:K.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class W extends b.AbstractExtensionTask{constructor(j,re,x){super();this.extension=j,this.options=re,this.extensionsScanner=x}async doRun(j){const re=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const K=new E.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);re.push(...x.filter(te=>K.equals(new E.ExtensionIdentifierWithVersion(te.identifier,te.manifest.version))))}else re.push(...x.filter(K=>(0,E.areSameExtensions)(K.identifier,this.extension.identifier)));if(!re.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...re),this.options.remove)for(const K of re)try{j.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(K)}catch(te){throw new Error(h.localize(6,null,(0,_.toErrorMessage)(te)))}}}}),define(we[58],ye([0,1,67,81,25,15,11,7,2,5,3,23,39,84,248]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(P,O=""){this.debugLabel=O,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=$=>{if(this.traceSocketEvent("error",{code:$?.code,message:$?.message}),$){if($.code==="EPIPE")return;(0,k.onUnexpectedError)($)}},this.socket.on("error",this._errorListener)}traceSocketEvent(P,O){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const O=$=>{this.traceSocketEvent("read",$),P(C.VSBuffer.wrap($))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(P){const O=$=>{this.traceSocketEvent("close",{hadError:$}),P({type:0,hadError:$,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(P){const O=()=>{this.traceSocketEvent("nodeEndReceived"),P()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(P){if(!this.socket.destroyed)try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const $=()=>{this.socket.off("close",$),this.socket.off("end",$),this.socket.off("error",$),this.socket.off("timeout",$),this.socket.off("drain",$),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",$),this.socket.on("end",$),this.socket.on("error",$),this.socket.on("timeout",$),this.socket.on("drain",$)})}}e.NodeSocket=h;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var y;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(y||(y={}));class b extends v.Disposable{constructor(P,O,$,L){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:$?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new f(this,O,$,L,this._onData,(T,U)=>this._write(T,U))),this._register(this._flowManager.onError(T=>{console.error(T),(0,k.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,O){this.socket.traceSocketEvent(P,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._flowManager.writeMessage(P)}_write(P,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let $=2;P.byteLength<126?$+=0:P.byteLength<2**16?$+=2:$+=8;const L=C.VSBuffer.alloc($);if(O?L.writeUInt8(194,0):L.writeUInt8(130,0),P.byteLength<126)L.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){L.writeUInt8(126,1);let T=1;L.writeUInt8(P.byteLength>>>8&255,++T),L.writeUInt8(P.byteLength>>>0&255,++T)}else{L.writeUInt8(127,1);let T=1;L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(P.byteLength>>>24&255,++T),L.writeUInt8(P.byteLength>>>16&255,++T),L.writeUInt8(P.byteLength>>>8&255,++T),L.writeUInt8(P.byteLength>>>0&255,++T)}this.socket.write(C.VSBuffer.concat([L,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),$=O.readUInt8(0),L=($&128)>>>7,T=($&64)>>>6,U=O.readUInt8(1),N=(U&128)>>>7,W=U&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),$=O.readUInt8(1),L=($&128)>>>7;let T=$&127,U=1;T===126?T=O.readUInt8(++U)*2**8+O.readUInt8(++U):T===127&&(T=O.readUInt8(++U)*0+O.readUInt8(++U)*0+O.readUInt8(++U)*0+O.readUInt8(++U)*0+O.readUInt8(++U)*2**24+O.readUInt8(++U)*2**16+O.readUInt8(++U)*2**8+O.readUInt8(++U));let N=0;L&&(N=O.readUInt8(++U)*2**24+O.readUInt8(++U)*2**16+O.readUInt8(++U)*2**8+O.readUInt8(++U)),this._state.state=3,this._state.readLen=T,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),o(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class f extends v.Disposable{constructor(P,O,$,L,T,U){super();this._tracer=P,this._onData=T,this._writeFn=U,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new E(this._tracer,L,$,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(P){this._writeQueue.push(P),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const P=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(O,!0)}else this._writeFn(P,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,O){return new Promise(($,L)=>{P.write(O),P.flush(T=>$(T))})}acceptFrame(P,O,$){this._readQueue.push({data:P,isCompressed:O,isLastFrameOfMessage:$}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1}}_inflateFrame(P,O,$){return new Promise((L,T)=>{P.write(O),$&&P.write(C.VSBuffer.fromByteArray([0,0,255,255])),P.flush(U=>L(U))})}}class E extends v.Disposable{constructor(P,O,$,L){super();this._tracer=P,this._recordInflateBytes=O,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=c.createInflateRaw(L),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(C.VSBuffer.wrap(T))}),$&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",$.buffer),this._zlibInflate.write($.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(O)})}}class u extends v.Disposable{constructor(P,O){super();this._tracer=P,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=c.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",$=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibDeflate.on("data",$=>{this._tracer.traceSocketEvent("zlibDeflateData",$),this._pendingDeflateData.push(C.VSBuffer.wrap($))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),P(O)})}}function o(w,P){if(P===0)return;let O=w.byteLength>>>2;for(let W=0;W<O;W++){const ie=w.readUInt32BE(W*4);w.writeUInt32BE(ie^P,W*4)}let $=O*4,L=w.byteLength-$;const T=P>>>24&255,U=P>>>16&255,N=P>>>8&255;L>=1&&w.writeUInt8(w.readUInt8($)^T,$),L>=2&&w.writeUInt8(w.readUInt8($+1)^U,$+1),L>=3&&w.writeUInt8(w.readUInt8($+2)^N,$+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const w=(0,R.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):P=(0,I.join)((0,p.tmpdir)(),`vscode-ipc-${w}.sock`),r(P),P}e.createRandomIPCHandle=s;function n(w,P,O){const $=(0,_.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${$}-${O}-${P}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${$.substr(0,8)}-${O}-${P}.sock`):L=(0,I.join)(w,`${O}-${P}.sock`),r(L),L}e.createStaticIPCHandle=n;function r(w){const P=l[A.platform];typeof P=="number"&&w.length>=P&&console.warn(`WARNING: IPC handle "${w}" is longer than ${P} chars, try a shorter --user-data-dir`)}class i extends g.IPCServer{constructor(P){super(i.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const O=D.Event.fromNodeEventEmitter(P,"connection");return D.Event.map(O,$=>({protocol:new S.Protocol(new h($,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter($,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function a(w){return new Promise((P,O)=>{const $=(0,t.createServer)();$.on("error",O),$.listen(w,()=>{$.removeListener("error",O),P(new i($))})})}e.serve=a;function d(w,P){return new Promise((O,$)=>{const L=(0,t.createConnection)(w,()=>{L.removeListener("error",$),O(S.Client.fromSocket(new h(L,`ipc-client${P}`),P))});L.once("error",$)})}e.connect=d}),define(we[114],ye([0,1,68,13,15,11,2,12,28,26,69,14,203,248]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let c=class extends k.Disposable{constructor(m,y,b){super();this.environmentService=y,this.logService=b,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,y){this.logService.trace("RequestService#request",m.url);const{proxyUrl:b,strictSSL:f}=this;let E;try{E=await(0,A.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const u={...process.env,...E},o=m.agent?m.agent:await(0,g.getProxyAgent)(m.url||"",u,{proxyUrl:b,strictSSL:f});return m.agent=o,m.strictSSL=f,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,y)}async getNodeRequest(m){return((0,_.parse)(m.url).protocol==="https:"?await new Promise((f,E)=>{J(["https"],f,E)}):await new Promise((f,E)=>{J(["http"],f,E)})).request}_request(m,y){return t.Promises.withAsyncBody(async(b,f)=>{let E;const u=(0,_.parse)(m.url),o=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,D.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password),E=o(l,s=>{const n=(0,D.isNumber)(m.followRedirects)?m.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)this._request({...m,url:s.headers.location,followRedirects:n-1},y).then(b,f);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,S.createGunzip)())),b({res:s,stream:(0,p.streamToBufferReadableStream)(r)})}}),E.on("error",f),m.timeout&&E.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&E.write(m.data),E.end(),y.onCancellationRequested(()=>{E.abort(),f((0,C.canceled)())})})}async resolveProxy(m){}};c=Ae([Oe(0,v.IConfigurationService),Oe(1,I.INativeEnvironmentService),Oe(2,R.ILogService)],c),e.RequestService=c}),define(we[115],ye([0,1,38,104,8,5,15,7,58,69,3,244,62]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function S(f={},E,u,o,l,s){const n=await(0,t.getNLSConfiguration)(u,l.userDataPath);let r={};if(E)try{r=await(0,I.getResolvedShellEnv)(s,l.args,process.env)}catch(O){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",O)}const a={...process.env,...r,VSCODE_LOG_NATIVE:String(o),VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(n,void 0,0),...f},d=l.isBuilt?(0,C.join)(l.appRoot,"bin"):(0,C.join)(l.appRoot,"resources","server","bin-dev"),w=(0,C.join)(d,"remote-cli");let P=m(a,"PATH");return P?P=w+C.delimiter+P:P=w,y(a,"PATH",P),l.args["without-browser-env-var"]||(a.BROWSER=(0,C.join)(d,"helpers",A.isWindows?"browser.cmd":"browser.sh")),b(a),a}e.buildUserEnvironment=S;class c{constructor(E,u,o,l,s,n){this.socket=E,this.socketDrain=u,this.initialDataChunk=o,this.skipWebSocketFrames=l,this.permessageDeflate=s,this.inflateBytes=n}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class h{constructor(E,u,o,l,s,n){this._environmentService=E,this._logService=u,this._reconnectionToken=o,this._onClose=new D.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=l,this._extensionHostProcess=null,this._connectionData=h._toConnectionData(s,n),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(E){this._logService.info(`${this._logPrefix}${E}`)}_logError(E){this._logService.error(`${this._logPrefix}${E}`)}static _toConnectionData(E,u){return E instanceof v.NodeSocket?new c(E.socket,E.drain(),u,!0,!1,k.VSBuffer.alloc(0)):new c(E.socket.socket,E.drain(),u,!1,E.permessageDeflate,E.recordedInflateBytes)}async _sendSocketToExtensionHost(E,u){await u.socketDrain;const o=u.toIExtHostSocketMessage();E.send(o,u.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const E={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(E)}acceptReconnection(E,u,o){this._remoteAddress=E,this._log("The client has reconnected.");const l=h._toConnectionData(u,o);if(!this._extensionHostProcess){this._connectionData=l;return}this._sendSocketToExtensionHost(this._extensionHostProcess,l)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(E){try{let u=[];E.port&&!process.pkg&&(u=[`--inspect${E.break?"-brk":""}=${E.port}`]);const o=await S(E.env,!0,E.language,!!E.debugId,this._environmentService,this._logService);(0,g.removeDangerousEnvVariables)(o);const l={env:o,execArgv:u,silent:!0},s=["--type=extensionHost","--transformURIs"],n=this._environmentService.args["use-host-proxy"];s.push(`--useHostProxy=${n?"true":"false"}`),this._extensionHostProcess=_.fork(p.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s,l);const r=this._extensionHostProcess.pid;this._log(`<${r}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const i=D.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),a=D.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");i(w=>this._log(`<${r}> ${w}`)),a(w=>this._log(`<${r}><stderr> ${w}`)),this._extensionHostProcess.on("message",w=>{w&&w.type==="__$console"&&(0,R.logRemoteEntry)(this._logService,w,`${this._logPrefix}<${r}>`)}),this._extensionHostProcess.on("error",w=>{this._logError(`<${r}> Extension Host Process had an error`),this._logService.error(w),this._cleanResources()}),this._extensionHostProcess.on("exit",(w,P)=>{this._log(`<${r}> Extension Host Process exited with code: ${w}, signal: ${P}.`),this._cleanResources()});const d=w=>{w.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",d),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",d)}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}}e.ExtensionHostConnection=h;function m(f,E){const u=Object.keys(f).filter(l=>l.toLowerCase()===E.toLowerCase()),o=u.length>0?u[0]:E;return f[o]}function y(f,E,u){const o=Object.keys(f).filter(s=>s.toLowerCase()===E.toLowerCase()),l=o.length>0?o[0]:E;f[l]=u}function b(f){for(let E of Object.keys(f))f[E]===null&&delete f[E]}}),define(we[249],ye([0,1,65,14,53,95,28,46,114,41,33,32,99,113,91,44,2,92,55,8,19,30,94,112,48,97,66,98,11,4,5,24,201,64,47,102,52,3]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E,u,o,l,s,n,r,i,a,d,w,P,O,$,L,T,U,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class W extends m.Disposable{constructor(x,K){super();this.args=x,this.remoteDataFolder=K,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async K=>{const te=K.get(t.ILogService),ce=K.get(R.IExtensionManagementCLIService);try{await this.doRun(ce)}catch(oe){throw te.error(oe),console.error((0,a.getErrorMessage)(oe)),oe}})}async initServices(){const x=new _.ServiceCollection,K={_serviceBrand:void 0,...h.default};x.set(u.IProductService,K);const te=new s.ServerEnvironmentService(this.args,K);x.set(s.IServerEnvironmentService,te);const ce=new t.LogService(new o.SpdLogLogger(l.RemoteExtensionLogFileName,(0,w.join)(te.logsPath,`${l.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(te)));x.set(t.ILogService,ce),ce.trace(`Remote configuration data at ${this.remoteDataFolder}`),ce.trace("process arguments:",this.args);const oe=this._register(new y.FileService(ce));x.set(E.IFileService,oe),oe.registerProvider(f.Schemas.file,this._register(new b.DiskFileSystemProvider(ce)));const me=this._register(new C.ConfigurationService(te.settingsResource,oe));return await me.initialize(),x.set(k.IConfigurationService,me),x.set(L.IUriIdentityService,new T.UriIdentityService(oe)),x.set(D.IRequestService,new p.SyncDescriptor(v.RequestService)),x.set($.IDownloadService,new p.SyncDescriptor(O.DownloadService)),x.set(A.ITelemetryService,I.NullTelemetryService),x.set(R.IExtensionGalleryService,new p.SyncDescriptor(g.ExtensionGalleryServiceWithNoStorageService)),x.set(R.IExtensionManagementService,new p.SyncDescriptor(S.ExtensionManagementService)),x.set(R.IExtensionManagementCLIService,new p.SyncDescriptor(n.ExtensionManagementCLIService)),x.set(r.ILocalizationsService,new p.SyncDescriptor(i.LocalizationsService)),new c.InstantiationService(x)}async doRun(x){if(this.args["list-extensions"])return x.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const K={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return x.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],K,!!this.args.force)}else{if(this.args["uninstall-extension"])return x.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return x.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(x){return x.map(K=>/\.vsix$/i.test(K)?d.URI.file((0,w.isAbsolute)(K)?K:(0,w.join)((0,P.cwd)(),K)):K)}}function ie(re){setTimeout(()=>process.exit(re),0)}async function j(re,x,K){if(re.help){const ce=h.default.serverApplicationName+(N.isWindows?".cmd":"");console.log((0,U.buildHelpMessage)(h.default.nameLong,ce,h.default.version,K,{noInputFiles:!0,noPipe:!0}));return}if(re.version){console.log((0,U.buildVersionMessage)(h.default.version,h.default.commit));return}const te=new W(re,x);try{await te.run(),ie(0)}catch{ie(1)}finally{te.dispose()}}e.run=j}),define(we[250],ye([0,1,58,261,27,243,4,14,103]),function(J,e,_,t,p,C,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(g,S,c){this._commands=g,this.logService=S,this._ipcHandlePath=c,this._server=t.createServer((h,m)=>this.onRequest(h,m)),this.setup().catch(h=>(S.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",g=>this.logService.error(g))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(g,S){const c=(m,y)=>{S.writeHead(m,{"content-type":"application/json"}),S.end(JSON.stringify(y),b=>b&&this.logService.error(b))},h=[];g.setEncoding("utf8"),g.on("data",m=>h.push(m)),g.on("end",async()=>{try{const m=JSON.parse(h.join(""));let y;switch(m.type){case"open":y=await this.open(m);break;case"openExternal":y=await this.openExternal(m);break;case"status":y=await this.getStatus(m);break;case"extensionManagement":y=await this.manageExtensions(m);break;default:c(404,`Unknown message type: ${m.type}`);break}c(200,y)}catch(m){const y=m instanceof Error?m.message:JSON.stringify(m);c(500,y),this.logService.error("Error while processing pipe request",m)}})}async open(g){const{fileURIs:S,folderURIs:c,forceNewWindow:h,diffMode:m,addMode:y,forceReuseWindow:b,gotoLineMode:f,waitMarkerFilePath:E,remoteAuthority:u}=g,o=[];if(Array.isArray(c))for(const r of c)try{o.push({folderUri:k.URI.parse(r)})}catch{}if(Array.isArray(S))for(const r of S)try{(0,v.hasWorkspaceFileExtension)(r)?o.push({workspaceUri:k.URI.parse(r)}):o.push({fileUri:k.URI.parse(r)})}catch{}const l=E?k.URI.file(E):void 0,n={forceNewWindow:h,diffMode:m,addMode:y,gotoLineMode:f,forceReuseWindow:b,preferNewWindow:!b&&!l&&!y,waitMarkerFileURI:l,remoteAuthority:u};return this._commands.executeCommand("_remoteCLI.windowOpen",o,n),""}async openExternal(g){for(const S of g.uris){const c=k.URI.parse(S),h=c.scheme==="file"?c:S;await this._commands.executeCommand("_remoteCLI.openExternal",h)}}async manageExtensions(g){const S=h=>h?.map(m=>/\.vsix$/i.test(m)?k.URI.parse(m):m),c={list:g.list,install:S(g.install),uninstall:S(g.uninstall),force:g.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",c)}async getStatus(g){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&p.existsSync(this._ipcHandlePath)&&p.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let A=class extends I{constructor(g,S){super(g,S,(0,_.createRandomIPCHandle)())}};A=Ae([Oe(0,C.IExtHostCommands),Oe(1,D.ILogService)],A),e.CLIServer=A}),define(we[251],ye([0,1,25,7,21,2,5,3,4,58,57,250,230,109,231,236,115]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class y extends h.AbstractVariableResolverService{constructor(E,u,o,l){super({getFolderUri:s=>{const n=u.filter(r=>r.name===s);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(s,n)=>l[`config:${n}`],getExecPath:()=>E.VSCODE_EXEC_PATH,getAppRoot:()=>E.VSCODE_CWD,getFilePath:()=>{if(o)return k.normalize(o.fsPath)},getSelectedText:()=>l.selectedText,getLineNumber:()=>l.lineNumber},void 0,Promise.resolve(_.homedir()),Promise.resolve(E))}}class b extends C.Disposable{constructor(E,u,o,l){super();this._environmentService=E,this._logService=u,this._ptyService=o,this._productService=l,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(E,u,o){switch(u){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,o);case"$createProcess":{const l=(0,A.createURITransformer)(E.remoteAuthority);return this._createProcess(l,o)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,o);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,o);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,o);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,o);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,o);case"$start":return this._ptyService.start.apply(this._ptyService,o);case"$input":return this._ptyService.input.apply(this._ptyService,o);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,o);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,o);case"$resize":return this._ptyService.resize.apply(this._ptyService,o);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,o);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,o);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,o);case"$sendCommandResult":return this._sendCommandResult(o[0],o[1],o[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,o);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,o);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,o);case"$getProfiles":return this._getProfiles.apply(this,o);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(o[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(o);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(o);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,o);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,o);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,o);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,o);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,o);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,o);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,o);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(o[0],o[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(o[0],o[1])}throw new Error(`IPC Command ${u} not found`)}listen(E,u,o){switch(u){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(E,u){const o={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd=="undefined"?u.shellLaunchConfig.cwd:v.URI.revive(E.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment},l=await(0,m.buildUserEnvironment)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,D.language,!1,this._environmentService,this._logService);this._logService.trace("baseEnv",l);const s=W=>({uri:v.URI.revive(E.transformIncoming(W.uri)),name:W.name,index:W.index,toResource:()=>{throw new Error("Not implemented")}}),n=u.workspaceFolders.map(s),r=u.activeWorkspaceFolder?s(u.activeWorkspaceFolder):void 0,i=u.activeFileResource?v.URI.revive(E.transformIncoming(u.activeFileResource)):void 0,a=new y(l,n,i,u.resolvedVariables),d=c.createVariableResolver(r,process.env,a),w=c.getCwd(o,_.homedir(),d,r?.uri,u.configuration["terminal.integrated.cwd"],this._logService);o.cwd=w;const P=D.isWindows?"terminal.integrated.env.windows":D.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=u.configuration[P],$=c.createTerminalEnvironment(o,O,d,this._productService.version,u.configuration["terminal.integrated.detectLocale"],l);if(!o.strictEnv){const W=[];for(const[re,x]of u.envVariableCollections)W.push([re,{map:(0,S.deserializeEnvironmentVariableCollection)(x)}]);const ie=new Map(W);new g.MergedEnvironmentVariableCollection(ie).applyToProcessEnvironment($)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:o,initialCwd:w,cols:u.cols,rows:u.rows,env:$});const L=(0,I.createRandomIPCHandle)();$.VSCODE_IPC_HOOK_CLI=L;const T={executeCommand:(W,...ie)=>this._executeCommand(W,ie,E)},U=new R.CLIServerBase(T,this._logService,L),N=await this._ptyService.createProcess(o,w,u.cols,u.rows,u.unicodeVersion,$,l,!1,u.shouldPersistTerminal,u.workspaceId,u.workspaceName);return this._ptyService.onProcessExit(W=>W.id===N&&U.dispose()),{persistentTerminalId:N,resolvedShellLaunchConfig:o}}_executeCommand(E,u,o){let l,s;const n=new Promise((a,d)=>{l=a,s=d}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:l,reject:s,uriTransformer:o});const i=(0,p.cloneAndChange)(u,a=>{if(a&&a.$mid===1)return o.transformOutgoing(a);if(a&&a instanceof v.URI)return o.transformOutgoingURI(a)});return this._onExecuteCommand.fire({reqId:r,commandId:E,commandArgs:i}),n}_sendCommandResult(E,u,o){const l=this._pendingCommands.get(E);if(!l)return;this._pendingCommands.delete(E);const s=(0,p.cloneAndChange)(o,n=>{if(n&&n.$mid===1)return l.uriTransformer.transformIncoming(n)});u?l.reject(s):l.resolve(s)}_getDefaultSystemShell(E){return this._ptyService.getDefaultSystemShell(E)}async _getProfiles(E,u,o,l){return this._ptyService.getProfiles?.(E,u,o,l)||[]}_getEnvironment(){return{...process.env}}_getWslPath(E){return this._ptyService.getWslPath(E)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=b}),define(we[252],ye([0,1,25,7,2,8,5,80,18,39,28,95,89,194,170,64,171,182,173,26,99,32,97,198,113,19,92,55,53,91,65,66,98,14,93,94,44,30,46,202,114,205,33,41,213,214,100,221,47,102,241,228,207,212,251,57,48,239,112,245]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E,u,o,l,s,n,r,i,a,d,w,P,O,$,L,T,U,N,W,ie,j,re,x,K,te,ce,oe,me,Y,z,H,q,ee,he,Ie,se,fe,ve,X,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const V="monacoworkbench";async function Q(ge,de,Te,Me){const He=new w.ServiceCollection,Be=new Pe,je={_serviceBrand:void 0,...U.default};He.set(N.IProductService,je);const qe=new fe.ServerEnvironmentService(de,je);He.set(f.IEnvironmentService,qe),He.set(f.INativeEnvironmentService,qe);const ne=new $.LogService(new T.SpdLogLogger(X.RemoteExtensionLogFileName,k.join(qe.logsPath,`${X.RemoteExtensionLogFileName}.log`),!0,!1,(0,$.getLogLevel)(qe))),be=new $.MultiplexLogService([new Re((0,$.getLogLevel)(qe)),ne]);He.set($.ILogService,be),setTimeout(()=>ae(qe.logsPath).then(null,et=>be.error(et)),1e4),be.trace(`Remote configuration data at ${Te}`),be.trace("process arguments:",qe.args),Array.isArray(je.serverGreeting)&&ne.info(`

${je.serverGreeting.join(`
`)}

`),Be.registerChannel(c.ExtensionHostDebugBroadcastChannel.ChannelName,new c.ExtensionHostDebugBroadcastChannel);const ke=new I.StaticRouter(et=>et.clientId==="renderer");Be.registerChannel("logger",new L.LogLevelChannel(be));const Le=Me.add(new r.FileService(be));He.set(n.IFileService,Le),Le.registerProvider(C.Schemas.file,Me.add(new i.DiskFileSystemProvider(be)));const Ne=new R.ConfigurationService(qe.machineSettingsResource,Le);He.set(A.IConfigurationService,Ne),He.set(Y.IUriIdentityService,new z.UriIdentityService(Le)),He.set(W.IRequestService,new a.SyncDescriptor(j.RequestService));let Qe=K.NullAppender;const $e=await(0,D.getMachineId)();if((0,K.supportsTelemetry)(je,qe)){je.aiConfig&&je.aiConfig.asimovKey&&(Qe=new te.AppInsightsAppender(V,null,je.aiConfig.asimovKey),Me.add((0,p.toDisposable)(()=>Qe.flush())));const et={appenders:[Qe],commonProperties:(0,re.resolveCommonProperties)(Le,(0,_.release)(),(0,_.hostname)(),process.arch,je.commit,je.version+"-remote",$e,je.msftInternalDomains,qe.installSourcePath,"remoteAgent"),piiPaths:(0,K.getPiiPathsFromEnvironment)(qe)},rt=qe.args["telemetry-level"];let nt;rt==="all"?nt=3:rt==="error"?nt=2:rt==="crash"?nt=1:rt!==void 0&&(nt=0),He.set(he.IServerTelemetryService,new a.SyncDescriptor(he.ServerTelemetryService,[et,nt]))}else He.set(he.IServerTelemetryService,he.ServerNullTelemetryService);He.set(u.IExtensionGalleryService,new a.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService));const Ve=Be.getChannel("download",ke);He.set(h.IDownloadService,new m.DownloadServiceChannelClient(Ve,()=>pe("renderer"))),He.set(u.IExtensionManagementService,new a.SyncDescriptor(s.ExtensionManagementService));const Ye=new d.InstantiationService(He);He.set(P.ILocalizationsService,Ye.createInstance(O.LocalizationsService));const xe=Ye.createInstance(o.ExtensionManagementCLIService);He.set(u.IExtensionManagementCLIService,xe);const Ze=Ye.createInstance(me.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Ne.getValue("terminal.integrated.persistentSessionScrollback")??100});return He.set(oe.IPtyService,Ze),He.set(y.IEncryptionMainService,new a.SyncDescriptor(b.EncryptionMainService,[$e])),He.set(g.ICredentialsMainService,new a.SyncDescriptor(S.CredentialsMainService,[!0])),Ye.invokeFunction(et=>{const rt=new H.RemoteAgentEnvironmentChannel(ge,qe,xe,be,je);Be.registerChannel("remoteextensionsenvironment",rt);const nt=new ee.ServerTelemetryChannel(et.get(he.IServerTelemetryService),Qe);Be.registerChannel("telemetry",nt),Be.registerChannel(ve.REMOTE_TERMINAL_CHANNEL_NAME,new Ie.RemoteTerminalChannel(qe,be,Ze,je));const pt=new q.RemoteAgentFileSystemProviderChannel(be,qe);Be.registerChannel(B.REMOTE_FILE_SYSTEM_CHANNEL_NAME,pt),Be.registerChannel("request",new ie.RequestChannel(et.get(W.IRequestService)));const gt=et.get(u.IExtensionManagementService),dt=new l.ExtensionManagementChannel(gt,Pt=>pe(Pt.remoteAuthority));Be.registerChannel("extensions",dt);const St=I.ProxyChannel.fromService(et.get(y.IEncryptionMainService));Be.registerChannel("encryption",St);const Dt=I.ProxyChannel.fromService(et.get(g.ICredentialsMainService));return Be.registerChannel("credentials",Dt),gt.removeDeprecatedExtensions(),Me.add(new ce.default(et.get(x.ITelemetryService))),{telemetryService:et.get(x.ITelemetryService)}}),{socketServer:Be,instantiationService:Ye}}e.setupServerServices=Q;const ue=Object.create(null);function pe(ge){return ue[ge]||(ue[ge]=(0,se.createURITransformer)(ge)),ue[ge]}class Pe extends I.IPCServer{constructor(){const de=new t.Emitter;super(de.event);this._onDidConnectEmitter=de}acceptConnection(de,Te){this._onDidConnectEmitter.fire({protocol:de,onDidClientDisconnect:Te})}}e.SocketServer=Pe;class Re extends $.AbstractLogger{constructor(de=$.DEFAULT_LOG_LEVEL){super();this.setLevel(de),this.useColors=Boolean(process.stdout.isTTY)}trace(de,...Te){this.getLevel()<=$.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Fe()}][0m`,de,...Te):console.log(`[${Fe()}]`,de,...Te))}debug(de,...Te){this.getLevel()<=$.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Fe()}][0m`,de,...Te):console.log(`[${Fe()}]`,de,...Te))}info(de,...Te){this.getLevel()<=$.LogLevel.Info&&(this.useColors?console.log(`[90m[${Fe()}][0m`,de,...Te):console.log(`[${Fe()}]`,de,...Te))}warn(de,...Te){this.getLevel()<=$.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Fe()}][0m`,de,...Te):console.warn(`[${Fe()}]`,de,...Te))}error(de,...Te){this.getLevel()<=$.LogLevel.Error&&(this.useColors?console.error(`[91m[${Fe()}][0m`,de,...Te):console.error(`[${Fe()}]`,de,...Te))}critical(de,...Te){this.getLevel()<=$.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Fe()}][0m`,de,...Te):console.error(`[${Fe()}]`,de,...Te))}dispose(){}flush(){}}function Fe(){const ge=new Date;return`${Ue(ge.getHours())}:${Ue(ge.getMinutes())}:${Ue(ge.getSeconds())}`}function Ue(ge){return ge<10?`0${ge}`:String(ge)}async function ae(ge){const de=k.basename(ge),Te=k.dirname(ge),Be=(await v.Promises.readdir(Te)).filter(qe=>/^\d{8}T\d{6}$/.test(qe)).sort().filter(qe=>qe!==de),je=Be.slice(0,Math.max(0,Be.length-9));await Promise.all(je.map(qe=>v.Promises.rm(k.join(Te,qe))))}}),define(we[253],ye([0,1,67,27,81,254,68,116,15,34,2,8,5,43,3,4,23,133,84,58,6,14,30,33,115,223,224,48,252,226]),function(J,e,_,t,p,C,k,D,v,I,A,R,g,S,c,h,m,y,b,f,E,u,o,l,s,n,r,i,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const w=5*60*1e3;let P=class extends A.Disposable{constructor(L,T,U,N,W,ie,j){super();this._socketServer=L,this._connectionToken=T,this._environmentService=N,this._productService=W,this._logService=ie,this._instantiationService=j,this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=U?this._instantiationService.createInstance(d.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(L,T){if(L.method!=="GET")return(0,d.serveError)(L,T,405,`Unsupported method ${L.method}`);if(!L.url)return(0,d.serveError)(L,T,400,"Bad request.");const U=k.parse(L.url,!0),N=U.pathname;if(!N)return(0,d.serveError)(L,T,400,"Bad request.");if(N==="/version")return T.writeHead(200,{"Content-Type":"text/plain"}),T.end(this._productService.commit||"");if(N==="/delay-shutdown")return this._delayShutdown(),T.writeHead(200),T.end("OK");if(!(0,r.requestHasValidConnectionToken)(this._connectionToken,L,U))return(0,d.serveError)(L,T,403,"Forbidden.");if(N==="/vscode-remote-resource"){const W=U.query.path;if(typeof W!="string")return(0,d.serveError)(L,T,400,"Bad request.");let ie;try{ie=h.URI.from({scheme:R.Schemas.file,path:W}).fsPath}catch{return(0,d.serveError)(L,T,400,"Bad request.")}const j=Object.create(null);return this._environmentService.isBuilt&&((0,I.isEqualOrParent)(ie,this._environmentService.builtinExtensionsPath,!c.isLinux)||(0,I.isEqualOrParent)(ie,this._environmentService.extensionsPath,!c.isLinux))&&(j["Cache-Control"]="public, max-age=31536000"),(0,d.serveFile)(this._logService,L,T,ie,j)}if(this._webClientServer){this._webClientServer.handle(L,T,U);return}return T.writeHead(404,{"Content-Type":"text/plain"}),T.end("Not found")}handleUpgrade(L,T){let U=(0,m.generateUuid)(),N=!1,W=!1;if(L.url){const te=k.parse(L.url,!0).query;typeof te.reconnectionToken=="string"&&(U=te.reconnectionToken),te.reconnection==="true"&&(N=!0),te.skipWebSocketFrames==="true"&&(W=!0)}if(L.headers.upgrade!=="websocket"){T.end("HTTP/1.1 400 Bad Request");return}const ie=L.headers["sec-websocket-key"],j=_.createHash("sha1");j.update(ie+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const re=j.digest("base64"),x=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${re}`];let K=!1;if(!W&&!this._environmentService.args["disable-websocket-compression"]&&L.headers["sec-websocket-extensions"]){const te=Array.isArray(L.headers["sec-websocket-extensions"])?L.headers["sec-websocket-extensions"]:[L.headers["sec-websocket-extensions"]];for(const ce of te)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(ce)){if(/\b(permessage-deflate)\b/.test(ce)){K=!0,x.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(ce)){K=!0,x.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}T.write(x.join(`\r
`)+`\r
\r
`),T.setTimeout(0),T.setNoDelay(!0),W?this._handleWebSocketConnection(new f.NodeSocket(T,`server-connection-${U}`),N,U):this._handleWebSocketConnection(new f.WebSocketNodeSocket(new f.NodeSocket(T,`server-connection-${U}`),K,null,!0),N,U)}handleServerError(L){this._logService.error("Error occurred in server"),this._logService.error(L)}_getRemoteAddress(L){let T;return L instanceof f.NodeSocket?T=L.socket:T=L.socket.socket,T.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(L,T,U){const N=T.getSocket();this._logService.error(`${L} ${U}.`);const W={type:"error",reason:U};T.sendControl(v.VSBuffer.fromString(JSON.stringify(W))),T.dispose(),await N.drain(),N.dispose()}_handleWebSocketConnection(L,T,U){const N=this._getRemoteAddress(L),W=`[${N}][${U.substr(0,8)}]`,ie=new b.PersistentProtocol(L);let j,re;try{const oe=J.__$__nodeRequire("vsda");j=new oe.validator,re=new oe.signer}catch{}let x;(function(oe){oe[oe.WaitingForAuth=0]="WaitingForAuth",oe[oe.WaitingForConnectionType=1]="WaitingForConnectionType",oe[oe.Done=2]="Done",oe[oe.Error=3]="Error"})(x||(x={}));let K=0;const te=oe=>{K=3,ce.dispose(),this._rejectWebSocketConnection(W,ie,oe)},ce=ie.onControlMessage(oe=>{if(K===0){let me;try{me=JSON.parse(oe.toString())}catch{return te("Malformed first message")}if(me.type!=="auth")return te("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(me.auth))return te("Unauthorized client refused: auth mismatch");let Y=(0,m.generateUuid)();if(re)try{Y=re.sign(me.data)}catch{}let z=(0,m.generateUuid)();if(j)try{z=j.createNewMessage(z)}catch{}const H={type:"sign",data:z,signedData:Y};ie.sendControl(v.VSBuffer.fromString(JSON.stringify(H))),K=1}else if(K===1){let me;try{me=JSON.parse(oe.toString())}catch{return te("Malformed second message")}if(me.type!=="connectionType")return te("Invalid second message");if(typeof me.signedData!="string")return te("Invalid second message field type");const Y=me.commit,z=this._productService.commit;if(Y&&z&&Y!==z)return te("Client refused: version mismatch");let H=!1;if(!j)H=!0;else if(this._connectionToken.validate(me.signedData))H=!0;else try{H=j.validate(me.signedData)==="ok"}catch{}if(!H){if(this._environmentService.isBuilt)return te("Unauthorized client refused");this._logService.error(`${W} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let q in this._managementConnections)this._managementConnections[q].shortenReconnectionGraceTimeIfNecessary();for(let q in this._extHostConnections)this._extHostConnections[q].shortenReconnectionGraceTimeIfNecessary();K=2,ce.dispose(),this._handleConnectionType(N,W,ie,L,T,U,me)}})}async _handleConnectionType(L,T,U,N,W,ie,j){const re=j.desiredConnectionType===1?`${T}[ManagementConnection]`:j.desiredConnectionType===2?`${T}[ExtensionHostConnection]`:T;if(j.desiredConnectionType===1)if(W){if(!this._managementConnections[ie])return this._allReconnectionTokens.has(ie)?this._rejectWebSocketConnection(re,U,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(re,U,"Unknown reconnection token (never seen)");U.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const x=U.readEntireBuffer();U.dispose(),this._managementConnections[ie].acceptReconnection(L,N,x)}else{if(this._managementConnections[ie])return this._rejectWebSocketConnection(re,U,"Duplicate reconnection token");U.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const x=new n.ManagementConnection(this._logService,ie,L,U);this._socketServer.acceptConnection(x.protocol,x.onClose),this._managementConnections[ie]=x,this._allReconnectionTokens.add(ie),x.onClose(()=>{delete this._managementConnections[ie]})}else if(j.desiredConnectionType===2){const x=j.args||{language:"en"},K=await this._updateWithFreeDebugPort(x);if(K.port&&this._logService.trace(`${re} - startParams debug port ${K.port}`),this._logService.trace(`${re} - startParams language: ${K.language}`),this._logService.trace(`${re} - startParams env: ${JSON.stringify(K.env)}`),W){if(!this._extHostConnections[ie])return this._allReconnectionTokens.has(ie)?this._rejectWebSocketConnection(re,U,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(re,U,"Unknown reconnection token (never seen)");U.sendPause(),U.sendControl(v.VSBuffer.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const te=U.readEntireBuffer();U.dispose(),this._extHostConnections[ie].acceptReconnection(L,N,te)}else{if(this._extHostConnections[ie])return this._rejectWebSocketConnection(re,U,"Duplicate reconnection token");U.sendPause(),U.sendControl(v.VSBuffer.fromString(JSON.stringify(K.port?{debugPort:K.port}:{})));const te=U.readEntireBuffer();U.dispose();const ce=new s.ExtensionHostConnection(this._environmentService,this._logService,ie,L,N,te);this._extHostConnections[ie]=ce,this._allReconnectionTokens.add(ie),ce.onClose(()=>{delete this._extHostConnections[ie],this._onDidCloseExtHostConnection()}),ce.start(K)}}else if(j.desiredConnectionType===3){const x=j.args;this._createTunnel(U,x)}else return this._rejectWebSocketConnection(re,U,"Unknown initial data received")}async _createTunnel(L,T){const U=L.getSocket().socket,N=L.readEntireBuffer();L.dispose(),U.pause();const W=await this._connectTunnelSocket(T.host,T.port);N.byteLength>0&&W.write(N.buffer),W.on("end",()=>U.end()),W.on("close",()=>U.end()),W.on("error",()=>U.destroy()),U.on("end",()=>W.end()),U.on("close",()=>W.end()),U.on("error",()=>W.destroy()),W.pipe(U),U.pipe(W)}_connectTunnelSocket(L,T){return new Promise((U,N)=>{const W=p.createConnection({host:L,port:T},()=>{W.removeListener("error",N),W.pause(),U(W)});W.once("error",N)})}_updateWithFreeDebugPort(L){return typeof L.port=="number"?(0,y.findFreePort)(L.port,10,5e3).then(T=>(L.port=T,L)):(L.debugId=void 0,L.port=void 0,L.break=void 0,Promise.resolve(L))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},w))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};P=Ae([Oe(3,i.IServerEnvironmentService),Oe(4,o.IProductService),Oe(5,u.ILogService),Oe(6,E.IInstantiationService)],P),e.RemoteExtensionHostAgentServer=P;async function O($,L,T){const U=await(0,r.determineServerConnectionToken)(L);U instanceof r.ServerConnectionTokenParseError&&(console.warn(U.message),process.exit(1));const N=new A.DisposableStore,{socketServer:W,instantiationService:ie}=await(0,a.setupServerServices)(U,L,T,N);ie.invokeFunction(oe=>{const me=oe.get(u.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Y=(0,g.join)(process.env.HOMEDRIVE,"node_modules"),z=(0,g.dirname)((0,g.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),H=(0,g.join)(z,"node_modules");if(t.existsSync(Y)||t.existsSync(H)){const q=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Y}
* ${H}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;me.warn(q),console.warn(q),process.exit(0)}}});const j=t.existsSync(R.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",J).fsPath);if(j&&$&&typeof $!="string"){const oe=U.type!==0?`?${R.connectionTokenQueryName}=${U.value}`:"";console.log(`Web UI available at http://localhost${$.port===80?"":`:${$.port}`}/${oe}`)}const re=ie.createInstance(P,W,U,j);S.mark("code/server/ready");const x=C.performance.now(),K=global.vscodeServerStartTime,te=global.vscodeServerListenTime,ce=global.vscodeServerCodeLoadedTime;if(ie.invokeFunction(oe=>{oe.get(l.ITelemetryService).publicLog2("serverStart",{startTime:K,startedTime:te,codeLoadedTime:ce,readyTime:x})}),L["print-startup-performance"]){const oe=D.LoaderStats.get();let me="";me+=`

### Load AMD-module
`,me+=D.LoaderStats.toMarkdownTable(["Module","Duration"],oe.amdLoad),me+=`

### Load commonjs-module
`,me+=D.LoaderStats.toMarkdownTable(["Module","Duration"],oe.nodeRequire),me+=`

### Invoke AMD-module factory
`,me+=D.LoaderStats.toMarkdownTable(["Module","Duration"],oe.amdInvoke),me+=`

### Invoke commonjs-module
`,me+=D.LoaderStats.toMarkdownTable(["Module","Duration"],oe.nodeEval),me+=`Start-up time: ${te-K}
`,me+=`Code loading time: ${ce-K}
`,me+=`Initialized time: ${x-K}
`,me+=`
`,console.log(me)}return re}e.createServer=O}),define(we[262],ye([0,1,25,27,8,249,253,52,5,254,48,44,43]),function(J,e,_,t,p,C,k,D,v,I,A,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,g.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=I.performance.now();const S={onMultipleValues:(s,n)=>{console.error(`Option ${s} can only be defined once. Using value ${n}.`)},onUnknownOption:s=>{console.error(`Ignoring option ${s}: not supported for server.`)},onDeprecatedOption:(s,n)=>{console.warn(`Option '${s}' is deprecated: ${n}`)}},c=(0,D.parseArgs)(process.argv.slice(2),A.serverOptions,S),h=c["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(_.homedir(),R.default.serverDataFolderName||".vscode-remote"),m=(0,v.join)(h,"data"),y=(0,v.join)(m,"User"),b=(0,v.join)(y,"globalStorage"),f=(0,v.join)(m,"Machine");c["user-data-dir"]=m;const E=(0,v.dirname)(p.FileAccess.asFileUri("",J).fsPath),u=(0,v.join)(E,"extensions");c["builtin-extensions-dir"]=u,c["extensions-dir"]=c["extensions-dir"]||(0,v.join)(h,"extensions"),[h,c["extensions-dir"],m,y,f,b].forEach(s=>{try{t.existsSync(s)||t.mkdirSync(s,{mode:448})}catch(n){console.error(n)}});function o(){(0,C.run)(c,h,A.serverOptions)}e.spawnCli=o;function l(s){return(0,k.createServer)(s,c,h)}e.createServer=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c722ca6c7eed3d7987c0d5c3df5c45f6b15e77d1/core/vs/server/node/server.main.js.map
